# include "Accepted.h"
# include "yyAccepted.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 22 "Accepted.puma"


# include <stdio.h>
# include "Idents.h"
# include "StringMem.h"
 
# include "protocol.h"

# include "Transform.h"      /* CombineACF     */
# include "Objects.h"
# include "Distributions.h"
# include "Intrinsics.h"
# include "Rank.h"
# include "Expressions.h"

# define MODULE "Accepted"
 
# undef DEBUG



static void yyExit () { Exit (1); }

void (* Accepted_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module Accepted, routine %s failed\n", yyFunction);
 Accepted_Exit ();
}

bool IsDescriptorVar ARGS((tTree var));
bool IsF77 ARGS((tTree exp));
bool DoLoopExpression ARGS((tTree t));

bool IsDescriptorVar
# if defined __STDC__ | defined __cplusplus
(register tTree var)
# else
(var)
 register tTree var;
# endif
{
  if (var->Kind == kUSED_VAR) {
# line 62 "Accepted.puma"
   return true;

  }
  if (var->Kind == kLOOP_VAR) {
# line 65 "Accepted.puma"
   return true;

  }
  if (var->Kind == kSUBSTRING_VAR) {
# line 68 "Accepted.puma"
  {
# line 70 "Accepted.puma"
   if (! ((IsDescriptorVar (var->SUBSTRING_VAR.IND_VAR)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (var->Kind == kINDEXED_VAR) {
# line 73 "Accepted.puma"
  {
# line 75 "Accepted.puma"
   if (! ((IsDescriptorVar (var->INDEXED_VAR.IND_VAR)))) goto yyL4;
  {
# line 76 "Accepted.puma"
   if (! ((IsF77 (var->INDEXED_VAR.IND_EXPS)))) goto yyL4;
  {
# line 77 "Accepted.puma"
   if (! ((TreeReadDistribution (var->INDEXED_VAR.IND_EXPS) == 0))) goto yyL4;
  }
  }
  }
   return true;
yyL4:;

  }
  if (var->Kind == kSELECTED_VAR) {
# line 80 "Accepted.puma"
  {
# line 82 "Accepted.puma"
   if (! ((IsDescriptorVar (var->SELECTED_VAR.SELEC_VAR)))) goto yyL5;
  }
   return true;
yyL5:;

  }
  return false;
}

bool IsF77
# if defined __STDC__ | defined __cplusplus
(register tTree exp)
# else
(exp)
 register tTree exp;
# endif
{

  switch (exp->Kind) {
  case kADDR:
# line 98 "Accepted.puma"
  {
# line 99 "Accepted.puma"
   if (! ((IsF77 (exp->ADDR.E)))) goto yyL1;
  }
   return true;
yyL1:;

  break;
  case kDUMMY_EXP:
# line 102 "Accepted.puma"
   return true;

  case kCONST_EXP:
# line 105 "Accepted.puma"
   return true;

  case kARRAY_EXP:
# line 108 "Accepted.puma"
  {
# line 109 "Accepted.puma"
   return false;
  }

  case kTYPE_EXP:
# line 112 "Accepted.puma"
  {
# line 113 "Accepted.puma"
   return false;
  }

  case kSLICE_EXP:
# line 116 "Accepted.puma"
  {
# line 117 "Accepted.puma"
   if (! ((IsF77 (exp->SLICE_EXP.START)))) goto yyL6;
  {
# line 118 "Accepted.puma"
   if (! ((IsF77 (exp->SLICE_EXP.STOP)))) goto yyL6;
  {
# line 119 "Accepted.puma"
   if (! ((IsF77 (exp->SLICE_EXP.INC)))) goto yyL6;
  }
  }
  }
   return true;
yyL6:;

  break;
  case kOP_EXP:
# line 122 "Accepted.puma"
  {
# line 123 "Accepted.puma"
   if (! ((IsF77 (exp->OP_EXP.OPND1)))) goto yyL7;
  {
# line 124 "Accepted.puma"
   if (! ((IsF77 (exp->OP_EXP.OPND2)))) goto yyL7;
  }
  }
   return true;
yyL7:;

  break;
  case kOP1_EXP:
# line 127 "Accepted.puma"
  {
# line 128 "Accepted.puma"
   if (! ((IsF77 (exp->OP1_EXP.OPND)))) goto yyL8;
  }
   return true;
yyL8:;

  break;
  case kPERM_EXP:
# line 131 "Accepted.puma"
  {
# line 132 "Accepted.puma"
   return false;
  }

  case kVAR_EXP:
# line 135 "Accepted.puma"
  {
# line 136 "Accepted.puma"
   if (! ((IsF77 (exp->VAR_EXP.V)))) goto yyL10;
  }
   return true;
yyL10:;

  break;
  case kFUNC_CALL_EXP:
# line 139 "Accepted.puma"
  {
# line 141 "Accepted.puma"
   if (! ((IsIntrCall (exp)))) goto yyL11;
  {
# line 142 "Accepted.puma"
   if (! ((IntrFuncElemental (exp->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident) || IntrFuncInquiry (exp->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL11;
  {
# line 143 "Accepted.puma"
   if (! ((IsF77 (exp->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL11;
  }
  }
  }
   return true;
yyL11:;

# line 146 "Accepted.puma"
  {
# line 149 "Accepted.puma"
   return false;
  }

  case kBOUND_EXP:
# line 152 "Accepted.puma"
   return true;

  case kRANK_EXP:
# line 155 "Accepted.puma"
   return true;

  case kBTE_LIST:
# line 158 "Accepted.puma"
  {
# line 159 "Accepted.puma"
   if (! ((IsF77 (exp->BTE_LIST.Elem)))) goto yyL15;
  {
# line 160 "Accepted.puma"
   if (! ((IsF77 (exp->BTE_LIST.Next)))) goto yyL15;
  }
  }
   return true;
yyL15:;

  break;
  case kBTE_EMPTY:
# line 163 "Accepted.puma"
   return true;

  case kBTP_LIST:
# line 166 "Accepted.puma"
  {
# line 167 "Accepted.puma"
   if (! ((IsF77 (exp->BTP_LIST.Elem)))) goto yyL17;
  {
# line 168 "Accepted.puma"
   if (! ((IsF77 (exp->BTP_LIST.Next)))) goto yyL17;
  }
  }
   return true;
yyL17:;

  break;
  case kBTP_EMPTY:
# line 171 "Accepted.puma"
   return true;

  case kVAR_PARAM:
  if (exp->VAR_PARAM.V->Kind == kADDR) {
# line 174 "Accepted.puma"
  {
# line 175 "Accepted.puma"
   if (! ((IsF77 (exp->VAR_PARAM.V->ADDR.E)))) goto yyL19;
  }
   return true;
yyL19:;

  }
# line 178 "Accepted.puma"
  {
# line 179 "Accepted.puma"
   if (! ((IsF77 (exp->VAR_PARAM.V)))) goto yyL20;
  }
   return true;
yyL20:;

  break;
  case kNO_PARAM:
# line 182 "Accepted.puma"
   return true;

  case kUSED_VAR:
# line 185 "Accepted.puma"
   return true;

  case kLOOP_VAR:
# line 188 "Accepted.puma"
   return true;

  case kSUBSTRING_VAR:
  if (exp->SUBSTRING_VAR.IND_EXP->Kind == kSLICE_EXP) {
# line 191 "Accepted.puma"
  {
# line 193 "Accepted.puma"
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_VAR)))) goto yyL24;
  {
# line 194 "Accepted.puma"
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_EXP->SLICE_EXP.START)))) goto yyL24;
  {
# line 195 "Accepted.puma"
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_EXP->SLICE_EXP.STOP)))) goto yyL24;
  }
  }
  }
   return true;
yyL24:;

  }
  break;
  case kINDEXED_VAR:
# line 198 "Accepted.puma"
  {
# line 200 "Accepted.puma"
   if (! ((IsF77 (exp->INDEXED_VAR.IND_VAR)))) goto yyL25;
  {
# line 201 "Accepted.puma"
   if (! ((TreeRank (exp) == 0))) goto yyL25;
  {
# line 202 "Accepted.puma"
   if (! ((IsF77 (exp->INDEXED_VAR.IND_EXPS)))) goto yyL25;
  }
  }
  }
   return true;
yyL25:;

  break;
  }

  return false;
}

bool DoLoopExpression
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{

  switch (t->Kind) {
  case kVAR_PARAM:
# line 221 "Accepted.puma"
  {
# line 223 "Accepted.puma"
   if (! ((DoLoopExpression (t->VAR_PARAM.V)))) goto yyL1;
  }
   return true;
yyL1:;

  break;
  case kADDR:
# line 226 "Accepted.puma"
  {
# line 228 "Accepted.puma"
   if (! ((DoLoopExpression (t->ADDR.E)))) goto yyL2;
  }
   return true;
yyL2:;

  break;
  case kVAR_EXP:
# line 231 "Accepted.puma"
  {
# line 233 "Accepted.puma"
   if (! ((DoLoopExpression (t->VAR_EXP.V)))) goto yyL3;
  }
   return true;
yyL3:;

  break;
  case kUSED_VAR:
# line 236 "Accepted.puma"
   return true;

  case kLOOP_VAR:
# line 239 "Accepted.puma"
   return true;

  case kCONST_EXP:
# line 242 "Accepted.puma"
   return true;

  case kOP_EXP:
# line 245 "Accepted.puma"
  {
# line 247 "Accepted.puma"
   if (! ((DoLoopExpression (t->OP_EXP.OPND1)))) goto yyL7;
  {
# line 248 "Accepted.puma"
   if (! ((DoLoopExpression (t->OP_EXP.OPND2)))) goto yyL7;
  }
  }
   return true;
yyL7:;

  break;
  case kOP1_EXP:
# line 251 "Accepted.puma"
  {
# line 253 "Accepted.puma"
   if (! ((DoLoopExpression (t->OP1_EXP.OPND)))) goto yyL8;
  }
   return true;
yyL8:;

  break;
  case kSLICE_EXP:
# line 256 "Accepted.puma"
  {
# line 258 "Accepted.puma"
   if (! ((DoLoopExpression (t->SLICE_EXP.START)))) goto yyL9;
  {
# line 259 "Accepted.puma"
   if (! ((DoLoopExpression (t->SLICE_EXP.STOP)))) goto yyL9;
  {
# line 260 "Accepted.puma"
   if (! ((DoLoopExpression (t->SLICE_EXP.INC)))) goto yyL9;
  }
  }
  }
   return true;
yyL9:;

  break;
  case kDUMMY_EXP:
# line 263 "Accepted.puma"
   return true;

  case kBOUND_EXP:
# line 266 "Accepted.puma"
   return true;

  case kARRAY_EXP:
  if (t->ARRAY_EXP.ELEMENTS->Kind == kBTE_LIST) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Elem->Kind == kSLICE_EXP) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Next->Kind == kBTE_EMPTY) {
# line 269 "Accepted.puma"
   return true;

  }
  }
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Elem->Kind == kDO_EXP) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Next->Kind == kBTE_EMPTY) {
# line 272 "Accepted.puma"
   return true;

  }
  }
  }
  break;
  case kINDEXED_VAR:
# line 275 "Accepted.puma"
  {
# line 277 "Accepted.puma"
   if (! ((DoLoopExpression (t->INDEXED_VAR.IND_EXPS)))) goto yyL14;
  }
   return true;
yyL14:;

  break;
  case kBTE_LIST:
# line 280 "Accepted.puma"
  {
# line 282 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTE_LIST.Elem)))) goto yyL15;
  {
# line 283 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTE_LIST.Next)))) goto yyL15;
  }
  }
   return true;
yyL15:;

  break;
  case kBTE_EMPTY:
# line 286 "Accepted.puma"
   return true;

  case kBTV_LIST:
# line 289 "Accepted.puma"
  {
# line 291 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTV_LIST.Elem)))) goto yyL17;
  {
# line 292 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTV_LIST.Next)))) goto yyL17;
  }
  }
   return true;
yyL17:;

  break;
  case kBTV_EMPTY:
# line 295 "Accepted.puma"
   return true;

  case kDO_VAR:
# line 298 "Accepted.puma"
  {
# line 300 "Accepted.puma"
   if (! ((DoLoopExpression (t->DO_VAR.BODY)))) goto yyL19;
  }
   return true;
yyL19:;

  break;
  case kDO_EXP:
# line 303 "Accepted.puma"
  {
# line 305 "Accepted.puma"
   if (! ((DoLoopExpression (t->DO_EXP.BODY)))) goto yyL20;
  }
   return true;
yyL20:;

  break;
  case kFUNC_CALL_EXP:
# line 312 "Accepted.puma"
  {
# line 314 "Accepted.puma"
   if (! ((IsPureCall (t)))) goto yyL21;
  {
# line 315 "Accepted.puma"
   if (! ((IntrFuncElemental (t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL21;
  {
# line 316 "Accepted.puma"
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL21;
  }
  }
  }
   return true;
yyL21:;

# line 323 "Accepted.puma"
  {
# line 325 "Accepted.puma"
   if (! ((IsIntrCall (t)))) goto yyL22;
  {
# line 326 "Accepted.puma"
   if (! ((IntrFuncInquiry (t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL22;
  {
# line 327 "Accepted.puma"
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL22;
  }
  }
  }
   return true;
yyL22:;

  if (t->FUNC_CALL_EXP.FUNC_PARAMS->Kind == kBTP_LIST) {
  if (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->Kind == kBTP_LIST) {
# line 334 "Accepted.puma"
 {
  bool found;
  int val;
  {
# line 336 "Accepted.puma"
   if (! ((IsIntrCall (t)))) goto yyL23;
  {
# line 337 "Accepted.puma"
   if (! ((IsIdent ("SPREAD") == t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident))) goto yyL23;
  {
# line 341 "Accepted.puma"

# line 342 "Accepted.puma"

# line 344 "Accepted.puma"
   GetIntConstValue (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->BTP_LIST.Elem, & found, & val);
# line 345 "Accepted.puma"
   if (! ((found))) goto yyL23;
  {
# line 347 "Accepted.puma"
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Elem)))) goto yyL23;
  }
  }
  }
  }
   return true;
 }
yyL23:;

  if (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->BTP_LIST.Elem->Kind == kNO_PARAM) {
# line 354 "Accepted.puma"
  {
# line 357 "Accepted.puma"
   if (! ((IsIntrCall (t)))) goto yyL24;
  {
# line 358 "Accepted.puma"
   if (! ((IsIdent ("TRANSPOSE") == t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident))) goto yyL24;
  {
# line 360 "Accepted.puma"
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Elem)))) goto yyL24;
  }
  }
  }
   return true;
yyL24:;

  }
  }
  }
  break;
  case kBTP_LIST:
# line 363 "Accepted.puma"
  {
# line 365 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTP_LIST.Elem)))) goto yyL25;
  {
# line 366 "Accepted.puma"
   if (! ((DoLoopExpression (t->BTP_LIST.Next)))) goto yyL25;
  }
  }
   return true;
yyL25:;

  break;
  case kBTP_EMPTY:
# line 369 "Accepted.puma"
   return true;

  case kNO_PARAM:
# line 372 "Accepted.puma"
   return true;

  }

  return false;
}

void BeginAccepted ()
{
}

void CloseAccepted ()
{
}
