# include "FArguments.h"
# include "yyFArguments.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 22 "FArguments.puma"

 
# define  MODULE "FArguments"
 
# include "Idents.h"
# include "Rank.h"
# include "protocol.h"

# include "Distributions.h"
# include "Objects.h"
# include "Nesting.h"
 


static void yyExit () { Exit (1); }

void (* FArguments_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module FArguments, routine %s failed\n", yyFunction);
 FArguments_Exit ();
}

bool FixedSizeArray ARGS((tDefinitions obj));
bool IsPointerDummy ARGS((tDefinitions dummy));
bool IsOnlyReadParam ARGS((tTree param));

bool FixedSizeArray
# if defined __STDC__ | defined __cplusplus
(register tDefinitions obj)
# else
(obj)
 register tDefinitions obj;
# endif
{
  if (obj->Kind == kVarObject) {
  if (obj->VarObject.Kind->Kind == kVarLocal) {
# line 45 "FArguments.puma"
  {
# line 46 "FArguments.puma"
   if (! ((obj->VarObject.Kind->VarLocal.dynamic == arr_fixed_size))) goto yyL1;
  {
# line 47 "FArguments.puma"
   if (! ((VarDistribution (obj) <= 0))) goto yyL1;
  {
# line 48 "FArguments.puma"
   if (! ((! IsDynamic (obj)))) goto yyL1;
  }
  }
  }
   return true;
yyL1:;

  }
  if (obj->VarObject.Kind->Kind == kVarCommon) {
# line 51 "FArguments.puma"
  {
# line 52 "FArguments.puma"
   if (! ((! IsVarAllocatable (obj)))) goto yyL2;
  {
# line 53 "FArguments.puma"
   if (! ((VarDistribution (obj) <= 0))) goto yyL2;
  {
# line 54 "FArguments.puma"
   if (! ((! IsDynamic (obj)))) goto yyL2;
  }
  }
  }
   return true;
yyL2:;

  }
  if (obj->VarObject.Kind->Kind == kVarDummy) {
# line 57 "FArguments.puma"
  {
# line 58 "FArguments.puma"
   if (! ((IsPointerDummy (obj)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  }
  return false;
}

bool IsPointerDummy
# if defined __STDC__ | defined __cplusplus
(register tDefinitions dummy)
# else
(dummy)
 register tDefinitions dummy;
# endif
{
  if (dummy->Kind == kFuncObject) {
# line 74 "FArguments.puma"
   return true;

  }
  if (dummy->Kind == kProcObject) {
# line 77 "FArguments.puma"
   return true;

  }
  if (dummy->Kind == kVarObject) {
  if (dummy->VarObject.Kind->Kind == kVarDummy) {
# line 82 "FArguments.puma"
  {
# line 83 "FArguments.puma"
   if (! ((VarRank (dummy) == 0))) goto yyL3;
  }
   return true;
yyL3:;

# line 86 "FArguments.puma"
  {
# line 87 "FArguments.puma"
   if (! ((IsVarAssumedSize (dummy)))) goto yyL4;
  }
   return true;
yyL4:;

# line 90 "FArguments.puma"
  {
# line 92 "FArguments.puma"
   if (! ((! IsVarAssumedShape (dummy)))) goto yyL5;
  {
# line 93 "FArguments.puma"
   if (! ((GetCurrentModel () == HPF_SERIAL))) goto yyL5;
  }
  }
   return true;
yyL5:;

# line 96 "FArguments.puma"
  {
# line 97 "FArguments.puma"
   return false;
  }

  }
  }
  return false;
}

bool IsOnlyReadParam
# if defined __STDC__ | defined __cplusplus
(register tTree param)
# else
(param)
 register tTree param;
# endif
{
  if (param->Kind == kVAR_PARAM) {
  if (param->VAR_PARAM.V->Kind == kADDR) {
# line 125 "FArguments.puma"
   return true;

  }
  if (param->VAR_PARAM.V->Kind == kUSED_VAR) {
# line 128 "FArguments.puma"
  {
# line 130 "FArguments.puma"
   if (! ((IsVarParameter (param->VAR_PARAM.V->USED_VAR.VARNAME->VAR_OBJ.Object)))) goto yyL2;
  }
   return true;
yyL2:;

  }
# line 133 "FArguments.puma"
  {
# line 135 "FArguments.puma"
   if (! ((param->VAR_PARAM.intent == IntentIn))) goto yyL3;
  }
   return true;
yyL3:;

  }
  return false;
}

void BeginFArguments ()
{
}

void CloseFArguments ()
{
}
