# include "RemoteAccess.h"
# include "yyRemoteAccess.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

# line 17 "RemoteAccess.puma"


# include <stdio.h>
# include "Idents.h"
# include "StringMem.h"

# include "protocol.h"

# include "Types.h"

# define MODULE "RemoteAccess"



static void yyExit () { Exit (1); }

void (* RemoteAccess_Exit) () = yyExit;

static FILE * yyf = stdout;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module RemoteAccess, routine %s failed\n", yyFunction);
 RemoteAccess_Exit ();
}

tTree TranslateRMA ARGS((tTree stmt));
static void Find_RMA_Read ARGS((tTree lhs, tTree rhs, bool * yyP3, tTree * yyP2, tTree * yyP1));
static void Find_RMA_Write ARGS((tTree lhs, tTree rhs, bool * yyP7, tTree * yyP6, tTree * yyP5, int * yyP4));
static tTree GetUsedVar ARGS((tTree var));
static bool LocalAccess ARGS((tTree exp));
static bool LocalVar ARGS((tTree var));

tTree TranslateRMA
# if defined __STDC__ | defined __cplusplus
(register tTree stmt)
# else
(stmt)
 register tTree stmt;
# endif
{
  if (stmt->Kind == kACF_BASIC) {
  if (stmt->ACF_BASIC.BASIC_STMT->Kind == kASSIGN_STMT) {
# line 39 "RemoteAccess.puma"
 {
  bool yyV1;
  tTree yyV2;
  tTree yyV3;
  {
# line 41 "RemoteAccess.puma"
   Find_RMA_Read (stmt->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_VAR, stmt->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_EXP, & yyV1, & yyV2, & yyV3);
# line 43 "RemoteAccess.puma"
   if (! ((yyV1))) goto yyL1;
  }
  {
   return mACF_RM_READ (yyV3, yyV2);
  }
 }
yyL1:;

# line 48 "RemoteAccess.puma"
 {
  bool yyV1;
  tTree yyV2;
  tTree yyV3;
  int yyV4;
  {
# line 50 "RemoteAccess.puma"
   Find_RMA_Write (stmt->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_VAR, stmt->ACF_BASIC.BASIC_STMT->ASSIGN_STMT.ASSIGN_EXP, & yyV1, & yyV2, & yyV3, & yyV4);
# line 52 "RemoteAccess.puma"
   if (! ((yyV1))) goto yyL2;
  }
  {
   return mACF_RM_WRITE (yyV4, yyV2, yyV3);
  }
 }
yyL2:;

  }
  }
# line 57 "RemoteAccess.puma"
   return stmt;

}

static void Find_RMA_Read
# if defined __STDC__ | defined __cplusplus
(register tTree lhs, register tTree rhs, register bool * yyP3, register tTree * yyP2, register tTree * yyP1)
# else
(lhs, rhs, yyP3, yyP2, yyP1)
 register tTree lhs;
 register tTree rhs;
 register bool * yyP3;
 register tTree * yyP2;
 register tTree * yyP1;
# endif
{
  if (rhs->Kind == kVAR_EXP) {
  if (rhs->VAR_EXP.V->Kind == kREMOTE_VAR) {
# line 74 "RemoteAccess.puma"
   * yyP3 = true;
   * yyP2 = rhs->VAR_EXP.V->REMOTE_VAR.VAR;
   * yyP1 = lhs;
   return;

  }
  }
# line 77 "RemoteAccess.puma"
   * yyP3 = false;
   * yyP2 = NoTree;
   * yyP1 = NoTree;
   return;

;
}

static void Find_RMA_Write
# if defined __STDC__ | defined __cplusplus
(register tTree lhs, register tTree rhs, register bool * yyP7, register tTree * yyP6, register tTree * yyP5, register int * yyP4)
# else
(lhs, rhs, yyP7, yyP6, yyP5, yyP4)
 register tTree lhs;
 register tTree rhs;
 register bool * yyP7;
 register tTree * yyP6;
 register tTree * yyP5;
 register int * yyP4;
# endif
{
  if (lhs->Kind == kREMOTE_VAR) {
# line 92 "RemoteAccess.puma"
  {
# line 94 "RemoteAccess.puma"
   if (! ((LocalAccess (rhs)))) goto yyL1;
  }
   * yyP7 = true;
   * yyP6 = lhs->REMOTE_VAR.VAR;
   * yyP5 = rhs;
   * yyP4 = 0;
   return;
yyL1:;

# line 97 "RemoteAccess.puma"
 {
  tTree fn;
  tTree exp;
  tTree red_exp;
  int op;
  {
# line 99 "RemoteAccess.puma"

# line 100 "RemoteAccess.puma"

# line 102 "RemoteAccess.puma"

# line 104 "RemoteAccess.puma"
   CheckReduction (lhs->REMOTE_VAR.VAR, rhs, GetUsedVar (lhs->REMOTE_VAR.VAR), & fn, & red_exp);
# line 106 "RemoteAccess.puma"
   if (! ((fn != NoTree))) goto yyL2;
  {
# line 108 "RemoteAccess.puma"

# line 110 "RemoteAccess.puma"
   op = GetGlobalOp (TreeType (lhs->REMOTE_VAR.VAR), fn->PROC_OBJ.Ident);
  }
  }
   * yyP7 = true;
   * yyP6 = lhs->REMOTE_VAR.VAR;
   * yyP5 = red_exp;
   * yyP4 = op;
   return;
 }
yyL2:;

  }
# line 113 "RemoteAccess.puma"
   * yyP7 = false;
   * yyP6 = NoTree;
   * yyP5 = NoTree;
   * yyP4 = 0;
   return;

;
}

static tTree GetUsedVar
# if defined __STDC__ | defined __cplusplus
(register tTree var)
# else
(var)
 register tTree var;
# endif
{
  if (var->Kind == kUSED_VAR) {
# line 118 "RemoteAccess.puma"
   return var;

  }
  if (var->Kind == kINDEXED_VAR) {
# line 123 "RemoteAccess.puma"
   return GetUsedVar (var->INDEXED_VAR.IND_VAR);

  }
  if (var->Kind == kREMOTE_VAR) {
# line 128 "RemoteAccess.puma"
   return GetUsedVar (var->REMOTE_VAR.VAR);

  }
# line 133 "RemoteAccess.puma"
   return var;

}

static bool LocalAccess
# if defined __STDC__ | defined __cplusplus
(register tTree exp)
# else
(exp)
 register tTree exp;
# endif
{
  if (exp->Kind == kOP_EXP) {
# line 148 "RemoteAccess.puma"
  {
# line 150 "RemoteAccess.puma"
   if (! ((LocalAccess (exp->OP_EXP.OPND1)))) goto yyL1;
  {
# line 151 "RemoteAccess.puma"
   if (! ((LocalAccess (exp->OP_EXP.OPND2)))) goto yyL1;
  }
  }
   return true;
yyL1:;

  }
  if (exp->Kind == kOP1_EXP) {
# line 154 "RemoteAccess.puma"
  {
# line 156 "RemoteAccess.puma"
   if (! ((LocalAccess (exp->OP1_EXP.OPND)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (exp->Kind == kVAR_EXP) {
# line 159 "RemoteAccess.puma"
  {
# line 161 "RemoteAccess.puma"
   if (! ((LocalVar (exp->VAR_EXP.V)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (exp->Kind == kBTE_LIST) {
# line 164 "RemoteAccess.puma"
  {
# line 166 "RemoteAccess.puma"
   if (! ((LocalAccess (exp->BTE_LIST.Elem)))) goto yyL4;
  {
# line 167 "RemoteAccess.puma"
   if (! ((LocalAccess (exp->BTE_LIST.Next)))) goto yyL4;
  }
  }
   return true;
yyL4:;

  }
  if (exp->Kind == kBTE_EMPTY) {
# line 170 "RemoteAccess.puma"
   return true;

  }
  if (exp->Kind == kCONST_EXP) {
# line 173 "RemoteAccess.puma"
   return true;

  }
  return false;
}

static bool LocalVar
# if defined __STDC__ | defined __cplusplus
(register tTree var)
# else
(var)
 register tTree var;
# endif
{
  if (var->Kind == kREMOTE_VAR) {
# line 186 "RemoteAccess.puma"
  {
# line 188 "RemoteAccess.puma"
   return false;
  }

  }
  if (var->Kind == kINDEXED_VAR) {
# line 191 "RemoteAccess.puma"
  {
# line 193 "RemoteAccess.puma"
   if (! ((LocalAccess (var->INDEXED_VAR.IND_EXPS)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (var->Kind == kUSED_VAR) {
# line 196 "RemoteAccess.puma"
   return true;

  }
  if (var->Kind == kLOOP_VAR) {
# line 199 "RemoteAccess.puma"
   return true;

  }
  return false;
}

void BeginRemoteAccess ()
{
}

void CloseRemoteAccess ()
{
}
