# include "Tree.inc"

void MyPutStringRef (yyf, t)
FILE *yyf;
tStringRef t;

{ char string[256];
  int  length;
  int  i;

  StGetString (t, string);
  length = strlen (string);

  fwrite (&length, sizeof(length), 1, yyf);

  for (i=0; i<length; i++)
    (void) fputc (string[i], yyf);

} /* MyPutStringRef */

tStringRef MyGetStringRef (yyf)
FILE *yyf;

{ char string[256];
  int  length;
  int  i;

  fread (&length, sizeof(length), 1, yyf);

  for (i=0; i<length; i++)
    string[i] = fgetc (yyf);

  return PutString (string, length);

} /* MyGetStringRef */


void (* Tree_Exit) () = yyExit;

typedef struct yysBlock {
 char yyBlock [yyBlockSize];
 struct yysBlock * yySuccessor;
} yytBlock, * yytBlockPtr;

tTree TreeRoot;
unsigned long Tree_HeapUsed = 0;

static yytBlockPtr yyBlockList	= (yytBlockPtr) NoTree;
char * Tree_PoolFreePtr	= (char *) NoTree;
char * Tree_PoolMaxPtr	= (char *) NoTree;

unsigned short Tree_NodeSize [311 + 1] = { 0,
 sizeof (yCOMP_UNIT),
 sizeof (yUNIT_NODE_LIST),
 sizeof (yUNIT_EMPTY),
 sizeof (yUNIT_LIST),
 sizeof (yUNIT_NODE),
 sizeof (yMODULE_DECL),
 sizeof (yPROGRAM_DECL),
 sizeof (yPROC_DECL),
 sizeof (yFUNC_DECL),
 sizeof (yMODULE_PROC_DECL),
 sizeof (yBLOCK_DATA_DECL),
 sizeof (yINTERFACE),
 sizeof (yBODY_NODE),
 sizeof (yTYPE_NODE),
 sizeof (yDUMMY_TYPE),
 sizeof (yALIGN_TYPE),
 sizeof (yINTEGER_TYPE),
 sizeof (yREAL_TYPE),
 sizeof (yBOOLEAN_TYPE),
 sizeof (yCOMPLEX_TYPE),
 sizeof (ySTRING_TYPE),
 sizeof (yTYPE_ID),
 sizeof (yARRAY_TYPE),
 sizeof (yRECORD_TYPE),
 sizeof (yPOINTER_TYPE),
 sizeof (ySHAPE_SPEC),
 sizeof (yEXPLICIT_SHAPE),
 sizeof (yASSUMED_SHAPE),
 sizeof (yDEFERRED_SHAPE),
 sizeof (yASSUMED_SIZE),
 sizeof (ySHAPE_SPEC_LIST),
 sizeof (ySHAPE_EMPTY),
 sizeof (ySHAPE_LIST),
 sizeof (yDECL_NODE),
 sizeof (yTYPE_DECL),
 sizeof (yNAME_DECL),
 sizeof (yRENAME_DECL),
 sizeof (yENTITY_DECL),
 sizeof (yVAR_DECL),
 sizeof (yCOMMON_DECL),
 sizeof (yNAMELIST_DECL),
 sizeof (yTEMPLATE_DECL),
 sizeof (yRAGGED_DECL),
 sizeof (yPROCESSORS_DECL),
 sizeof (ySUB_PROCS_DECL),
 sizeof (yINHERIT_DECL),
 sizeof (yRANGE_DECL),
 sizeof (ySTMT_FUNC_DECL),
 sizeof (yINTERFACE_DECL),
 sizeof (yVAR_PARAM_DECL),
 sizeof (yRET_PARAM_DECL),
 sizeof (yIMPLICIT_DECL),
 sizeof (yUSE_DECL),
 sizeof (yONLY_USE_DECL),
 sizeof (yEQV_DECL),
 sizeof (yDATA_DECL),
 sizeof (yFORMAT_DECL),
 sizeof (yDIMENSION_DECL),
 sizeof (yINIT_DATA_DECL),
 sizeof (yTYPESPEC_DECL),
 sizeof (yALLOCATABLE_DECL),
 sizeof (yEXTERNAL_DECL),
 sizeof (yINTENT_DECL),
 sizeof (yINTRINSIC_DECL),
 sizeof (yOPTIONAL_DECL),
 sizeof (yPOINTER_DECL),
 sizeof (ySAVE_DECL),
 sizeof (yTARGET_DECL),
 sizeof (yPARAMETER_DECL),
 sizeof (yPUBLIC_DECL),
 sizeof (yPRIVATE_DECL),
 sizeof (ySEQUENCE_DECL),
 sizeof (yDISTRIBUTE_DECL),
 sizeof (yALIGN_DECL),
 sizeof (yMAP_DECL),
 sizeof (yOVERLAP_DECL),
 sizeof (ySHARED_DECL),
 sizeof (yDYNAMIC_DECL),
 sizeof (yTRACE_DECL),
 sizeof (yTREE_DECL),
 sizeof (ySELECT_DECL),
 sizeof (yHPF_SEQUENCE_DECL),
 sizeof (yNOSEQUENCE_DECL),
 sizeof (yLAYOUT_DECL),
 sizeof (yPASS_BY_DECL),
 sizeof (yMAP_TO_DECL),
 sizeof (yDECL_NODE_LIST),
 sizeof (yDECL_EMPTY),
 sizeof (yDECL_LIST),
 sizeof (yRANGE_SPEC_LIST),
 sizeof (yRANGE_EMPTY),
 sizeof (yRANGE_LIST),
 sizeof (ySELECT_SPEC_LIST),
 sizeof (ySELECT_EMPTY),
 sizeof (ySELECT_LIST),
 sizeof (ySELECT_SPEC),
 sizeof (yDISTRIBUTION_SPEC),
 sizeof (yANY_DISTRIBUTION),
 sizeof (yDEFAULT_DISTRIBUTION),
 sizeof (yREPL_DISTRIBUTION),
 sizeof (yNODE_DISTRIBUTION),
 sizeof (yDIST_FORMAT_LIST),
 sizeof (yDIST_EMPTY),
 sizeof (yDIST_LIST),
 sizeof (yDISTRIBUTION_FORMAT),
 sizeof (yBLOCK_DISTRIBUTION),
 sizeof (yCYCLIC_DISTRIBUTION),
 sizeof (yGEN_BLOCK_DISTRIBUTION),
 sizeof (yINDIRECT_DISTRIBUTION),
 sizeof (yARBITRARY_DISTRIBUTION),
 sizeof (ySERIAL_DISTRIBUTION),
 sizeof (yANY_BLOCK_DISTRIBUTION),
 sizeof (yANY_CYCLIC_DISTRIBUTION),
 sizeof (yANY_GEN_BLOCK_DISTRIBUTION),
 sizeof (yANY_INDIRECT_DISTRIBUTION),
 sizeof (yANY_ARBITRARY_DISTRIBUTION),
 sizeof (yANY_DIM_DISTRIBUTION),
 sizeof (yPROCESSOR_SPEC),
 sizeof (yANY_PROCESSOR_ARRAY),
 sizeof (yDEFAULT_PROCESSOR_ARRAY),
 sizeof (yPROCESSOR_ARRAY),
 sizeof (yPROCESSOR_SUBSET),
 sizeof (yALIGN_SPEC),
 sizeof (yGENERIC_SPEC),
 sizeof (yNO_GENERIC_SPEC),
 sizeof (yID_GENERIC_SPEC),
 sizeof (yOP_GENERIC_SPEC),
 sizeof (yASSIGN_GENERIC_SPEC),
 sizeof (yACF_NODE_LIST),
 sizeof (yACF_EMPTY),
 sizeof (yACF_LIST),
 sizeof (yACF_NODE),
 sizeof (yACF_DUMMY),
 sizeof (yACF_BASIC),
 sizeof (yACF_IF),
 sizeof (yACF_WHERE),
 sizeof (yACF_CASE),
 sizeof (yACF_WHILE),
 sizeof (yACF_REPEAT),
 sizeof (yACF_LOOP),
 sizeof (yACF_DO),
 sizeof (yACF_FORALL),
 sizeof (yACF_FLOW_GRAPH),
 sizeof (yACF_ENTRY),
 sizeof (yACF_HOME),
 sizeof (yACF_RESIDENT),
 sizeof (yACF_NEW),
 sizeof (yACF_REDUCTION),
 sizeof (yACF_TASK_REGION),
 sizeof (yACF_PARALLEL),
 sizeof (yACF_CRITICAL),
 sizeof (yACF_ON),
 sizeof (yACF_RM_READ),
 sizeof (yACF_RM_WRITE),
 sizeof (yACF_MOVE),
 sizeof (yACF_BARRIER),
 sizeof (yACF_UPDATE),
 sizeof (yACF_FLOW_KIND),
 sizeof (yACF_COMPLEX_FLOW),
 sizeof (yACF_INTERVAL_FLOW),
 sizeof (yACF_SIMPLE_FLOW),
 sizeof (yON_CLAUSE),
 sizeof (yON_HOST_CLAUSE),
 sizeof (yON_ALL_CLAUSE),
 sizeof (yON_VAR_CLAUSE),
 sizeof (yON_PROC_CLAUSE),
 sizeof (yON_TOPOLOGY),
 sizeof (yON_ALL),
 sizeof (yON_HOST),
 sizeof (yON_PROCS),
 sizeof (yON_VAR),
 sizeof (yON_SPEC_LIST),
 sizeof (yON_EMPTY),
 sizeof (yON_LIST),
 sizeof (yON_SPEC),
 sizeof (ySELECTED_ACF_NODE_LIST),
 sizeof (ySELECTED_ACF_EMPTY),
 sizeof (ySELECTED_ACF_LIST),
 sizeof (ySELECTED_ACF_NODE),
 sizeof (yBT_STMT),
 sizeof (yASSIGN_STMT),
 sizeof (yPTR_ASSIGN_STMT),
 sizeof (yLABEL_ASSIGN_STMT),
 sizeof (yCALL_STMT),
 sizeof (yIO_STMT),
 sizeof (yGOTO_STMT),
 sizeof (yASS_GOTO_STMT),
 sizeof (yCOMP_GOTO_STMT),
 sizeof (yCOMP_IF_STMT),
 sizeof (yRETURN_STMT),
 sizeof (yPAUSE_STMT),
 sizeof (yEXIT_STMT),
 sizeof (yCYCLE_STMT),
 sizeof (ySTOP_STMT),
 sizeof (yFORMAT_STMT),
 sizeof (yINHERIT_DSP_STMT),
 sizeof (yCREATE_DSP_STMT),
 sizeof (yFREE_DSP_STMT),
 sizeof (yALLOCATE_STMT),
 sizeof (yDEALLOCATE_STMT),
 sizeof (yNULLIFY_STMT),
 sizeof (yREDUCE_STMT),
 sizeof (yMOVE_STMT),
 sizeof (ySCATTER_STMT),
 sizeof (yREALIGN_STMT),
 sizeof (yREDISTRIBUTE_STMT),
 sizeof (yREG_SHADOW_GET),
 sizeof (yREG_SHADOW_PUT),
 sizeof (yREG_SHADOW_SET),
 sizeof (yIND_SHADOW_CREATE),
 sizeof (yIND_SHADOW_FREE),
 sizeof (yIND_SHADOW_GET),
 sizeof (yIND_SHADOW_PUT),
 sizeof (yIND_SHADOW_SET),
 sizeof (yBROADCAST_STMT),
 sizeof (yREDUCTION_STMT),
 sizeof (yDIRTY_STMT),
 sizeof (yLABEL_USE_LIST),
 sizeof (yLABEL_EMPTY),
 sizeof (yLABEL_LIST),
 sizeof (yOP),
 sizeof (yOP_EQ),
 sizeof (yOP_NE),
 sizeof (yOP_LT),
 sizeof (yOP_GT),
 sizeof (yOP_GE),
 sizeof (yOP_LE),
 sizeof (yOP_PLUS),
 sizeof (yOP_MINUS),
 sizeof (yOP_XOR),
 sizeof (yOP_OR),
 sizeof (yOP_CONCAT),
 sizeof (yOP_TIMES),
 sizeof (yOP_DIVIDE),
 sizeof (yOP_AND),
 sizeof (yOP_EQV),
 sizeof (yOP_NEQV),
 sizeof (yOP_EXPO),
 sizeof (yOP_DEFINED),
 sizeof (yOP_ASSIGN),
 sizeof (yOP1_NOT),
 sizeof (yOP1_SIGN),
 sizeof (yOP1_PSIGN),
 sizeof (yBT_EXP),
 sizeof (yDUMMY_EXP),
 sizeof (yCONST_EXP),
 sizeof (yOP_EXP),
 sizeof (yOP1_EXP),
 sizeof (ySLICE_EXP),
 sizeof (yVAR_EXP),
 sizeof (yFUNC_CALL_EXP),
 sizeof (yNAMED_EXP),
 sizeof (yDO_EXP),
 sizeof (yTYPE_EXP),
 sizeof (yARRAY_EXP),
 sizeof (yPERM_EXP),
 sizeof (yBOUND_EXP),
 sizeof (yRANK_EXP),
 sizeof (yBT_EXP_LIST),
 sizeof (yBTE_EMPTY),
 sizeof (yBTE_LIST),
 sizeof (yBT_VAR),
 sizeof (yDUMMY_VAR),
 sizeof (yUSED_VAR),
 sizeof (yINDEXED_VAR),
 sizeof (ySUBSTRING_VAR),
 sizeof (ySELECTED_VAR),
 sizeof (yLOOP_VAR),
 sizeof (yPERM_VAR),
 sizeof (yADDR),
 sizeof (yDO_VAR),
 sizeof (yREMOTE_VAR),
 sizeof (yBT_VAR_LIST),
 sizeof (yBTV_EMPTY),
 sizeof (yBTV_LIST),
 sizeof (yBT_PARAM),
 sizeof (yVAR_PARAM),
 sizeof (yVALUE_PARAM),
 sizeof (yNAMED_PARAM),
 sizeof (yPROC_PARAM),
 sizeof (yFUNC_PARAM),
 sizeof (yFORMAT_PARAM),
 sizeof (yRETURN_PARAM),
 sizeof (yNO_PARAM),
 sizeof (yBT_PARAM_LIST),
 sizeof (yBTP_EMPTY),
 sizeof (yBTP_LIST),
 sizeof (yCONSTANT),
 sizeof (yBOOL_CONSTANT),
 sizeof (yINT_CONSTANT),
 sizeof (yREAL_CONSTANT),
 sizeof (ySTRING_CONSTANT),
 sizeof (yCOMPLEX_CONSTANT),
 sizeof (yPROC_OBJ),
 sizeof (yVAR_OBJ),
 sizeof (yTYPE_OBJ),
 sizeof (yREC_COMP),
 sizeof (yTOP_OBJ),
 sizeof (yTEMP_OBJ),
 sizeof (yOVERLAP_SPEC),
 sizeof (yDEPENDENCE_INFO),
 sizeof (ySERIAL_INFO),
 sizeof (yINDEP_INFO),
 sizeof (yVECTOR_INFO),
 sizeof (yPARDO_INFO),
 sizeof (yHOME_INFO),
 sizeof (yNO_HOME_INFO),
 sizeof (yCOMM_INFO),
 sizeof (yON_INFO),
 sizeof (yPARALLEL_INFO),
 sizeof (yREACHING_INFO),
};
char * Tree_NodeName [311 + 1] = {
 "NoTree",
 "COMP_UNIT",
 "UNIT_NODE_LIST",
 "UNIT_EMPTY",
 "UNIT_LIST",
 "UNIT_NODE",
 "MODULE_DECL",
 "PROGRAM_DECL",
 "PROC_DECL",
 "FUNC_DECL",
 "MODULE_PROC_DECL",
 "BLOCK_DATA_DECL",
 "INTERFACE",
 "BODY_NODE",
 "TYPE_NODE",
 "DUMMY_TYPE",
 "ALIGN_TYPE",
 "INTEGER_TYPE",
 "REAL_TYPE",
 "BOOLEAN_TYPE",
 "COMPLEX_TYPE",
 "STRING_TYPE",
 "TYPE_ID",
 "ARRAY_TYPE",
 "RECORD_TYPE",
 "POINTER_TYPE",
 "SHAPE_SPEC",
 "EXPLICIT_SHAPE",
 "ASSUMED_SHAPE",
 "DEFERRED_SHAPE",
 "ASSUMED_SIZE",
 "SHAPE_SPEC_LIST",
 "SHAPE_EMPTY",
 "SHAPE_LIST",
 "DECL_NODE",
 "TYPE_DECL",
 "NAME_DECL",
 "RENAME_DECL",
 "ENTITY_DECL",
 "VAR_DECL",
 "COMMON_DECL",
 "NAMELIST_DECL",
 "TEMPLATE_DECL",
 "RAGGED_DECL",
 "PROCESSORS_DECL",
 "SUB_PROCS_DECL",
 "INHERIT_DECL",
 "RANGE_DECL",
 "STMT_FUNC_DECL",
 "INTERFACE_DECL",
 "VAR_PARAM_DECL",
 "RET_PARAM_DECL",
 "IMPLICIT_DECL",
 "USE_DECL",
 "ONLY_USE_DECL",
 "EQV_DECL",
 "DATA_DECL",
 "FORMAT_DECL",
 "DIMENSION_DECL",
 "INIT_DATA_DECL",
 "TYPESPEC_DECL",
 "ALLOCATABLE_DECL",
 "EXTERNAL_DECL",
 "INTENT_DECL",
 "INTRINSIC_DECL",
 "OPTIONAL_DECL",
 "POINTER_DECL",
 "SAVE_DECL",
 "TARGET_DECL",
 "PARAMETER_DECL",
 "PUBLIC_DECL",
 "PRIVATE_DECL",
 "SEQUENCE_DECL",
 "DISTRIBUTE_DECL",
 "ALIGN_DECL",
 "MAP_DECL",
 "OVERLAP_DECL",
 "SHARED_DECL",
 "DYNAMIC_DECL",
 "TRACE_DECL",
 "TREE_DECL",
 "SELECT_DECL",
 "HPF_SEQUENCE_DECL",
 "NOSEQUENCE_DECL",
 "LAYOUT_DECL",
 "PASS_BY_DECL",
 "MAP_TO_DECL",
 "DECL_NODE_LIST",
 "DECL_EMPTY",
 "DECL_LIST",
 "RANGE_SPEC_LIST",
 "RANGE_EMPTY",
 "RANGE_LIST",
 "SELECT_SPEC_LIST",
 "SELECT_EMPTY",
 "SELECT_LIST",
 "SELECT_SPEC",
 "DISTRIBUTION_SPEC",
 "ANY_DISTRIBUTION",
 "DEFAULT_DISTRIBUTION",
 "REPL_DISTRIBUTION",
 "NODE_DISTRIBUTION",
 "DIST_FORMAT_LIST",
 "DIST_EMPTY",
 "DIST_LIST",
 "DISTRIBUTION_FORMAT",
 "BLOCK_DISTRIBUTION",
 "CYCLIC_DISTRIBUTION",
 "GEN_BLOCK_DISTRIBUTION",
 "INDIRECT_DISTRIBUTION",
 "ARBITRARY_DISTRIBUTION",
 "SERIAL_DISTRIBUTION",
 "ANY_BLOCK_DISTRIBUTION",
 "ANY_CYCLIC_DISTRIBUTION",
 "ANY_GEN_BLOCK_DISTRIBUTION",
 "ANY_INDIRECT_DISTRIBUTION",
 "ANY_ARBITRARY_DISTRIBUTION",
 "ANY_DIM_DISTRIBUTION",
 "PROCESSOR_SPEC",
 "ANY_PROCESSOR_ARRAY",
 "DEFAULT_PROCESSOR_ARRAY",
 "PROCESSOR_ARRAY",
 "PROCESSOR_SUBSET",
 "ALIGN_SPEC",
 "GENERIC_SPEC",
 "NO_GENERIC_SPEC",
 "ID_GENERIC_SPEC",
 "OP_GENERIC_SPEC",
 "ASSIGN_GENERIC_SPEC",
 "ACF_NODE_LIST",
 "ACF_EMPTY",
 "ACF_LIST",
 "ACF_NODE",
 "ACF_DUMMY",
 "ACF_BASIC",
 "ACF_IF",
 "ACF_WHERE",
 "ACF_CASE",
 "ACF_WHILE",
 "ACF_REPEAT",
 "ACF_LOOP",
 "ACF_DO",
 "ACF_FORALL",
 "ACF_FLOW_GRAPH",
 "ACF_ENTRY",
 "ACF_HOME",
 "ACF_RESIDENT",
 "ACF_NEW",
 "ACF_REDUCTION",
 "ACF_TASK_REGION",
 "ACF_PARALLEL",
 "ACF_CRITICAL",
 "ACF_ON",
 "ACF_RM_READ",
 "ACF_RM_WRITE",
 "ACF_MOVE",
 "ACF_BARRIER",
 "ACF_UPDATE",
 "ACF_FLOW_KIND",
 "ACF_COMPLEX_FLOW",
 "ACF_INTERVAL_FLOW",
 "ACF_SIMPLE_FLOW",
 "ON_CLAUSE",
 "ON_HOST_CLAUSE",
 "ON_ALL_CLAUSE",
 "ON_VAR_CLAUSE",
 "ON_PROC_CLAUSE",
 "ON_TOPOLOGY",
 "ON_ALL",
 "ON_HOST",
 "ON_PROCS",
 "ON_VAR",
 "ON_SPEC_LIST",
 "ON_EMPTY",
 "ON_LIST",
 "ON_SPEC",
 "SELECTED_ACF_NODE_LIST",
 "SELECTED_ACF_EMPTY",
 "SELECTED_ACF_LIST",
 "SELECTED_ACF_NODE",
 "BT_STMT",
 "ASSIGN_STMT",
 "PTR_ASSIGN_STMT",
 "LABEL_ASSIGN_STMT",
 "CALL_STMT",
 "IO_STMT",
 "GOTO_STMT",
 "ASS_GOTO_STMT",
 "COMP_GOTO_STMT",
 "COMP_IF_STMT",
 "RETURN_STMT",
 "PAUSE_STMT",
 "EXIT_STMT",
 "CYCLE_STMT",
 "STOP_STMT",
 "FORMAT_STMT",
 "INHERIT_DSP_STMT",
 "CREATE_DSP_STMT",
 "FREE_DSP_STMT",
 "ALLOCATE_STMT",
 "DEALLOCATE_STMT",
 "NULLIFY_STMT",
 "REDUCE_STMT",
 "MOVE_STMT",
 "SCATTER_STMT",
 "REALIGN_STMT",
 "REDISTRIBUTE_STMT",
 "REG_SHADOW_GET",
 "REG_SHADOW_PUT",
 "REG_SHADOW_SET",
 "IND_SHADOW_CREATE",
 "IND_SHADOW_FREE",
 "IND_SHADOW_GET",
 "IND_SHADOW_PUT",
 "IND_SHADOW_SET",
 "BROADCAST_STMT",
 "REDUCTION_STMT",
 "DIRTY_STMT",
 "LABEL_USE_LIST",
 "LABEL_EMPTY",
 "LABEL_LIST",
 "OP",
 "OP_EQ",
 "OP_NE",
 "OP_LT",
 "OP_GT",
 "OP_GE",
 "OP_LE",
 "OP_PLUS",
 "OP_MINUS",
 "OP_XOR",
 "OP_OR",
 "OP_CONCAT",
 "OP_TIMES",
 "OP_DIVIDE",
 "OP_AND",
 "OP_EQV",
 "OP_NEQV",
 "OP_EXPO",
 "OP_DEFINED",
 "OP_ASSIGN",
 "OP1_NOT",
 "OP1_SIGN",
 "OP1_PSIGN",
 "BT_EXP",
 "DUMMY_EXP",
 "CONST_EXP",
 "OP_EXP",
 "OP1_EXP",
 "SLICE_EXP",
 "VAR_EXP",
 "FUNC_CALL_EXP",
 "NAMED_EXP",
 "DO_EXP",
 "TYPE_EXP",
 "ARRAY_EXP",
 "PERM_EXP",
 "BOUND_EXP",
 "RANK_EXP",
 "BT_EXP_LIST",
 "BTE_EMPTY",
 "BTE_LIST",
 "BT_VAR",
 "DUMMY_VAR",
 "USED_VAR",
 "INDEXED_VAR",
 "SUBSTRING_VAR",
 "SELECTED_VAR",
 "LOOP_VAR",
 "PERM_VAR",
 "ADDR",
 "DO_VAR",
 "REMOTE_VAR",
 "BT_VAR_LIST",
 "BTV_EMPTY",
 "BTV_LIST",
 "BT_PARAM",
 "VAR_PARAM",
 "VALUE_PARAM",
 "NAMED_PARAM",
 "PROC_PARAM",
 "FUNC_PARAM",
 "FORMAT_PARAM",
 "RETURN_PARAM",
 "NO_PARAM",
 "BT_PARAM_LIST",
 "BTP_EMPTY",
 "BTP_LIST",
 "CONSTANT",
 "BOOL_CONSTANT",
 "INT_CONSTANT",
 "REAL_CONSTANT",
 "STRING_CONSTANT",
 "COMPLEX_CONSTANT",
 "PROC_OBJ",
 "VAR_OBJ",
 "TYPE_OBJ",
 "REC_COMP",
 "TOP_OBJ",
 "TEMP_OBJ",
 "OVERLAP_SPEC",
 "DEPENDENCE_INFO",
 "SERIAL_INFO",
 "INDEP_INFO",
 "VECTOR_INFO",
 "PARDO_INFO",
 "HOME_INFO",
 "NO_HOME_INFO",
 "COMM_INFO",
 "ON_INFO",
 "PARALLEL_INFO",
 "REACHING_INFO",
};
static Tree_tKind yyTypeRange [311 + 1] = { 0,
 kCOMP_UNIT,
 kUNIT_LIST,
 kUNIT_EMPTY,
 kUNIT_LIST,
 kINTERFACE,
 kMODULE_DECL,
 kPROGRAM_DECL,
 kPROC_DECL,
 kFUNC_DECL,
 kMODULE_PROC_DECL,
 kBLOCK_DATA_DECL,
 kINTERFACE,
 kBODY_NODE,
 kPOINTER_TYPE,
 kDUMMY_TYPE,
 kALIGN_TYPE,
 kINTEGER_TYPE,
 kREAL_TYPE,
 kBOOLEAN_TYPE,
 kCOMPLEX_TYPE,
 kSTRING_TYPE,
 kTYPE_ID,
 kARRAY_TYPE,
 kRECORD_TYPE,
 kPOINTER_TYPE,
 kASSUMED_SIZE,
 kEXPLICIT_SHAPE,
 kASSUMED_SHAPE,
 kDEFERRED_SHAPE,
 kASSUMED_SIZE,
 kSHAPE_LIST,
 kSHAPE_EMPTY,
 kSHAPE_LIST,
 kMAP_TO_DECL,
 kTYPE_DECL,
 kNAME_DECL,
 kRENAME_DECL,
 kENTITY_DECL,
 kVAR_DECL,
 kCOMMON_DECL,
 kNAMELIST_DECL,
 kTEMPLATE_DECL,
 kRAGGED_DECL,
 kPROCESSORS_DECL,
 kSUB_PROCS_DECL,
 kINHERIT_DECL,
 kRANGE_DECL,
 kSTMT_FUNC_DECL,
 kINTERFACE_DECL,
 kVAR_PARAM_DECL,
 kRET_PARAM_DECL,
 kIMPLICIT_DECL,
 kUSE_DECL,
 kONLY_USE_DECL,
 kEQV_DECL,
 kDATA_DECL,
 kFORMAT_DECL,
 kDIMENSION_DECL,
 kINIT_DATA_DECL,
 kTYPESPEC_DECL,
 kALLOCATABLE_DECL,
 kEXTERNAL_DECL,
 kINTENT_DECL,
 kINTRINSIC_DECL,
 kOPTIONAL_DECL,
 kPOINTER_DECL,
 kSAVE_DECL,
 kTARGET_DECL,
 kPARAMETER_DECL,
 kPUBLIC_DECL,
 kPRIVATE_DECL,
 kSEQUENCE_DECL,
 kDISTRIBUTE_DECL,
 kALIGN_DECL,
 kMAP_DECL,
 kOVERLAP_DECL,
 kSHARED_DECL,
 kDYNAMIC_DECL,
 kTRACE_DECL,
 kTREE_DECL,
 kSELECT_DECL,
 kHPF_SEQUENCE_DECL,
 kNOSEQUENCE_DECL,
 kLAYOUT_DECL,
 kPASS_BY_DECL,
 kMAP_TO_DECL,
 kDECL_LIST,
 kDECL_EMPTY,
 kDECL_LIST,
 kRANGE_LIST,
 kRANGE_EMPTY,
 kRANGE_LIST,
 kSELECT_LIST,
 kSELECT_EMPTY,
 kSELECT_LIST,
 kSELECT_SPEC,
 kNODE_DISTRIBUTION,
 kANY_DISTRIBUTION,
 kDEFAULT_DISTRIBUTION,
 kREPL_DISTRIBUTION,
 kNODE_DISTRIBUTION,
 kDIST_LIST,
 kDIST_EMPTY,
 kDIST_LIST,
 kANY_DIM_DISTRIBUTION,
 kBLOCK_DISTRIBUTION,
 kCYCLIC_DISTRIBUTION,
 kGEN_BLOCK_DISTRIBUTION,
 kINDIRECT_DISTRIBUTION,
 kARBITRARY_DISTRIBUTION,
 kSERIAL_DISTRIBUTION,
 kANY_BLOCK_DISTRIBUTION,
 kANY_CYCLIC_DISTRIBUTION,
 kANY_GEN_BLOCK_DISTRIBUTION,
 kANY_INDIRECT_DISTRIBUTION,
 kANY_ARBITRARY_DISTRIBUTION,
 kANY_DIM_DISTRIBUTION,
 kPROCESSOR_SUBSET,
 kANY_PROCESSOR_ARRAY,
 kDEFAULT_PROCESSOR_ARRAY,
 kPROCESSOR_ARRAY,
 kPROCESSOR_SUBSET,
 kALIGN_SPEC,
 kASSIGN_GENERIC_SPEC,
 kNO_GENERIC_SPEC,
 kID_GENERIC_SPEC,
 kOP_GENERIC_SPEC,
 kASSIGN_GENERIC_SPEC,
 kACF_LIST,
 kACF_EMPTY,
 kACF_LIST,
 kACF_UPDATE,
 kACF_DUMMY,
 kACF_BASIC,
 kACF_IF,
 kACF_WHERE,
 kACF_CASE,
 kACF_WHILE,
 kACF_REPEAT,
 kACF_LOOP,
 kACF_DO,
 kACF_FORALL,
 kACF_FLOW_GRAPH,
 kACF_ENTRY,
 kACF_HOME,
 kACF_RESIDENT,
 kACF_NEW,
 kACF_REDUCTION,
 kACF_TASK_REGION,
 kACF_PARALLEL,
 kACF_CRITICAL,
 kACF_ON,
 kACF_RM_READ,
 kACF_RM_WRITE,
 kACF_MOVE,
 kACF_BARRIER,
 kACF_UPDATE,
 kACF_SIMPLE_FLOW,
 kACF_COMPLEX_FLOW,
 kACF_INTERVAL_FLOW,
 kACF_SIMPLE_FLOW,
 kON_PROC_CLAUSE,
 kON_HOST_CLAUSE,
 kON_ALL_CLAUSE,
 kON_VAR_CLAUSE,
 kON_PROC_CLAUSE,
 kON_VAR,
 kON_ALL,
 kON_HOST,
 kON_PROCS,
 kON_VAR,
 kON_LIST,
 kON_EMPTY,
 kON_LIST,
 kON_SPEC,
 kSELECTED_ACF_LIST,
 kSELECTED_ACF_EMPTY,
 kSELECTED_ACF_LIST,
 kSELECTED_ACF_NODE,
 kDIRTY_STMT,
 kASSIGN_STMT,
 kPTR_ASSIGN_STMT,
 kLABEL_ASSIGN_STMT,
 kCALL_STMT,
 kIO_STMT,
 kGOTO_STMT,
 kASS_GOTO_STMT,
 kCOMP_GOTO_STMT,
 kCOMP_IF_STMT,
 kRETURN_STMT,
 kPAUSE_STMT,
 kEXIT_STMT,
 kCYCLE_STMT,
 kSTOP_STMT,
 kFORMAT_STMT,
 kINHERIT_DSP_STMT,
 kCREATE_DSP_STMT,
 kFREE_DSP_STMT,
 kALLOCATE_STMT,
 kDEALLOCATE_STMT,
 kNULLIFY_STMT,
 kREDUCE_STMT,
 kMOVE_STMT,
 kSCATTER_STMT,
 kREALIGN_STMT,
 kREDISTRIBUTE_STMT,
 kREG_SHADOW_GET,
 kREG_SHADOW_PUT,
 kREG_SHADOW_SET,
 kIND_SHADOW_CREATE,
 kIND_SHADOW_FREE,
 kIND_SHADOW_GET,
 kIND_SHADOW_PUT,
 kIND_SHADOW_SET,
 kBROADCAST_STMT,
 kREDUCTION_STMT,
 kDIRTY_STMT,
 kLABEL_LIST,
 kLABEL_EMPTY,
 kLABEL_LIST,
 kOP1_PSIGN,
 kOP_EQ,
 kOP_NE,
 kOP_LT,
 kOP_GT,
 kOP_GE,
 kOP_LE,
 kOP_PLUS,
 kOP_MINUS,
 kOP_XOR,
 kOP_OR,
 kOP_CONCAT,
 kOP_TIMES,
 kOP_DIVIDE,
 kOP_AND,
 kOP_EQV,
 kOP_NEQV,
 kOP_EXPO,
 kOP_DEFINED,
 kOP_ASSIGN,
 kOP1_NOT,
 kOP1_SIGN,
 kOP1_PSIGN,
 kRANK_EXP,
 kDUMMY_EXP,
 kCONST_EXP,
 kOP_EXP,
 kOP1_EXP,
 kSLICE_EXP,
 kVAR_EXP,
 kFUNC_CALL_EXP,
 kNAMED_EXP,
 kDO_EXP,
 kTYPE_EXP,
 kARRAY_EXP,
 kPERM_EXP,
 kBOUND_EXP,
 kRANK_EXP,
 kBTE_LIST,
 kBTE_EMPTY,
 kBTE_LIST,
 kREMOTE_VAR,
 kDUMMY_VAR,
 kUSED_VAR,
 kINDEXED_VAR,
 kSUBSTRING_VAR,
 kSELECTED_VAR,
 kLOOP_VAR,
 kPERM_VAR,
 kADDR,
 kDO_VAR,
 kREMOTE_VAR,
 kBTV_LIST,
 kBTV_EMPTY,
 kBTV_LIST,
 kNO_PARAM,
 kVAR_PARAM,
 kVALUE_PARAM,
 kNAMED_PARAM,
 kPROC_PARAM,
 kFUNC_PARAM,
 kFORMAT_PARAM,
 kRETURN_PARAM,
 kNO_PARAM,
 kBTP_LIST,
 kBTP_EMPTY,
 kBTP_LIST,
 kCOMPLEX_CONSTANT,
 kBOOL_CONSTANT,
 kINT_CONSTANT,
 kREAL_CONSTANT,
 kSTRING_CONSTANT,
 kCOMPLEX_CONSTANT,
 kPROC_OBJ,
 kVAR_OBJ,
 kTYPE_OBJ,
 kREC_COMP,
 kTOP_OBJ,
 kTEMP_OBJ,
 kOVERLAP_SPEC,
 kPARDO_INFO,
 kSERIAL_INFO,
 kINDEP_INFO,
 kVECTOR_INFO,
 kPARDO_INFO,
 kON_INFO,
 kNO_HOME_INFO,
 kCOMM_INFO,
 kON_INFO,
 kPARALLEL_INFO,
 kREACHING_INFO,
};

unsigned short yyMaxSize = 0;

tTree Tree_Alloc ()
{
 register yytBlockPtr yyBlockPtr = yyBlockList;
 register int i;

 if (yyMaxSize == 0)
  for (i = 1; i <= 311; i ++) {
   Tree_NodeSize [i] = (Tree_NodeSize [i] + yyMaxAlign - 1) & yyAlignMasks [yyMaxAlign];
   yyMaxSize = Max (Tree_NodeSize [i], yyMaxSize);
  }
 yyBlockList = (yytBlockPtr) Alloc (sizeof (yytBlock));
 yyBlockList->yySuccessor = yyBlockPtr;
 Tree_PoolFreePtr = yyBlockList->yyBlock;
 Tree_PoolMaxPtr = Tree_PoolFreePtr + yyBlockSize - yyMaxSize + 1;
 Tree_HeapUsed += yyBlockSize;
 return (tTree) Tree_PoolFreePtr;
}

tTree MakeTree
# if defined __STDC__ | defined __cplusplus
 (Tree_tKind yyKind)
# else
 (yyKind) Tree_tKind yyKind;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [yyKind])
 yyt->Kind = yyKind;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

bool Tree_IsType
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt, register Tree_tKind yyKind)
# else
 (yyt, yyKind) register tTree yyt; register Tree_tKind yyKind;
# endif
{
 return yyt != NoTree && yyKind <= yyt->Kind && yyt->Kind <= yyTypeRange [yyKind];
}

