# include "Tree.inc"

tTree mACF_NODE_LIST
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_NODE_LIST])
 yyt->Kind = kACF_NODE_LIST;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mACF_EMPTY
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_EMPTY])
 yyt->Kind = kACF_EMPTY;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mACF_LIST
# if defined __STDC__ | defined __cplusplus
(tTree pElem, tTree pNext)
# else
(pElem, pNext)
tTree pElem;
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_LIST])
 yyt->Kind = kACF_LIST;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 yyt->ACF_LIST.Elem = pElem;
 yyt->ACF_LIST.Next = pNext;
 return yyt;
}

tTree mACF_NODE
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_NODE])
 yyt->Kind = kACF_NODE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_NODE.Label)
 beginint(yyt->ACF_NODE.Line)
 return yyt;
}

tTree mACF_DUMMY
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_DUMMY])
 yyt->Kind = kACF_DUMMY;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_DUMMY.Label)
 beginint(yyt->ACF_DUMMY.Line)
 return yyt;
}

tTree mACF_BASIC
# if defined __STDC__ | defined __cplusplus
(tTree pBASIC_STMT)
# else
(pBASIC_STMT)
tTree pBASIC_STMT;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_BASIC])
 yyt->Kind = kACF_BASIC;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_BASIC.Label)
 beginint(yyt->ACF_BASIC.Line)
 yyt->ACF_BASIC.BASIC_STMT = pBASIC_STMT;
 return yyt;
}

tTree mACF_IF
# if defined __STDC__ | defined __cplusplus
(tTree pIF_EXP, tTree pTHEN_PART, tTree pELSE_PART)
# else
(pIF_EXP, pTHEN_PART, pELSE_PART)
tTree pIF_EXP;
tTree pTHEN_PART;
tTree pELSE_PART;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_IF])
 yyt->Kind = kACF_IF;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_IF.Label)
 beginint(yyt->ACF_IF.Line)
 yyt->ACF_IF.IF_EXP = pIF_EXP;
 yyt->ACF_IF.THEN_PART = pTHEN_PART;
 yyt->ACF_IF.ELSE_PART = pELSE_PART;
 return yyt;
}

tTree mACF_WHERE
# if defined __STDC__ | defined __cplusplus
(tTree pWHERE_EXP, tTree pTRUE_PART, tTree pFALSE_PART)
# else
(pWHERE_EXP, pTRUE_PART, pFALSE_PART)
tTree pWHERE_EXP;
tTree pTRUE_PART;
tTree pFALSE_PART;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_WHERE])
 yyt->Kind = kACF_WHERE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_WHERE.Label)
 beginint(yyt->ACF_WHERE.Line)
 yyt->ACF_WHERE.WHERE_EXP = pWHERE_EXP;
 yyt->ACF_WHERE.TRUE_PART = pTRUE_PART;
 yyt->ACF_WHERE.FALSE_PART = pFALSE_PART;
 return yyt;
}

tTree mACF_CASE
# if defined __STDC__ | defined __cplusplus
(tTree pCASE_EXP, tTree pCASE_ALTS)
# else
(pCASE_EXP, pCASE_ALTS)
tTree pCASE_EXP;
tTree pCASE_ALTS;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_CASE])
 yyt->Kind = kACF_CASE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_CASE.Label)
 beginint(yyt->ACF_CASE.Line)
 yyt->ACF_CASE.CASE_EXP = pCASE_EXP;
 yyt->ACF_CASE.CASE_ALTS = pCASE_ALTS;
 return yyt;
}

tTree mACF_WHILE
# if defined __STDC__ | defined __cplusplus
(tTree pWHILE_EXP, tTree pWHILE_BODY)
# else
(pWHILE_EXP, pWHILE_BODY)
tTree pWHILE_EXP;
tTree pWHILE_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_WHILE])
 yyt->Kind = kACF_WHILE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_WHILE.Label)
 beginint(yyt->ACF_WHILE.Line)
 yyt->ACF_WHILE.WHILE_EXP = pWHILE_EXP;
 yyt->ACF_WHILE.WHILE_BODY = pWHILE_BODY;
 return yyt;
}

tTree mACF_REPEAT
# if defined __STDC__ | defined __cplusplus
(tTree pREPEAT_BODY, tTree pREPEAT_EXP)
# else
(pREPEAT_BODY, pREPEAT_EXP)
tTree pREPEAT_BODY;
tTree pREPEAT_EXP;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_REPEAT])
 yyt->Kind = kACF_REPEAT;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_REPEAT.Label)
 beginint(yyt->ACF_REPEAT.Line)
 yyt->ACF_REPEAT.REPEAT_BODY = pREPEAT_BODY;
 yyt->ACF_REPEAT.REPEAT_EXP = pREPEAT_EXP;
 return yyt;
}

tTree mACF_LOOP
# if defined __STDC__ | defined __cplusplus
(tTree pLOOP_BODY)
# else
(pLOOP_BODY)
tTree pLOOP_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_LOOP])
 yyt->Kind = kACF_LOOP;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_LOOP.Label)
 beginint(yyt->ACF_LOOP.Line)
 yyt->ACF_LOOP.LOOP_BODY = pLOOP_BODY;
 return yyt;
}

tTree mACF_DO
# if defined __STDC__ | defined __cplusplus
(tTree pDO_ID, tTree pDO_RANGE, tTree pDO_BODY, tTree pDO_DEP_INFO, tTree pDO_HOME_INFO)
# else
(pDO_ID, pDO_RANGE, pDO_BODY, pDO_DEP_INFO, pDO_HOME_INFO)
tTree pDO_ID;
tTree pDO_RANGE;
tTree pDO_BODY;
tTree pDO_DEP_INFO;
tTree pDO_HOME_INFO;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_DO])
 yyt->Kind = kACF_DO;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_DO.Label)
 beginint(yyt->ACF_DO.Line)
 yyt->ACF_DO.DO_ID = pDO_ID;
 yyt->ACF_DO.DO_RANGE = pDO_RANGE;
 yyt->ACF_DO.DO_BODY = pDO_BODY;
 yyt->ACF_DO.DO_DEP_INFO = pDO_DEP_INFO;
 yyt->ACF_DO.DO_HOME_INFO = pDO_HOME_INFO;
 return yyt;
}

tTree mACF_FORALL
# if defined __STDC__ | defined __cplusplus
(tTree pFORALL_ID, tTree pFORALL_RANGE, tTree pFORALL_BODY, tTree pFORALL_DEP_INFO, tTree pFORALL_HOME_INFO)
# else
(pFORALL_ID, pFORALL_RANGE, pFORALL_BODY, pFORALL_DEP_INFO, pFORALL_HOME_INFO)
tTree pFORALL_ID;
tTree pFORALL_RANGE;
tTree pFORALL_BODY;
tTree pFORALL_DEP_INFO;
tTree pFORALL_HOME_INFO;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_FORALL])
 yyt->Kind = kACF_FORALL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_FORALL.Label)
 beginint(yyt->ACF_FORALL.Line)
 yyt->ACF_FORALL.FORALL_ID = pFORALL_ID;
 yyt->ACF_FORALL.FORALL_RANGE = pFORALL_RANGE;
 yyt->ACF_FORALL.FORALL_BODY = pFORALL_BODY;
 yyt->ACF_FORALL.FORALL_DEP_INFO = pFORALL_DEP_INFO;
 yyt->ACF_FORALL.FORALL_HOME_INFO = pFORALL_HOME_INFO;
 return yyt;
}

tTree mACF_FLOW_GRAPH
# if defined __STDC__ | defined __cplusplus
(tTree pFLOW_NODES)
# else
(pFLOW_NODES)
tTree pFLOW_NODES;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_FLOW_GRAPH])
 yyt->Kind = kACF_FLOW_GRAPH;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_FLOW_GRAPH.Label)
 beginint(yyt->ACF_FLOW_GRAPH.Line)
 yyt->ACF_FLOW_GRAPH.FLOW_NODES = pFLOW_NODES;
 return yyt;
}

tTree mACF_ENTRY
# if defined __STDC__ | defined __cplusplus
(tTree pENTRY_DECL)
# else
(pENTRY_DECL)
tTree pENTRY_DECL;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_ENTRY])
 yyt->Kind = kACF_ENTRY;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_ENTRY.Label)
 beginint(yyt->ACF_ENTRY.Line)
 yyt->ACF_ENTRY.ENTRY_DECL = pENTRY_DECL;
 return yyt;
}

tTree mACF_HOME
# if defined __STDC__ | defined __cplusplus
(tTree pHOME_VAR, bool puser_home, tTree pHOME_BODY)
# else
(pHOME_VAR, puser_home, pHOME_BODY)
tTree pHOME_VAR;
bool puser_home;
tTree pHOME_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_HOME])
 yyt->Kind = kACF_HOME;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_HOME.Label)
 beginint(yyt->ACF_HOME.Line)
 yyt->ACF_HOME.HOME_VAR = pHOME_VAR;
 yyt->ACF_HOME.user_home = puser_home;
 yyt->ACF_HOME.HOME_BODY = pHOME_BODY;
 return yyt;
}

tTree mACF_RESIDENT
# if defined __STDC__ | defined __cplusplus
(tTree pRESIDENT_VAR, tTree pRESIDENT_BODY)
# else
(pRESIDENT_VAR, pRESIDENT_BODY)
tTree pRESIDENT_VAR;
tTree pRESIDENT_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_RESIDENT])
 yyt->Kind = kACF_RESIDENT;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_RESIDENT.Label)
 beginint(yyt->ACF_RESIDENT.Line)
 yyt->ACF_RESIDENT.RESIDENT_VAR = pRESIDENT_VAR;
 yyt->ACF_RESIDENT.RESIDENT_BODY = pRESIDENT_BODY;
 return yyt;
}

tTree mACF_NEW
# if defined __STDC__ | defined __cplusplus
(tTree pNEW_VAR, tTree pNEW_BODY)
# else
(pNEW_VAR, pNEW_BODY)
tTree pNEW_VAR;
tTree pNEW_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_NEW])
 yyt->Kind = kACF_NEW;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_NEW.Label)
 beginint(yyt->ACF_NEW.Line)
 yyt->ACF_NEW.NEW_VAR = pNEW_VAR;
 yyt->ACF_NEW.NEW_BODY = pNEW_BODY;
 return yyt;
}

tTree mACF_REDUCTION
# if defined __STDC__ | defined __cplusplus
(bool pis_zero, tTree pREDUCTION_VAR, tTree pREDUCTION_LVAR, tTree pREDUCTION_FUNC, tTree pREDUCTION_BODY)
# else
(pis_zero, pREDUCTION_VAR, pREDUCTION_LVAR, pREDUCTION_FUNC, pREDUCTION_BODY)
bool pis_zero;
tTree pREDUCTION_VAR;
tTree pREDUCTION_LVAR;
tTree pREDUCTION_FUNC;
tTree pREDUCTION_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_REDUCTION])
 yyt->Kind = kACF_REDUCTION;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_REDUCTION.Label)
 beginint(yyt->ACF_REDUCTION.Line)
 yyt->ACF_REDUCTION.is_zero = pis_zero;
 yyt->ACF_REDUCTION.REDUCTION_VAR = pREDUCTION_VAR;
 yyt->ACF_REDUCTION.REDUCTION_LVAR = pREDUCTION_LVAR;
 yyt->ACF_REDUCTION.REDUCTION_FUNC = pREDUCTION_FUNC;
 yyt->ACF_REDUCTION.REDUCTION_BODY = pREDUCTION_BODY;
 return yyt;
}

tTree mACF_TASK_REGION
# if defined __STDC__ | defined __cplusplus
(int ptask_flag, tTree pTASK_BODY)
# else
(ptask_flag, pTASK_BODY)
int ptask_flag;
tTree pTASK_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_TASK_REGION])
 yyt->Kind = kACF_TASK_REGION;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_TASK_REGION.Label)
 beginint(yyt->ACF_TASK_REGION.Line)
 yyt->ACF_TASK_REGION.task_flag = ptask_flag;
 yyt->ACF_TASK_REGION.TASK_BODY = pTASK_BODY;
 return yyt;
}

tTree mACF_PARALLEL
# if defined __STDC__ | defined __cplusplus
(tTree pREDUCTION_VARS, tTree pSHARED_VARS, tTree pLOCAL_VARS, tTree pPARALLEL_BODY)
# else
(pREDUCTION_VARS, pSHARED_VARS, pLOCAL_VARS, pPARALLEL_BODY)
tTree pREDUCTION_VARS;
tTree pSHARED_VARS;
tTree pLOCAL_VARS;
tTree pPARALLEL_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_PARALLEL])
 yyt->Kind = kACF_PARALLEL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_PARALLEL.Label)
 beginint(yyt->ACF_PARALLEL.Line)
 yyt->ACF_PARALLEL.REDUCTION_VARS = pREDUCTION_VARS;
 yyt->ACF_PARALLEL.SHARED_VARS = pSHARED_VARS;
 yyt->ACF_PARALLEL.LOCAL_VARS = pLOCAL_VARS;
 yyt->ACF_PARALLEL.PARALLEL_BODY = pPARALLEL_BODY;
 return yyt;
}

tTree mACF_CRITICAL
# if defined __STDC__ | defined __cplusplus
(tTree pCRITICAL_BODY)
# else
(pCRITICAL_BODY)
tTree pCRITICAL_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_CRITICAL])
 yyt->Kind = kACF_CRITICAL;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_CRITICAL.Label)
 beginint(yyt->ACF_CRITICAL.Line)
 yyt->ACF_CRITICAL.CRITICAL_BODY = pCRITICAL_BODY;
 return yyt;
}

tTree mACF_ON
# if defined __STDC__ | defined __cplusplus
(tTree pON_HOME, tTree pON_SPECS, tTree pON_BODY)
# else
(pON_HOME, pON_SPECS, pON_BODY)
tTree pON_HOME;
tTree pON_SPECS;
tTree pON_BODY;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_ON])
 yyt->Kind = kACF_ON;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_ON.Label)
 beginint(yyt->ACF_ON.Line)
 yyt->ACF_ON.ON_HOME = pON_HOME;
 yyt->ACF_ON.ON_SPECS = pON_SPECS;
 yyt->ACF_ON.ON_BODY = pON_BODY;
 return yyt;
}

tTree mACF_RM_READ
# if defined __STDC__ | defined __cplusplus
(tTree pLOCAL_VAR, tTree pREMOTE_VAR)
# else
(pLOCAL_VAR, pREMOTE_VAR)
tTree pLOCAL_VAR;
tTree pREMOTE_VAR;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_RM_READ])
 yyt->Kind = kACF_RM_READ;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_RM_READ.Label)
 beginint(yyt->ACF_RM_READ.Line)
 yyt->ACF_RM_READ.LOCAL_VAR = pLOCAL_VAR;
 yyt->ACF_RM_READ.REMOTE_VAR = pREMOTE_VAR;
 return yyt;
}

tTree mACF_RM_WRITE
# if defined __STDC__ | defined __cplusplus
(int pop, tTree pREMOTE_VAR, tTree pLOCAL_DATA)
# else
(pop, pREMOTE_VAR, pLOCAL_DATA)
int pop;
tTree pREMOTE_VAR;
tTree pLOCAL_DATA;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_RM_WRITE])
 yyt->Kind = kACF_RM_WRITE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_RM_WRITE.Label)
 beginint(yyt->ACF_RM_WRITE.Line)
 yyt->ACF_RM_WRITE.op = pop;
 yyt->ACF_RM_WRITE.REMOTE_VAR = pREMOTE_VAR;
 yyt->ACF_RM_WRITE.LOCAL_DATA = pLOCAL_DATA;
 return yyt;
}

tTree mACF_MOVE
# if defined __STDC__ | defined __cplusplus
(tTree pMOVE_STMT)
# else
(pMOVE_STMT)
tTree pMOVE_STMT;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_MOVE])
 yyt->Kind = kACF_MOVE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_MOVE.Label)
 beginint(yyt->ACF_MOVE.Line)
 yyt->ACF_MOVE.MOVE_STMT = pMOVE_STMT;
 return yyt;
}

tTree mACF_BARRIER
# if defined __STDC__ | defined __cplusplus
(tTree pBARRIER_VARS)
# else
(pBARRIER_VARS)
tTree pBARRIER_VARS;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_BARRIER])
 yyt->Kind = kACF_BARRIER;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_BARRIER.Label)
 beginint(yyt->ACF_BARRIER.Line)
 yyt->ACF_BARRIER.BARRIER_VARS = pBARRIER_VARS;
 return yyt;
}

tTree mACF_UPDATE
# if defined __STDC__ | defined __cplusplus
(tTree pOVERLAP_VAR)
# else
(pOVERLAP_VAR)
tTree pOVERLAP_VAR;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_UPDATE])
 yyt->Kind = kACF_UPDATE;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 beginint(yyt->ACF_UPDATE.Label)
 beginint(yyt->ACF_UPDATE.Line)
 yyt->ACF_UPDATE.OVERLAP_VAR = pOVERLAP_VAR;
 return yyt;
}

tTree mACF_FLOW_KIND
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_FLOW_KIND])
 yyt->Kind = kACF_FLOW_KIND;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mACF_COMPLEX_FLOW
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_COMPLEX_FLOW])
 yyt->Kind = kACF_COMPLEX_FLOW;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mACF_INTERVAL_FLOW
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_INTERVAL_FLOW])
 yyt->Kind = kACF_INTERVAL_FLOW;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

tTree mACF_SIMPLE_FLOW
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kACF_SIMPLE_FLOW])
 yyt->Kind = kACF_SIMPLE_FLOW;
 yyt->yyHead.yyMark = 0;
 yyt->yyHead.yyParent = NoTree;
 return yyt;
}

