# ifndef yyMoveControl
# define yyMoveControl

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"
# include "Definitions.h"

# line 87 "MoveControl.puma"


# include "VarDescriptor.h"
# include "MoveDescriptor.h"    /* shift_vector, pshift */



extern void (* MoveControl_Exit) ();

extern bool VDHasLocalCopy ARGS((pvar home, pvar var));
extern bool VDIsOwner ARGS((pvar home, pvar var));
extern bool VDIsSingleOwner ARGS((pvar home, pvar var));
extern int CountCommunication ARGS((pvar home, tTree exp));
extern int CountMovements ARGS((tTree var, tTree exp));
extern int CountVarMovements ARGS((tTree var, tTree var1));
extern void GetMajorityVar ARGS((tTree exp, int * flag, tTree * var));
extern void GetMajorityVar2 ARGS((tTree exp1, tTree exp2, int * yyP2, tTree * yyP1));
extern void GetShifting ARGS((tTree lvar, tTree rvar, bool * yyP10, shift_vector * yyP9));
extern void GetCircularShifting ARGS((tTree exp, bool * yyP13, tTree * yyP12, shift_vector * yyP11));
extern bool EnoughOverlapArea ARGS((tTree var, pshift pos));
extern bool SpreadAligned ARGS((tTree var, tTree maj_var, int dim));
extern bool VDIsLocalAssignment ARGS((pvar lvar, pvar rvar));
extern bool SameDistribution ARGS((tDefinitions actual, tDefinitions formal));

extern void BeginMoveControl ();
extern void CloseMoveControl ();

# endif
