# ifndef yyReductions
# define yyReductions

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"
# include "Definitions.h"


extern void (* Reductions_Exit) ();

extern bool IsReduction ARGS((tTree t));
extern bool IsLocReduction ARGS((tTree t));
extern void SplitReduction ARGS((tTree params, tTree * reduction_array, int * reduction_dim, tTree * reduction_mask));
extern int GetReductionDim ARGS((tTree params));
extern tTree InitReductionStmt ARGS((tTree var, tTree vtype, tTree func));
extern tTree GenRedAssign ARGS((tTree var, tTree exp, tIdent id));
extern tTree ResolveReduce ARGS((tTree t));
extern int GetGlobalOp ARGS((tTree type, tIdent redfunc));
extern tTree GetReductionZero ARGS((tTree vtype, tIdent ident));

extern void BeginReductions ();
extern void CloseReductions ();

# endif
