/* $Id: Parser.c,v 2.9 1992/08/07 15:28:42 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "Parser.h"
# include "Errors.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } tScanAttribute;
        static	tScanAttribute	Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "Scanner.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 58 "fortran.lalr" */


#include <stdio.h>
#include "global.h"
#include "MySource.h"  /* CodeLine, GetPosition */
#include "Tree.h"
#include "BuildTree.h"
#include "labels.h"

#define NLine(a) MyCodeLine(a.Scan.Position.Line)

int MyCodeLine (line)
int line;
{
   return CodeLine(line);   /* CodeLine imported form MySource */
}

   /********************************************************
   *                                                       *
   *     Special functions for abstract syntax trees       *
   *                                                       *
   ********************************************************/

typedef struct { tScanAttribute Scan;
                 int Label;
                 int Line;
                 tTree Tree;         } tParsAttribute;

tStringRef MakeIntToReal (n)
int n;

{ char number[15];
  sprintf (number, "%d.", n);
  return (PutString (number, strlen (number)));
}



# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		255
# define yyTableMax		2232
# define yyNTableMax		5412
# define yyFirstReadState	1
# define yyLastReadState	850
# define yyFirstReadTermState	851
# define yyLastReadTermState	1048
# define yyLastReadNontermState	1475
# define yyFirstReduceState	1476
# define yyLastReduceState	2302
# define yyStartState		1
# define yyStopState		1476

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		Parser_TokenName	[yyLastTerminal + 1] = {
"_EndOfFile",
"Ident",
"IntConst",
"RealConst",
"DRealConst",
"StringConst",
0,
"UserOp",
0,
0,
"=",
"//",
"=>",
"(",
")",
"+",
"-",
"*",
"/",
"**",
":",
",",
0,
"[",
"]",
0,
0,
"::",
".",
"%",
"<>",
"==",
">",
">=",
"<",
"<=",
"AND",
"OR",
0,
"EQV",
"NEQV",
"TRUE",
"FALSE",
"NOT",
"XOR",
"BLOCKDATA",
"DATA",
0,
"INTRINSIC",
0,
"INTEGER",
"REAL",
"COMPLEX",
"LOGICAL",
"CHARACTER",
"DOUBLE_PRECISION",
"DOUBLE_COMPLEX",
"SAVE",
"IMPLICIT",
"EXTERNAL",
"PARAMETER",
"DIMENSION",
"COMMON",
"EQUIVALENCE",
"PROGRAM",
"RECURSIVE",
"SUBROUTINE",
"FUNCTION",
"END",
"DO",
"WHILE",
"IF",
"THEN",
"ELSE",
"ELSEIF",
"ENDDO",
"ENDIF",
"RESULT",
"ASSIGN",
"TO",
"CALL",
"CONTINUE",
"STOP",
"RETURN",
0,
"FORMAT",
"FORMAT_ARG",
"GOTO",
"ENTRY",
0,
"READ",
"WRITE",
"PRINT",
"OPEN",
"CLOSE",
"INQUIRE",
"BACKSPACE",
"ENDFILE",
"REWIND",
0,
"ALLOCATE",
"DEALLOCATE",
"WHERE",
"ENDWHERE",
"ELSEWHERE",
"SELECTCASE",
"CASE",
"DEFAULT",
0,
"FORALL",
"INTENT",
"IN",
"OUT",
"INOUT",
"ENDFORALL",
"CYCLE",
"EXIT",
0,
0,
0,
0,
"REDUCE",
0,
0,
0,
"PROCEDURE",
"OPERATOR",
"ASSIGNMENT",
0,
0,
"TYPE",
"ENDTYPE",
"INTERFACE",
"ENDINTERFACE",
"MODULE",
0,
"CONTAINS",
"USE",
"ONLY",
0,
"ALLOCATABLE",
"OPTIONAL",
"POINTER",
"TARGET",
"PUBLIC",
"PRIVATE",
"NULLIFY",
"NAMELIST",
"SEQUENCE",
0,
0,
"ALIGN",
"WITH",
"REALIGN",
"DISTRIBUTE",
"REDISTRIBUTE",
"PROCESSORS",
"TEMPLATE",
"DYNAMIC",
"ONTO",
"BLOCK",
"CYCLIC",
"NOSEQUENCE",
"HPFSEQUENCE",
"INDEPENDENT",
"RESIDENT",
"ON",
"NEW",
"REDUCTION",
"INHERIT",
"HOME",
0,
0,
0,
0,
0,
0,
0,
0,
0,
"PURE",
"EXTRINSIC",
0,
0,
0,
0,
0,
0,
0,
0,
0,
"DIMENSION1",
"PARAMETER1",
"INTENT1",
"EXTERNAL1",
"INTRINSIC1",
"OPTIONAL1",
"POINTER1",
"SAVE1",
"TARGET1",
"DATA1",
"PUBLIC1",
"PRIVATE1",
"ALLOCATABLE1",
"ARRAY1",
"ENDSELECT",
"SEQUENCE1",
0,
"GEN_BLOCK",
"INDIRECT",
"HPF_BEGIN",
"HPF_END",
"TASK_REGION",
0,
"RANGE",
"ALL",
"LAYOUT",
"PASS_BY",
"MAP_TO",
"ARBITRARY",
"MAP",
"SHADOW",
"SHARED",
"RMA",
"TRACE",
"TREE",
"SELECT",
"NOVECTOR",
"NOCONCUR",
"SHORT",
"EXPAND",
"VECTOR",
"CONCUR",
"SKIP",
0,
0,
0,
0,
0,
0,
"LAYOUT1",
"PASS_BY1",
"MAP_TO1",
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
"NewLine",
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{839, 1512},
{1, 1479},
{107, 926},
{328, 9},
{343, 996},
{100, 924},
{102, 925},
{25, 881},
{125, 887},
{237, 238},
{16, 17},
{69, 70},
{110, 102},
{31, 32},
{15, 885},
{18, 2228},
{24, 25},
{8, 77},
{20, 11},
{20, 13},
{16, 2219},
{33, 900},
{18, 2228},
{48, 2227},
{16, 2219},
{18, 2228},
{52, 2233},
{16, 2219},
{49, 2225},
{51, 52},
{48, 2227},
{57, 906},
{56, 2233},
{48, 2227},
{53, 2234},
{49, 50},
{51, 56},
{60, 907},
{49, 2225},
{56, 2233},
{53, 2234},
{53, 2234},
{56, 2233},
{64, 2219},
{53, 2234},
{1, 1479},
{1, 1479},
{53, 2234},
{1, 1479},
{65, 66},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{62, 908},
{1, 1479},
{68, 66},
{5, 1479},
{5, 1479},
{5, 1479},
{5, 1479},
{62, 63},
{1, 1479},
{71, 72},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{75, 2139},
{1, 1479},
{76, 910},
{1, 1479},
{1, 1479},
{77, 911},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{79, 80},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{5, 1479},
{1, 1479},
{5, 1479},
{80, 912},
{81, 913},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{1, 1479},
{54, 2230},
{82, 914},
{84, 916},
{85, 1650},
{1, 1479},
{86, 917},
{54, 55},
{54, 2230},
{89, 920},
{90, 922},
{54, 2230},
{91, 1562},
{92, 921},
{1, 1479},
{5, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{91, 92},
{1, 1479},
{1, 1479},
{95, 96},
{97, 923},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{99, 100},
{101, 1552},
{1, 1479},
{103, 104},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{113, 930},
{123, 124},
{126, 934},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{108, 1548},
{124, 1600},
{127, 1596},
{128, 122},
{129, 887},
{130, 1600},
{131, 1602},
{108, 109},
{124, 1600},
{127, 128},
{1, 1479},
{1, 1479},
{130, 1600},
{131, 132},
{132, 932},
{133, 134},
{134, 933},
{129, 130},
{3, 4},
{135, 136},
{137, 138},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{5, 1479},
{1, 1479},
{3, 87},
{3, 94},
{3, 1541},
{3, 1541},
{5, 1479},
{1, 1479},
{138, 139},
{1, 1479},
{143, 940},
{1, 1479},
{1, 1479},
{1, 1479},
{7, 1585},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{1, 1479},
{30, 9},
{30, 878},
{30, 879},
{30, 880},
{7, 8},
{112, 927},
{112, 928},
{145, 939},
{150, 151},
{152, 153},
{112, 929},
{30, 10},
{7, 1585},
{1, 1479},
{1, 1479},
{1, 1479},
{73, 2138},
{144, 1942},
{7, 1585},
{147, 1933},
{153, 154},
{30, 12},
{159, 942},
{73, 74},
{144, 145},
{160, 943},
{147, 148},
{162, 944},
{1, 2},
{4, 5},
{6, 5},
{93, 5},
{115, 5},
{117, 5},
{118, 5},
{156, 935},
{163, 945},
{164, 165},
{165, 946},
{30, 882},
{30, 883},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{166, 947},
{30, 884},
{3, 833},
{167, 168},
{158, 159},
{158, 1964},
{168, 948},
{9, 2290},
{7, 1585},
{7, 1585},
{7, 1585},
{9, 2290},
{158, 1964},
{169, 949},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{170, 171},
{9, 2290},
{9, 2290},
{161, 162},
{161, 1967},
{171, 951},
{9, 2290},
{172, 173},
{174, 175},
{9, 2290},
{176, 952},
{161, 1967},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{9, 2290},
{146, 142},
{9, 2290},
{9, 2290},
{177, 953},
{182, 954},
{183, 184},
{9, 2290},
{187, 955},
{146, 1940},
{191, 1952},
{3, 98},
{3, 99},
{75, 2139},
{178, 1962},
{146, 1940},
{135, 149},
{7, 1585},
{7, 1585},
{7, 1585},
{14, 2285},
{178, 179},
{193, 1873},
{194, 195},
{14, 2285},
{206, 207},
{197, 1868},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{184, 1956},
{7, 1585},
{14, 2285},
{198, 199},
{202, 935},
{14, 2285},
{184, 1956},
{201, 202},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{14, 2285},
{21, 2256},
{14, 2285},
{14, 2285},
{192, 1995},
{196, 1994},
{208, 956},
{14, 2285},
{21, 2256},
{204, 205},
{192, 1995},
{196, 1994},
{150, 155},
{200, 1990},
{21, 2256},
{21, 2256},
{203, 1991},
{212, 213},
{21, 2256},
{200, 1990},
{217, 957},
{21, 2256},
{203, 1991},
{220, 221},
{21, 889},
{21, 890},
{21, 891},
{21, 892},
{21, 893},
{21, 894},
{21, 2256},
{21, 2256},
{188, 186},
{21, 2256},
{21, 2256},
{211, 1927},
{7, 1585},
{7, 1585},
{21, 2256},
{222, 958},
{188, 1957},
{211, 1927},
{223, 224},
{227, 228},
{229, 961},
{230, 231},
{188, 1957},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{7, 1585},
{34, 2241},
{7, 1585},
{180, 181},
{232, 966},
{216, 1881},
{156, 938},
{233, 234},
{34, 2241},
{218, 1879},
{235, 975},
{180, 1961},
{216, 1881},
{214, 1882},
{34, 2241},
{34, 2241},
{218, 219},
{180, 1961},
{34, 2241},
{214, 215},
{214, 1882},
{34, 2241},
{236, 237},
{238, 976},
{239, 240},
{240, 241},
{23, 2265},
{241, 977},
{242, 243},
{243, 244},
{23, 2265},
{244, 978},
{248, 122},
{23, 2265},
{249, 980},
{245, 226},
{7, 1585},
{7, 1585},
{7, 1585},
{23, 2265},
{23, 2265},
{245, 1655},
{254, 1646},
{23, 2265},
{257, 981},
{255, 256},
{23, 2265},
{258, 5},
{259, 5},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{23, 2265},
{26, 2274},
{23, 2265},
{23, 2265},
{247, 1641},
{26, 2274},
{73, 2138},
{23, 2265},
{26, 2274},
{26, 2274},
{26, 2274},
{247, 1641},
{250, 1643},
{260, 261},
{26, 2274},
{26, 2274},
{261, 1805},
{263, 264},
{26, 2274},
{250, 251},
{266, 267},
{26, 2274},
{270, 136},
{250, 1643},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{26, 2274},
{271, 183},
{26, 2274},
{26, 2274},
{268, 269},
{28, 2279},
{272, 207},
{26, 2274},
{202, 938},
{28, 2279},
{268, 1982},
{273, 213},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 899},
{28, 2279},
{28, 2279},
{276, 277},
{9, 2290},
{28, 2279},
{275, 276},
{275, 279},
{28, 2279},
{278, 987},
{279, 280},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{28, 2279},
{36, 2243},
{28, 2279},
{28, 2279},
{280, 281},
{265, 248},
{251, 915},
{28, 2279},
{36, 2243},
{38, 2247},
{281, 988},
{146, 1940},
{282, 5},
{265, 1641},
{36, 2243},
{36, 2243},
{38, 2247},
{251, 84},
{36, 2243},
{252, 253},
{287, 288},
{36, 2243},
{38, 2247},
{38, 2247},
{193, 1873},
{194, 1871},
{38, 2247},
{180, 1961},
{197, 1868},
{38, 2247},
{252, 1645},
{286, 287},
{288, 289},
{36, 2243},
{36, 2243},
{290, 291},
{14, 2285},
{184, 1956},
{292, 989},
{38, 2247},
{198, 1866},
{38, 2247},
{38, 2247},
{293, 294},
{201, 1947},
{40, 2264},
{38, 2247},
{294, 295},
{295, 990},
{40, 2264},
{299, 290},
{299, 293},
{40, 2264},
{40, 895},
{40, 896},
{296, 1730},
{300, 297},
{306, 1788},
{40, 2264},
{40, 2264},
{306, 1788},
{204, 1922},
{40, 2264},
{307, 308},
{298, 299},
{40, 2264},
{309, 310},
{21, 2256},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{40, 2264},
{41, 2267},
{40, 2264},
{40, 2264},
{311, 312},
{41, 2267},
{301, 302},
{40, 2264},
{41, 2267},
{41, 2267},
{41, 2267},
{313, 991},
{211, 1927},
{315, 305},
{41, 2267},
{41, 2267},
{316, 317},
{188, 1957},
{41, 2267},
{223, 1876},
{270, 149},
{41, 2267},
{323, 909},
{321, 887},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{41, 2267},
{329, 993},
{41, 2267},
{41, 2267},
{337, 1749},
{42, 2246},
{321, 322},
{41, 2267},
{340, 995},
{318, 319},
{318, 2290},
{275, 1829},
{42, 2246},
{318, 2290},
{325, 326},
{325, 878},
{325, 879},
{180, 1961},
{42, 2246},
{42, 2246},
{324, 9},
{34, 2241},
{42, 2246},
{324, 880},
{335, 336},
{42, 2246},
{327, 328},
{327, 1794},
{341, 342},
{326, 2301},
{327, 1794},
{324, 320},
{326, 2301},
{342, 339},
{42, 905},
{42, 2246},
{43, 2242},
{42, 2246},
{42, 2246},
{326, 877},
{346, 347},
{330, 1792},
{42, 2246},
{43, 2242},
{330, 331},
{350, 997},
{23, 2265},
{353, 354},
{254, 1646},
{43, 2242},
{43, 2242},
{255, 1638},
{332, 1786},
{43, 2242},
{344, 1585},
{332, 333},
{43, 2242},
{345, 1581},
{344, 83},
{324, 882},
{324, 883},
{345, 107},
{355, 998},
{207, 941},
{358, 357},
{351, 1712},
{43, 903},
{44, 2273},
{43, 2242},
{43, 2242},
{360, 361},
{44, 2273},
{351, 352},
{43, 904},
{44, 2273},
{44, 2273},
{44, 2273},
{26, 2274},
{362, 363},
{364, 365},
{44, 2273},
{44, 2273},
{266, 1979},
{367, 999},
{44, 2273},
{250, 1643},
{370, 121},
{44, 2273},
{372, 121},
{376, 1001},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{44, 2273},
{377, 1002},
{44, 2273},
{44, 2273},
{46, 2257},
{366, 1803},
{47, 2239},
{44, 2273},
{46, 888},
{368, 1801},
{373, 374},
{46, 2257},
{366, 1803},
{47, 2239},
{381, 1506},
{28, 2279},
{368, 369},
{46, 2257},
{46, 2257},
{47, 2239},
{47, 2239},
{46, 2257},
{383, 384},
{47, 2239},
{46, 2257},
{348, 1714},
{47, 2239},
{348, 349},
{391, 392},
{396, 1003},
{397, 398},
{398, 390},
{348, 1714},
{46, 2257},
{46, 2257},
{399, 400},
{46, 2257},
{46, 2257},
{47, 901},
{47, 902},
{400, 2112},
{46, 2257},
{379, 1688},
{59, 2270},
{265, 1641},
{379, 1688},
{36, 2243},
{59, 2270},
{401, 402},
{403, 404},
{59, 2270},
{59, 2270},
{59, 2270},
{404, 405},
{38, 2247},
{388, 1505},
{59, 2270},
{59, 2270},
{388, 381},
{406, 407},
{59, 2270},
{252, 1645},
{286, 1699},
{59, 2270},
{427, 1725},
{435, 1004},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{59, 2270},
{61, 2269},
{59, 2270},
{59, 2270},
{410, 1770},
{61, 2269},
{440, 434},
{59, 2270},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 897},
{61, 898},
{296, 1730},
{61, 2269},
{61, 2269},
{395, 1684},
{40, 2264},
{61, 2269},
{443, 1761},
{446, 1005},
{61, 2269},
{298, 1702},
{395, 394},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{61, 2269},
{448, 445},
{61, 2269},
{61, 2269},
{452, 1006},
{207, 158},
{207, 161},
{61, 2269},
{301, 1699},
{411, 412},
{67, 2219},
{454, 451},
{455, 456},
{67, 2137},
{67, 2219},
{456, 457},
{67, 2219},
{41, 2267},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{457, 458},
{67, 2219},
{357, 873},
{357, 874},
{357, 875},
{357, 876},
{357, 344},
{357, 918},
{357, 919},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{67, 2219},
{262, 7},
{67, 2219},
{67, 2219},
{402, 963},
{402, 964},
{402, 965},
{67, 2219},
{262, 120},
{415, 416},
{419, 1780},
{420, 421},
{42, 2246},
{207, 164},
{207, 167},
{106, 1581},
{424, 1775},
{335, 1721},
{425, 426},
{429, 430},
{207, 950},
{341, 1751},
{78, 2219},
{442, 438},
{207, 170},
{78, 79},
{78, 2219},
{106, 8},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{106, 1581},
{431, 1507},
{431, 1507},
{449, 1507},
{462, 463},
{463, 464},
{106, 1581},
{464, 465},
{43, 2242},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{78, 2219},
{467, 468},
{78, 2219},
{78, 2219},
{468, 469},
{358, 1708},
{469, 470},
{78, 2219},
{447, 448},
{453, 454},
{460, 461},
{360, 1717},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{111, 1807},
{473, 474},
{492, 493},
{44, 2273},
{475, 1886},
{494, 495},
{262, 95},
{262, 1810},
{106, 1581},
{106, 1581},
{106, 1581},
{331, 318},
{331, 878},
{331, 879},
{331, 880},
{478, 1992},
{225, 1652},
{476, 477},
{479, 480},
{482, 483},
{111, 112},
{478, 1992},
{331, 320},
{495, 496},
{331, 324},
{331, 325},
{111, 931},
{262, 135},
{486, 487},
{373, 1677},
{262, 156},
{490, 491},
{262, 192},
{262, 196},
{262, 200},
{481, 1993},
{499, 1900},
{46, 2257},
{503, 504},
{47, 2239},
{501, 1904},
{481, 1993},
{225, 979},
{499, 500},
{501, 502},
{262, 203},
{504, 1007},
{501, 1904},
{505, 1015},
{397, 1681},
{331, 882},
{331, 883},
{507, 1532},
{508, 5},
{106, 1581},
{106, 1581},
{106, 1581},
{502, 1008},
{502, 1009},
{502, 1010},
{502, 1011},
{502, 1012},
{502, 1013},
{502, 1014},
{379, 1688},
{506, 507},
{514, 304},
{269, 120},
{515, 516},
{517, 518},
{497, 498},
{518, 606},
{519, 520},
{106, 1581},
{521, 522},
{522, 1017},
{59, 2270},
{388, 1690},
{406, 1848},
{524, 525},
{226, 227},
{226, 962},
{226, 230},
{226, 967},
{226, 968},
{226, 969},
{226, 970},
{226, 971},
{226, 972},
{226, 973},
{262, 206},
{509, 2000},
{226, 974},
{226, 233},
{431, 1724},
{528, 1018},
{410, 1770},
{262, 212},
{262, 959},
{262, 960},
{534, 1019},
{530, 531},
{535, 2063},
{527, 528},
{537, 2040},
{514, 399},
{532, 2065},
{61, 2269},
{533, 2066},
{535, 536},
{111, 1807},
{111, 1807},
{111, 1807},
{532, 2065},
{538, 2041},
{533, 2066},
{539, 2043},
{540, 2044},
{545, 546},
{548, 2036},
{550, 551},
{552, 1021},
{541, 1017},
{106, 1581},
{106, 1581},
{314, 1505},
{225, 1652},
{225, 1652},
{225, 1652},
{226, 236},
{226, 239},
{226, 242},
{411, 1768},
{541, 542},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{106, 1581},
{543, 2034},
{106, 1581},
{553, 554},
{555, 556},
{556, 1024},
{559, 1025},
{557, 2100},
{543, 544},
{561, 1023},
{269, 270},
{562, 2083},
{509, 2000},
{269, 271},
{557, 2100},
{269, 982},
{269, 983},
{269, 984},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{274, 1814},
{415, 1734},
{419, 1780},
{420, 1778},
{269, 985},
{274, 1814},
{563, 2109},
{564, 565},
{424, 1775},
{558, 2099},
{425, 1773},
{429, 1728},
{106, 1581},
{106, 1581},
{106, 1581},
{442, 1744},
{558, 2099},
{569, 2077},
{575, 554},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{111, 1807},
{449, 1755},
{111, 1807},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{225, 1652},
{269, 272},
{225, 1652},
{549, 1505},
{447, 1763},
{453, 1757},
{460, 1740},
{560, 2097},
{269, 273},
{269, 959},
{269, 960},
{549, 992},
{566, 567},
{375, 1696},
{560, 561},
{571, 572},
{314, 1505},
{314, 1505},
{314, 1505},
{475, 1886},
{111, 1807},
{111, 1807},
{111, 1807},
{375, 1000},
{577, 2095},
{570, 1017},
{274, 1814},
{274, 1814},
{570, 1022},
{580, 581},
{375, 376},
{579, 1027},
{476, 1884},
{479, 1914},
{482, 1918},
{506, 1533},
{225, 1652},
{225, 1652},
{225, 1652},
{582, 1028},
{570, 1026},
{274, 117},
{579, 554},
{486, 1888},
{274, 118},
{586, 1029},
{490, 1892},
{274, 1814},
{588, 589},
{590, 591},
{274, 1814},
{291, 986},
{274, 1814},
{274, 1814},
{274, 1814},
{291, 888},
{303, 304},
{592, 2048},
{303, 334},
{291, 895},
{291, 896},
{291, 897},
{291, 898},
{291, 899},
{584, 585},
{274, 1814},
{488, 1507},
{303, 337},
{303, 343},
{303, 359},
{303, 362},
{303, 370},
{303, 375},
{303, 389},
{291, 889},
{291, 890},
{291, 891},
{291, 892},
{291, 893},
{291, 894},
{291, 905},
{291, 903},
{593, 2046},
{291, 901},
{291, 902},
{497, 1897},
{594, 595},
{291, 886},
{291, 904},
{595, 529},
{596, 1030},
{597, 598},
{488, 994},
{597, 600},
{599, 2037},
{303, 399},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{314, 1505},
{274, 1814},
{314, 1505},
{601, 887},
{602, 603},
{604, 605},
{605, 1017},
{606, 1510},
{274, 1814},
{274, 1814},
{274, 1814},
{303, 401},
{607, 5},
{610, 1510},
{375, 1696},
{375, 1696},
{375, 1696},
{527, 2060},
{530, 2219},
{532, 2065},
{611, 5},
{533, 2066},
{613, 5},
{612, 1509},
{615, 616},
{617, 618},
{618, 619},
{619, 1510},
{620, 5},
{621, 2002},
{621, 2002},
{622, 610},
{622, 615},
{623, 624},
{622, 2151},
{624, 1510},
{314, 1505},
{314, 1505},
{314, 1505},
{628, 629},
{630, 1031},
{303, 408},
{303, 413},
{303, 417},
{303, 422},
{303, 427},
{303, 431},
{631, 632},
{303, 433},
{633, 634},
{634, 5},
{314, 1783},
{303, 135},
{612, 2002},
{639, 640},
{303, 156},
{637, 638},
{303, 192},
{303, 196},
{303, 200},
{640, 5},
{641, 2000},
{612, 1509},
{303, 443},
{303, 449},
{642, 2156},
{642, 637},
{488, 1507},
{488, 1507},
{488, 1507},
{303, 203},
{643, 5},
{645, 2000},
{646, 1032},
{647, 648},
{614, 2002},
{614, 2002},
{614, 2002},
{614, 2002},
{649, 650},
{650, 5},
{651, 652},
{652, 653},
{563, 2109},
{564, 2107},
{655, 2169},
{657, 2168},
{659, 1033},
{661, 654},
{662, 1510},
{663, 5},
{665, 1510},
{655, 2169},
{657, 2168},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{375, 1696},
{614, 2002},
{375, 1696},
{666, 5},
{668, 669},
{669, 1510},
{658, 2170},
{670, 2160},
{303, 206},
{614, 2002},
{303, 455},
{303, 462},
{303, 467},
{658, 2170},
{303, 472},
{303, 212},
{303, 478},
{303, 481},
{303, 484},
{303, 488},
{303, 492},
{656, 2167},
{671, 672},
{674, 523},
{660, 2165},
{580, 583},
{675, 1509},
{656, 657},
{656, 2167},
{549, 2032},
{566, 2081},
{660, 661},
{673, 887},
{571, 2079},
{676, 1034},
{677, 678},
{375, 1696},
{375, 1696},
{375, 1696},
{673, 674},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{488, 1507},
{680, 886},
{488, 1507},
{511, 2135},
{511, 1016},
{681, 682},
{510, 511},
{584, 587},
{510, 515},
{667, 1509},
{644, 1509},
{679, 674},
{675, 1509},
{683, 684},
{685, 2058},
{686, 1035},
{652, 662},
{687, 688},
{679, 680},
{689, 2059},
{512, 1505},
{690, 2055},
{694, 695},
{511, 2135},
{695, 696},
{510, 625},
{689, 2059},
{692, 693},
{690, 691},
{697, 140},
{693, 936},
{698, 693},
{644, 2002},
{693, 937},
{699, 700},
{701, 702},
{488, 1507},
{488, 1507},
{488, 1507},
{510, 631},
{512, 992},
{675, 2002},
{510, 647},
{704, 1952},
{706, 183},
{707, 708},
{510, 671},
{614, 2002},
{667, 1509},
{644, 1509},
{709, 710},
{705, 157},
{711, 2217},
{614, 2002},
{591, 519},
{705, 180},
{717, 1036},
{712, 718},
{510, 681},
{712, 733},
{722, 723},
{591, 523},
{723, 1037},
{591, 526},
{591, 1020},
{591, 537},
{591, 539},
{644, 2002},
{644, 2002},
{667, 2002},
{591, 541},
{724, 725},
{511, 2135},
{591, 553},
{591, 568},
{591, 570},
{591, 573},
{591, 574},
{591, 575},
{591, 576},
{591, 578},
{591, 579},
{726, 1039},
{591, 580},
{591, 584},
{591, 588},
{713, 714},
{728, 729},
{715, 2204},
{512, 1505},
{510, 692},
{601, 2038},
{510, 703},
{732, 1040},
{713, 2202},
{715, 716},
{720, 721},
{720, 1038},
{591, 592},
{591, 593},
{644, 2002},
{510, 711},
{510, 713},
{510, 745},
{510, 728},
{510, 733},
{733, 734},
{737, 1041},
{743, 992},
{721, 2233},
{730, 2127},
{744, 5},
{736, 15},
{511, 2135},
{511, 2135},
{511, 2135},
{721, 2233},
{730, 731},
{735, 2219},
{735, 2132},
{745, 719},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{735, 2132},
{546, 1505},
{736, 58},
{591, 594},
{512, 1505},
{512, 1505},
{512, 1505},
{546, 1505},
{735, 2219},
{546, 1505},
{546, 1505},
{738, 2130},
{637, 5},
{747, 713},
{706, 1952},
{546, 992},
{746, 747},
{546, 1505},
{738, 739},
{748, 749},
{749, 728},
{674, 5},
{751, 752},
{510, 2218},
{752, 753},
{740, 2221},
{740, 2133},
{754, 755},
{750, 2219},
{755, 606},
{750, 2219},
{750, 2219},
{757, 758},
{740, 2133},
{760, 5},
{546, 1505},
{546, 1505},
{546, 1505},
{750, 751},
{762, 763},
{692, 697},
{740, 2221},
{667, 2002},
{756, 511},
{698, 697},
{546, 1505},
{766, 5},
{750, 2219},
{763, 1042},
{704, 183},
{768, 769},
{769, 1043},
{772, 5},
{774, 775},
{775, 1044},
{759, 760},
{751, 647},
{765, 766},
{758, 511},
{771, 772},
{778, 5},
{780, 781},
{781, 1045},
{777, 778},
{783, 784},
{784, 5},
{786, 787},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{511, 2135},
{785, 1509},
{511, 2135},
{756, 671},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{512, 1505},
{758, 671},
{512, 1505},
{759, 5},
{787, 1046},
{765, 5},
{788, 789},
{771, 5},
{546, 1505},
{546, 1505},
{546, 1505},
{777, 5},
{789, 1510},
{790, 791},
{791, 792},
{713, 2202},
{713, 2202},
{713, 2202},
{713, 2202},
{511, 2135},
{511, 2135},
{511, 2135},
{793, 794},
{785, 1509},
{794, 5},
{796, 797},
{797, 1510},
{798, 799},
{800, 5},
{743, 1505},
{743, 1505},
{743, 1505},
{743, 1505},
{801, 1509},
{511, 2135},
{802, 803},
{512, 1505},
{512, 1505},
{512, 1505},
{803, 1510},
{763, 2194},
{804, 1567},
{805, 5},
{809, 89},
{769, 2199},
{775, 2209},
{701, 2175},
{807, 808},
{807, 811},
{810, 5},
{812, 1559},
{512, 5},
{781, 2214},
{813, 628},
{745, 724},
{814, 5},
{817, 1536},
{806, 7},
{816, 817},
{818, 5},
{713, 2202},
{709, 2182},
{801, 2002},
{819, 5},
{821, 1569},
{822, 1509},
{823, 1047},
{825, 826},
{806, 94},
{806, 1541},
{806, 1541},
{827, 5},
{801, 1509},
{828, 829},
{830, 1048},
{831, 1823},
{831, 825},
{834, 5},
{782, 1509},
{832, 1819},
{832, 1819},
{836, 837},
{837, 1527},
{838, 5},
{840, 1479},
{843, 1523},
{844, 5},
{847, 848},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{546, 1505},
{842, 843},
{546, 1505},
{848, 1557},
{713, 2202},
{849, 5},
{850, 1476},
{746, 2187},
{804, 805},
{0, 0},
{748, 2188},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{743, 2121},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{845, 873},
{845, 874},
{845, 875},
{845, 876},
{845, 7},
{845, 918},
{845, 919},
{806, 95},
{0, 0},
{0, 0},
{0, 0},
{546, 1505},
{546, 1505},
{546, 1505},
{833, 851},
{845, 94},
{845, 1541},
{845, 1541},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{782, 1509},
{785, 2002},
{0, 0},
{0, 0},
{0, 0},
{746, 2187},
{0, 0},
{782, 1509},
{748, 2188},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{782, 1509},
{806, 98},
{806, 99},
{0, 0},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{836, 1528},
{0, 0},
{0, 0},
{0, 0},
{845, 95},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{813, 1539},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{816, 1537},
{0, 0},
{0, 0},
{0, 0},
{833, 852},
{833, 853},
{833, 854},
{0, 0},
{0, 0},
{0, 0},
{845, 98},
{845, 99},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{782, 1509},
{0, 0},
{809, 1559},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{842, 1524},
{0, 0},
{0, 0},
{0, 0},
{847, 1558},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{828, 1826},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{782, 1509},
{782, 1509},
{782, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{833, 855},
{833, 856},
{833, 857},
{833, 858},
{833, 859},
{833, 860},
{833, 861},
{833, 862},
{833, 863},
{833, 864},
{833, 865},
{833, 866},
{833, 867},
{833, 868},
{0, 0},
{833, 869},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{0, 0},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 7},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{833, 870},
{833, 871},
{833, 872},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1509},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1509},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 111},
{0, 0},
{846, 275},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 285},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1610},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{0, 0},
{846, 1610},
{846, 1509},
{846, 1610},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{0, 0},
{846, 1509},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{846, 1509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{846, 1610},
{846, 1610},
{846, 1610},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
3,
1049,
850,
1464,
1051,
6,
1050,
1052,
1072,
88,
303,
78,
839,
1466,
1467,
1468,
1469,
1470,
840,
841,
93,
1077,
1079,
284,
1077,
807,
815,
97,
115,
845,
110,
1053,
116,
1091,
846,
1092,
150,
141,
509,
188,
185,
1149,
1076,
1082,
1150,
106,
1083,
1084,
82,
1085,
1075,
90,
91,
1053,
1078,
91,
1088,
108,
1449,
819,
1451,
1452,
1453,
1454,
1102,
1090,
1093,
1095,
62,
105,
1089,
101,
1103,
1124,
105,
146,
193,
1103,
1103,
1080,
1096,
16,
146,
105,
146,
106,
1083,
1084,
146,
1085,
106,
1083,
1084,
197,
1085,
103,
1086,
1087,
108,
106,
1083,
1084,
1053,
1085,
113,
225,
189,
14,
1053,
1081,
1127,
1094,
1130,
105,
1130,
246,
257,
1133,
48,
193,
232,
106,
1083,
1084,
197,
1085,
220,
14,
209,
106,
1083,
1084,
220,
1085,
1053,
1053,
245,
1144,
1053,
258,
1143,
250,
252,
1145,
1146,
1163,
283,
286,
1151,
14,
1187,
1181,
1186,
114,
119,
315,
1167,
338,
274,
16,
274,
259,
340,
1208,
300,
1211,
1210,
29,
27,
24,
22,
18,
22,
45,
37,
35,
39,
14,
1133,
20,
1216,
377,
1219,
1053,
1053,
372,
371,
1053,
383,
247,
378,
1053,
1178,
387,
247,
385,
48,
396,
14,
20,
1225,
397,
1224,
403,
14,
1226,
397,
1205,
409,
1053,
265,
1232,
379,
348,
414,
418,
1238,
379,
1136,
210,
423,
177,
1115,
182,
211,
1138,
1106,
1107,
1102,
208,
14,
166,
1053,
260,
169,
262,
1116,
1117,
178,
178,
178,
190,
1118,
1119,
1121,
1119,
178,
211,
1137,
20,
1114,
1166,
1241,
1113,
268,
14,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
428,
1125,
194,
301,
1053,
255,
1148,
1139,
210,
1114,
255,
1147,
1217,
373,
14,
174,
1128,
198,
14,
432,
1212,
1222,
176,
436,
435,
137,
441,
147,
1053,
1108,
1109,
152,
147,
147,
1053,
1152,
1110,
20,
1111,
296,
14,
49,
1112,
1228,
1126,
194,
380,
1129,
198,
60,
1054,
382,
263,
1141,
223,
268,
1053,
350,
351,
1142,
223,
1227,
20,
14,
1134,
204,
1206,
341,
1120,
191,
1054,
1122,
1131,
201,
1132,
201,
19,
1139,
210,
1055,
1123,
1056,
282,
444,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1055,
14,
1056,
1193,
19,
34,
43,
42,
1066,
1063,
21,
40,
41,
20,
1064,
28,
30,
1061,
31,
1065,
49,
1054,
1055,
1069,
1056,
14,
1135,
204,
57,
1248,
1053,
14,
1213,
360,
61,
19,
1064,
28,
30,
1061,
31,
1065,
1054,
1182,
1183,
298,
1185,
1192,
1054,
1065,
1055,
51,
1056,
14,
446,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
440,
1055,
348,
1056,
1054,
1054,
265,
1055,
1054,
1056,
364,
1164,
266,
59,
450,
1064,
28,
30,
1061,
31,
1065,
1058,
28,
30,
1061,
31,
1065,
327,
1205,
1054,
33,
1069,
296,
1055,
1055,
1056,
383,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
1202,
1064,
28,
30,
1061,
31,
1065,
1054,
1054,
20,
14,
1054,
1055,
51,
1056,
1054,
1202,
34,
43,
42,
1066,
1063,
21,
40,
41,
452,
1064,
28,
30,
1061,
31,
1065,
1053,
1054,
348,
437,
1055,
1055,
1056,
1212,
1055,
459,
1060,
14,
1055,
1057,
21,
40,
41,
1252,
1064,
28,
30,
1061,
31,
1065,
1054,
1061,
31,
1065,
1053,
383,
1055,
466,
1056,
1209,
351,
47,
43,
42,
1066,
1063,
21,
40,
41,
1251,
1064,
28,
30,
1061,
31,
1065,
20,
471,
485,
1055,
489,
1056,
1221,
1184,
1183,
298,
1185,
1054,
503,
379,
23,
41,
508,
1064,
28,
30,
1061,
31,
1065,
383,
1207,
341,
379,
1053,
16,
367,
368,
1203,
335,
20,
1311,
1054,
440,
1312,
329,
440,
1055,
1054,
1056,
330,
1200,
364,
14,
1204,
335,
1248,
512,
1053,
44,
1067,
1064,
28,
30,
1061,
31,
1065,
1053,
355,
351,
1054,
1055,
48,
1056,
524,
1214,
360,
1055,
410,
1056,
1248,
14,
1194,
26,
1220,
1064,
28,
30,
1061,
31,
1065,
1059,
28,
30,
1061,
31,
1065,
513,
278,
1055,
790,
1056,
1253,
447,
53,
36,
42,
1066,
1063,
21,
40,
41,
1313,
1064,
28,
30,
1061,
31,
1065,
386,
1165,
266,
1053,
1229,
527,
20,
1179,
1180,
1223,
1053,
391,
14,
388,
1053,
1314,
284,
547,
807,
815,
372,
1229,
105,
67,
1054,
1168,
1169,
1170,
1171,
1172,
1173,
1174,
1175,
1176,
1177,
306,
1053,
410,
106,
1083,
1084,
1235,
1085,
1235,
14,
1250,
1194,
53,
1249,
345,
346,
353,
543,
1055,
545,
1056,
569,
1054,
327,
439,
38,
1066,
1063,
21,
40,
41,
550,
1064,
28,
30,
1061,
31,
1065,
53,
292,
1190,
314,
316,
1053,
332,
1215,
368,
1327,
442,
20,
543,
1055,
1316,
1056,
1233,
411,
34,
43,
42,
1066,
1063,
21,
40,
41,
306,
1064,
28,
30,
1061,
31,
1065,
14,
419,
1195,
1196,
306,
64,
1218,
373,
1328,
71,
20,
356,
1244,
306,
1168,
1169,
1170,
1171,
1172,
1173,
1174,
1175,
1176,
1177,
1244,
1053,
14,
67,
1053,
67,
1329,
1197,
1277,
1065,
1338,
49,
1054,
307,
345,
346,
353,
1339,
65,
1068,
1191,
314,
316,
604,
332,
824,
1252,
832,
1236,
415,
1237,
415,
514,
309,
313,
311,
549,
1234,
411,
1271,
1054,
1055,
68,
1056,
14,
419,
1230,
406,
20,
1062,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1195,
1198,
1231,
406,
1268,
1244,
1199,
1053,
1055,
424,
1056,
330,
1200,
20,
1258,
473,
14,
1255,
46,
40,
41,
358,
1064,
28,
30,
1061,
31,
1065,
1054,
1054,
1073,
1069,
1268,
429,
1053,
543,
306,
552,
306,
393,
14,
1365,
1246,
608,
73,
429,
1255,
1282,
501,
424,
1239,
420,
1054,
623,
1245,
20,
612,
1055,
1055,
51,
1056,
1054,
69,
34,
43,
42,
1066,
1063,
21,
40,
41,
75,
1064,
28,
30,
1061,
31,
1065,
1201,
1258,
332,
1055,
309,
1188,
311,
614,
69,
621,
20,
395,
1055,
54,
1056,
1254,
447,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
1053,
429,
20,
1370,
626,
1265,
1054,
627,
1240,
420,
1247,
1265,
1197,
1054,
1065,
473,
1372,
1054,
630,
1271,
14,
1258,
1274,
1259,
460,
1274,
1054,
1053,
646,
645,
1317,
1242,
425,
1256,
453,
1055,
1320,
81,
641,
1054,
1278,
497,
1055,
1070,
1056,
1373,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
1055,
1064,
28,
30,
1061,
31,
1065,
1257,
453,
85,
20,
1272,
486,
1055,
1071,
1056,
1243,
425,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1260,
460,
1258,
1277,
20,
1053,
644,
1197,
14,
1065,
1367,
788,
613,
1263,
476,
1366,
1269,
482,
1366,
1197,
607,
1065,
1055,
611,
1056,
86,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
125,
1318,
1270,
482,
1054,
1053,
1054,
1054,
1054,
651,
1261,
460,
1095,
1055,
1320,
1056,
76,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
665,
1055,
1055,
1055,
20,
1056,
1074,
664,
34,
43,
42,
1066,
1063,
21,
40,
41,
667,
1064,
28,
30,
1061,
31,
1065,
1054,
1384,
14,
1386,
1366,
510,
123,
494,
20,
620,
499,
1281,
501,
126,
1054,
1097,
1098,
127,
146,
1100,
131,
146,
1262,
460,
1264,
476,
1266,
479,
1391,
1055,
1273,
486,
1267,
479,
804,
1275,
490,
1366,
1276,
490,
514,
1054,
1371,
1055,
577,
1056,
1053,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
1280,
706,
14,
499,
1281,
501,
510,
1055,
1103,
1056,
1382,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
129,
1064,
28,
30,
1061,
31,
1065,
510,
514,
505,
1099,
127,
499,
1281,
501,
636,
1053,
510,
668,
670,
19,
1366,
1366,
1366,
1279,
497,
663,
666,
1379,
1380,
670,
712,
1321,
1390,
1054,
1401,
642,
1053,
727,
16,
1395,
1119,
720,
1053,
712,
514,
1375,
1408,
514,
746,
562,
1409,
566,
133,
20,
1397,
1119,
1412,
712,
14,
764,
1054,
1101,
1055,
761,
1056,
1100,
131,
34,
43,
42,
1066,
1063,
21,
40,
41,
48,
1064,
28,
30,
1061,
31,
1065,
748,
1410,
1390,
1431,
1390,
675,
1053,
1055,
1053,
1056,
16,
514,
34,
43,
42,
1066,
1063,
21,
40,
41,
1394,
1064,
28,
30,
1061,
31,
1065,
770,
767,
14,
1053,
1367,
609,
613,
741,
742,
743,
712,
712,
1433,
776,
773,
510,
1435,
1054,
782,
1394,
48,
20,
510,
577,
779,
14,
1411,
1437,
510,
577,
1321,
785,
1366,
795,
801,
822,
1053,
1439,
806,
1330,
160,
809,
1331,
1441,
1388,
1053,
1055,
1389,
1056,
643,
571,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1053,
1366,
757,
1412,
810,
1366,
1440,
510,
20,
597,
1442,
726,
1445,
14,
1054,
683,
163,
1413,
1367,
1368,
613,
812,
1055,
813,
814,
1367,
1369,
613,
1446,
818,
694,
20,
147,
14,
1367,
622,
613,
172,
1447,
1448,
820,
823,
830,
1055,
831,
1056,
1458,
643,
34,
43,
42,
1066,
1063,
21,
40,
41,
834,
1064,
28,
30,
1061,
31,
1065,
835,
303,
16,
685,
838,
643,
1367,
1374,
613,
506,
1462,
1457,
14,
1457,
1394,
643,
1460,
1463,
831,
1471,
225,
844,
20,
143,
144,
1105,
1472,
1473,
1054,
509,
849,
1474,
1475,
14,
0,
0,
106,
1083,
1084,
48,
1085,
0,
20,
1367,
1377,
613,
1367,
1378,
613,
1449,
819,
1451,
1452,
1453,
1454,
0,
798,
1055,
0,
1056,
514,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1104,
144,
1105,
0,
1054,
1332,
0,
20,
1333,
744,
0,
1334,
0,
0,
1335,
1367,
676,
613,
1053,
0,
0,
14,
1402,
0,
0,
1054,
1381,
1054,
20,
1069,
216,
1054,
701,
1055,
1393,
1056,
1405,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1432,
1064,
28,
30,
1061,
31,
1065,
1434,
1055,
1053,
1055,
51,
1056,
1436,
1055,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
0,
1054,
0,
1054,
1053,
1054,
0,
1069,
698,
699,
701,
0,
1392,
14,
0,
0,
214,
20,
827,
828,
1459,
828,
1406,
1407,
0,
1054,
686,
687,
1438,
709,
1055,
1399,
1055,
0,
1055,
51,
1056,
0,
730,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
709,
1056,
1398,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
49,
14,
0,
0,
1425,
1053,
1426,
0,
187,
0,
214,
20,
0,
1055,
1054,
704,
0,
1396,
0,
0,
0,
514,
1055,
0,
1056,
1053,
730,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
214,
1055,
514,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
514,
1064,
28,
30,
1061,
31,
1065,
514,
0,
0,
0,
735,
0,
14,
1367,
762,
613,
20,
1053,
1053,
0,
0,
0,
1054,
0,
1069,
0,
0,
123,
0,
0,
0,
0,
514,
0,
229,
0,
1097,
1098,
127,
0,
1100,
131,
217,
218,
14,
1053,
0,
0,
705,
707,
0,
1055,
51,
1056,
254,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
685,
1064,
28,
30,
1061,
31,
1065,
735,
0,
0,
715,
0,
0,
0,
0,
0,
0,
0,
123,
0,
20,
0,
14,
0,
0,
235,
1054,
1097,
1098,
127,
0,
1100,
131,
0,
0,
1367,
768,
613,
0,
0,
0,
0,
736,
0,
0,
1053,
1140,
218,
732,
14,
715,
1054,
20,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
14,
222,
218,
1055,
0,
123,
0,
0,
0,
0,
0,
1054,
249,
0,
1097,
1098,
127,
20,
1100,
131,
0,
0,
0,
0,
0,
0,
736,
0,
0,
0,
0,
0,
0,
1403,
0,
0,
1054,
0,
0,
0,
1055,
0,
1056,
0,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1367,
774,
613,
0,
14,
1055,
0,
0,
0,
1081,
1053,
0,
20,
105,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
1367,
780,
613,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
1367,
786,
613,
0,
1387,
687,
0,
1367,
796,
613,
0,
0,
71,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1367,
802,
613,
1054,
0,
0,
0,
0,
20,
246,
257,
0,
1055,
1054,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
0,
0,
717,
0,
14,
0,
0,
0,
1055,
737,
738,
740,
0,
0,
0,
0,
0,
0,
1054,
1054,
1055,
0,
1056,
1053,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
1400,
0,
0,
0,
1054,
1055,
1055,
1056,
0,
1189,
34,
43,
42,
1066,
1063,
21,
40,
41,
321,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
1404,
738,
740,
0,
0,
1055,
20,
1056,
0,
225,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
106,
1083,
1084,
0,
1085,
1053,
1055,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
258,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
323,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1283,
1284,
1285,
1286,
1287,
1288,
1289,
1290,
1291,
1292,
1293,
1294,
1295,
1296,
1297,
1298,
1299,
1300,
1301,
1302,
1303,
1304,
1305,
0,
1443,
1444,
0,
0,
0,
0,
0,
0,
20,
284,
0,
807,
815,
14,
0,
105,
0,
0,
1053,
0,
0,
0,
0,
0,
1153,
1053,
262,
1455,
821,
1054,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
0,
0,
1055,
0,
1056,
0,
366,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
475,
0,
0,
20,
0,
0,
0,
0,
0,
0,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
1306,
1307,
1308,
1309,
1310,
0,
0,
263,
0,
303,
268,
0,
0,
597,
0,
0,
0,
816,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
0,
0,
509,
1443,
1444,
14,
0,
0,
1054,
106,
1083,
1084,
284,
1085,
807,
815,
0,
263,
105,
750,
268,
1053,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
1456,
821,
0,
0,
106,
1083,
1084,
1055,
1085,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
20,
517,
1179,
1180,
0,
0,
0,
0,
0,
0,
0,
284,
0,
807,
815,
0,
0,
105,
1053,
0,
20,
0,
0,
0,
0,
0,
1414,
1415,
1054,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
521,
0,
1055,
597,
1056,
14,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1364,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
602,
0,
0,
0,
0,
0,
0,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
530,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
20,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
533,
0,
0,
0,
1461,
1053,
832,
0,
0,
0,
1054,
0,
1055,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
532,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
14,
1416,
1417,
1418,
1419,
1420,
1421,
1422,
1423,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
0,
0,
0,
0,
0,
0,
530,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
0,
14,
0,
0,
0,
0,
0,
0,
1424,
756,
1426,
0,
0,
1053,
1427,
1428,
1429,
0,
0,
0,
1054,
0,
1054,
0,
1430,
0,
533,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
759,
0,
765,
0,
0,
0,
771,
0,
777,
0,
783,
1055,
538,
1055,
0,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
20,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
540,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
14,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
303,
0,
0,
0,
555,
0,
0,
534,
535,
548,
0,
0,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
1053,
0,
20,
0,
0,
106,
1083,
1084,
0,
1085,
0,
558,
1054,
0,
0,
0,
0,
0,
1450,
819,
1451,
1452,
1453,
1454,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
557,
14,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
20,
555,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
1315,
535,
0,
558,
0,
303,
0,
20,
0,
0,
0,
0,
0,
836,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
225,
0,
0,
0,
0,
0,
0,
0,
0,
509,
0,
1054,
0,
0,
0,
20,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
1449,
819,
1451,
1452,
1453,
1454,
1054,
0,
0,
14,
0,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
1055,
1053,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
563,
0,
0,
0,
1055,
0,
1056,
0,
20,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
563,
559,
560,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
1053,
0,
0,
0,
563,
1054,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
14,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
563,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
530,
0,
0,
0,
1319,
560,
0,
20,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
533,
0,
20,
0,
0,
14,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
563,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
303,
0,
0,
0,
0,
0,
0,
0,
842,
0,
530,
0,
0,
0,
0,
20,
0,
0,
0,
225,
0,
0,
14,
0,
0,
1322,
0,
0,
509,
0,
564,
0,
0,
530,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
1054,
0,
0,
533,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
1323,
0,
0,
0,
0,
564,
0,
0,
0,
0,
0,
0,
20,
533,
0,
0,
1055,
0,
1056,
1054,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
0,
1324,
0,
0,
0,
0,
564,
1055,
14,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
14,
530,
0,
1325,
0,
0,
0,
0,
564,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
1054,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
533,
0,
0,
582,
535,
0,
0,
0,
0,
0,
0,
20,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
1326,
0,
0,
0,
0,
564,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
1054,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
590,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
1336,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
0,
586,
535,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
14,
0,
0,
0,
530,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
1053,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
533,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
1055,
0,
1056,
0,
1053,
34,
43,
42,
1066,
1063,
21,
40,
41,
599,
1064,
28,
30,
1061,
31,
1065,
0,
20,
0,
0,
0,
0,
0,
303,
0,
0,
0,
0,
0,
0,
1337,
847,
0,
0,
0,
0,
0,
601,
0,
0,
0,
0,
225,
0,
0,
14,
597,
0,
0,
1053,
0,
509,
0,
0,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
1054,
0,
0,
0,
14,
1053,
0,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
0,
0,
0,
0,
0,
0,
617,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
14,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
633,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
20,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
20,
635,
1053,
0,
0,
0,
0,
639,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1340,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
20,
596,
535,
0,
0,
0,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
14,
1053,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
597,
0,
0,
0,
0,
0,
649,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
1055,
1055,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
1054,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
14,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1054,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
656,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1340,
1064,
28,
30,
1061,
31,
1065,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
0,
0,
1053,
0,
0,
0,
1054,
0,
0,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
14,
0,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
1054,
655,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
658,
0,
0,
0,
0,
1053,
0,
0,
1055,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
64,
0,
0,
0,
0,
20,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
656,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1053,
0,
0,
14,
0,
0,
0,
673,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
64,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
53,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
673,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
0,
0,
0,
0,
1053,
0,
20,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
14,
0,
0,
1053,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
754,
1054,
677,
0,
0,
0,
14,
20,
0,
0,
0,
659,
660,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
689,
0,
20,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
677,
0,
16,
0,
0,
0,
20,
14,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
0,
0,
1054,
0,
0,
0,
14,
0,
0,
0,
0,
0,
48,
0,
0,
0,
0,
1053,
0,
0,
0,
0,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1053,
1064,
28,
30,
1061,
31,
1065,
1055,
20,
1056,
793,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
14,
0,
0,
1376,
660,
0,
0,
20,
0,
0,
71,
0,
0,
0,
1054,
1385,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
14,
1055,
1054,
1056,
679,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
1054,
1383,
0,
0,
0,
14,
0,
0,
20,
1055,
51,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
690,
20,
0,
800,
1054,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
49,
0,
0,
0,
0,
0,
0,
0,
722,
0,
0,
0,
20,
0,
1054,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
1069,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1055,
51,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1054,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
1054,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
0,
1064,
28,
30,
1061,
31,
1065,
0,
0,
0,
0,
0,
0,
0,
1055,
0,
1056,
0,
0,
34,
43,
42,
1066,
1063,
21,
40,
41,
1465,
1064,
28,
30,
1061,
31,
1065,
303,
0,
839,
1466,
1467,
1468,
1469,
1470,
840,
841,
0,
0,
0,
284,
0,
807,
815,
0,
0,
845,
0,
0,
0,
0,
846,
0,
0,
0,
509,
0,
0,
0,
0,
0,
0,
106,
1083,
1084,
0,
1085,
0,
0,
0,
0,
0,
0,
0,
0,
1449,
819,
1451,
1452,
1453,
1454,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [143],
& yyTComb [1],
& yyTComb [0],
& yyTComb [2],
& yyTComb [218],
& yyTComb [0],
& yyTComb [275],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [325],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1],
& yyTComb [0],
& yyTComb [3],
& yyTComb [356],
& yyTComb [0],
& yyTComb [441],
& yyTComb [0],
& yyTComb [0],
& yyTComb [472],
& yyTComb [0],
& yyTComb [507],
& yyTComb [0],
& yyTComb [225],
& yyTComb [0],
& yyTComb [0],
& yyTComb [7],
& yyTComb [416],
& yyTComb [0],
& yyTComb [538],
& yyTComb [0],
& yyTComb [546],
& yyTComb [0],
& yyTComb [582],
& yyTComb [613],
& yyTComb [648],
& yyTComb [679],
& yyTComb [710],
& yyTComb [0],
& yyTComb [744],
& yyTComb [746],
& yyTComb [9],
& yyTComb [14],
& yyTComb [0],
& yyTComb [9],
& yyTComb [6],
& yyTComb [20],
& yyTComb [103],
& yyTComb [0],
& yyTComb [18],
& yyTComb [17],
& yyTComb [0],
& yyTComb [783],
& yyTComb [13],
& yyTComb [814],
& yyTComb [56],
& yyTComb [0],
& yyTComb [29],
& yyTComb [28],
& yyTComb [0],
& yyTComb [854],
& yyTComb [51],
& yyTComb [1],
& yyTComb [0],
& yyTComb [58],
& yyTComb [0],
& yyTComb [229],
& yyTComb [0],
& yyTComb [70],
& yyTComb [72],
& yyTComb [75],
& yyTComb [906],
& yyTComb [82],
& yyTComb [93],
& yyTComb [94],
& yyTComb [104],
& yyTComb [0],
& yyTComb [102],
& yyTComb [106],
& yyTComb [108],
& yyTComb [0],
& yyTComb [0],
& yyTComb [111],
& yyTComb [112],
& yyTComb [114],
& yyTComb [112],
& yyTComb [3],
& yyTComb [0],
& yyTComb [125],
& yyTComb [0],
& yyTComb [125],
& yyTComb [0],
& yyTComb [136],
& yyTComb [0],
& yyTComb [136],
& yyTComb [1],
& yyTComb [138],
& yyTComb [0],
& yyTComb [0],
& yyTComb [905],
& yyTComb [0],
& yyTComb [156],
& yyTComb [0],
& yyTComb [2],
& yyTComb [961],
& yyTComb [31],
& yyTComb [132],
& yyTComb [0],
& yyTComb [4],
& yyTComb [0],
& yyTComb [5],
& yyTComb [6],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [140],
& yyTComb [157],
& yyTComb [1],
& yyTComb [147],
& yyTComb [158],
& yyTComb [153],
& yyTComb [167],
& yyTComb [161],
& yyTComb [162],
& yyTComb [167],
& yyTComb [165],
& yyTComb [169],
& yyTComb [176],
& yyTComb [0],
& yyTComb [176],
& yyTComb [61],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [201],
& yyTComb [230],
& yyTComb [217],
& yyTComb [300],
& yyTComb [232],
& yyTComb [0],
& yyTComb [0],
& yyTComb [222],
& yyTComb [0],
& yyTComb [222],
& yyTComb [95],
& yyTComb [0],
& yyTComb [0],
& yyTComb [261],
& yyTComb [0],
& yyTComb [266],
& yyTComb [235],
& yyTComb [238],
& yyTComb [283],
& yyTComb [240],
& yyTComb [249],
& yyTComb [251],
& yyTComb [251],
& yyTComb [261],
& yyTComb [265],
& yyTComb [267],
& yyTComb [274],
& yyTComb [280],
& yyTComb [284],
& yyTComb [279],
& yyTComb [0],
& yyTComb [280],
& yyTComb [0],
& yyTComb [289],
& yyTComb [302],
& yyTComb [312],
& yyTComb [0],
& yyTComb [412],
& yyTComb [0],
& yyTComb [303],
& yyTComb [301],
& yyTComb [326],
& yyTComb [0],
& yyTComb [0],
& yyTComb [306],
& yyTComb [381],
& yyTComb [0],
& yyTComb [0],
& yyTComb [301],
& yyTComb [345],
& yyTComb [313],
& yyTComb [314],
& yyTComb [0],
& yyTComb [346],
& yyTComb [317],
& yyTComb [329],
& yyTComb [0],
& yyTComb [354],
& yyTComb [333],
& yyTComb [350],
& yyTComb [357],
& yyTComb [350],
& yyTComb [0],
& yyTComb [324],
& yyTComb [696],
& yyTComb [354],
& yyTComb [0],
& yyTComb [0],
& yyTComb [376],
& yyTComb [366],
& yyTComb [0],
& yyTComb [421],
& yyTComb [0],
& yyTComb [413],
& yyTComb [368],
& yyTComb [417],
& yyTComb [0],
& yyTComb [372],
& yyTComb [0],
& yyTComb [387],
& yyTComb [383],
& yyTComb [0],
& yyTComb [977],
& yyTComb [851],
& yyTComb [392],
& yyTComb [0],
& yyTComb [392],
& yyTComb [394],
& yyTComb [0],
& yyTComb [412],
& yyTComb [416],
& yyTComb [0],
& yyTComb [418],
& yyTComb [431],
& yyTComb [4],
& yyTComb [431],
& yyTComb [433],
& yyTComb [442],
& yyTComb [435],
& yyTComb [437],
& yyTComb [446],
& yyTComb [439],
& yyTComb [436],
& yyTComb [0],
& yyTComb [472],
& yyTComb [434],
& yyTComb [442],
& yyTComb [480],
& yyTComb [548],
& yyTComb [553],
& yyTComb [0],
& yyTComb [443],
& yyTComb [446],
& yyTComb [0],
& yyTComb [439],
& yyTComb [214],
& yyTComb [215],
& yyTComb [360],
& yyTComb [239],
& yyTComb [838],
& yyTComb [468],
& yyTComb [0],
& yyTComb [536],
& yyTComb [477],
& yyTComb [0],
& yyTComb [492],
& yyTComb [968],
& yyTComb [487],
& yyTComb [351],
& yyTComb [502],
& yyTComb [507],
& yyTComb [1077],
& yyTComb [406],
& yyTComb [516],
& yyTComb [0],
& yyTComb [521],
& yyTComb [523],
& yyTComb [538],
& yyTComb [540],
& yyTComb [301],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [554],
& yyTComb [426],
& yyTComb [556],
& yyTComb [0],
& yyTComb [566],
& yyTComb [1225],
& yyTComb [568],
& yyTComb [574],
& yyTComb [581],
& yyTComb [578],
& yyTComb [578],
& yyTComb [0],
& yyTComb [587],
& yyTComb [468],
& yyTComb [588],
& yyTComb [604],
& yyTComb [0],
& yyTComb [1191],
& yyTComb [0],
& yyTComb [0],
& yyTComb [583],
& yyTComb [586],
& yyTComb [0],
& yyTComb [589],
& yyTComb [0],
& yyTComb [613],
& yyTComb [0],
& yyTComb [616],
& yyTComb [1086],
& yyTComb [619],
& yyTComb [617],
& yyTComb [0],
& yyTComb [642],
& yyTComb [0],
& yyTComb [0],
& yyTComb [635],
& yyTComb [0],
& yyTComb [627],
& yyTComb [668],
& yyTComb [662],
& yyTComb [661],
& yyTComb [659],
& yyTComb [1],
& yyTComb [633],
& yyTComb [673],
& yyTComb [971],
& yyTComb [684],
& yyTComb [0],
& yyTComb [0],
& yyTComb [653],
& yyTComb [0],
& yyTComb [399],
& yyTComb [0],
& yyTComb [0],
& yyTComb [640],
& yyTComb [657],
& yyTComb [665],
& yyTComb [3],
& yyTComb [691],
& yyTComb [694],
& yyTComb [677],
& yyTComb [0],
& yyTComb [758],
& yyTComb [0],
& yyTComb [681],
& yyTComb [701],
& yyTComb [0],
& yyTComb [684],
& yyTComb [0],
& yyTComb [698],
& yyTComb [0],
& yyTComb [826],
& yyTComb [693],
& yyTComb [0],
& yyTComb [699],
& yyTComb [0],
& yyTComb [715],
& yyTComb [0],
& yyTComb [719],
& yyTComb [0],
& yyTComb [738],
& yyTComb [719],
& yyTComb [742],
& yyTComb [0],
& yyTComb [723],
& yyTComb [0],
& yyTComb [725],
& yyTComb [736],
& yyTComb [0],
& yyTComb [1193],
& yyTComb [721],
& yyTComb [730],
& yyTComb [0],
& yyTComb [771],
& yyTComb [0],
& yyTComb [743],
& yyTComb [0],
& yyTComb [751],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [784],
& yyTComb [0],
& yyTComb [0],
& yyTComb [754],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [822],
& yyTComb [762],
& yyTComb [756],
& yyTComb [765],
& yyTComb [696],
& yyTComb [532],
& yyTComb [782],
& yyTComb [784],
& yyTComb [782],
& yyTComb [773],
& yyTComb [0],
& yyTComb [785],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [803],
& yyTComb [839],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [879],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [880],
& yyTComb [881],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [886],
& yyTComb [888],
& yyTComb [0],
& yyTComb [556],
& yyTComb [0],
& yyTComb [889],
& yyTComb [0],
& yyTComb [801],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [794],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [808],
& yyTComb [0],
& yyTComb [893],
& yyTComb [584],
& yyTComb [0],
& yyTComb [0],
& yyTComb [822],
& yyTComb [930],
& yyTComb [834],
& yyTComb [911],
& yyTComb [0],
& yyTComb [0],
& yyTComb [837],
& yyTComb [931],
& yyTComb [844],
& yyTComb [850],
& yyTComb [861],
& yyTComb [860],
& yyTComb [0],
& yyTComb [0],
& yyTComb [932],
& yyTComb [0],
& yyTComb [917],
& yyTComb [926],
& yyTComb [919],
& yyTComb [0],
& yyTComb [0],
& yyTComb [931],
& yyTComb [942],
& yyTComb [935],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [884],
& yyTComb [0],
& yyTComb [945],
& yyTComb [958],
& yyTComb [0],
& yyTComb [956],
& yyTComb [959],
& yyTComb [0],
& yyTComb [976],
& yyTComb [960],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [969],
& yyTComb [0],
& yyTComb [1246],
& yyTComb [0],
& yyTComb [972],
& yyTComb [0],
& yyTComb [951],
& yyTComb [0],
& yyTComb [953],
& yyTComb [958],
& yyTComb [0],
& yyTComb [1011],
& yyTComb [0],
& yyTComb [984],
& yyTComb [0],
& yyTComb [988],
& yyTComb [792],
& yyTComb [987],
& yyTComb [991],
& yyTComb [996],
& yyTComb [961],
& yyTComb [759],
& yyTComb [760],
& yyTComb [985],
& yyTComb [1387],
& yyTComb [1452],
& yyTComb [1469],
& yyTComb [0],
& yyTComb [982],
& yyTComb [1017],
& yyTComb [0],
& yyTComb [1017],
& yyTComb [961],
& yyTComb [1021],
& yyTComb [0],
& yyTComb [1022],
& yyTComb [1035],
& yyTComb [0],
& yyTComb [962],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1052],
& yyTComb [1043],
& yyTComb [0],
& yyTComb [1053],
& yyTComb [0],
& yyTComb [1054],
& yyTComb [1056],
& yyTComb [1048],
& yyTComb [1050],
& yyTComb [0],
& yyTComb [811],
& yyTComb [821],
& yyTComb [823],
& yyTComb [824],
& yyTComb [1082],
& yyTComb [0],
& yyTComb [1096],
& yyTComb [0],
& yyTComb [1066],
& yyTComb [1570],
& yyTComb [0],
& yyTComb [826],
& yyTComb [1171],
& yyTComb [1069],
& yyTComb [0],
& yyTComb [1069],
& yyTComb [1099],
& yyTComb [0],
& yyTComb [1103],
& yyTComb [1097],
& yyTComb [1102],
& yyTComb [1128],
& yyTComb [1101],
& yyTComb [1174],
& yyTComb [1101],
& yyTComb [865],
& yyTComb [1118],
& yyTComb [1119],
& yyTComb [0],
& yyTComb [1172],
& yyTComb [0],
& yyTComb [0],
& yyTComb [895],
& yyTComb [1204],
& yyTComb [1175],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1138],
& yyTComb [0],
& yyTComb [950],
& yyTComb [0],
& yyTComb [1210],
& yyTComb [1197],
& yyTComb [0],
& yyTComb [1206],
& yyTComb [0],
& yyTComb [1232],
& yyTComb [0],
& yyTComb [1212],
& yyTComb [0],
& yyTComb [1216],
& yyTComb [0],
& yyTComb [1216],
& yyTComb [1433],
& yyTComb [983],
& yyTComb [1008],
& yyTComb [1254],
& yyTComb [1253],
& yyTComb [1257],
& yyTComb [1262],
& yyTComb [0],
& yyTComb [1020],
& yyTComb [0],
& yyTComb [1286],
& yyTComb [1273],
& yyTComb [0],
& yyTComb [1274],
& yyTComb [1294],
& yyTComb [1042],
& yyTComb [1047],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1048],
& yyTComb [1055],
& yyTComb [1267],
& yyTComb [1057],
& yyTComb [1292],
& yyTComb [1301],
& yyTComb [0],
& yyTComb [1301],
& yyTComb [1244],
& yyTComb [1062],
& yyTComb [1063],
& yyTComb [1246],
& yyTComb [1248],
& yyTComb [1247],
& yyTComb [1070],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1316],
& yyTComb [0],
& yyTComb [1316],
& yyTComb [1324],
& yyTComb [0],
& yyTComb [1325],
& yyTComb [1085],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1333],
& yyTComb [0],
& yyTComb [1330],
& yyTComb [1095],
& yyTComb [1247],
& yyTComb [1252],
& yyTComb [1106],
& yyTComb [1414],
& yyTComb [1259],
& yyTComb [1260],
& yyTComb [1351],
& yyTComb [0],
& yyTComb [1355],
& yyTComb [1115],
& yyTComb [1265],
& yyTComb [1359],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1361],
& yyTComb [1404],
& yyTComb [1362],
& yyTComb [1389],
& yyTComb [1363],
& yyTComb [1407],
& yyTComb [1358],
& yyTComb [1124],
& yyTComb [1125],
& yyTComb [0],
& yyTComb [1126],
& yyTComb [1145],
& yyTComb [1413],
& yyTComb [1196],
& yyTComb [1147],
& yyTComb [1199],
& yyTComb [1406],
& yyTComb [0],
& yyTComb [1422],
& yyTComb [1342],
& yyTComb [1377],
& yyTComb [1317],
& yyTComb [1422],
& yyTComb [0],
& yyTComb [1447],
& yyTComb [1408],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1443],
& yyTComb [1451],
& yyTComb [1446],
& yyTComb [0],
& yyTComb [1455],
& yyTComb [1457],
& yyTComb [0],
& yyTComb [1464],
& yyTComb [1463],
& yyTComb [1458],
& yyTComb [1322],
& yyTComb [0],
& yyTComb [1462],
& yyTComb [1468],
& yyTComb [1457],
& yyTComb [0],
& yyTComb [1464],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1466],
& yyTComb [1488],
& yyTComb [1335],
& yyTComb [1468],
& yyTComb [0],
& yyTComb [1479],
& yyTComb [0],
& yyTComb [1290],
& yyTComb [1341],
& yyTComb [1523],
& yyTComb [0],
& yyTComb [1524],
& yyTComb [0],
& yyTComb [1492],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1533],
& yyTComb [1539],
& yyTComb [1496],
& yyTComb [1498],
& yyTComb [1508],
& yyTComb [0],
& yyTComb [1518],
& yyTComb [0],
& yyTComb [1524],
& yyTComb [0],
& yyTComb [1546],
& yyTComb [0],
& yyTComb [1529],
& yyTComb [1543],
& yyTComb [0],
& yyTComb [1555],
& yyTComb [1549],
& yyTComb [1543],
& yyTComb [1573],
& yyTComb [0],
& yyTComb [1588],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1537],
& yyTComb [1306],
& yyTComb [1557],
& yyTComb [1571],
& yyTComb [1424],
& yyTComb [1574],
& yyTComb [1429],
& yyTComb [1594],
& yyTComb [1527],
& yyTComb [1587],
& yyTComb [0],
& yyTComb [1589],
& yyTComb [1533],
& yyTComb [1550],
& yyTComb [1588],
& yyTComb [1565],
& yyTComb [1421],
& yyTComb [1355],
& yyTComb [0],
& yyTComb [1404],
& yyTComb [1458],
& yyTComb [0],
& yyTComb [1423],
& yyTComb [1367],
& yyTComb [0],
& yyTComb [1415],
& yyTComb [1462],
& yyTComb [0],
& yyTComb [1425],
& yyTComb [1373],
& yyTComb [0],
& yyTComb [1418],
& yyTComb [1463],
& yyTComb [0],
& yyTComb [1429],
& yyTComb [1381],
& yyTComb [0],
& yyTComb [1426],
& yyTComb [1470],
& yyTComb [1750],
& yyTComb [1428],
& yyTComb [1386],
& yyTComb [1611],
& yyTComb [1431],
& yyTComb [1465],
& yyTComb [1604],
& yyTComb [1430],
& yyTComb [1616],
& yyTComb [1674],
& yyTComb [0],
& yyTComb [1681],
& yyTComb [1442],
& yyTComb [0],
& yyTComb [1623],
& yyTComb [1444],
& yyTComb [1690],
& yyTComb [0],
& yyTComb [1446],
& yyTComb [1660],
& yyTComb [1633],
& yyTComb [1457],
& yyTComb [1646],
& yyTComb [1460],
& yyTComb [1676],
& yyTComb [1654],
& yyTComb [0],
& yyTComb [1703],
& yyTComb [1467],
& yyTComb [0],
& yyTComb [1646],
& yyTComb [1649],
& yyTComb [1473],
& yyTComb [0],
& yyTComb [1664],
& yyTComb [1474],
& yyTComb [1477],
& yyTComb [1481],
& yyTComb [0],
& yyTComb [1669],
& yyTComb [1670],
& yyTComb [1671],
& yyTComb [0],
& yyTComb [1615],
& yyTComb [0],
& yyTComb [1489],
& yyTComb [1725],
& yyTComb [0],
& yyTComb [1614],
& yyTComb [1615],
& yyTComb [1619],
& yyTComb [1812],
& yyTComb [1495],
& yyTComb [0],
& yyTComb [1620],
& yyTComb [1500],
& yyTComb [1501],
& yyTComb [0],
& yyTComb [1757],
& yyTComb [0],
& yyTComb [1711],
& yyTComb [1503],
& yyTComb [1504],
& yyTComb [1749],
& yyTComb [1977],
& yyTComb [1715],
& yyTComb [1522],
& yyTComb [1524],
& yyTComb [1780],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-254],
& yyNComb [-255],
& yyNComb [-250],
& yyNComb [-252],
& yyNComb [-256],
& yyNComb [-249],
& yyNComb [-256],
& yyNComb [-229],
& yyNComb [-207],
& yyNComb [-179],
& yyNComb [-158],
& yyNComb [-256],
& yyNComb [-101],
& yyNComb [-256],
& yyNComb [-126],
& yyNComb [-256],
& yyNComb [-51],
& yyNComb [-77],
& yyNComb [-254],
& yyNComb [-28],
& yyNComb [-256],
& yyNComb [9],
& yyNComb [33],
& yyNComb [-256],
& yyNComb [-152],
& yyNComb [-256],
& yyNComb [39],
& yyNComb [-73],
& yyNComb [-256],
& yyNComb [167],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [61],
& yyNComb [-256],
& yyNComb [134],
& yyNComb [-253],
& yyNComb [252],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-253],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [280],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [330],
& yyNComb [-256],
& yyNComb [362],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [424],
& yyNComb [450],
& yyNComb [-256],
& yyNComb [-252],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [525],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [549],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [492],
& yyNComb [-256],
& yyNComb [612],
& yyNComb [-256],
& yyNComb [639],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [715],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-252],
& yyNComb [742],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-251],
& yyNComb [-255],
& yyNComb [-239],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-236],
& yyNComb [-237],
& yyNComb [-214],
& yyNComb [-256],
& yyNComb [-233],
& yyNComb [-256],
& yyNComb [-209],
& yyNComb [-256],
& yyNComb [-189],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-200],
& yyNComb [-170],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-230],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-246],
& yyNComb [-256],
& yyNComb [-232],
& yyNComb [-227],
& yyNComb [-256],
& yyNComb [-226],
& yyNComb [-224],
& yyNComb [-178],
& yyNComb [-241],
& yyNComb [871],
& yyNComb [-243],
& yyNComb [-229],
& yyNComb [808],
& yyNComb [-198],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [948],
& yyNComb [-256],
& yyNComb [-242],
& yyNComb [-256],
& yyNComb [1001],
& yyNComb [-229],
& yyNComb [808],
& yyNComb [-225],
& yyNComb [-189],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-186],
& yyNComb [-224],
& yyNComb [-256],
& yyNComb [1024],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1078],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-184],
& yyNComb [-179],
& yyNComb [-256],
& yyNComb [-183],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-177],
& yyNComb [-173],
& yyNComb [-155],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1098],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1140],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-125],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-122],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1161],
& yyNComb [-256],
& yyNComb [-76],
& yyNComb [-256],
& yyNComb [-69],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-256],
& yyNComb [-254],
& yyNComb [-256],
& yyNComb [-222],
& yyNComb [-221],
& yyNComb [-256],
& yyNComb [1226],
& yyNComb [-256],
& yyNComb [-255],
& yyNComb [-248],
& yyNComb [-248],
& yyNComb [-246],
& yyNComb [-184],
& yyNComb [-232],
& yyNComb [-256],
& yyNComb [-141],
& yyNComb [-167],
& yyNComb [-195],
& yyNComb [-256],
& yyNComb [-136],
& yyNComb [-149],
& yyNComb [-256],
& yyNComb [-147],
& yyNComb [-143],
& yyNComb [-256],
& yyNComb [-82],
& yyNComb [-132],
& yyNComb [-248],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-251],
& yyNComb [-228],
& yyNComb [-134],
& yyNComb [1356],
& yyNComb [-256],
& yyNComb [1294],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1424],
& yyNComb [-256],
& yyNComb [1456],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-128],
& yyNComb [-232],
& yyNComb [-213],
& yyNComb [-256],
& yyNComb [1498],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-231],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1553],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-208],
& yyNComb [-71],
& yyNComb [-202],
& yyNComb [1617],
& yyNComb [-256],
& yyNComb [-202],
& yyNComb [-159],
& yyNComb [-201],
& yyNComb [1525],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-66],
& yyNComb [-256],
& yyNComb [-218],
& yyNComb [-215],
& yyNComb [-256],
& yyNComb [-112],
& yyNComb [1867],
& yyNComb [-256],
& yyNComb [-51],
& yyNComb [-198],
& yyNComb [-256],
& yyNComb [179],
& yyNComb [-256],
& yyNComb [-244],
& yyNComb [-249],
& yyNComb [-155],
& yyNComb [-202],
& yyNComb [-256],
& yyNComb [-254],
& yyNComb [-68],
& yyNComb [-256],
& yyNComb [277],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-113],
& yyNComb [413],
& yyNComb [1221],
& yyNComb [-113],
& yyNComb [-212],
& yyNComb [-96],
& yyNComb [-256],
& yyNComb [44],
& yyNComb [-256],
& yyNComb [372],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-109],
& yyNComb [-256],
& yyNComb [206],
& yyNComb [-256],
& yyNComb [-210],
& yyNComb [-96],
& yyNComb [1912],
& yyNComb [353],
& yyNComb [417],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [437],
& yyNComb [-256],
& yyNComb [547],
& yyNComb [-256],
& yyNComb [1719],
& yyNComb [-256],
& yyNComb [-107],
& yyNComb [428],
& yyNComb [-256],
& yyNComb [201],
& yyNComb [-256],
& yyNComb [377],
& yyNComb [1834],
& yyNComb [-256],
& yyNComb [1911],
& yyNComb [-256],
& yyNComb [-199],
& yyNComb [-245],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [460],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [472],
& yyNComb [-256],
& yyNComb [545],
& yyNComb [220],
& yyNComb [-256],
& yyNComb [236],
& yyNComb [-106],
& yyNComb [-53],
& yyNComb [-98],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [202],
& yyNComb [424],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-47],
& yyNComb [-256],
& yyNComb [-97],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [176],
& yyNComb [-256],
& yyNComb [254],
& yyNComb [-256],
& yyNComb [-203],
& yyNComb [519],
& yyNComb [-202],
& yyNComb [25],
& yyNComb [-256],
& yyNComb [259],
& yyNComb [-256],
& yyNComb [184],
& yyNComb [-256],
& yyNComb [2019],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [347],
& yyNComb [-77],
& yyNComb [-75],
& yyNComb [-125],
& yyNComb [-256],
& yyNComb [434],
& yyNComb [-168],
& yyNComb [-79],
& yyNComb [-256],
& yyNComb [-48],
& yyNComb [-123],
& yyNComb [-74],
& yyNComb [-43],
& yyNComb [208],
& yyNComb [-166],
& yyNComb [-79],
& yyNComb [315],
& yyNComb [279],
& yyNComb [328],
& yyNComb [323],
& yyNComb [-154],
& yyNComb [329],
& yyNComb [-256],
& yyNComb [548],
& yyNComb [-160],
& yyNComb [598],
& yyNComb [-155],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-149],
& yyNComb [-243],
& yyNComb [-225],
& yyNComb [-256],
& yyNComb [-148],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [418],
& yyNComb [-256],
& yyNComb [435],
& yyNComb [-55],
& yyNComb [373],
& yyNComb [-94],
& yyNComb [-256],
& yyNComb [451],
& yyNComb [-49],
& yyNComb [455],
& yyNComb [-256],
& yyNComb [457],
& yyNComb [-48],
& yyNComb [521],
& yyNComb [-89],
& yyNComb [-256],
& yyNComb [589],
& yyNComb [-43],
& yyNComb [614],
& yyNComb [-53],
& yyNComb [-256],
& yyNComb [654],
& yyNComb [2],
& yyNComb [532],
& yyNComb [-256],
& yyNComb [544],
& yyNComb [21],
& yyNComb [610],
& yyNComb [-93],
& yyNComb [29],
& yyNComb [-256],
& yyNComb [133],
& yyNComb [172],
& yyNComb [351],
& yyNComb [336],
& yyNComb [-90],
& yyNComb [375],
& yyNComb [339],
& yyNComb [85],
& yyNComb [269],
& yyNComb [158],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [570],
& yyNComb [185],
& yyNComb [622],
& yyNComb [245],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [651],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [258],
& yyNComb [619],
& yyNComb [-256],
& yyNComb [684],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [280],
& yyNComb [736],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [300],
& yyNComb [805],
& yyNComb [620],
& yyNComb [-256],
& yyNComb [2039],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [730],
& yyNComb [720],
& yyNComb [-256],
& yyNComb [726],
& yyNComb [609],
& yyNComb [-256],
& yyNComb [637],
& yyNComb [301],
& yyNComb [583],
& yyNComb [-256],
& yyNComb [734],
& yyNComb [303],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [740],
& yyNComb [314],
& yyNComb [707],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [552],
& yyNComb [-256],
& yyNComb [806],
& yyNComb [-256],
& yyNComb [763],
& yyNComb [-256],
& yyNComb [446],
& yyNComb [-256],
& yyNComb [792],
& yyNComb [-256],
& yyNComb [300],
& yyNComb [336],
& yyNComb [340],
& yyNComb [903],
& yyNComb [2149],
& yyNComb [57],
& yyNComb [393],
& yyNComb [572],
& yyNComb [2149],
& yyNComb [-256],
& yyNComb [2151],
& yyNComb [-256],
& yyNComb [2012],
& yyNComb [-256],
& yyNComb [2205],
& yyNComb [-256],
& yyNComb [2012],
& yyNComb [103],
& yyNComb [-256],
& yyNComb [407],
& yyNComb [419],
& yyNComb [-256],
& yyNComb [2296],
& yyNComb [163],
& yyNComb [-256],
& yyNComb [2338],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2422],
& yyNComb [2446],
& yyNComb [-256],
& yyNComb [2488],
& yyNComb [-256],
& yyNComb [580],
& yyNComb [200],
& yyNComb [-256],
& yyNComb [233],
& yyNComb [-256],
& yyNComb [429],
& yyNComb [2530],
& yyNComb [-256],
& yyNComb [478],
& yyNComb [-256],
& yyNComb [374],
& yyNComb [-256],
& yyNComb [751],
& yyNComb [2562],
& yyNComb [-256],
& yyNComb [2588],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2657],
& yyNComb [2780],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [2812],
& yyNComb [-256],
& yyNComb [2854],
& yyNComb [186],
& yyNComb [2887],
& yyNComb [859],
& yyNComb [-256],
& yyNComb [2966],
& yyNComb [212],
& yyNComb [244],
& yyNComb [266],
& yyNComb [850],
& yyNComb [-256],
& yyNComb [1022],
& yyNComb [1028],
& yyNComb [-256],
& yyNComb [2941],
& yyNComb [-256],
& yyNComb [3050],
& yyNComb [-256],
& yyNComb [3073],
& yyNComb [-256],
& yyNComb [3170],
& yyNComb [-256],
& yyNComb [3259],
& yyNComb [-256],
& yyNComb [3360],
& yyNComb [554],
& yyNComb [561],
& yyNComb [-256],
& yyNComb [3359],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3382],
& yyNComb [-256],
& yyNComb [3410],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [301],
& yyNComb [-256],
& yyNComb [380],
& yyNComb [818],
& yyNComb [649],
& yyNComb [858],
& yyNComb [349],
& yyNComb [821],
& yyNComb [662],
& yyNComb [938],
& yyNComb [691],
& yyNComb [945],
& yyNComb [-256],
& yyNComb [3459],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [906],
& yyNComb [693],
& yyNComb [954],
& yyNComb [409],
& yyNComb [-256],
& yyNComb [939],
& yyNComb [719],
& yyNComb [707],
& yyNComb [709],
& yyNComb [-256],
& yyNComb [733],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3479],
& yyNComb [-256],
& yyNComb [3580],
& yyNComb [967],
& yyNComb [433],
& yyNComb [745],
& yyNComb [3548],
& yyNComb [-256],
& yyNComb [754],
& yyNComb [988],
& yyNComb [450],
& yyNComb [810],
& yyNComb [989],
& yyNComb [998],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3645],
& yyNComb [-256],
& yyNComb [855],
& yyNComb [692],
& yyNComb [566],
& yyNComb [3768],
& yyNComb [3848],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3868],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3910],
& yyNComb [1006],
& yyNComb [887],
& yyNComb [1026],
& yyNComb [1007],
& yyNComb [896],
& yyNComb [1029],
& yyNComb [-256],
& yyNComb [1008],
& yyNComb [703],
& yyNComb [-256],
& yyNComb [3931],
& yyNComb [668],
& yyNComb [1074],
& yyNComb [1075],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [3961],
& yyNComb [596],
& yyNComb [3981],
& yyNComb [-256],
& yyNComb [905],
& yyNComb [-256],
& yyNComb [1131],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [4060],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1476],
& yyNComb [1069],
& yyNComb [972],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [919],
& yyNComb [922],
& yyNComb [613],
& yyNComb [-256],
& yyNComb [1017],
& yyNComb [-256],
& yyNComb [1071],
& yyNComb [1237],
& yyNComb [795],
& yyNComb [737],
& yyNComb [810],
& yyNComb [-256],
& yyNComb [1087],
& yyNComb [-256],
& yyNComb [1113],
& yyNComb [1014],
& yyNComb [804],
& yyNComb [694],
& yyNComb [1486],
& yyNComb [-256],
& yyNComb [1526],
& yyNComb [-256],
& yyNComb [726],
& yyNComb [1027],
& yyNComb [-256],
& yyNComb [4125],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1076],
& yyNComb [-256],
& yyNComb [1027],
& yyNComb [-256],
& yyNComb [1319],
& yyNComb [-256],
& yyNComb [1381],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1518],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1579],
& yyNComb [-256],
& yyNComb [1041],
& yyNComb [1103],
& yyNComb [1104],
& yyNComb [1033],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [770],
& yyNComb [-256],
& yyNComb [737],
& yyNComb [-256],
& yyNComb [870],
& yyNComb [-256],
& yyNComb [4034],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1163],
& yyNComb [-256],
& yyNComb [748],
& yyNComb [1046],
& yyNComb [1050],
& yyNComb [1280],
& yyNComb [-256],
& yyNComb [748],
& yyNComb [1106],
& yyNComb [1096],
& yyNComb [1097],
& yyNComb [1366],
& yyNComb [-256],
& yyNComb [782],
& yyNComb [1113],
& yyNComb [1109],
& yyNComb [1110],
& yyNComb [1468],
& yyNComb [-256],
& yyNComb [782],
& yyNComb [1119],
& yyNComb [1114],
& yyNComb [1120],
& yyNComb [1491],
& yyNComb [-256],
& yyNComb [791],
& yyNComb [1164],
& yyNComb [-256],
& yyNComb [1127],
& yyNComb [1503],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [-256],
& yyNComb [1127],
& yyNComb [1138],
& yyNComb [-256],
& yyNComb [4167],
& yyNComb [-256],
& yyNComb [1129],
& yyNComb [1510],
& yyNComb [-256],
& yyNComb [1162],
& yyNComb [-256],
& yyNComb [4194],
& yyNComb [1130],
& yyNComb [1536],
& yyNComb [-256],
& yyNComb [1166],
& yyNComb [1096],
& yyNComb [1134],
& yyNComb [1986],
& yyNComb [-256],
& yyNComb [1136],
& yyNComb [1150],
& yyNComb [1174],
& yyNComb [1182],
& yyNComb [1169],
& yyNComb [1163],
& yyNComb [1190],
& yyNComb [2100],
& yyNComb [1169],
& yyNComb [1199],
& yyNComb [1201],
& yyNComb [1202],
& yyNComb [2554],
& yyNComb [2125],
& yyNComb [1198],
& yyNComb [-256],
& yyNComb [1046],
& yyNComb [-256],
& yyNComb [1235],
& yyNComb [1208],
& yyNComb [-256],
& yyNComb [1237],
& yyNComb [-256],
& yyNComb [1083],
& yyNComb [2181],
& yyNComb [1217],
& yyNComb [1225],
& yyNComb [2692],
& yyNComb [1212],
& yyNComb [1234],
& yyNComb [1242],
& yyNComb [4543],
& yyNComb [1247],
& yyNComb [3036],
& yyNComb [1231],
& yyNComb [1250],
& yyNComb [1252],
& yyNComb [1699],
& yyNComb [3429],
& yyNComb [1225],
& yyNComb [1255],
& yyNComb [1257],
& yyNComb [-256],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
0,
5,
846,
833,
840,
0,
344,
680,
318,
680,
25,
721,
25,
736,
721,
555,
680,
673,
680,
25,
46,
20,
40,
25,
30,
61,
25,
0,
25,
833,
0,
680,
673,
47,
680,
43,
680,
42,
680,
0,
61,
0,
0,
61,
20,
0,
0,
53,
0,
721,
0,
56,
673,
0,
56,
680,
0,
833,
61,
0,
0,
673,
680,
67,
323,
680,
0,
321,
0,
680,
321,
680,
673,
680,
673,
0,
0,
0,
680,
0,
673,
673,
251,
680,
673,
0,
833,
809,
92,
0,
0,
833,
0,
806,
0,
833,
0,
806,
0,
833,
110,
0,
0,
806,
806,
345,
0,
0,
100,
0,
95,
0,
0,
833,
0,
274,
0,
0,
262,
372,
248,
130,
125,
134,
130,
0,
0,
680,
0,
0,
0,
680,
125,
680,
202,
693,
0,
0,
697,
202,
146,
145,
0,
0,
721,
0,
0,
693,
697,
0,
693,
0,
0,
697,
697,
271,
207,
0,
680,
673,
0,
680,
673,
0,
833,
736,
0,
833,
736,
0,
680,
321,
833,
736,
833,
736,
0,
0,
207,
0,
207,
0,
202,
202,
188,
721,
0,
0,
705,
706,
704,
833,
372,
0,
833,
833,
372,
0,
833,
202,
0,
0,
833,
0,
833,
833,
0,
0,
272,
211,
272,
833,
680,
673,
680,
673,
0,
0,
680,
0,
680,
0,
0,
833,
245,
112,
0,
248,
0,
0,
402,
0,
0,
248,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
833,
265,
132,
0,
0,
0,
0,
680,
321,
0,
833,
0,
0,
0,
0,
833,
357,
0,
202,
0,
0,
202,
0,
0,
0,
705,
0,
0,
0,
833,
0,
291,
0,
0,
0,
0,
0,
832,
846,
833,
0,
833,
0,
299,
0,
0,
0,
0,
0,
0,
300,
833,
0,
833,
0,
0,
833,
0,
315,
315,
736,
0,
315,
0,
315,
0,
680,
0,
549,
833,
0,
331,
326,
328,
680,
0,
680,
673,
325,
0,
0,
0,
331,
0,
0,
833,
0,
315,
833,
0,
833,
449,
342,
833,
0,
0,
833,
357,
0,
0,
0,
833,
0,
833,
0,
0,
833,
0,
833,
0,
358,
0,
0,
833,
0,
833,
0,
833,
0,
680,
673,
0,
0,
833,
488,
833,
0,
0,
833,
0,
833,
0,
833,
372,
388,
833,
388,
0,
833,
833,
388,
833,
0,
398,
833,
736,
833,
395,
833,
736,
0,
0,
0,
0,
399,
0,
0,
0,
0,
833,
0,
833,
488,
833,
372,
0,
833,
488,
833,
0,
833,
488,
833,
372,
0,
833,
488,
833,
372,
0,
833,
431,
299,
0,
299,
488,
299,
440,
833,
0,
833,
442,
381,
442,
0,
833,
388,
449,
448,
833,
0,
0,
833,
488,
454,
833,
0,
0,
833,
0,
0,
0,
488,
833,
0,
833,
0,
0,
0,
488,
833,
0,
0,
0,
488,
833,
833,
0,
680,
321,
0,
833,
833,
0,
833,
833,
0,
833,
488,
833,
0,
833,
0,
833,
0,
833,
833,
504,
0,
0,
833,
0,
833,
0,
504,
0,
0,
0,
502,
0,
0,
833,
0,
782,
591,
0,
0,
801,
510,
0,
680,
673,
522,
0,
680,
673,
591,
605,
0,
833,
833,
0,
595,
605,
555,
680,
673,
673,
0,
0,
595,
680,
601,
680,
601,
833,
605,
0,
605,
0,
0,
680,
601,
0,
0,
605,
0,
570,
561,
64,
680,
673,
673,
0,
0,
680,
680,
321,
0,
680,
0,
680,
575,
680,
833,
0,
680,
575,
575,
0,
579,
736,
579,
833,
0,
595,
0,
595,
0,
595,
0,
595,
0,
680,
673,
833,
833,
833,
0,
680,
0,
736,
680,
601,
680,
0,
0,
605,
0,
0,
833,
0,
621,
622,
833,
0,
782,
0,
644,
0,
680,
673,
0,
833,
0,
612,
0,
0,
833,
833,
812,
813,
0,
833,
0,
0,
680,
673,
591,
641,
642,
0,
680,
673,
0,
645,
0,
0,
782,
782,
0,
0,
680,
673,
0,
0,
0,
661,
680,
673,
673,
680,
673,
0,
0,
680,
833,
0,
667,
833,
0,
782,
0,
833,
651,
0,
680,
0,
833,
782,
0,
0,
721,
0,
20,
0,
833,
0,
833,
736,
0,
0,
680,
673,
0,
833,
202,
202,
0,
0,
697,
202,
0,
0,
202,
0,
202,
156,
0,
0,
0,
0,
202,
0,
202,
743,
747,
0,
833,
736,
833,
0,
745,
833,
0,
680,
0,
0,
0,
833,
736,
743,
0,
833,
736,
833,
0,
0,
833,
0,
0,
0,
0,
833,
0,
743,
743,
0,
0,
0,
0,
749,
0,
0,
0,
758,
0,
680,
673,
0,
833,
0,
0,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
782,
0,
0,
785,
0,
0,
0,
0,
0,
782,
0,
0,
0,
833,
833,
0,
680,
673,
0,
801,
0,
833,
0,
680,
0,
782,
0,
833,
0,
0,
357,
0,
833,
0,
0,
833,
809,
0,
0,
846,
0,
833,
0,
0,
846,
806,
0,
0,
831,
0,
833,
0,
0,
833,
0,
0,
806,
0,
0,
846,
0,
833,
0,
3,
1,
846,
0,
833,
0,
225,
357,
0,
833,
0,
0,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
2,
2,
0,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
0,
1,
0,
1,
0,
0,
1,
1,
2,
1,
1,
1,
1,
1,
2,
4,
4,
2,
1,
0,
6,
2,
1,
0,
4,
5,
2,
1,
0,
4,
2,
1,
0,
6,
0,
4,
0,
2,
2,
2,
5,
1,
1,
1,
3,
3,
1,
1,
4,
3,
2,
2,
1,
0,
0,
2,
3,
1,
3,
1,
1,
5,
0,
3,
1,
2,
1,
1,
3,
5,
3,
5,
1,
1,
1,
1,
1,
3,
1,
1,
1,
3,
2,
2,
1,
1,
1,
4,
3,
1,
1,
1,
3,
2,
3,
0,
1,
1,
3,
2,
4,
1,
3,
1,
3,
0,
1,
1,
1,
1,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
3,
4,
0,
3,
0,
2,
0,
2,
3,
1,
1,
1,
3,
0,
1,
2,
2,
3,
1,
1,
1,
4,
4,
4,
1,
1,
1,
4,
4,
4,
1,
1,
1,
1,
1,
1,
1,
3,
1,
3,
2,
2,
1,
3,
6,
0,
3,
4,
4,
1,
2,
0,
3,
4,
3,
2,
1,
0,
3,
6,
0,
3,
3,
1,
3,
1,
1,
2,
3,
0,
3,
4,
4,
1,
3,
1,
3,
2,
1,
3,
1,
2,
1,
3,
1,
1,
1,
3,
3,
1,
3,
1,
4,
4,
3,
1,
3,
1,
6,
6,
6,
1,
3,
1,
4,
0,
3,
4,
3,
1,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
3,
1,
3,
1,
2,
3,
1,
3,
1,
2,
3,
1,
3,
1,
2,
2,
1,
3,
4,
1,
3,
1,
5,
3,
3,
1,
3,
1,
1,
3,
3,
1,
1,
4,
1,
3,
3,
8,
0,
1,
0,
1,
3,
0,
2,
2,
2,
0,
2,
2,
2,
6,
0,
2,
1,
1,
0,
2,
4,
1,
3,
1,
0,
1,
4,
4,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
6,
1,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
1,
3,
1,
2,
2,
1,
3,
1,
2,
2,
1,
3,
4,
1,
3,
3,
1,
2,
1,
3,
3,
3,
1,
3,
1,
3,
1,
3,
1,
5,
6,
1,
3,
1,
1,
3,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
2,
1,
3,
1,
2,
1,
3,
1,
2,
1,
3,
1,
3,
2,
0,
2,
3,
2,
6,
3,
1,
3,
1,
1,
1,
2,
3,
0,
3,
1,
3,
1,
1,
2,
1,
3,
1,
2,
3,
0,
1,
3,
4,
2,
0,
3,
3,
4,
1,
1,
3,
1,
4,
3,
1,
4,
3,
4,
3,
4,
8,
3,
3,
1,
1,
3,
1,
3,
2,
1,
3,
2,
2,
5,
2,
2,
1,
1,
1,
1,
1,
1,
1,
2,
4,
2,
3,
0,
3,
0,
1,
2,
2,
2,
1,
1,
1,
1,
1,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
0,
4,
1,
3,
6,
3,
3,
4,
1,
2,
1,
1,
2,
2,
1,
2,
1,
4,
3,
4,
3,
4,
6,
3,
5,
1,
1,
1,
2,
4,
5,
1,
3,
3,
1,
2,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
2,
4,
2,
4,
2,
3,
2,
2,
2,
2,
2,
2,
2,
2,
2,
1,
1,
3,
1,
3,
1,
3,
1,
3,
1,
1,
1,
1,
1,
3,
1,
2,
2,
1,
4,
1,
2,
1,
3,
11,
10,
3,
0,
4,
3,
3,
3,
4,
1,
3,
4,
1,
3,
1,
1,
6,
0,
1,
1,
3,
5,
3,
5,
4,
2,
2,
4,
9,
5,
3,
1,
11,
0,
9,
4,
5,
8,
0,
7,
3,
8,
1,
2,
5,
5,
3,
1,
3,
1,
2,
2,
3,
3,
4,
2,
5,
1,
3,
1,
4,
4,
2,
1,
1,
3,
1,
3,
6,
2,
4,
4,
6,
4,
3,
6,
0,
1,
3,
6,
1,
0,
1,
2,
0,
3,
1,
3,
3,
6,
1,
0,
1,
3,
6,
1,
0,
1,
6,
1,
0,
1,
1,
1,
3,
3,
4,
1,
3,
1,
3,
1,
3,
5,
3,
0,
1,
3,
5,
3,
3,
3,
1,
1,
1,
3,
1,
1,
1,
3,
1,
1,
1,
3,
1,
1,
2,
1,
1,
3,
1,
1,
1,
1,
1,
1,
1,
3,
1,
1,
3,
2,
2,
1,
1,
1,
2,
1,
3,
1,
1,
1,
3,
1,
2,
1,
1,
1,
1,
3,
4,
1,
1,
1,
5,
2,
1,
1,
1,
1,
1,
1,
2,
2,
2,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
613,
258,
259,
256,
256,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
260,
261,
261,
262,
262,
263,
263,
264,
265,
265,
257,
257,
266,
266,
266,
266,
266,
267,
267,
273,
274,
274,
274,
271,
276,
276,
276,
268,
277,
278,
278,
278,
269,
281,
281,
281,
280,
282,
282,
279,
279,
279,
279,
279,
284,
284,
286,
286,
287,
287,
285,
270,
288,
288,
289,
289,
289,
275,
275,
275,
290,
290,
291,
291,
272,
294,
294,
295,
295,
296,
296,
298,
298,
298,
298,
299,
299,
299,
299,
300,
300,
300,
300,
301,
301,
303,
303,
283,
283,
283,
283,
305,
304,
304,
307,
307,
308,
308,
309,
306,
306,
306,
311,
311,
310,
310,
292,
312,
312,
313,
313,
313,
313,
313,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
318,
342,
342,
341,
343,
343,
344,
344,
345,
345,
302,
302,
346,
346,
317,
347,
347,
347,
348,
348,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
349,
350,
350,
350,
326,
352,
352,
353,
327,
354,
354,
355,
357,
357,
323,
323,
359,
359,
360,
360,
360,
361,
358,
358,
358,
314,
314,
362,
362,
364,
363,
363,
365,
365,
320,
320,
368,
368,
367,
367,
369,
369,
370,
370,
328,
371,
371,
372,
330,
373,
373,
374,
321,
321,
321,
321,
375,
375,
366,
366,
366,
332,
377,
377,
378,
338,
338,
338,
379,
379,
380,
331,
383,
383,
383,
381,
382,
334,
334,
384,
384,
385,
385,
335,
335,
386,
386,
387,
387,
336,
336,
388,
388,
389,
389,
322,
390,
390,
391,
391,
337,
392,
392,
393,
393,
333,
394,
394,
395,
395,
324,
396,
396,
397,
398,
398,
400,
400,
401,
401,
399,
399,
404,
404,
404,
404,
406,
406,
319,
407,
407,
408,
315,
412,
412,
409,
409,
409,
411,
411,
413,
413,
410,
410,
414,
414,
316,
416,
416,
418,
418,
417,
417,
419,
420,
420,
421,
415,
415,
415,
415,
376,
376,
422,
422,
422,
422,
422,
422,
422,
422,
422,
329,
351,
351,
351,
432,
432,
433,
339,
339,
339,
339,
339,
339,
339,
339,
339,
340,
340,
340,
340,
340,
434,
448,
448,
449,
449,
435,
450,
450,
451,
451,
442,
452,
452,
453,
454,
454,
455,
455,
443,
456,
456,
457,
445,
458,
458,
459,
446,
460,
460,
461,
447,
447,
463,
463,
464,
462,
462,
465,
465,
466,
466,
467,
467,
467,
467,
467,
467,
467,
444,
468,
468,
469,
444,
470,
470,
471,
440,
472,
472,
473,
441,
474,
476,
476,
475,
436,
478,
478,
479,
479,
481,
481,
481,
480,
480,
482,
482,
483,
483,
484,
484,
438,
486,
486,
487,
437,
488,
490,
490,
491,
491,
491,
492,
492,
489,
489,
489,
477,
477,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
494,
439,
496,
496,
497,
495,
495,
498,
499,
499,
498,
500,
500,
498,
498,
498,
498,
498,
498,
498,
498,
498,
293,
293,
502,
502,
503,
503,
503,
501,
504,
504,
504,
504,
504,
509,
509,
509,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
505,
526,
519,
519,
527,
527,
528,
528,
519,
513,
513,
513,
524,
524,
515,
523,
523,
518,
518,
518,
516,
512,
512,
517,
517,
522,
506,
532,
532,
531,
533,
534,
514,
514,
514,
529,
529,
530,
530,
530,
521,
521,
521,
521,
521,
521,
521,
521,
521,
537,
537,
535,
535,
536,
536,
536,
536,
538,
539,
540,
540,
541,
541,
542,
542,
543,
547,
547,
544,
548,
548,
549,
549,
549,
549,
546,
546,
546,
546,
545,
545,
550,
325,
551,
551,
507,
509,
509,
552,
552,
554,
554,
553,
556,
556,
556,
556,
556,
559,
561,
561,
560,
562,
562,
563,
563,
554,
555,
555,
402,
403,
403,
554,
565,
565,
565,
567,
567,
520,
520,
509,
509,
568,
569,
569,
569,
525,
510,
570,
570,
570,
511,
571,
571,
572,
572,
573,
574,
574,
575,
575,
575,
575,
508,
508,
577,
577,
578,
578,
576,
508,
508,
580,
580,
581,
581,
579,
508,
508,
582,
582,
582,
582,
557,
557,
557,
583,
583,
508,
508,
584,
585,
585,
558,
586,
586,
587,
587,
508,
508,
588,
589,
589,
508,
508,
590,
591,
591,
508,
592,
592,
356,
356,
356,
564,
593,
593,
493,
493,
485,
485,
485,
566,
566,
566,
594,
594,
595,
595,
596,
596,
297,
597,
297,
598,
598,
431,
431,
599,
599,
430,
430,
600,
600,
429,
601,
601,
428,
602,
602,
427,
427,
427,
427,
427,
427,
603,
603,
426,
604,
604,
604,
604,
425,
425,
606,
606,
605,
605,
424,
424,
607,
607,
423,
608,
609,
608,
595,
595,
595,
595,
611,
610,
610,
610,
612,
612,
612,
610,
610,
610,
405,
405,
405,
405,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
1,
0,
1,
255,
0,
255,
1,
1,
7,
1,
1,
1,
1,
7,
14,
7,
1,
14,
1,
1,
7,
1,
7,
1,
1,
7,
1,
7,
1,
1,
13,
1,
14,
7,
1,
7,
1,
7,
1,
7,
7,
7,
7,
7,
1,
7,
7,
14,
14,
1,
20,
14,
14,
14,
14,
14,
14,
1,
7,
24,
7,
21,
1,
7,
14,
1,
10,
21,
10,
1,
21,
1,
14,
1,
14,
14,
14,
7,
1,
14,
14,
14,
2,
17,
14,
14,
1,
255,
14,
14,
14,
1,
255,
66,
13,
1,
14,
66,
13,
1,
14,
5,
14,
66,
66,
1,
2,
14,
5,
10,
13,
201,
27,
1,
255,
50,
255,
255,
131,
13,
17,
14,
20,
17,
14,
14,
14,
20,
20,
14,
14,
17,
20,
17,
152,
20,
14,
152,
1,
1,
21,
17,
14,
14,
17,
21,
14,
20,
1,
152,
20,
14,
152,
1,
1,
1,
160,
14,
14,
14,
14,
14,
14,
13,
14,
14,
13,
14,
14,
13,
14,
21,
1,
21,
1,
14,
14,
14,
160,
21,
160,
14,
1,
21,
21,
1,
14,
21,
17,
255,
21,
1,
21,
255,
1,
1,
21,
255,
1,
1,
255,
1,
1,
255,
1,
13,
160,
14,
13,
21,
21,
13,
1,
14,
1,
14,
14,
14,
1,
13,
1,
14,
255,
1,
1,
192,
13,
17,
14,
13,
111,
14,
13,
17,
14,
13,
5,
14,
13,
5,
14,
13,
5,
14,
27,
1,
10,
17,
14,
10,
2,
21,
1,
21,
255,
1,
27,
255,
255,
131,
255,
131,
27,
1,
21,
255,
1,
27,
158,
152,
17,
13,
13,
50,
255,
13,
7,
14,
13,
10,
14,
255,
133,
1,
1,
255,
1,
20,
1,
13,
7,
14,
13,
10,
14,
21,
1,
255,
1,
12,
255,
1,
145,
1,
1,
18,
21,
1,
21,
1,
10,
1,
14,
255,
1,
18,
1,
18,
2,
1,
21,
1,
14,
2,
2,
18,
18,
2,
18,
18,
1,
18,
1,
1,
255,
1,
255,
1,
1,
18,
255,
1,
1,
13,
13,
13,
1,
14,
1,
14,
14,
1,
13,
1,
14,
255,
51,
255,
1,
255,
1,
13,
1,
10,
1,
14,
14,
14,
1,
13,
1,
13,
255,
1,
1,
18,
18,
1,
18,
255,
1,
255,
18,
1,
1,
255,
1,
255,
13,
1,
21,
1,
14,
1,
14,
14,
255,
13,
86,
255,
13,
111,
14,
27,
1,
255,
1,
1,
1,
21,
255,
1,
1,
1,
255,
1,
1,
1,
21,
255,
1,
1,
1,
21,
255,
1,
255,
1,
255,
1,
255,
1,
18,
1,
18,
1,
255,
1,
255,
18,
1,
255,
255,
1,
1,
18,
255,
1,
255,
1,
1,
18,
255,
1,
13,
5,
14,
1,
1,
255,
1,
13,
5,
14,
1,
1,
13,
5,
14,
1,
1,
1,
79,
1,
21,
255,
1,
21,
255,
1,
21,
255,
1,
1,
1,
255,
1,
1,
1,
255,
1,
1,
17,
14,
27,
1,
255,
1,
14,
17,
14,
227,
13,
17,
14,
255,
255,
255,
68,
81,
1,
255,
75,
81,
13,
1,
14,
81,
13,
1,
14,
81,
2,
79,
1,
1,
255,
14,
2,
7,
1,
14,
14,
14,
14,
1,
255,
255,
255,
255,
2,
2,
14,
2,
14,
1,
1,
255,
255,
13,
2,
14,
2,
1,
7,
1,
14,
14,
14,
14,
1,
255,
21,
255,
1,
255,
1,
13,
255,
2,
255,
1,
13,
13,
13,
2,
255,
2,
2,
225,
1,
14,
1,
225,
1,
14,
1,
13,
1,
14,
81,
255,
255,
13,
1,
14,
10,
1,
255,
1,
255,
21,
2,
21,
2,
255,
255,
73,
76,
255,
255,
76,
255,
68,
13,
1,
14,
72,
255,
255,
73,
76,
76,
255,
1,
77,
255,
13,
1,
14,
13,
1,
14,
81,
103,
103,
255,
1,
14,
255,
103,
103,
255,
68,
103,
103,
13,
1,
14,
255,
106,
107,
1,
1,
14,
14,
14,
14,
14,
14,
1,
255,
255,
106,
255,
255,
106,
205,
255,
205,
13,
1,
14,
255,
114,
114,
10,
20,
14,
1,
13,
1,
21,
1,
21,
14,
21,
1,
14,
14,
1,
1,
20,
14,
152,
1,
1,
152,
27,
1,
255,
1,
1,
27,
17,
255,
27,
1,
255,
1,
212,
165,
21,
1,
14,
1,
14,
13,
1,
14,
1,
14,
14,
13,
1,
14,
255,
13,
1,
14,
1,
14,
13,
1,
14,
29,
14,
14,
1,
14,
255,
255,
255,
255,
13,
210,
165,
210,
167,
10,
69,
13,
1,
14,
72,
69,
20,
69,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
255,
255,
211,
211,
255,
1,
212,
255,
211,
211,
212,
75,
255,
70,
13,
1,
14,
255,
75,
75,
255,
10,
1,
255,
75,
75,
255,
68,
255,
66,
66,
1,
255,
255,
1,
77,
255,
255,
1,
255,
255,
255,
255,
1,
68,
68,
68,
133,
125,
1,
255,
255,
1,
133,
133,
133,
1,
255,
1,
255,
255,
255,
0,
0,
1,
255,
255,
255,
1,
1,
255,
255,
255,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
1481,
1482,
1483,
1484,
1486,
1487,
1488,
1489,
1490,
1491,
1495,
1496,
1497,
1498,
1499,
1500,
1485,
1502,
1501,
1492,
1493,
1494,
1578,
1577,
1579,
1580,
2293,
2294,
2295,
2296,
2283,
2297,
2298,
2289,
2223,
2255,
2240,
2266,
2261,
2258,
2263,
2260,
2262,
2259,
2271,
2272,
2277,
2278,
2281,
2288,
2244,
2245,
2248,
2249,
2252,
2224,
2287,
2235,
2292,
2236,
1575,
1576,
1574,
1573,
1648,
1649,
1647,
1583,
1584,
1560,
1565,
1561,
1592,
1551,
1550,
1582,
1673,
1674,
1675,
1809,
1808,
1606,
1607,
1593,
1503,
1936,
1935,
1504,
1944,
1941,
1976,
1966,
1965,
1969,
1968,
1971,
1970,
1974,
1972,
1977,
1975,
1973,
1959,
1960,
1958,
1929,
1997,
1878,
1992,
1993,
1660,
1657,
1845,
1846,
1847,
1662,
1663,
1664,
1665,
1669,
1670,
1671,
1672,
1659,
1661,
1666,
1667,
1668,
1653,
1642,
1654,
1995,
1994,
1990,
1991,
1833,
1831,
1832,
1731,
1732,
1789,
1506,
1785,
1508,
1754,
1706,
1710,
1711,
1800,
1695,
1694,
1693,
1683,
1747,
1766,
1760,
1902,
1906,
1912,
1908,
1909,
1907,
1911,
1910,
1895,
2136,
2029,
2061,
2062,
2042,
2033,
2105,
2101,
2102,
2096,
2104,
2094,
2049,
2051,
2053,
1540,
2155,
2164,
2145,
2054,
2203,
2193,
2192,
2191,
2126,
2129,
2195,
2200,
2210,
2215,
2216,
1566,
1818,
1480,
1478,
1555,
1554,
2219,
2221,
2220,
2284,
2254,
2276,
2280,
2282,
2286,
2251,
2253,
2275,
2291,
2250,
2268,
2226,
2229,
2231,
2232,
2222,
2238,
2237,
1586,
1587,
1564,
1563,
1521,
1545,
1542,
1588,
1591,
1590,
1589,
1546,
1547,
1549,
1544,
1543,
1816,
1817,
1598,
1605,
1599,
1604,
1594,
1595,
1597,
1601,
1603,
1996,
1937,
1943,
1945,
1939,
1938,
1986,
1934,
1985,
1931,
1932,
1930,
1984,
1963,
1955,
1954,
1951,
1953,
1950,
1988,
1989,
1987,
1874,
1870,
1872,
1869,
1865,
1867,
1949,
1946,
1948,
1924,
1921,
1923,
1925,
1928,
1926,
1998,
1880,
1875,
1877,
1656,
1658,
1644,
1640,
1639,
1651,
1812,
1813,
1806,
1804,
1811,
1851,
1852,
1853,
1854,
1855,
1856,
1857,
1858,
1859,
1981,
1978,
1980,
1983,
1815,
1834,
1835,
1836,
1837,
1838,
1839,
1840,
1841,
1842,
1843,
1830,
1821,
1822,
1701,
1698,
1705,
1703,
1704,
1700,
1697,
1790,
1791,
1782,
1784,
2300,
2302,
1799,
1798,
1796,
2299,
1797,
1793,
1795,
1787,
1723,
1720,
1722,
1753,
1750,
1752,
1715,
1713,
1709,
1707,
1719,
1716,
1718,
1802,
1679,
1676,
1678,
1689,
1692,
1691,
1686,
1687,
1685,
1680,
1682,
2111,
2110,
1850,
1844,
1849,
1771,
1767,
1769,
1736,
1733,
1735,
1781,
1777,
1779,
1776,
1772,
1774,
1730,
1729,
1726,
1727,
1748,
1746,
1745,
1743,
1765,
1762,
1764,
1759,
1756,
1758,
1742,
1738,
1741,
1739,
1737,
1883,
1885,
1916,
1913,
1915,
1920,
1917,
1919,
1890,
1887,
1889,
1894,
1891,
1893,
1899,
1896,
1898,
1901,
1903,
1905,
1615,
1616,
1617,
1618,
1619,
1620,
1621,
1622,
1623,
1624,
1625,
1626,
1627,
1628,
1629,
1630,
1631,
1632,
1633,
1634,
1635,
1636,
1637,
1860,
1861,
1862,
1863,
1864,
1531,
1529,
2039,
2067,
2064,
2035,
2031,
2030,
2098,
2106,
2103,
2084,
2108,
2082,
2078,
2080,
2085,
2086,
2093,
2090,
2089,
2092,
2091,
2088,
2087,
2050,
2052,
2047,
2045,
2154,
2015,
2016,
2017,
2018,
2019,
2020,
2021,
2022,
2023,
2024,
2025,
2026,
2027,
2028,
2068,
2069,
2070,
2071,
2072,
2073,
2074,
2075,
2076,
2147,
2146,
1511,
2003,
2153,
2001,
2152,
2150,
2113,
2157,
1999,
2158,
2166,
2163,
2162,
2159,
2161,
2144,
2143,
2141,
2142,
2140,
2057,
2056,
2174,
2173,
2177,
2171,
2176,
2172,
2184,
2180,
2181,
2178,
2183,
2179,
2205,
2201,
2122,
2128,
2131,
2123,
2124,
2125,
2120,
2190,
2189,
2014,
2117,
2148,
2004,
2005,
2006,
2007,
2008,
2009,
2010,
2011,
2012,
2013,
2114,
2115,
2116,
2198,
2208,
2213,
2149,
2186,
2185,
2197,
2196,
2207,
2206,
2212,
2211,
2134,
2118,
2137,
2119,
1571,
1572,
1530,
1538,
1535,
1534,
1608,
1609,
1611,
1612,
1613,
1614,
1568,
1570,
1828,
1825,
1827,
1824,
1820,
1526,
1525,
1477,
1513,
1514,
1515,
1516,
1517,
1518,
1519,
1522,
1520,
1556,
1553,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginParser		();

int Parser ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   
/* line 65 "fortran.lalr" */

#include "Tree.h"
#include <stdio.h>

char Word [256];

tTree global_objects, 
      global_groups;     /* used for COMMON, NAMELIST */



      BeginParser ();
      yyState		= yyStartState;
      yyTerminal	= GetToken ();
      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register short * yyTCombPtr;

	    yyTCombPtr = (short *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadTermState) { /* read or read terminal reduce ? */
		     ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, Attribute.Position,
			xxString, Parser_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadTermState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, Attribute);
	       yyTerminal = GetToken ();
	       yyIsRepairing = false;
	    }

	    for (;;) {
	       /* register long yyNonterminal;		/* left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 1476: /* _0000_ : fortran _EndOfFile .*/
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 1477:
case 1464: /* fortran : CR0 program_units .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 258; {
/* line 342 "fortran.lalr" */
 TreeRoot = mCOMP_UNIT (yyAttrStackPtr [2-1].Tree, mUNIT_EMPTY());
       if (verbose_flag)
          printf ("Compilation ready\n");  
     
} break;
case 1478:
case 1050: /* CR1 : NewLine CR0 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 259; {

} break;
case 1479: /* CR0 : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 256; {

} break;
case 1480:
case 1049: /* CR0 : NewLine CR0 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 256; {

} break;
case 1481:
case 851: /* PIdent : Ident .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 359 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
       yySynAttribute.Label = NLine(yyAttrStackPtr [1-1]); 
} break;
case 1482:
case 852: /* PIdent : IN .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 364 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("IN");
       yySynAttribute.Label = NLine(yyAttrStackPtr [1-1]); 
} break;
case 1483:
case 853: /* PIdent : OUT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 368 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("OUT");
       yySynAttribute.Label = NLine(yyAttrStackPtr [1-1]); 
} break;
case 1484:
case 854: /* PIdent : INOUT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 372 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("INOUT");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1485:
case 867: /* PIdent : ALLOCATABLE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 376 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("ALLOCATABLE");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1486:
case 855: /* PIdent : DIMENSION1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 380 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("DIMENSION");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1487:
case 856: /* PIdent : PARAMETER1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 384 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("PARAMETER");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1488:
case 857: /* PIdent : INTENT1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 388 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("INTENT");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1489:
case 858: /* PIdent : EXTERNAL1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 392 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("EXTERNAL");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1490:
case 859: /* PIdent : INTRINSIC1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 396 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("INTRINSIC");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1491:
case 860: /* PIdent : OPTIONAL1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 400 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("OPTIONAL");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1492:
case 870: /* PIdent : LAYOUT1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 404 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("LAYOUT");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1493:
case 871: /* PIdent : PASS_BY1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 408 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("PASS_BY");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1494:
case 872: /* PIdent : MAP_TO1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 412 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("MAP_TO");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1495:
case 861: /* PIdent : POINTER1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 416 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("POINTER");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1496:
case 862: /* PIdent : SAVE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 420 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("SAVE");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1497:
case 863: /* PIdent : TARGET1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 424 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("TARGET");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1498:
case 864: /* PIdent : DATA1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 428 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("DATA");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1499:
case 865: /* PIdent : PUBLIC1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 432 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("PUBLIC");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1500:
case 866: /* PIdent : PRIVATE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 436 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("PRIVATE");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1501:
case 869: /* PIdent : SEQUENCE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 440 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("SEQUENCE");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1502:
case 868: /* PIdent : ARRAY1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 260; {
/* line 444 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("ARRAY");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1503:
case 935: /* HPFIdent : Ident .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 261; {
/* line 454 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
       yySynAttribute.Label = NLine(yyAttrStackPtr [1-1]); 
} break;
case 1504:
case 938: /* HPFIdent : NEW .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 261; {
/* line 458 "fortran.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Scan.Ident = IsIdent ("NEW");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 1505: /* opt_comma : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 262; {

} break;
case 1506:
case 992: /* opt_comma : ',' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 262; {

} break;
case 1507: /* opt_dcolon : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 263; {

} break;
case 1508:
case 994: /* opt_dcolon : '::' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 263; {

} break;
case 1509: /* opt_label : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 264; {
/* line 469 "fortran.lalr" */
 yySynAttribute.Label = GetTheLabel (); 
} break;
case 1510: /* opt_ident : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 265; {

} break;
case 1511:
case 1366: /* opt_ident : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 265; {

} break;
case 1512: /* program_units : program_unit .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 257; {
/* line 482 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, mUNIT_EMPTY()); 
} break;
case 1513:
case 1465: /* program_units : program_unit program_units .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 257; {
/* line 486 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1514:
case 1466: /* program_unit : main_program .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 490 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1515:
case 1467: /* program_unit : subroutine_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 494 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1516:
case 1468: /* program_unit : function_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 498 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1517:
case 1469: /* program_unit : block_data .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 502 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1518:
case 1470: /* program_unit : module .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 266; {
/* line 506 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1519:
case 1471: /* main_program : block CR0 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 267; {
/* line 517 "fortran.lalr" */
 yySynAttribute.Tree = mPROGRAM_DECL (IsIdent ("no_name"), 0,
                 mDECL_EMPTY (), yyAttrStackPtr [1-1].Tree); 
       InitLabels ();
     
} break;
case 1520:
case 1473: /* main_program : program_definition block program_token CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 267; {
/* line 527 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->PROGRAM_DECL.PROGRAM_BODY = yyAttrStackPtr [2-1].Tree; 
       yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       InitLabels ();
       CheckSameIdent (yyAttrStackPtr [1-1].Tree->PROGRAM_DECL.Ident, yyAttrStackPtr [3-1].Label);
     
} break;
case 1521:
case 1079: /* program_definition : PROGRAM PIdent dummy_arguments CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 273; {
/* line 536 "fortran.lalr" */
 yySynAttribute.Tree = mPROGRAM_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, yyAttrStackPtr [3-1].Tree, NoTree); 
} break;
case 1522:
case 1472: /* program_token : PROGRAM PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 274; {
/* line 541 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [2-1].Scan.Ident; 
} break;
case 1523: /* program_token : PROGRAM .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 274; {
/* line 545 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1524: /* program_token : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 274; {
/* line 549 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1525:
case 1463: /* module : MODULE PIdent CR1 block module_token CR1 .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 271; {
/* line 562 "fortran.lalr" */
 yySynAttribute.Tree = mMODULE_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, yyAttrStackPtr [4-1].Tree); 
       CheckSameIdent (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [5-1].Label);
     
} break;
case 1526:
case 1462: /* module_token : MODULE PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 276; {
/* line 569 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [2-1].Scan.Ident; 
} break;
case 1527: /* module_token : MODULE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 276; {
/* line 573 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1528: /* module_token : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 276; {
/* line 577 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1529:
case 1312: /* subroutine_subprogram : subroutine_definition block subroutine_token CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 268; {
/* line 589 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->PROC_DECL.PROC_BODY = yyAttrStackPtr [2-1].Tree; 
       yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       InitLabels ();
       CheckSameIdent (yyAttrStackPtr [1-1].Tree->PROC_DECL.Ident, yyAttrStackPtr [3-1].Label);
     
} break;
case 1530:
case 1445: /* subroutine_definition : prefix SUBROUTINE PIdent dummy_arguments CR1 .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 277; {
/* line 598 "fortran.lalr" */
 yySynAttribute.Tree = mPROC_DECL (yyAttrStackPtr [3-1].Scan.Ident, yyAttrStackPtr [3-1].Label, 
                             yyAttrStackPtr [4-1].Tree, NoTree); 

       yySynAttribute.Tree->PROC_DECL.IsRecursive  = (yyAttrStackPtr [1-1].Label & 16);
       yySynAttribute.Tree->PROC_DECL.IsPure       = (yyAttrStackPtr [1-1].Label & 8 );
       yySynAttribute.Tree->PROC_DECL.HPFExtrinsic = yyAttrStackPtr [1-1].Line;
     
} break;
case 1531:
case 1311: /* subroutine_token : SUBROUTINE PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 278; {
/* line 609 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [2-1].Scan.Ident; 
} break;
case 1532: /* subroutine_token : SUBROUTINE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 278; {
/* line 613 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1533: /* subroutine_token : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 278; {
/* line 617 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1534:
case 1448: /* function_subprogram : function_definition block function_token CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 269; {
/* line 630 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->FUNC_DECL.FUNC_BODY = yyAttrStackPtr [2-1].Tree; 
       yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
       InitLabels ();
       CheckSameIdent (yyAttrStackPtr [1-1].Tree->FUNC_DECL.Ident, yyAttrStackPtr [3-1].Label);
     
} break;
case 1535:
case 1447: /* function_token : FUNCTION PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 281; {
/* line 639 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [2-1].Scan.Ident; 
} break;
case 1536: /* function_token : FUNCTION .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 281; {
/* line 643 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1537: /* function_token : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 281; {
/* line 647 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1538:
case 1446: /* function_definition : prefix FUNCTION PIdent dummy_arguments function_result CR1 .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 280; {
/* line 652 "fortran.lalr" */
 yySynAttribute.Tree = mFUNC_DECL (yyAttrStackPtr [3-1].Scan.Ident, yyAttrStackPtr [3-1].Label,  /* name, pos */
                             yyAttrStackPtr [4-1].Tree,   /* formals */
                             NoTree,    /* body is set later */
                             yyAttrStackPtr [1-1].Tree,   /* result_type */
                             yyAttrStackPtr [5-1].Label); /* result_id   */ 
       yySynAttribute.Tree->FUNC_DECL.IsRecursive  = (yyAttrStackPtr [1-1].Label & 16);
       yySynAttribute.Tree->FUNC_DECL.IsPure       = (yyAttrStackPtr [1-1].Label & 8 );
       yySynAttribute.Tree->FUNC_DECL.HPFExtrinsic = yyAttrStackPtr [1-1].Line;   
     
} break;
case 1539: /* function_result : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 282; {
/* line 663 "fortran.lalr" */
 yySynAttribute.Label = DefaultId (); 
} break;
case 1540:
case 1031: /* function_result : RESULT '(' PIdent ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 282; {
/* line 666 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [3-1].Scan.Ident; 
} break;
case 1541: /* prefix : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 279; {
/* line 672 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_TYPE (); 
       yySynAttribute.Label = 0;      /* is nothing */    
       yySynAttribute.Line  = DefaultId();    /* no EXTRINSIC */
     
} break;
case 1542:
case 1081: /* prefix : type_spec prefix .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 279; {
/* line 679 "fortran.lalr" */
 yySynAttribute.Tree  = yyAttrStackPtr [1-1].Tree; 
       yySynAttribute.Label = yyAttrStackPtr [2-1].Label;
       yySynAttribute.Line  = yyAttrStackPtr [2-1].Line;
     
} break;
case 1543:
case 1090: /* prefix : RECURSIVE prefix .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 279; {
/* line 687 "fortran.lalr" */
 yySynAttribute.Tree  = yyAttrStackPtr [2-1].Tree; 
       yySynAttribute.Label = (yyAttrStackPtr [2-1].Label | 16) ;
       yySynAttribute.Line  = yyAttrStackPtr [2-1].Line;
     
} break;
case 1544:
case 1089: /* prefix : PURE prefix .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 279; {
/* line 695 "fortran.lalr" */
 yySynAttribute.Tree  = yyAttrStackPtr [2-1].Tree;
       yySynAttribute.Label = (yyAttrStackPtr [2-1].Label |  8);
       yySynAttribute.Line  = yyAttrStackPtr [2-1].Line;
     
} break;
case 1545:
case 1080: /* prefix : EXTRINSIC '(' extrinsic_spec ')' prefix .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 279; {
/* line 703 "fortran.lalr" */
 yySynAttribute.Tree  = yyAttrStackPtr [5-1].Tree;
       yySynAttribute.Label = yyAttrStackPtr [5-1].Label;
       yySynAttribute.Line  = yyAttrStackPtr [3-1].Line;
     
} break;
case 1546:
case 1086: /* extrinsic_spec : extrinsic_kind_keyword .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 284; {
/* line 719 "fortran.lalr" */
 yySynAttribute.Line = yyAttrStackPtr [1-1].Line; 
} break;
case 1547:
case 1087: /* extrinsic_spec : extrinsic_spec_arg_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 284; {
/* line 723 "fortran.lalr" */
 yySynAttribute.Line = DecodeExtrinsic (yyAttrStackPtr [1-1].Line); 
} break;
case 1548: /* extrinsic_spec_arg_list : extrinsic_spec_arg .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 286; {
/* line 727 "fortran.lalr" */
 yySynAttribute.Line = yyAttrStackPtr [1-1].Line; 
} break;
case 1549:
case 1088: /* extrinsic_spec_arg_list : extrinsic_spec_arg ',' extrinsic_spec_arg_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 286; {
/* line 731 "fortran.lalr" */
 yySynAttribute.Line = MixExtrinsic (yyAttrStackPtr [1-1].Line, yyAttrStackPtr [3-1].Line); 
} break;
case 1550:
case 925: /* extrinsic_spec_arg : PIdent '=' StringConst .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 287; {
/* line 735 "fortran.lalr" */
 yySynAttribute.Line = CodeExtrinsic1 (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [3-1].Scan.StringConst); 
} break;
case 1551:
case 924: /* extrinsic_spec_arg : StringConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 287; {
/* line 739 "fortran.lalr" */
 yySynAttribute.Line = CodeExtrinsic (yyAttrStackPtr [1-1].Scan.StringConst); 
} break;
case 1552: /* extrinsic_kind_keyword : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 285; {
/* line 743 "fortran.lalr" */
 yySynAttribute.Line = yyAttrStackPtr [1-1].Scan.Ident; 
} break;
case 1553:
case 1475: /* block_data : block_data_definition block block_data_token CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 270; {
/* line 754 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->BLOCK_DATA_DECL.DATA_BODY = yyAttrStackPtr [2-1].Tree; 
       yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       InitLabels ();
       CheckSameIdent (yyAttrStackPtr [1-1].Tree->BLOCK_DATA_DECL.Ident, yyAttrStackPtr [3-1].Label);
     
} break;
case 1554:
case 1052: /* block_data_definition : BLOCKDATA PIdent CR1 .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 288; {
/* line 763 "fortran.lalr" */
 yySynAttribute.Tree = mBLOCK_DATA_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, NoTree); 
} break;
case 1555:
case 1051: /* block_data_definition : BLOCKDATA CR1 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 288; {
/* line 768 "fortran.lalr" */
 yySynAttribute.Tree = mBLOCK_DATA_DECL (IsIdent("_block_data"), 
                                   NLine(yyAttrStackPtr [1-1]), NoTree); 
} break;
case 1556:
case 1474: /* block_data_token : BLOCKDATA PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 289; {
/* line 774 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [2-1].Scan.Ident; 
} break;
case 1557: /* block_data_token : BLOCKDATA .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 289; {
/* line 778 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1558: /* block_data_token : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 289; {
/* line 782 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1559: /* dummy_arguments : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 275; {
/* line 790 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_EMPTY (); 
} break;
case 1560:
case 920: /* dummy_arguments : '(' ')' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 275; {
/* line 793 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_EMPTY (); 
} break;
case 1561:
case 922: /* dummy_arguments : '(' unit_param_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 275; {
/* line 796 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1562: /* unit_param_list : unit_param .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 290; {
/* line 799 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree , mDECL_EMPTY ()); 
} break;
case 1563:
case 1078: /* unit_param_list : unit_param ',' unit_param_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 290; {
/* line 802 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1564:
case 1077: /* unit_param : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 291; {
/* line 805 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_PARAM_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, mDUMMY_TYPE ()); 
} break;
case 1565:
case 921: /* unit_param : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 291; {
/* line 809 "fortran.lalr" */
 yySynAttribute.Tree = mRET_PARAM_DECL (DefaultId(), NLine(yyAttrStackPtr [1-1])); 
} break;
case 1566:
case 1047: /* block : specification_part execution_part internal_subprogram_part opt_label END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 272; {
/* line 823 "fortran.lalr" */
 yySynAttribute.Tree = mBODY_NODE (CompleteDecls (yyAttrStackPtr [1-1].Tree),  /* append DECL_EMPTY */
                             yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 

       Spec_Exec_Separation (yySynAttribute.Tree);
       LabelForEnd (yySynAttribute.Tree, yyAttrStackPtr [4-1].Label, NLine (yyAttrStackPtr [5-1]));

     
} break;
case 1567: /* internal_subprogram_part : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 294; {
/* line 833 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_EMPTY (); 
} break;
case 1568:
case 1455: /* internal_subprogram_part : CONTAINS CR1 internal_subprograms .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 294; {
/* line 837 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1569: /* internal_subprograms : internal_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 295; {
/* line 841 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, mUNIT_EMPTY() ); 
} break;
case 1570:
case 1456: /* internal_subprograms : internal_subprogram internal_subprograms .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 295; {
/* line 845 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1571:
case 1443: /* internal_subprogram : subroutine_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 296; {
/* line 849 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1572:
case 1444: /* internal_subprogram : function_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 296; {
/* line 853 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1573:
case 914: /* kind_selector : '(' expression ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 298; {
/* line 863 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1574:
case 913: /* kind_selector : '(' PIdent '=' expression ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 298; {
/* line 867 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [4-1].Tree; 
} break;
case 1575:
case 911: /* kind_selector : '(' '*' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 298; {
/* line 871 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_EXP (); 
} break;
case 1576:
case 912: /* kind_selector : '(' PIdent '=' '*' ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 298; {
/* line 875 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_EXP (); 
} break;
case 1577:
case 874: /* basic_num_type : REAL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 299; {
/* line 887 "fortran.lalr" */
 yySynAttribute.Tree = mREAL_TYPE (NoTree); 
} break;
case 1578:
case 873: /* basic_num_type : INTEGER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 299; {
/* line 891 "fortran.lalr" */
 yySynAttribute.Tree = mINTEGER_TYPE (NoTree); 
} break;
case 1579:
case 875: /* basic_num_type : COMPLEX .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 299; {
/* line 895 "fortran.lalr" */
 yySynAttribute.Tree = mCOMPLEX_TYPE (NoTree); 
} break;
case 1580:
case 876: /* basic_num_type : LOGICAL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 299; {
/* line 899 "fortran.lalr" */
 yySynAttribute.Tree = mBOOLEAN_TYPE (NoTree); 
} break;
case 1581: /* num_type : basic_num_type .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 300; {
/* line 905 "fortran.lalr" */
 yySynAttribute.Tree = SetDefaultSize (yyAttrStackPtr [1-1].Tree); 
} break;
case 1582:
case 926: /* num_type : basic_num_type '*' IntConst .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 300; {
/* line 909 "fortran.lalr" */
 yySynAttribute.Tree = SetTypeSize (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Scan.IntConst); 
} break;
case 1583:
case 918: /* num_type : DOUBLE_PRECISION .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 300; {
/* line 913 "fortran.lalr" */
 yySynAttribute.Tree = mREAL_TYPE (mCONST_EXP (
                               mINT_CONSTANT (2*default_real_size)));
     
} break;
case 1584:
case 919: /* num_type : DOUBLE_COMPLEX .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 300; {
/* line 919 "fortran.lalr" */
 yySynAttribute.Tree = mCOMPLEX_TYPE (mCONST_EXP (
                                  mINT_CONSTANT (4*default_real_size)));
     
} break;
case 1585: /* char_type : CHARACTER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 301; {
/* line 927 "fortran.lalr" */
 yySynAttribute.Tree = mSTRING_TYPE (mCONST_EXP (mINT_CONSTANT (1))); 
} break;
case 1586:
case 1075: /* char_type : CHARACTER '*' char_length .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 301; {
/* line 931 "fortran.lalr" */
 yySynAttribute.Tree = mSTRING_TYPE (yyAttrStackPtr [3-1].Tree); 
} break;
case 1587:
case 1076: /* kind_type : CHARACTER kind_selector .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 303; {
/* line 937 "fortran.lalr" */
 yySynAttribute.Tree = mSTRING_TYPE (yyAttrStackPtr [2-1].Tree); 
} break;
case 1588:
case 1082: /* kind_type : basic_num_type kind_selector .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 303; {
/* line 941 "fortran.lalr" */
 yySynAttribute.Tree = SetTypeKind (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1589:
case 1085: /* type_spec : kind_type .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 283; {
/* line 947 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1590:
case 1084: /* type_spec : char_type .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 283; {
/* line 951 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1591:
case 1083: /* type_spec : num_type .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 283; {
/* line 955 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1592:
case 923: /* type_spec : TYPE '(' PIdent ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 283; {
/* line 959 "fortran.lalr" */
 yySynAttribute.Tree = mTYPE_OBJ (yyAttrStackPtr [3-1].Scan.Ident);
       yySynAttribute.Tree = mTYPE_ID (yySynAttribute.Tree);   
} break;
case 1593:
case 934: /* DimSpec : '(' DimIndexes ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 305; {
/* line 972 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1594:
case 1097: /* DimIndexes : Index_Typen .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 304; {
/* line 976 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1595:
case 1098: /* DimIndexes : Dyn_Specifications .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 304; {
/* line 980 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1596: /* Dyn_Specifications : Dyn_Spec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 307; {
/* line 984 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, mSHAPE_EMPTY()); 
} break;
case 1597:
case 1099: /* Dyn_Specifications : Dyn_Spec ',' Dyn_Specifications .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 307; {
/* line 988 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1598:
case 1093: /* Dyn_Spec : ':' Overlap .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 308; {
/* line 992 "fortran.lalr" */
 yySynAttribute.Tree = mDEFERRED_SHAPE ();
         yySynAttribute.Tree->DEFERRED_SHAPE.Overlap = yyAttrStackPtr [2-1].Tree;
       
} break;
case 1599:
case 1095: /* Dyn_Spec : expression ':' Overlap .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 308; {
/* line 998 "fortran.lalr" */
 yySynAttribute.Tree = mASSUMED_SHAPE (yyAttrStackPtr [1-1].Tree);
         yySynAttribute.Tree->ASSUMED_SHAPE.Overlap = yyAttrStackPtr [3-1].Tree;
       
} break;
case 1600: /* Overlap : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 309; {
/* line 1004 "fortran.lalr" */
 yySynAttribute.Tree  = mOVERLAP_SPEC (0, 0, 0, 0);
       
} break;
case 1601:
case 1100: /* Index_Typen : LastBegrenzer .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 306; {
/* line 1018 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, mSHAPE_EMPTY()); 
} break;
case 1602: /* Index_Typen : Begrenzer .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 306; {
/* line 1022 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, mSHAPE_EMPTY()); 
} break;
case 1603:
case 1101: /* Index_Typen : Begrenzer ',' Index_Typen .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 306; {
/* line 1026 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1604:
case 1096: /* Begrenzer : expression Overlap .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 311; {
/* line 1030 "fortran.lalr" */
 yySynAttribute.Tree = mEXPLICIT_SHAPE (mCONST_EXP(mINT_CONSTANT(1)), yyAttrStackPtr [1-1].Tree); 
         yySynAttribute.Tree->EXPLICIT_SHAPE.Overlap = yyAttrStackPtr [2-1].Tree;
       
} break;
case 1605:
case 1094: /* Begrenzer : expression ':' expression Overlap .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 311; {
/* line 1036 "fortran.lalr" */
 yySynAttribute.Tree = mEXPLICIT_SHAPE (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
         yySynAttribute.Tree->EXPLICIT_SHAPE.Overlap = yyAttrStackPtr [4-1].Tree;
       
} break;
case 1606:
case 932: /* LastBegrenzer : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 310; {
/* line 1042 "fortran.lalr" */
 yySynAttribute.Tree = mASSUMED_SIZE (mCONST_EXP(mINT_CONSTANT(1))); 
         yySynAttribute.Tree->ASSUMED_SIZE.Overlap = mOVERLAP_SPEC (0, 0, 0, 0);
       
} break;
case 1607:
case 933: /* LastBegrenzer : expression ':' '*' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 310; {
/* line 1048 "fortran.lalr" */
 yySynAttribute.Tree = mASSUMED_SIZE (yyAttrStackPtr [1-1].Tree); 
         yySynAttribute.Tree->ASSUMED_SIZE.Overlap = mOVERLAP_SPEC (0, 0, 0, 0);
       
} break;
case 1608:
case 1449: /* specification_part : decl_constructs .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 292; {
/* line 1060 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1609:
case 1450: /* decl_constructs : declaration_construct CR1 decl_constructs .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 312; {
/* line 1064 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1610: /* decl_constructs : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 312; {
/* line 1068 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1611:
case 1451: /* declaration_construct : use_stmt .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 313; {
/* line 1072 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1612:
case 1452: /* declaration_construct : derived_type_def .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 313; {
/* line 1076 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1613:
case 1453: /* declaration_construct : interface_block .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 313; {
/* line 1080 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1614:
case 1454: /* declaration_construct : type_declaration_stmt .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 313; {
/* line 1084 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1615:
case 1283: /* declaration_construct : opt_label definition .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 313; {
/* line 1088 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree;
       /* some definitions will use the label */
       SetDefinitionLabel (yySynAttribute.Tree, yyAttrStackPtr [1-1].Label);
     
} break;
case 1616:
case 1284: /* definition : parameter_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1096 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1617:
case 1285: /* definition : implicit_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1097 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1618:
case 1286: /* definition : access_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1101 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1619:
case 1287: /* definition : allocatable_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1102 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1620:
case 1288: /* definition : common_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1103 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1621:
case 1289: /* definition : data_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1104 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1622:
case 1290: /* definition : format_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1105 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1623:
case 1291: /* definition : dimension_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1106 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1624:
case 1292: /* definition : equivalence_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1107 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1625:
case 1293: /* definition : external_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1108 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1626:
case 1294: /* definition : intent_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1109 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1627:
case 1295: /* definition : intrinsic_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1110 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1628:
case 1296: /* definition : namelist_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1111 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1629:
case 1297: /* definition : optional_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1112 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1630:
case 1298: /* definition : pointer_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1113 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1631:
case 1299: /* definition : save_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1114 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1632:
case 1300: /* definition : sequ_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1115 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1633:
case 1301: /* definition : nsequ_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1116 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1634:
case 1302: /* definition : target_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1117 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1635:
case 1303: /* definition : map_definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1119 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1636:
case 1304: /* definition : hpf_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1121 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1637:
case 1305: /* definition : adp_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 318; {
/* line 1122 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1638: /* entity_decl_list : entity_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 342; {
/* line 1131 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1639:
case 1147: /* entity_decl_list : entity_decl ',' entity_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 342; {
/* line 1135 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1640:
case 1146: /* entity_decl : PIdent opt_array_spec opt_char_length opt_init_expr .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 341; {
/* line 1139 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_EMPTY();
      if (yyAttrStackPtr [4-1].Tree != NoTree)
         yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [4-1].Tree, yySynAttribute.Tree);
      if (yyAttrStackPtr [3-1].Tree != NoTree)
         yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [3-1].Tree, yySynAttribute.Tree);
      if (yyAttrStackPtr [2-1].Tree != NoTree)
         yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, yySynAttribute.Tree);
      yySynAttribute.Tree = mENTITY_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yySynAttribute.Tree); 
} break;
case 1641: /* opt_array_spec : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 343; {
/* line 1150 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1642:
case 980: /* opt_array_spec : '(' DimIndexes ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 343; {
/* line 1154 "fortran.lalr" */
 yySynAttribute.Tree = mDIMENSION_DECL (DefaultId(), 0, yyAttrStackPtr [2-1].Tree); 
} break;
case 1643: /* opt_char_length : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 344; {
/* line 1158 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1644:
case 1145: /* opt_char_length : '*' char_length .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 344; {
/* line 1162 "fortran.lalr" */
 yySynAttribute.Tree = mTYPESPEC_DECL (DefaultId(), 0, mSTRING_TYPE (yyAttrStackPtr [2-1].Tree)); 
} break;
case 1645: /* opt_init_expr : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 345; {
/* line 1166 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1646: /* opt_init_expr : '=' expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 345; {
/* line 1170 "fortran.lalr" */
 yySynAttribute.Tree = mINIT_DATA_DECL (DefaultId(), 0, yyAttrStackPtr [2-1].Tree); 
} break;
case 1647:
case 917: /* char_length : '(' type_param_value ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 302; {
/* line 1178 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1648:
case 915: /* char_length : IntConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 302; {
/* line 1182 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mINT_CONSTANT (yyAttrStackPtr [1-1].Scan.IntConst)); 
} break;
case 1649:
case 916: /* type_param_value : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 346; {
/* line 1186 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mINT_CONSTANT (-1)); 
} break;
case 1650: /* type_param_value : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 346; {
/* line 1190 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;   
} break;
case 1651:
case 1148: /* type_declaration_stmt : type_spec optional_attributes entity_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 317; {
/* line 1200 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
       yyAttrStackPtr [1-1].Tree = mDECL_LIST (mTYPESPEC_DECL (DefaultId(), 0, yyAttrStackPtr [1-1].Tree), yyAttrStackPtr [2-1].Tree);
       /* set all Attributes to Entity Declaration Attributes */
       SetAttributes (yyAttrStackPtr [1-1].Tree, yySynAttribute.Tree); 
} break;
case 1652: /* optional_attributes : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 347; {
/* line 1209 "fortran.lalr" */
 yySynAttribute.Tree = NoTree;  
} break;
case 1653:
case 979: /* optional_attributes : '::' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 347; {
/* line 1213 "fortran.lalr" */
 yySynAttribute.Tree = NoTree;  
} break;
case 1654:
case 981: /* optional_attributes : attribute_list '::' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 347; {
/* line 1217 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1655: /* attribute_list : ',' attr_spec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 348; {
/* line 1221 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, NoTree); 
} break;
case 1656:
case 1143: /* attribute_list : ',' attr_spec attribute_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 348; {
/* line 1225 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1657:
case 962: /* attr_spec : PARAMETER1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1229 "fortran.lalr" */
 yySynAttribute.Tree = mPARAMETER_DECL (DefaultId(), 0, mDUMMY_EXP()); 
} break;
case 1658:
case 1144: /* attr_spec : access_spec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1233 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1659:
case 974: /* attr_spec : ALLOCATABLE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1237 "fortran.lalr" */
 yySynAttribute.Tree = mALLOCATABLE_DECL (DefaultId(), 0); 
} break;
case 1660:
case 961: /* attr_spec : DIMENSION1 '(' DimIndexes ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1241 "fortran.lalr" */
 yySynAttribute.Tree = mDIMENSION_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Tree); 
} break;
case 1661:
case 975: /* attr_spec : ARRAY1 '(' DimIndexes ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1245 "fortran.lalr" */
 yySynAttribute.Tree = mDIMENSION_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Tree); 
} break;
case 1662:
case 966: /* attr_spec : INTENT1 '(' intent_spec ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1249 "fortran.lalr" */
 yySynAttribute.Tree = mINTENT_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Label); 
} break;
case 1663:
case 967: /* attr_spec : EXTERNAL1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1253 "fortran.lalr" */
 yySynAttribute.Tree = mEXTERNAL_DECL (DefaultId(), 0); 
} break;
case 1664:
case 968: /* attr_spec : INTRINSIC1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1257 "fortran.lalr" */
 yySynAttribute.Tree = mINTRINSIC_DECL (DefaultId(), DefaultId(), 0, 0, 0); 
} break;
case 1665:
case 969: /* attr_spec : OPTIONAL1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1261 "fortran.lalr" */
 yySynAttribute.Tree = mOPTIONAL_DECL (DefaultId(), 0); 
} break;
case 1666:
case 976: /* attr_spec : LAYOUT1 '(' StringConst ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1265 "fortran.lalr" */
 yySynAttribute.Tree = mLAYOUT_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Scan.StringConst); 
} break;
case 1667:
case 977: /* attr_spec : PASS_BY1 '(' StringConst ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1269 "fortran.lalr" */
 yySynAttribute.Tree = mPASS_BY_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Scan.StringConst); 
} break;
case 1668:
case 978: /* attr_spec : MAP_TO1 '(' StringConst ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 349; {
/* line 1273 "fortran.lalr" */
 yySynAttribute.Tree = mMAP_TO_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Scan.StringConst); 
} break;
case 1669:
case 970: /* attr_spec : POINTER1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1277 "fortran.lalr" */
 yySynAttribute.Tree = mPOINTER_DECL (DefaultId(), 0); 
} break;
case 1670:
case 971: /* attr_spec : SAVE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1281 "fortran.lalr" */
 yySynAttribute.Tree = mSAVE_DECL (DefaultId(), 0); 
} break;
case 1671:
case 972: /* attr_spec : TARGET1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1285 "fortran.lalr" */
 yySynAttribute.Tree = mTARGET_DECL (DefaultId(), 0); 
} break;
case 1672:
case 973: /* attr_spec : DATA1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 349; {
/* line 1289 "fortran.lalr" */
 yySynAttribute.Tree = mINIT_DATA_DECL (DefaultId(), 0, mDUMMY_EXP()); 
} break;
case 1673:
case 927: /* access_spec : PUBLIC1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 350; {
/* line 1293 "fortran.lalr" */
 yySynAttribute.Tree = mPUBLIC_DECL (DefaultId(), 0); 
} break;
case 1674:
case 928: /* access_spec : PRIVATE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 350; {
/* line 1297 "fortran.lalr" */
 yySynAttribute.Tree = mPRIVATE_DECL (DefaultId(), 0); 
} break;
case 1675:
case 929: /* access_spec : SEQUENCE1 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 350; {
/* line 1301 "fortran.lalr" */
 yySynAttribute.Tree = mSEQUENCE_DECL (DefaultId(), 0); 
} break;
case 1676:
case 1217: /* dimension_definition : DIMENSION opt_dcolon ArraySpecList .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 326; {
/* line 1311 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1677: /* ArraySpecList : ArraySpec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 352; {
/* line 1315 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1678:
case 1218: /* ArraySpecList : ArraySpec ',' ArraySpecList .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 352; {
/* line 1319 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1679:
case 1216: /* ArraySpec : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 353; {
/* line 1323 "fortran.lalr" */
 yySynAttribute.Tree = mDIMENSION_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree); 
} break;
case 1680:
case 1225: /* equivalence_definition : EQUIVALENCE eqvblocks .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 327; {
/* line 1333 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1681: /* eqvblocks : eqvblock .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 354; {
/* line 1337 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1682:
case 1226: /* eqvblocks : eqvblock ',' eqvblocks .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 354; {
/* line 1341 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1683:
case 1003: /* eqvblock : '(' variable ',' variable more_eqvs ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 355; {
/* line 1345 "fortran.lalr" */
 yySynAttribute.Tree = mEQV_DECL (DefaultId(), NLine (yyAttrStackPtr [6-1]), 
                  mBTV_LIST (yyAttrStackPtr [2-1].Tree, mBTV_LIST (yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [5-1].Tree))); 
} break;
case 1684: /* more_eqvs : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 357; {
/* line 1350 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_EMPTY (); 
} break;
case 1685:
case 1224: /* more_eqvs : ',' variable more_eqvs .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 357; {
/* line 1354 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1686:
case 1222: /* common_definition : COMMON blank_common common_object common_cont .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 323; {
/* line 1364 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [3-1].Tree, global_objects);
       yyAttrStackPtr [2-1].Tree->COMMON_DECL.IDS = global_objects;
       yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_groups);         
     
} break;
case 1687:
case 1223: /* common_definition : COMMON named_common common_object common_cont .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 323; {
/* line 1370 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [3-1].Tree, global_objects);
       yyAttrStackPtr [2-1].Tree->COMMON_DECL.IDS = global_objects;
       yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_groups);         
     
} break;
case 1688: /* common_object : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 359; {
/* line 1376 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, mDUMMY_TYPE()); 
     
} break;
case 1689:
case 1219: /* common_object : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 359; {
/* line 1380 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label,
                   mARRAY_TYPE (yyAttrStackPtr [2-1].Tree, mDUMMY_TYPE()));  
     
} break;
case 1690: /* common_cont : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 360; {
/* line 1385 "fortran.lalr" */
 global_objects = mDECL_EMPTY   (); 
       global_groups  = mDECL_EMPTY ();
     
} break;
case 1691:
case 1221: /* common_cont : ',' common_object common_cont .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 360; {
/* line 1390 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_objects); 
} break;
case 1692:
case 1220: /* common_cont : opt_comma named_common common_object common_cont .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 360; {
/* line 1394 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [3-1].Tree, global_objects);
       yyAttrStackPtr [2-1].Tree->COMMON_DECL.IDS = global_objects;
       global_groups  = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_groups); 
       global_objects = mDECL_EMPTY ();                         
} break;
case 1693:
case 1002: /* named_common : '/' PIdent '/' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 361; {
/* line 1401 "fortran.lalr" */
  yySynAttribute.Tree = mCOMMON_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, mDECL_EMPTY () ); 
} break;
case 1694:
case 1001: /* blank_common : '/' '/' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 358; {
/* line 1405 "fortran.lalr" */
 yySynAttribute.Tree = mCOMMON_DECL (DefaultId(), NLine (yyAttrStackPtr [1-1]), mDECL_EMPTY () ); 
} break;
case 1695:
case 1000: /* blank_common : '//' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 358; {
/* line 1409 "fortran.lalr" */
 yySynAttribute.Tree = mCOMMON_DECL (DefaultId(), NLine (yyAttrStackPtr [1-1]), mDECL_EMPTY () ); 
} break;
case 1696: /* blank_common : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 358; {
/* line 1413 "fortran.lalr" */
 yySynAttribute.Tree = mCOMMON_DECL (DefaultId(), 0, mDECL_EMPTY () );   
} break;
case 1697:
case 1187: /* use_stmt : USE PIdent rename_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 314; {
/* line 1423 "fortran.lalr" */
 yySynAttribute.Tree = mUSE_DECL (DefaultId(), NLine(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [3-1].Tree);
       yySynAttribute.Tree = mDECL_LIST (yySynAttribute.Tree, NoTree);                       
} break;
case 1698:
case 1182: /* use_stmt : USE PIdent ',' ONLY ':' only_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 314; {
/* line 1427 "fortran.lalr" */
 yySynAttribute.Tree = mONLY_USE_DECL (DefaultId(), NLine (yyAttrStackPtr [1-1]), 
                                 yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [6-1].Tree);
       yySynAttribute.Tree = mDECL_LIST (yySynAttribute.Tree, NoTree);                       
} break;
case 1699: /* rename_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 362; {
/* line 1432 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_EMPTY (); 
} break;
case 1700:
case 1186: /* rename_list : ',' rename rename_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 362; {
/* line 1435 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1701:
case 1181: /* rename : PIdent '=>' PIdent .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 364; {
/* line 1438 "fortran.lalr" */
 yySynAttribute.Tree = mRENAME_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Scan.Ident); 
} break;
case 1702: /* only_list : only .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 363; {
/* line 1441 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, mDECL_EMPTY ()); 
} break;
case 1703:
case 1184: /* only_list : only ',' only_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 363; {
/* line 1444 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1704:
case 1185: /* only : access_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 365; {
/* line 1447 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1705:
case 1183: /* only : rename .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 365; {
/* line 1450 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1706:
case 996: /* implicit_definition : IMPLICIT Ident .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 320; {
/* line 1460 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mIMPLICIT_DECL (DefaultId(), NLine (yyAttrStackPtr [1-1]),
                            IsIdent ("A"), IsIdent ("Z"),
                            mDUMMY_TYPE ()),
             NoTree ); 
} break;
case 1707:
case 1211: /* implicit_definition : IMPLICIT implicit_decl more_implicit_decl .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 320; {
/* line 1465 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1708: /* more_implicit_decl : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 368; {
/* line 1467 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1709:
case 1210: /* more_implicit_decl : ',' implicit_decl more_implicit_decl .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 368; {
/* line 1470 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1710:
case 997: /* implicit_decl : num_type '(' letter_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 367; {
/* line 1474 "fortran.lalr" */
 SetImplicitType (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [1-1].Tree); 
      yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;                    
} break;
case 1711:
case 998: /* implicit_decl : char_type '(' letter_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 367; {
/* line 1479 "fortran.lalr" */
 SetImplicitType (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [1-1].Tree); 
      yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;                    
} break;
case 1712: /* letter_list : letter_spec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 369; {
/* line 1484 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1713:
case 1209: /* letter_list : letter_spec ',' letter_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 369; {
/* line 1488 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1714: /* letter_spec : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 370; {
/* line 1492 "fortran.lalr" */
 yySynAttribute.Tree = mIMPLICIT_DECL (IsIdent (" "), yyAttrStackPtr [1-1].Label, 
                  yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Scan.Ident, NoTree); 
} break;
case 1715:
case 1208: /* letter_spec : PIdent '-' PIdent .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 370; {
/* line 1497 "fortran.lalr" */
 yySynAttribute.Tree = mIMPLICIT_DECL (IsIdent (" "), yyAttrStackPtr [1-1].Label,
                  yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [3-1].Scan.Ident, NoTree); 
} break;
case 1716:
case 1213: /* external_definition : EXTERNAL ExtIdentList .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 328; {
/* line 1508 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1717: /* ExtIdentList : ExtIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 371; {
/* line 1511 "fortran.lalr" */
 yySynAttribute.Tree=mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1718:
case 1214: /* ExtIdentList : ExtIdent ',' ExtIdentList .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 371; {
/* line 1515 "fortran.lalr" */
 yySynAttribute.Tree=mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1719:
case 1212: /* ExtIdent : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 372; {
/* line 1519 "fortran.lalr" */
 yySynAttribute.Tree= mEXTERNAL_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1720:
case 1203: /* intrinsic_definition : INTRINSIC IntIdentList .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 330; {
/* line 1523 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1721: /* IntIdentList : Intrinsic_Ident .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 373; {
/* line 1527 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1722:
case 1204: /* IntIdentList : Intrinsic_Ident ',' IntIdentList .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 373; {
/* line 1531 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1723:
case 1202: /* Intrinsic_Ident : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 374; {
/* line 1535 "fortran.lalr" */
 yySynAttribute.Tree = mINTRINSIC_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, DefaultId (), 0, 0); 
} break;
case 1724: /* access_definition : PRIVATE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 321; {
/* line 1545 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mPRIVATE_DECL (DefaultId(), 0),
                             mDECL_EMPTY ()); 
} break;
case 1725: /* access_definition : PUBLIC .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 321; {
/* line 1549 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mPUBLIC_DECL (DefaultId(), 0),
                             mDECL_EMPTY ()); 
} break;
case 1726:
case 1246: /* access_definition : PUBLIC opt_dcolon access_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 321; {
/* line 1553 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
       MakePublicDecls (yySynAttribute.Tree);
     
} break;
case 1727:
case 1247: /* access_definition : PRIVATE opt_dcolon access_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 321; {
/* line 1558 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
       MakePrivateDecls (yySynAttribute.Tree);
     
} break;
case 1728: /* access_id_list : access_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 375; {
/* line 1569 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1729:
case 1245: /* access_id_list : access_id ',' access_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 375; {
/* line 1572 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1730:
case 1244: /* access_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 366; {
/* line 1575 "fortran.lalr" */
 yySynAttribute.Tree = mNAME_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1731:
case 989: /* access_id : OPERATOR '(' defined_operator ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 366; {
/* line 1578 "fortran.lalr" */
 yySynAttribute.Tree = mNAME_DECL (DefaultId(), NLine(yyAttrStackPtr [2-1]) ); 
} break;
case 1732:
case 990: /* access_id : ASSIGNMENT '(' '=' ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 366; {
/* line 1581 "fortran.lalr" */
 yySynAttribute.Tree = mNAME_DECL (DefaultId(), NLine(yyAttrStackPtr [2-1]) ); 
} break;
case 1733:
case 1236: /* optional_definition : OPTIONAL opt_dcolon optional_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 332; {
/* line 1590 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1734: /* optional_id_list : optional_ident .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 377; {
/* line 1593 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1735:
case 1237: /* optional_id_list : optional_ident ',' optional_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 377; {
/* line 1596 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1736:
case 1235: /* optional_ident : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 378; {
/* line 1599 "fortran.lalr" */
 yySynAttribute.Tree = mOPTIONAL_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1737:
case 1262: /* map_definition : MAP_TO '(' StringConst ')' opt_dcolon map_id_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 338; {
/* line 1609 "fortran.lalr" */
 SetMapKind (kMAP_TO_DECL, yyAttrStackPtr [3-1].Scan.StringConst, yyAttrStackPtr [6-1].Tree); 
       yySynAttribute.Tree = yyAttrStackPtr [6-1].Tree;
     
} break;
case 1738:
case 1259: /* map_definition : LAYOUT '(' StringConst ')' opt_dcolon map_id_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 338; {
/* line 1615 "fortran.lalr" */
 SetMapKind (kLAYOUT_DECL, yyAttrStackPtr [3-1].Scan.StringConst, yyAttrStackPtr [6-1].Tree); 
       yySynAttribute.Tree = yyAttrStackPtr [6-1].Tree;
     
} break;
case 1739:
case 1261: /* map_definition : PASS_BY '(' StringConst ')' opt_dcolon map_id_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 338; {
/* line 1621 "fortran.lalr" */
 SetMapKind (kPASS_BY_DECL, yyAttrStackPtr [3-1].Scan.StringConst, yyAttrStackPtr [6-1].Tree); 
       yySynAttribute.Tree = yyAttrStackPtr [6-1].Tree;
     
} break;
case 1740: /* map_id_list : map_ident .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 379; {
/* line 1626 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1741:
case 1260: /* map_id_list : map_ident ',' map_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 379; {
/* line 1629 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1742:
case 1258: /* map_ident : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 380; {
/* line 1632 "fortran.lalr" */
 yySynAttribute.Tree = mMAP_TO_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, 0); 
} break;
case 1743:
case 1251: /* namelist_definition : NAMELIST namelist_groupid namelist_object namelist_cont .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 331; {
/* line 1641 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [3-1].Tree, global_objects);
       yyAttrStackPtr [2-1].Tree->COMMON_DECL.IDS = global_objects;
       global_groups = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_groups); 
       yySynAttribute.Tree = global_groups;                               
} break;
case 1744: /* namelist_cont : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 383; {
/* line 1647 "fortran.lalr" */
 global_objects = mDECL_EMPTY();
       global_groups  = mDECL_EMPTY();  
} break;
case 1745:
case 1250: /* namelist_cont : ',' namelist_object namelist_cont .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 383; {
/* line 1651 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_objects); 
} break;
case 1746:
case 1249: /* namelist_cont : opt_comma namelist_groupid namelist_object namelist_cont .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 383; {
/* line 1654 "fortran.lalr" */
 global_objects = mDECL_LIST (yyAttrStackPtr [3-1].Tree, global_objects);
       yyAttrStackPtr [2-1].Tree->NAMELIST_DECL.IDS = global_objects;
       global_groups   = mDECL_LIST (yyAttrStackPtr [2-1].Tree, global_groups); 
       global_objects  = mDECL_EMPTY ();                         
} break;
case 1747:
case 1004: /* namelist_groupid : '/' PIdent '/' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 381; {
/* line 1660 "fortran.lalr" */
 yySynAttribute.Tree = mNAMELIST_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, NoTree); 
} break;
case 1748:
case 1248: /* namelist_object : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 382; {
/* line 1663 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, mDUMMY_TYPE()); 
} break;
case 1749: /* save_definition : SAVE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 334; {
/* line 1672 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mSAVE_DECL (DefaultId(), yyAttrStackPtr [1-1].Label), 
                             NoTree); 
} break;
case 1750:
case 1206: /* save_definition : SAVE opt_dcolon save_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 334; {
/* line 1677 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1751: /* save_var_list : save_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 384; {
/* line 1681 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1752:
case 1207: /* save_var_list : save_var ',' save_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 384; {
/* line 1685 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1753:
case 1205: /* save_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 385; {
/* line 1689 "fortran.lalr" */
 yySynAttribute.Tree = mSAVE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1754:
case 995: /* save_var : '/' PIdent '/' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 385; {
/* line 1693 "fortran.lalr" */
 yySynAttribute.Tree = mSAVE_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label); 
} break;
case 1755: /* sequ_definition : HPFSEQUENCE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 335; {
/* line 1703 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mHPF_SEQUENCE_DECL (DefaultId(), yyAttrStackPtr [1-1].Label), 
                             NoTree); 
} break;
case 1756:
case 1256: /* sequ_definition : HPFSEQUENCE opt_dcolon sequ_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 335; {
/* line 1708 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1757: /* sequ_var_list : sequ_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 386; {
/* line 1712 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1758:
case 1257: /* sequ_var_list : sequ_var ',' sequ_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 386; {
/* line 1716 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1759:
case 1255: /* sequ_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 387; {
/* line 1720 "fortran.lalr" */
 yySynAttribute.Tree = mHPF_SEQUENCE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1760:
case 1006: /* sequ_var : '/' PIdent '/' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 387; {
/* line 1724 "fortran.lalr" */
 yySynAttribute.Tree = mHPF_SEQUENCE_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label); 
} break;
case 1761: /* nsequ_definition : NOSEQUENCE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 336; {
/* line 1734 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mNOSEQUENCE_DECL (DefaultId(), yyAttrStackPtr [1-1].Label), 
                             NoTree); 
} break;
case 1762:
case 1253: /* nsequ_definition : NOSEQUENCE opt_dcolon nsequ_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 336; {
/* line 1739 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1763: /* nsequ_var_list : nsequ_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 388; {
/* line 1743 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1764:
case 1254: /* nsequ_var_list : nsequ_var ',' nsequ_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 388; {
/* line 1747 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1765:
case 1252: /* nsequ_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 389; {
/* line 1751 "fortran.lalr" */
 yySynAttribute.Tree = mNOSEQUENCE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1766:
case 1005: /* nsequ_var : '/' PIdent '/' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 389; {
/* line 1755 "fortran.lalr" */
 yySynAttribute.Tree = mNOSEQUENCE_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label); 
} break;
case 1767:
case 1233: /* allocatable_definition : ALLOCATABLE opt_dcolon allocatable_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 322; {
/* line 1765 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1768: /* allocatable_var_list : allocatable_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 390; {
/* line 1769 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1769:
case 1234: /* allocatable_var_list : allocatable_var ',' allocatable_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 390; {
/* line 1773 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1770: /* allocatable_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 391; {
/* line 1777 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                    mALLOCATABLE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                    NoTree); 
} break;
case 1771:
case 1232: /* allocatable_var : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 391; {
/* line 1783 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                    mDIMENSION_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree),
                    mDECL_LIST (mALLOCATABLE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                                NoTree)); 
} break;
case 1772:
case 1242: /* target_definition : TARGET opt_dcolon target_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 337; {
/* line 1796 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1773: /* target_var_list : target_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 392; {
/* line 1800 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1774:
case 1243: /* target_var_list : target_var ',' target_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 392; {
/* line 1804 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1775: /* target_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 393; {
/* line 1808 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                    mTARGET_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                    NoTree); 
} break;
case 1776:
case 1241: /* target_var : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 393; {
/* line 1814 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                  mDIMENSION_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree),
                   mDECL_LIST( mPOINTER_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                               NoTree)); 
} break;
case 1777:
case 1239: /* pointer_definition : POINTER opt_dcolon pointer_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 333; {
/* line 1827 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1778: /* pointer_var_list : pointer_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 394; {
/* line 1831 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1779:
case 1240: /* pointer_var_list : pointer_var ',' pointer_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 394; {
/* line 1835 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1780: /* pointer_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 395; {
/* line 1839 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                    mPOINTER_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                    NoTree); 
} break;
case 1781:
case 1238: /* pointer_var : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 395; {
/* line 1845 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (
                  mDIMENSION_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree),
                   mDECL_LIST( mPOINTER_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label),
                               NoTree)); 
} break;
case 1782:
case 1190: /* data_statement : DATA data_defs .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 324; {
/* line 1858 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1783: /* data_defs : data_def .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 396; {
/* line 1862 "fortran.lalr" */
 yySynAttribute.Tree=mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree);  
} break;
case 1784:
case 1191: /* data_defs : data_def opt_comma data_defs .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 396; {
/* line 1866 "fortran.lalr" */
 yySynAttribute.Tree=mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 1785:
case 993: /* data_def : data_liste '/' data_values '/' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 397; {
/* line 1870 "fortran.lalr" */
 yySynAttribute.Tree = mDATA_DECL (DefaultId(), NLine (yyAttrStackPtr [4-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1786: /* data_liste : data_elem .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 398; {
/* line 1874 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY()); 
} break;
case 1787:
case 1201: /* data_liste : data_elem ',' data_liste .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 398; {
/* line 1878 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1788: /* data_elem : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 400; {
/* line 1882 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1789:
case 991: /* data_elem : '(' data_elem ',' impl_do_var ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 400; {
/* line 1886 "fortran.lalr" */
 yyAttrStackPtr [4-1].Tree->DO_VAR.BODY = 
         mBTV_LIST (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree->DO_VAR.BODY); 
       yySynAttribute.Tree = yyAttrStackPtr [4-1].Tree; 
} break;
case 1790:
case 1188: /* impl_do_var : data_elem ',' impl_do_var .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 401; {
/* line 1892 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree->DO_VAR.BODY = 
         mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree->DO_VAR.BODY); 
       yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1791:
case 1189: /* impl_do_var : Laufvariable '=' DoRange .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 401; {
/* line 1898 "fortran.lalr" */
 yySynAttribute.Tree = mDO_VAR (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, mBTV_EMPTY()); 
} break;
case 1792: /* data_values : data_value .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 399; {
/* line 1902 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, mBTE_EMPTY()); 
} break;
case 1793:
case 1199: /* data_values : data_value ',' data_values .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 399; {
/* line 1906 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1794: /* data_value : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 404; {
/* line 1910 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_EXP (mUSED_VAR (
                               mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident))); 
} break;
case 1795:
case 1200: /* data_value : SignedKonstante .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 404; {
/* line 1915 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1796:
case 1196: /* data_value : IntConst '*' data_real_value .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 404; {
/* line 1919 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (mOP_TIMES(), 
                           mCONST_EXP (mINT_CONSTANT (yyAttrStackPtr [1-1].Scan.IntConst)),
                           yyAttrStackPtr [3-1].Tree); 
} break;
case 1797:
case 1198: /* data_value : PIdent '*' data_real_value .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 404; {
/* line 1924 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (mOP_TIMES(), 
                           mVAR_EXP (mUSED_VAR (
                               mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident))),
                           yyAttrStackPtr [3-1].Tree); 
} break;
case 1798:
case 1195: /* data_real_value : SignedKonstante .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 406; {
/* line 1930 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1799:
case 1194: /* data_real_value : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 406; {
/* line 1934 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_EXP (mUSED_VAR (
                      mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)));
      
} break;
case 1800:
case 999: /* parameter_definition : PARAMETER '(' named_constant_def_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 319; {
/* line 1946 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1801: /* named_constant_def_list : named_constant_def .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 407; {
/* line 1950 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1802:
case 1215: /* named_constant_def_list : named_constant_def ',' named_constant_def_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 407; {
/* line 1954 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1803: /* named_constant_def : PIdent '=' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 408; {
/* line 1958 "fortran.lalr" */
 yySynAttribute.Tree = mPARAMETER_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree); 
} break;
case 1804:
case 1152: /* derived_type_def : TYPE opt_access_spec PIdent CR1 private_sequence_stmts derived_type_components ENDTYPE optional_id .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 315; {
/* line 1974 "fortran.lalr" */
 yySynAttribute.Tree = mRECORD_TYPE (yyAttrStackPtr [3-1].Scan.Ident, 
                      CompleteDecls (ConcatDecls(yyAttrStackPtr [5-1].Tree, yyAttrStackPtr [6-1].Tree)));
        yySynAttribute.Tree = mTYPE_DECL (yyAttrStackPtr [3-1].Scan.Ident, yyAttrStackPtr [3-1].Label, yySynAttribute.Tree);
        yySynAttribute.Tree = mDECL_LIST (yySynAttribute.Tree, NoTree);            
        CheckSameIdent (yyAttrStackPtr [3-1].Scan.Ident, yyAttrStackPtr [8-1].Label);
      
} break;
case 1805: /* optional_id : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 412; {
/* line 1984 "fortran.lalr" */
 yySynAttribute.Label = DefaultId(); 
} break;
case 1806:
case 1151: /* optional_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 412; {
/* line 1989 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [1-1].Scan.Ident; 
} break;
case 1807: /* opt_access_spec : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 409; {
/* line 1994 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1808:
case 931: /* opt_access_spec : '::' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 409; {
/* line 1998 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1809:
case 930: /* opt_access_spec : ',' access_spec '::' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 409; {
/* line 2002 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1810: /* derived_type_components : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 411; {
/* line 2006 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1811:
case 1153: /* derived_type_components : component_def_stmt derived_type_components .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 411; {
/* line 2010 "fortran.lalr" */
 yySynAttribute.Tree = ConcatDecls (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1812:
case 1149: /* component_def_stmt : type_declaration_stmt CR1 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 413; {
/* line 2014 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1813:
case 1150: /* component_def_stmt : hpf_directive CR1 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 413; {
/* line 2018 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1814: /* private_sequence_stmts : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 410; {
/* line 2022 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1815:
case 1167: /* private_sequence_stmts : private_sequence_stmt private_sequence_stmts .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 410; {
/* line 2026 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1816:
case 1091: /* private_sequence_stmt : PRIVATE CR1 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 414; {
/* line 2030 "fortran.lalr" */
 yySynAttribute.Tree = mPRIVATE_DECL (DefaultId(), 0); 
} break;
case 1817:
case 1092: /* private_sequence_stmt : SEQUENCE CR1 .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 414; {
/* line 2034 "fortran.lalr" */
 yySynAttribute.Tree = mSEQUENCE_DECL (DefaultId(), 0); 
} break;
case 1818:
case 1048: /* interface_block : INTERFACE generic_spec CR1 interface_body_list module_procedure_stmt_list ENDINTERFACE .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 316; {
/* line 2047 "fortran.lalr" */
 yySynAttribute.Tree = mINTERFACE_DECL  (DefaultId(), NLine (yyAttrStackPtr [6-1]), yyAttrStackPtr [2-1].Tree, 
                         CompleteUnits (ConcatUnits (yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [5-1].Tree)));
       yySynAttribute.Tree = mDECL_LIST (yySynAttribute.Tree, NoTree);                      
} break;
case 1819: /* interface_body_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 416; {
/* line 2053 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1820:
case 1461: /* interface_body_list : interface_body interface_body_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 416; {
/* line 2057 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1821:
case 1179: /* interface_body : subroutine_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 418; {
/* line 2061 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1822:
case 1180: /* interface_body : function_subprogram .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 418; {
/* line 2065 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1823: /* module_procedure_stmt_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 417; {
/* line 2069 "fortran.lalr" */
 yySynAttribute.Tree = NoTree; 
} break;
case 1824:
case 1460: /* module_procedure_stmt_list : module_procedure_stmt module_procedure_stmt_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 417; {
/* line 2073 "fortran.lalr" */
 yySynAttribute.Tree = ConcatUnits (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1825:
case 1458: /* module_procedure_stmt : MODULE PROCEDURE procedure_name_list CR1 .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 419; {
/* line 2077 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1826: /* procedure_name_list : procedure_name .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 420; {
/* line 2081 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1827:
case 1459: /* procedure_name_list : procedure_name ',' procedure_name_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 420; {
/* line 2085 "fortran.lalr" */
 yySynAttribute.Tree = mUNIT_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1828:
case 1457: /* procedure_name : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 421; {
/* line 2089 "fortran.lalr" */
 yySynAttribute.Tree = mMODULE_PROC_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1829: /* generic_spec : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 415; {
/* line 2093 "fortran.lalr" */
 yySynAttribute.Tree = mNO_GENERIC_SPEC (); 
} break;
case 1830:
case 1178: /* generic_spec : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 415; {
/* line 2096 "fortran.lalr" */
 yySynAttribute.Tree = mID_GENERIC_SPEC (yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 1831:
case 987: /* generic_spec : OPERATOR '(' defined_operator ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 415; {
/* line 2099 "fortran.lalr" */
 yySynAttribute.Tree = mOP_GENERIC_SPEC (yyAttrStackPtr [3-1].Tree); 
} break;
case 1832:
case 988: /* generic_spec : ASSIGNMENT '(' '=' ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 415; {
/* line 2102 "fortran.lalr" */
 yySynAttribute.Tree = mASSIGN_GENERIC_SPEC (); 
} break;
case 1833:
case 986: /* defined_operator : UserOp .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 376; {
/* line 2105 "fortran.lalr" */
 yySynAttribute.Tree = mOP_DEFINED (yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 1834:
case 1168: /* defined_operator : intrinsic_operator .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 376; {
/* line 2108 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1835:
case 1169: /* intrinsic_operator : power_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2110 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1836:
case 1170: /* intrinsic_operator : mult_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2111 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1837:
case 1171: /* intrinsic_operator : add_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2112 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1838:
case 1172: /* intrinsic_operator : concat_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2113 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1839:
case 1173: /* intrinsic_operator : rel_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2114 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1840:
case 1174: /* intrinsic_operator : not_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2115 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1841:
case 1175: /* intrinsic_operator : and_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2116 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1842:
case 1176: /* intrinsic_operator : or_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2117 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1843:
case 1177: /* intrinsic_operator : equiv_op .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 422; {
/* line 2118 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1844:
case 1230: /* intent_definition : INTENT '(' intent_spec ')' '::' intent_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 329; {
/* line 2127 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [6-1].Tree; 
        SetIntent (yySynAttribute.Tree, yyAttrStackPtr [3-1].Label); 
} break;
case 1845:
case 963: /* intent_spec : IN .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 351; {
/* line 2132 "fortran.lalr" */
 yySynAttribute.Label = IntentIn; 
} break;
case 1846:
case 964: /* intent_spec : OUT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 351; {
/* line 2136 "fortran.lalr" */
 yySynAttribute.Label = IntentOut; 
} break;
case 1847:
case 965: /* intent_spec : INOUT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 351; {
/* line 2140 "fortran.lalr" */
 yySynAttribute.Label = IntentInOut; 
} break;
case 1848: /* intent_list : intent_item .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 432; {
/* line 2144 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1849:
case 1231: /* intent_list : intent_item ',' intent_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 432; {
/* line 2148 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1850:
case 1229: /* intent_item : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 433; {
/* line 2152 "fortran.lalr" */
 yySynAttribute.Tree = mINTENT_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, 0); 
} break;
case 1851:
case 1154: /* hpf_directive : template_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2162 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1852:
case 1155: /* hpf_directive : processors_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2166 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1853:
case 1156: /* hpf_directive : align_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2170 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1854:
case 1157: /* hpf_directive : distribute_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2174 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1855:
case 1158: /* hpf_directive : dynamic_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2178 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1856:
case 1159: /* hpf_directive : combined_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2182 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1857:
case 1160: /* hpf_directive : inherit_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2186 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1858:
case 1161: /* hpf_directive : range_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2190 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1859:
case 1162: /* hpf_directive : overlap_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 339; {
/* line 2194 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1860:
case 1306: /* adp_directive : map_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 340; {
/* line 2204 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1861:
case 1307: /* adp_directive : shared_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 340; {
/* line 2208 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1862:
case 1308: /* adp_directive : trace_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 340; {
/* line 2212 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1863:
case 1309: /* adp_directive : tree_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 340; {
/* line 2216 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1864:
case 1310: /* adp_directive : select_directive .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 340; {
/* line 2220 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1865:
case 1128: /* template_directive : TEMPLATE template_decl_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 434; {
/* line 2230 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1866: /* template_decl_list : template_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 448; {
/* line 2234 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1867:
case 1129: /* template_decl_list : template_decl ',' template_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 448; {
/* line 2238 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1868: /* template_decl : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 449; {
/* line 2242 "fortran.lalr" */
 yySynAttribute.Tree = mTEMPLATE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, mSHAPE_EMPTY()); 
} break;
case 1869:
case 1127: /* template_decl : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 449; {
/* line 2246 "fortran.lalr" */
 yySynAttribute.Tree = mTEMPLATE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree); 
} break;
case 1870:
case 1125: /* processors_directive : PROCESSORS processors_decl_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 435; {
/* line 2256 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1871: /* processors_decl_list : processors_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 450; {
/* line 2260 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1872:
case 1126: /* processors_decl_list : processors_decl ',' processors_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 450; {
/* line 2264 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1873: /* processors_decl : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 451; {
/* line 2268 "fortran.lalr" */
 yySynAttribute.Tree = mPROCESSORS_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, mSHAPE_EMPTY()); 
} break;
case 1874:
case 1124: /* processors_decl : PIdent DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 451; {
/* line 2272 "fortran.lalr" */
 yySynAttribute.Tree = mPROCESSORS_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Tree); 
} break;
case 1875:
case 1141: /* overlap_directive : SHADOW overlap_decl_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 442; {
/* line 2282 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1876: /* overlap_decl_list : overlap_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 452; {
/* line 2286 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1877:
case 1142: /* overlap_decl_list : overlap_decl ',' overlap_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 452; {
/* line 2290 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1878:
case 958: /* overlap_decl : PIdent '(' overlap_specifications ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 453; {
/* line 2294 "fortran.lalr" */
 yySynAttribute.Tree = mOVERLAP_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree); 
} break;
case 1879: /* overlap_specifications : ovl_spec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 454; {
/* line 2298 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, mSHAPE_EMPTY()); 
} break;
case 1880:
case 1140: /* overlap_specifications : ovl_spec ',' overlap_specifications .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 454; {
/* line 2302 "fortran.lalr" */
 yySynAttribute.Tree = mSHAPE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1881: /* ovl_spec : expression ':' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 455; {
/* line 2306 "fortran.lalr" */
 yySynAttribute.Tree = mEXPLICIT_SHAPE (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);
         yySynAttribute.Tree->EXPLICIT_SHAPE.Overlap = mOVERLAP_SPEC (0, 0, 0, 0);
       
} break;
case 1882: /* ovl_spec : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 455; {
/* line 2312 "fortran.lalr" */
 yySynAttribute.Tree = mEXPLICIT_SHAPE (yyAttrStackPtr [1-1].Tree, CopyTree(yyAttrStackPtr [1-1].Tree));
         yySynAttribute.Tree->EXPLICIT_SHAPE.Overlap = mOVERLAP_SPEC (0, 0, 0, 0);
       
} break;
case 1883:
case 1263: /* map_directive : MAP map_decl_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 443; {
/* line 2324 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1884: /* map_decl_list : map_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 456; {
/* line 2328 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1885:
case 1264: /* map_decl_list : map_decl ',' map_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 456; {
/* line 2332 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1886: /* map_decl : PIdent TO expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 457; {
/* line 2336 "fortran.lalr" */
 yySynAttribute.Tree = mMAP_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree);
       
} break;
case 1887:
case 1272: /* trace_directive : TRACE opt_dcolon trace_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 445; {
/* line 2348 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1888: /* trace_id_list : trace_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 458; {
/* line 2353 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1889:
case 1273: /* trace_id_list : trace_id ',' trace_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 458; {
/* line 2358 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1890:
case 1271: /* trace_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 459; {
/* line 2363 "fortran.lalr" */
 yySynAttribute.Tree = mTRACE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label);  
} break;
case 1891:
case 1275: /* tree_directive : TREE opt_dcolon tree_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 446; {
/* line 2374 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 1892: /* tree_id_list : tree_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 460; {
/* line 2379 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1893:
case 1276: /* tree_id_list : tree_id ',' tree_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 460; {
/* line 2384 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1894:
case 1274: /* tree_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 461; {
/* line 2389 "fortran.lalr" */
 yySynAttribute.Tree = mTREE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label);  
} break;
case 1895:
case 1015: /* select_directive : SELECT PIdent '(' select_spec_dim_list ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 447; {
/* line 2401 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (mSELECT_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, yyAttrStackPtr [4-1].Tree),
                            NoTree);
    
} break;
case 1896:
case 1278: /* select_directive : SELECT '(' select_spec_dim_list ')' '::' selectee_list .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 447; {
/* line 2407 "fortran.lalr" */
 SpreadSelection (yyAttrStackPtr [6-1].Tree, yyAttrStackPtr [3-1].Tree);

      yySynAttribute.Tree = yyAttrStackPtr [6-1].Tree;
    
} break;
case 1897: /* selectee_list : selectee .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 463; {
/* line 2414 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1898:
case 1279: /* selectee_list : selectee ',' selectee_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 463; {
/* line 2418 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1899:
case 1277: /* selectee : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 464; {
/* line 2422 "fortran.lalr" */
 yySynAttribute.Tree = mSELECT_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, NoTree); 
} break;
case 1900: /* select_spec_dim_list : select_spec_dim .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 462; {
/* line 2426 "fortran.lalr" */
 yySynAttribute.Tree = mSELECT_LIST (yyAttrStackPtr [1-1].Tree, mSELECT_EMPTY ()); 
} break;
case 1901:
case 1280: /* select_spec_dim_list : select_spec_dim ',' select_spec_dim_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 462; {
/* line 2430 "fortran.lalr" */
 yySynAttribute.Tree = mSELECT_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1902:
case 1007: /* select_spec_dim : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 465; {
/* line 2434 "fortran.lalr" */
 yySynAttribute.Tree  = mSELECT_SPEC (0); /* no user selection */  
} break;
case 1903:
case 1281: /* select_spec_dim : selector_list .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 465; {
/* line 2438 "fortran.lalr" */
 yySynAttribute.Tree  = mSELECT_SPEC (yyAttrStackPtr [1-1].Label); 
} break;
case 1904: /* selector_list : selector .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 466; {
/* line 2442 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [1-1].Label; 
} break;
case 1905:
case 1282: /* selector_list : selector '/' selector_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 466; {
/* line 2446 "fortran.lalr" */
 yySynAttribute.Label = yyAttrStackPtr [1-1].Label | yyAttrStackPtr [3-1].Label;  /* bit-or */   
} break;
case 1906:
case 1008: /* selector : NOVECTOR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2450 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_NOVECTOR; 
} break;
case 1907:
case 1012: /* selector : VECTOR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2454 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_VECTOR; 
} break;
case 1908:
case 1010: /* selector : SHORT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2458 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_SHORT; 
} break;
case 1909:
case 1011: /* selector : EXPAND .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2462 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_EXPAND; 
} break;
case 1910:
case 1014: /* selector : SKIP .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2466 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_NOVECTOR | kSELECT_NOCONCUR; 
} break;
case 1911:
case 1013: /* selector : CONCUR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2470 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_CONCUR; 
} break;
case 1912:
case 1009: /* selector : NOCONCUR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 467; {
/* line 2474 "fortran.lalr" */
 yySynAttribute.Label = kSELECT_NOCONCUR; 
} break;
case 1913:
case 1266: /* shared_directive : SHARED shared_id_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 444; {
/* line 2485 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1914: /* shared_id_list : shared_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 468; {
/* line 2489 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1915:
case 1267: /* shared_id_list : shared_id ',' shared_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 468; {
/* line 2493 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1916:
case 1265: /* shared_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 469; {
/* line 2497 "fortran.lalr" */
 yySynAttribute.Tree = mSHARED_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, 1);  
} break;
case 1917:
case 1269: /* shared_directive : RMA rma_id_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 444; {
/* line 2509 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1918: /* rma_id_list : rma_id .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 470; {
/* line 2513 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1919:
case 1270: /* rma_id_list : rma_id ',' rma_id_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 470; {
/* line 2517 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1920:
case 1268: /* rma_id : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 471; {
/* line 2521 "fortran.lalr" */
 yySynAttribute.Tree = mSHARED_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, 2);  
} break;
case 1921:
case 1134: /* inherit_directive : INHERIT inherit_decl_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 440; {
/* line 2531 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1922: /* inherit_decl_list : inherit_decl .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 472; {
/* line 2535 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1923:
case 1135: /* inherit_decl_list : inherit_decl ',' inherit_decl_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 472; {
/* line 2539 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1924:
case 1133: /* inherit_decl : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 473; {
/* line 2543 "fortran.lalr" */
 yySynAttribute.Tree = mINHERIT_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1925:
case 1136: /* range_directive : RANGE PIdent range_attr_stuff_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 441; {
/* line 2554 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree = mRANGE_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree) ; 
        yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [3-1].Tree, NoTree);
      
} break;
case 1926:
case 1138: /* range_attr_stuff_list : range_attr_stuff range_attr_continue .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 474; {
/* line 2561 "fortran.lalr" */
 yySynAttribute.Tree = mRANGE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1927: /* range_attr_continue : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 476; {
/* line 2566 "fortran.lalr" */
 yySynAttribute.Tree = mRANGE_EMPTY(); 
} break;
case 1928:
case 1137: /* range_attr_continue : range_attr_stuff range_attr_continue .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 476; {
/* line 2571 "fortran.lalr" */
 yySynAttribute.Tree = mRANGE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1929:
case 956: /* range_attr_stuff : '(' dist_format_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 475; {
/* line 2576 "fortran.lalr" */
 yySynAttribute.Tree = mNODE_DISTRIBUTION (0, yyAttrStackPtr [2-1].Tree); 
} break;
case 1930:
case 1113: /* align_directive : ALIGN single_align_stuff .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 436; {
/* line 2586 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, NoTree); 
} break;
case 1931:
case 1111: /* single_align_stuff : HPFIdent '(' align_source_list ')' WITH align_spec .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 478; {
/* line 2590 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 1932:
case 1112: /* single_align_stuff : HPFIdent WITH align_spec .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 478; {
/* line 2594 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_DECL (yyAttrStackPtr [1-1].Scan.Ident,yyAttrStackPtr [1-1].Label,mBTE_EMPTY(),yyAttrStackPtr [3-1].Tree); 
} break;
case 1933: /* align_source_list : align_source .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 479; {
/* line 2598 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, mBTE_EMPTY()); 
} break;
case 1934:
case 1109: /* align_source_list : align_source ',' align_source_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 479; {
/* line 2602 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1935:
case 937: /* align_source : ':' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 481; {
/* line 2606 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (mDUMMY_EXP(), mDUMMY_EXP(), mDUMMY_EXP()); 
} break;
case 1936:
case 936: /* align_source : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 481; {
/* line 2610 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_EXP (); 
} break;
case 1937:
case 1103: /* align_source : HPFIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 481; {
/* line 2614 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_EXP (mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident))); 
} break;
case 1938:
case 1107: /* align_spec : HPFIdent opt_align_subscript_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 480; {
/* line 2622 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_SPEC (0, mTEMP_OBJ (yyAttrStackPtr [1-1].Scan.Ident), yyAttrStackPtr [2-1].Tree); 
} break;
case 1939:
case 1106: /* align_spec : '*' HPFIdent opt_align_subscript_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 480; {
/* line 2626 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_SPEC (1, mTEMP_OBJ (yyAttrStackPtr [2-1].Scan.Ident), yyAttrStackPtr [3-1].Tree); 
} break;
case 1940: /* opt_align_subscript_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 482; {
/* line 2630 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_EMPTY (); 
} break;
case 1941:
case 940: /* opt_align_subscript_list : '(' align_subscript_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 482; {
/* line 2634 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1942: /* align_subscript_list : align_subscript .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 483; {
/* line 2638 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, mBTE_EMPTY()); 
} break;
case 1943:
case 1104: /* align_subscript_list : align_subscript ',' align_subscript_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 483; {
/* line 2642 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1944:
case 939: /* align_subscript : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 484; {
/* line 2646 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_EXP (); 
} break;
case 1945:
case 1105: /* align_subscript : Index_Elem .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 484; {
/* line 2650 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1946:
case 1131: /* dynamic_directive : DYNAMIC dynamic_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 438; {
/* line 2663 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1947: /* dynamic_list : dynamic_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 486; {
/* line 2668 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1948:
case 1132: /* dynamic_list : dynamic_var ',' dynamic_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 486; {
/* line 2673 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1949:
case 1130: /* dynamic_var : HPFIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 487; {
/* line 2678 "fortran.lalr" */
 yySynAttribute.Tree = mDYNAMIC_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label); 
} break;
case 1950:
case 1120: /* distribute_directive : DISTRIBUTE single_dist_stuff .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 437; {
/* line 2688 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, NoTree); 
} break;
case 1951:
case 1118: /* single_dist_stuff : HPFIdent dist_format_clause opt_onto .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 488; {
/* line 2692 "fortran.lalr" */
 yySynAttribute.Tree = mDISTRIBUTE_DECL(yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, 
                     yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1952: /* opt_onto : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 490; {
/* line 2697 "fortran.lalr" */
 yySynAttribute.Tree = mDEFAULT_PROCESSOR_ARRAY (); 
} break;
case 1953:
case 1119: /* opt_onto : dist_onto_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 490; {
/* line 2701 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 1954:
case 1117: /* dist_onto_clause : ONTO HPFIdent opt_section_subscript_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 491; {
/* line 2705 "fortran.lalr" */
 SetProcessorId (yyAttrStackPtr [3-1].Tree, mTOP_OBJ(yyAttrStackPtr [2-1].Scan.Ident)); 
       yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
     
} break;
case 1955:
case 1116: /* dist_onto_clause : ONTO '*' HPFIdent opt_section_subscript_list .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 491; {
/* line 2710 "fortran.lalr" */
 SetProcessorId (yyAttrStackPtr [4-1].Tree, mTOP_OBJ(yyAttrStackPtr [3-1].Scan.Ident)); 
       yySynAttribute.Tree = yyAttrStackPtr [4-1].Tree;
     
} break;
case 1956: /* dist_onto_clause : ONTO '*' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 491; {
/* line 2715 "fortran.lalr" */
 yySynAttribute.Tree = mANY_PROCESSOR_ARRAY (); 
} break;
case 1957: /* opt_section_subscript_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 492; {
/* line 2720 "fortran.lalr" */
 yySynAttribute.Tree = mPROCESSOR_ARRAY (NoTree); 
} break;
case 1958:
case 955: /* opt_section_subscript_list : '(' section_subscript_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 492; {
/* line 2725 "fortran.lalr" */
 yySynAttribute.Tree = mPROCESSOR_SUBSET (NoTree, NoTree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1959:
case 953: /* dist_format_clause : '(' dist_format_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 489; {
/* line 2735 "fortran.lalr" */
 yySynAttribute.Tree = mNODE_DISTRIBUTION (0, yyAttrStackPtr [2-1].Tree); 
} break;
case 1960:
case 954: /* dist_format_clause : '*' '(' dist_format_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 489; {
/* line 2740 "fortran.lalr" */
 yySynAttribute.Tree = mNODE_DISTRIBUTION (1, yyAttrStackPtr [3-1].Tree); 
} break;
case 1961: /* dist_format_clause : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 489; {
/* line 2744 "fortran.lalr" */
 yySynAttribute.Tree = mANY_DISTRIBUTION (1);  
} break;
case 1962: /* dist_format_list : dist_format .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 477; {
/* line 2754 "fortran.lalr" */
 yySynAttribute.Tree = mDIST_LIST (yyAttrStackPtr [1-1].Tree, mDIST_EMPTY()); 
} break;
case 1963:
case 1115: /* dist_format_list : dist_format ',' dist_format_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 477; {
/* line 2758 "fortran.lalr" */
 yySynAttribute.Tree = mDIST_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1964: /* dist_format : BLOCK .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 494; {
/* line 2762 "fortran.lalr" */
 yySynAttribute.Tree = mBLOCK_DISTRIBUTION (mDUMMY_EXP ()); 
} break;
case 1965:
case 943: /* dist_format : BLOCK '(' expression ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 494; {
/* line 2766 "fortran.lalr" */
 yySynAttribute.Tree = mBLOCK_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1966:
case 942: /* dist_format : BLOCK '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 494; {
/* line 2770 "fortran.lalr" */
 yySynAttribute.Tree = mANY_BLOCK_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1967: /* dist_format : CYCLIC .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 494; {
/* line 2774 "fortran.lalr" */
 yySynAttribute.Tree = mCYCLIC_DISTRIBUTION (mDUMMY_EXP ()); 
} break;
case 1968:
case 945: /* dist_format : CYCLIC '(' expression ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 494; {
/* line 2778 "fortran.lalr" */
 yySynAttribute.Tree = mCYCLIC_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1969:
case 944: /* dist_format : CYCLIC '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 494; {
/* line 2782 "fortran.lalr" */
 yySynAttribute.Tree = mANY_CYCLIC_DISTRIBUTION (); 
} break;
case 1970:
case 947: /* dist_format : GEN_BLOCK '(' variable ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 494; {
/* line 2786 "fortran.lalr" */
 yySynAttribute.Tree = mGEN_BLOCK_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1971:
case 946: /* dist_format : GEN_BLOCK '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 494; {
/* line 2790 "fortran.lalr" */
 yySynAttribute.Tree = mANY_GEN_BLOCK_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1972:
case 949: /* dist_format : INDIRECT '(' variable ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 494; {
/* line 2794 "fortran.lalr" */
 yySynAttribute.Tree = mINDIRECT_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1973:
case 952: /* dist_format : ARBITRARY '(' expression ',' variable ',' variable ')' .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 494; {
/* line 2798 "fortran.lalr" */
 yySynAttribute.Tree = mARBITRARY_DISTRIBUTION (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [5-1].Tree, yyAttrStackPtr [7-1].Tree); 
} break;
case 1974:
case 948: /* dist_format : INDIRECT '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 494; {
/* line 2802 "fortran.lalr" */
 yySynAttribute.Tree = mANY_INDIRECT_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1975:
case 951: /* dist_format : ARBITRARY '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 494; {
/* line 2806 "fortran.lalr" */
 yySynAttribute.Tree = mANY_ARBITRARY_DISTRIBUTION (yyAttrStackPtr [3-1].Tree); 
} break;
case 1976:
case 941: /* dist_format : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 494; {
/* line 2810 "fortran.lalr" */
 yySynAttribute.Tree = mSERIAL_DISTRIBUTION (); 
} break;
case 1977:
case 950: /* dist_format : ALL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 494; {
/* line 2814 "fortran.lalr" */
 yySynAttribute.Tree = mANY_DIM_DISTRIBUTION (); 
} break;
case 1978:
case 1164: /* combined_directive : combined_att_list '::' object_name_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 439; {
/* line 2824 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
       /* set all Attributes to Entity Declaration Attributes */
       SetAttributes (yyAttrStackPtr [1-1].Tree, yySynAttribute.Tree); 
     
} break;
case 1979: /* object_name_list : object_name .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 496; {
/* line 2831 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1980:
case 1165: /* object_name_list : object_name ',' object_name_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 496; {
/* line 2835 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1981:
case 1163: /* object_name : HPFIdent opt_array_spec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 497; {
/* line 2840 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_EMPTY ();
      if (yyAttrStackPtr [2-1].Tree != NoTree)
         yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [2-1].Tree, yySynAttribute.Tree);
      yySynAttribute.Tree = mENTITY_DECL (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [1-1].Label, yySynAttribute.Tree); 
} break;
case 1982: /* combined_att_list : combined_att .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 495; {
/* line 2847 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, NoTree); 
} break;
case 1983:
case 1166: /* combined_att_list : combined_att ',' combined_att_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 495; {
/* line 2851 "fortran.lalr" */
 yySynAttribute.Tree = mDECL_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1984:
case 1114: /* combined_att : ALIGN align_attribute_stuff .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 498; {
/* line 2855 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1985:
case 1110: /* align_attribute_stuff : WITH align_spec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 499; {
/* line 2859 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_DECL (DefaultId(), 0, mBTE_EMPTY(), yyAttrStackPtr [2-1].Tree); 
} break;
case 1986:
case 1108: /* align_attribute_stuff : '(' align_source_list ')' WITH align_spec .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 499; {
/* line 2863 "fortran.lalr" */
 yySynAttribute.Tree = mALIGN_DECL (DefaultId(), 0, yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 1987:
case 1123: /* combined_att : DISTRIBUTE dist_attribute_stuff .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 498; {
/* line 2867 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 1988:
case 1121: /* dist_attribute_stuff : dist_format_clause opt_onto .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 500; {
/* line 2871 "fortran.lalr" */
 yySynAttribute.Tree = mDISTRIBUTE_DECL (DefaultId(), 0, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1989:
case 1122: /* dist_attribute_stuff : dist_onto_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 500; {
/* line 2876 "fortran.lalr" */
 yySynAttribute.Tree = mDEFAULT_DISTRIBUTION (0);
       yySynAttribute.Tree = mDISTRIBUTE_DECL (DefaultId(), 0, yySynAttribute.Tree, yyAttrStackPtr [1-1].Tree);
     
} break;
case 1990:
case 984: /* combined_att : DYNAMIC .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2882 "fortran.lalr" */
 yySynAttribute.Tree = mDYNAMIC_DECL (DefaultId(), 0); 
} break;
case 1991:
case 985: /* combined_att : INHERIT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2886 "fortran.lalr" */
 yySynAttribute.Tree = mINHERIT_DECL (DefaultId(), 0); 
} break;
case 1992:
case 959: /* combined_att : SHARED .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2890 "fortran.lalr" */
 yySynAttribute.Tree = mSHARED_DECL (DefaultId(), 0, 1); 
} break;
case 1993:
case 960: /* combined_att : RMA .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2894 "fortran.lalr" */
 yySynAttribute.Tree = mSHARED_DECL (DefaultId(), 0, 2); 
} break;
case 1994:
case 983: /* combined_att : TEMPLATE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2898 "fortran.lalr" */
 yySynAttribute.Tree = mTEMPLATE_DECL (DefaultId(), 0, mSHAPE_EMPTY()); 
} break;
case 1995:
case 982: /* combined_att : PROCESSORS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 498; {
/* line 2902 "fortran.lalr" */
 yySynAttribute.Tree = mPROCESSORS_DECL (DefaultId(), 0, mSHAPE_EMPTY()); 
} break;
case 1996:
case 1102: /* combined_att : DIMENSION DimSpec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 498; {
/* line 2906 "fortran.lalr" */
 yySynAttribute.Tree = mDIMENSION_DECL (DefaultId(), 0, yyAttrStackPtr [2-1].Tree); 
} break;
case 1997:
case 957: /* combined_att : SHADOW '(' overlap_specifications ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 498; {
/* line 2910 "fortran.lalr" */
 yySynAttribute.Tree = mOVERLAP_DECL (DefaultId(), 0, yyAttrStackPtr [3-1].Tree); 
} break;
case 1998:
case 1139: /* combined_att : RANGE range_attr_stuff_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 498; {
/* line 2915 "fortran.lalr" */
 yySynAttribute.Tree = mRANGE_DECL (DefaultId(), 0,  yyAttrStackPtr [2-1].Tree); 
} break;
case 1999:
case 1374: /* execution_part : executable_construct CR1 execution_block .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 293; {
/* line 2929 "fortran.lalr" */
 yySynAttribute.Tree = mACF_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2000: /* execution_part : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 293; {
/* line 2933 "fortran.lalr" */
 yySynAttribute.Tree = mACF_EMPTY (); 
} break;
case 2001:
case 1369: /* execution_block : execution_part_construct CR1 execution_block .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 502; {
/* line 2937 "fortran.lalr" */
 yySynAttribute.Tree = mACF_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2002: /* execution_block : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 502; {
/* line 2941 "fortran.lalr" */
 yySynAttribute.Tree = mACF_EMPTY (); 
} break;
case 2003:
case 1367: /* execution_part_construct : executable_construct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 503; {
/* line 2945 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2004:
case 1414: /* execution_part_construct : opt_label data_statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 503; {
/* line 2949 "fortran.lalr" */
 /* label will be ignored */
       yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
     
} break;
case 2005:
case 1415: /* execution_part_construct : opt_label format_statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 503; {
/* line 2955 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
       SetDefinitionLabel (yySynAttribute.Tree, yyAttrStackPtr [1-1].Label);
     
} break;
case 2006:
case 1416: /* executable_construct : opt_label statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 501; {
/* line 2964 "fortran.lalr" */
  SetACFNode (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Label, yyAttrStackPtr [2-1].Line);
        yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
     
} break;
case 2007:
case 1417: /* statement : action_stmt .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 504; {
/* line 2970 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line; 
} break;
case 2008:
case 1418: /* statement : reduce_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 504; {
/* line 2975 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2009:
case 1419: /* statement : entry_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 504; {
/* line 2980 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2010:
case 1420: /* statement : hpf_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 504; {
/* line 2985 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
     
} break;
case 2011:
case 1421: /* statement : structured_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 504; {
/* line 2990 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2012:
case 1422: /* structured_statement : where_construct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 509; {
/* line 3002 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2013:
case 1423: /* structured_statement : case_construct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 509; {
/* line 3007 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2014:
case 1411: /* structured_statement : PIdent ':' case_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 509; {
/* line 3012 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
       yySynAttribute.Line = yyAttrStackPtr [3-1].Line;
       yySynAttribute.Tree->ACF_NODE.Label = - (yyAttrStackPtr [1-1].Scan.Ident);
       /* negative label stands for tIdent */
     
} break;
case 2015:
case 1341: /* action_stmt : allocate_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3026 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2016:
case 1342: /* action_stmt : assignment_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3031 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree);
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;                
} break;
case 2017:
case 1343: /* action_stmt : call_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3036 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       SetACFNode (yySynAttribute.Tree, 0, yyAttrStackPtr [1-1].Line);
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2018:
case 1344: /* action_stmt : continue_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3042 "fortran.lalr" */
 yySynAttribute.Tree = mACF_DUMMY (); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2019:
case 1345: /* action_stmt : cycle_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3047 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC (yyAttrStackPtr [1-1].Tree);
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2020:
case 1346: /* action_stmt : deallocate_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3052 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;            
} break;
case 2021:
case 1347: /* action_stmt : exit_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3057 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC (yyAttrStackPtr [1-1].Tree);
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2022:
case 1348: /* action_stmt : goto_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3062 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;  
} break;
case 2023:
case 1349: /* action_stmt : if_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3067 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2024:
case 1350: /* action_stmt : io_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3072 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2025:
case 1351: /* action_stmt : nullify_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3077 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2026:
case 1352: /* action_stmt : return_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3082 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC (yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2027:
case 1353: /* action_stmt : stop_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3087 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2028:
case 1354: /* action_stmt : where_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 505; {
/* line 3092 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;             
} break;
case 2029:
case 1017: /* used_label : IntConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 526; {
/* line 3103 "fortran.lalr" */
 LabelUse (yyAttrStackPtr [1-1].Scan.IntConst);
       yySynAttribute.Label = yyAttrStackPtr [1-1].Scan.IntConst;            
} break;
case 2030:
case 1318: /* goto_statement : GOTO used_label .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 519; {
/* line 3107 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(mGOTO_STMT ( yyAttrStackPtr [2-1].Label )); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                                            
} break;
case 2031:
case 1317: /* goto_statement : GOTO PIdent assigned_labels .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 519; {
/* line 3112 "fortran.lalr" */
 yyAttrStackPtr [2-1].Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [2-1].Label, yyAttrStackPtr [2-1].Scan.Ident));
       yySynAttribute.Tree = mACF_BASIC(mASS_GOTO_STMT (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree)); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                                            
} break;
case 2032: /* assigned_labels : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 527; {
/* line 3118 "fortran.lalr" */
 yySynAttribute.Tree = mLABEL_EMPTY (); 
} break;
case 2033:
case 1021: /* assigned_labels : opt_comma '(' label_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 527; {
/* line 3121 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 2034: /* label_list : used_label .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 528; {
/* line 3124 "fortran.lalr" */
 yySynAttribute.Tree = mLABEL_LIST (yyAttrStackPtr [1-1].Label, mLABEL_EMPTY ()); 
} break;
case 2035:
case 1316: /* label_list : used_label ',' label_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 528; {
/* line 3127 "fortran.lalr" */
 yySynAttribute.Tree = mLABEL_LIST (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [3-1].Tree); 
} break;
case 2036: /* goto_statement : GOTO '(' label_list ')' opt_comma expression .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 519; {
/* line 3130 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC (mCOMP_GOTO_STMT(yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [6-1].Tree)); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);
     
} break;
case 2037: /* assignment_statement : variable '=' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 513; {
/* line 3135 "fortran.lalr" */
 yySynAttribute.Tree = mASSIGN_STMT (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [2-1]);            
} break;
case 2038: /* assignment_statement : variable '=>' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 513; {
/* line 3140 "fortran.lalr" */
 yySynAttribute.Tree = mPTR_ASSIGN_STMT (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [2-1]);            
} break;
case 2039:
case 1313: /* assignment_statement : ASSIGN used_label TO PIdent .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 513; {
/* line 3145 "fortran.lalr" */
 yyAttrStackPtr [4-1].Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [4-1].Label, yyAttrStackPtr [4-1].Scan.Ident)); 
       yySynAttribute.Tree = mLABEL_ASSIGN_STMT (yyAttrStackPtr [2-1].Label, yyAttrStackPtr [4-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);            
} break;
case 2040: /* stop_statement : STOP .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 524; {
/* line 3151 "fortran.lalr" */
 yySynAttribute.Tree = mSTOP_STMT (mDUMMY_EXP()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);     
} break;
case 2041: /* stop_statement : STOP expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 524; {
/* line 3156 "fortran.lalr" */
 yySynAttribute.Tree = mSTOP_STMT (yyAttrStackPtr [2-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);  
} break;
case 2042:
case 1020: /* continue_statement : CONTINUE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 515; {
/* line 3161 "fortran.lalr" */
 yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]); 
} break;
case 2043: /* return_statement : RETURN .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 523; {
/* line 3165 "fortran.lalr" */
 yySynAttribute.Tree = mRETURN_STMT (mDUMMY_EXP()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2044: /* return_statement : RETURN expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 523; {
/* line 3170 "fortran.lalr" */
 yySynAttribute.Tree = mRETURN_STMT (yyAttrStackPtr [2-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2045:
case 1339: /* exit_statement : EXIT PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 518; {
/* line 3175 "fortran.lalr" */
 yySynAttribute.Tree = mEXIT_STMT (yyAttrStackPtr [2-1].Scan.Ident);
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2046: /* exit_statement : EXIT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 518; {
/* line 3180 "fortran.lalr" */
 yySynAttribute.Tree = mEXIT_STMT (DefaultId());
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2047:
case 1338: /* exit_statement : CYCLE PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 518; {
/* line 3185 "fortran.lalr" */
 yySynAttribute.Tree = mCYCLE_STMT (yyAttrStackPtr [2-1].Scan.Ident);
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2048: /* cycle_statement : CYCLE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 516; {
/* line 3190 "fortran.lalr" */
 yySynAttribute.Tree = mCYCLE_STMT (DefaultId());
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);         
} break;
case 2049:
case 1028: /* allocate_statement : ALLOCATE '(' params ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 512; {
/* line 3195 "fortran.lalr" */
 yySynAttribute.Tree = mALLOCATE_STMT (yyAttrStackPtr [3-1].Tree, mDUMMY_VAR()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                   
} break;
case 2050:
case 1336: /* allocate_statement : ALLOCATE TREE param .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 512; {
/* line 3200 "fortran.lalr" */
 yySynAttribute.Tree = mALLOCATE_STMT (mBTP_LIST (yyAttrStackPtr [3-1].Tree, mBTP_EMPTY()), mDUMMY_VAR()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                   
} break;
case 2051:
case 1029: /* deallocate_statement : DEALLOCATE '(' params ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 517; {
/* line 3205 "fortran.lalr" */
 yySynAttribute.Tree = mDEALLOCATE_STMT (yyAttrStackPtr [3-1].Tree, mDUMMY_VAR()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                     
} break;
case 2052:
case 1337: /* deallocate_statement : DEALLOCATE TREE param .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 517; {
/* line 3210 "fortran.lalr" */
 yySynAttribute.Tree = mDEALLOCATE_STMT (mBTP_LIST (yyAttrStackPtr [3-1].Tree, mBTP_EMPTY()), mDUMMY_VAR()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                   
} break;
case 2053:
case 1030: /* nullify_statement : NULLIFY '(' params ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 522; {
/* line 3215 "fortran.lalr" */
 yySynAttribute.Tree = mNULLIFY_STMT (yyAttrStackPtr [3-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                     
} break;
case 2054:
case 1035: /* reduce_statement : REDUCE '(' reduce_func ',' reduce_params ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 506; {
/* line 3220 "fortran.lalr" */
 yySynAttribute.Tree = mREDUCE_STMT (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [5-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                     
     
} break;
case 2055: /* reduce_params : reduce_var ',' reduce_exp .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 532; {
/* line 3226 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, mBTP_LIST (yyAttrStackPtr [3-1].Tree, mBTP_EMPTY())); 
} break;
case 2056:
case 1387: /* reduce_params : reduce_var ',' reduce_exp ',' reduce_params .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 532; {
/* line 3230 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, mBTP_LIST (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [5-1].Tree )); 
} break;
case 2057:
case 1386: /* reduce_func : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 531; {
/* line 3234 "fortran.lalr" */
 yySynAttribute.Tree = mPROC_OBJ (yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 2058: /* reduce_var : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 533; {
/* line 3238 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (mVAR_EXP(yyAttrStackPtr [1-1].Tree)); 
} break;
case 2059: /* reduce_exp : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 534; {
/* line 3242 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2060: /* call_statement : CALL PIdent .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 514; {
/* line 3246 "fortran.lalr" */
 yySynAttribute.Tree = mCALL_STMT (mPROC_OBJ (yyAttrStackPtr [2-1].Scan.Ident), mBTP_EMPTY()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);      
} break;
case 2061:
case 1018: /* call_statement : CALL PIdent '(' ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 514; {
/* line 3250 "fortran.lalr" */
 yySynAttribute.Tree = mCALL_STMT (mPROC_OBJ (yyAttrStackPtr [2-1].Scan.Ident), mBTP_EMPTY()); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);      
} break;
case 2062:
case 1019: /* call_statement : CALL PIdent '(' params ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 514; {
/* line 3254 "fortran.lalr" */
 yySynAttribute.Tree = mCALL_STMT (mPROC_OBJ (yyAttrStackPtr [2-1].Scan.Ident), yyAttrStackPtr [4-1].Tree); 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);      
} break;
case 2063: /* params : param .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 529; {
/* line 3258 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, mBTP_EMPTY()); 
} break;
case 2064:
case 1315: /* params : param ',' params .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 529; {
/* line 3261 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2065: /* param : PIdent '=' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 530; {
/* line 3264 "fortran.lalr" */
 yySynAttribute.Tree = mNAMED_PARAM (yyAttrStackPtr [1-1].Scan.Ident, mVALUE_PARAM (yyAttrStackPtr [3-1].Tree)); 
} break;
case 2066: /* param : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 530; {
/* line 3267 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2067:
case 1314: /* param : '*' used_label .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 530; {
/* line 3270 "fortran.lalr" */
 yySynAttribute.Tree = mRETURN_PARAM (yyAttrStackPtr [2-1].Label); 
} break;
case 2068:
case 1355: /* io_statement : print_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3279 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2069:
case 1356: /* io_statement : read_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3284 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2070:
case 1357: /* io_statement : write_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3289 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2071:
case 1358: /* io_statement : open_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3294 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2072:
case 1359: /* io_statement : close_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3299 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2073:
case 1360: /* io_statement : rewind_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3304 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2074:
case 1361: /* io_statement : backspace_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3309 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2075:
case 1362: /* io_statement : endfile_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3314 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2076:
case 1363: /* io_statement : inquire_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 521; {
/* line 3319 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [1-1].Tree); 
       yySynAttribute.Line = yyAttrStackPtr [1-1].Line;              
} break;
case 2077: /* write_statement : WRITE io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 537; {
/* line 3324 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent ("WRITE")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()    );   
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
} break;
case 2078:
case 1325: /* write_statement : WRITE io_specification io_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 537; {
/* line 3330 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent ("WRITE")),
                           yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree);                 
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
} break;
case 2079: /* print_statement : PRINT format_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 535; {
/* line 3336 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("PRINT")),
                           mBTP_LIST(yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()), 
                           mBTP_EMPTY ()     );
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
} break;
case 2080:
case 1326: /* print_statement : PRINT format_identifier ',' io_list .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 535; {
/* line 3343 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("PRINT")),
                           mBTP_LIST(yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()), 
                           yyAttrStackPtr [4-1].Tree     );    
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
} break;
case 2081: /* read_statement : READ format_identifier .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 536; {
/* line 3350 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("READ")),
                           mBTP_LIST(yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()), 
                           mBTP_EMPTY ()     );    
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
} break;
case 2082:
case 1324: /* read_statement : READ format_identifier ',' io_list .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 536; {
/* line 3357 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("READ")),
                           mBTP_LIST(yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()), 
                           yyAttrStackPtr [4-1].Tree     );    
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2083: /* read_statement : READ io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 536; {
/* line 3364 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("READ")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ()    );    
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2084:
case 1322: /* read_statement : READ io_specification io_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 536; {
/* line 3370 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("READ")),
                           yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree);
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2085:
case 1327: /* open_statement : OPEN io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 538; {
/* line 3376 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("OPEN")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY());
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2086:
case 1328: /* close_statement : CLOSE io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 539; {
/* line 3382 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("CLOSE")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY());
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2087:
case 1335: /* rewind_statement : REWIND external_file_unit .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 540; {
/* line 3388 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("REWIND")),
                           mBTP_LIST (yyAttrStackPtr [2-1].Tree, mBTP_EMPTY()),
                           mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2088:
case 1334: /* rewind_statement : REWIND io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 540; {
/* line 3396 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("REWIND")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2089:
case 1331: /* backspace_statement : BACKSPACE external_file_unit .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 541; {
/* line 3402 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("BACKSPACE")),
                           mBTP_LIST (yyAttrStackPtr [2-1].Tree, mBTP_EMPTY()),
                           mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2090:
case 1330: /* backspace_statement : BACKSPACE io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 541; {
/* line 3409 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("BACKSPACE")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2091:
case 1333: /* endfile_statement : ENDFILE external_file_unit .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 542; {
/* line 3415 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("ENDFILE")),
                           mBTP_LIST (yyAttrStackPtr [2-1].Tree, mBTP_EMPTY()),
                           mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2092:
case 1332: /* endfile_statement : ENDFILE io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 542; {
/* line 3422 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("ENDFILE")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY ())   ;
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2093:
case 1329: /* inquire_statement : INQUIRE io_specification .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 543; {
/* line 3428 "fortran.lalr" */
 yySynAttribute.Tree = mIO_STMT (mPROC_OBJ (IsIdent("INQUIRE")),
                           yyAttrStackPtr [2-1].Tree, mBTP_EMPTY());
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                
} break;
case 2094:
case 1027: /* external_file_unit : IntConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 547; {
/* line 3434 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (mCONST_EXP (mINT_CONSTANT (yyAttrStackPtr [1-1].Scan.IntConst))); 
} break;
case 2095: /* external_file_unit : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 547; {
/* line 3438 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2096:
case 1025: /* io_specification : '(' io_spec_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 544; {
/* line 3448 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 2097: /* io_spec_list : io_spec .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 548; {
/* line 3452 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, mBTP_EMPTY ()); 
} break;
case 2098:
case 1319: /* io_spec_list : io_spec ',' io_spec_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 548; {
/* line 3456 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2099: /* io_spec : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 549; {
/* line 3460 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2100: /* io_spec : PIdent '=' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 549; {
/* line 3464 "fortran.lalr" */
 yySynAttribute.Tree = mNAMED_PARAM (yyAttrStackPtr [1-1].Scan.Ident, mVALUE_PARAM (yyAttrStackPtr [3-1].Tree)); 
} break;
case 2101:
case 1023: /* io_spec : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 549; {
/* line 3468 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (mDUMMY_EXP()); 
} break;
case 2102:
case 1024: /* io_spec : PIdent '=' '*' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 549; {
/* line 3472 "fortran.lalr" */
 yySynAttribute.Tree = mNAMED_PARAM (yyAttrStackPtr [1-1].Scan.Ident, mVALUE_PARAM (mDUMMY_EXP())); 
} break;
case 2103:
case 1321: /* format_identifier : used_label .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 546; {
/* line 3476 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree = mCONST_EXP (mINT_CONSTANT (yyAttrStackPtr [1-1].Label));
       yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2104:
case 1026: /* format_identifier : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 546; {
/* line 3481 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (mDUMMY_EXP()); 
} break;
case 2105:
case 1022: /* format_identifier : StringConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 546; {
/* line 3485 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree = mCONST_EXP (mSTRING_CONSTANT (yyAttrStackPtr [1-1].Scan.StringConst)); 
       yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2106:
case 1320: /* format_identifier : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 546; {
/* line 3490 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
       yySynAttribute.Tree = mVALUE_PARAM (mVAR_EXP(yyAttrStackPtr [1-1].Tree)); 
} break;
case 2107: /* io_list : io_item .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 545; {
/* line 3495 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, mBTP_EMPTY ()); 
} break;
case 2108:
case 1323: /* io_list : io_item ',' io_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 545; {
/* line 3499 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);  
} break;
case 2109: /* io_item : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 550; {
/* line 3503 "fortran.lalr" */
 yySynAttribute.Tree = mVALUE_PARAM (yyAttrStackPtr [1-1].Tree); 
} break;
case 2110:
case 1228: /* format_statement : FORMAT format_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 325; {
/* line 3515 "fortran.lalr" */
 yySynAttribute.Tree = mFORMAT_DECL (DefaultId(), NLine (yyAttrStackPtr [1-1]), 0, yyAttrStackPtr [2-1].Tree);    
       yySynAttribute.Tree = mDECL_LIST (yySynAttribute.Tree, NoTree);
     
} break;
case 2111:
case 1227: /* format_list : FORMAT_ARG format_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 551; {
/* line 3521 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (mFORMAT_PARAM (yyAttrStackPtr [1-1].Scan.StringConst),
                              yyAttrStackPtr [2-1].Tree); 
     
} break;
case 2112: /* format_list : FORMAT_ARG .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 551; {
/* line 3527 "fortran.lalr" */
 yySynAttribute.Tree = mBTP_LIST (mFORMAT_PARAM (yyAttrStackPtr [1-1].Scan.StringConst),
                              mBTP_EMPTY());
     
} break;
case 2113:
case 1372: /* entry_statement : ENTRY PIdent dummy_arguments function_result .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 507; {
/* line 3539 "fortran.lalr" */
 yySynAttribute.Tree = mFUNC_DECL (yyAttrStackPtr [2-1].Scan.Ident, yyAttrStackPtr [2-1].Label, 
                             yyAttrStackPtr [3-1].Tree,       /* formals */
                             mBODY_NODE( mDECL_EMPTY(),
                                         mACF_EMPTY(),
                                         mUNIT_EMPTY() ),
                             mDUMMY_TYPE(), /* result_type   */
                             yyAttrStackPtr [4-1].Label);      /* result_id     */
       yySynAttribute.Tree = mACF_ENTRY (yySynAttribute.Tree);
       yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);   
     
} break;
case 2114:
case 1424: /* structured_statement : struct_loop_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 509; {
/* line 3558 "fortran.lalr" */
 SetSerial (yyAttrStackPtr [1-1].Tree);   /* set info in ACF_DO, ACF_FORALL */

        yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
        yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
      
} break;
case 2115:
case 1425: /* structured_statement : independent_clause struct_loop_statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 509; {
/* line 3567 "fortran.lalr" */
 SetIndependent (yyAttrStackPtr [2-1].Tree);  

        SetACFNodeLine (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [2-1].Line);
        yySynAttribute.Tree = ApplyParInfo (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [1-1].Line);
        yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
      
} break;
case 2116:
case 1426: /* struct_loop_statement : loop_statement .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 552; {
/* line 3577 "fortran.lalr" */
 yySynAttribute.Tree  = yyAttrStackPtr [1-1].Tree;
        yySynAttribute.Line  = yyAttrStackPtr [1-1].Line;
      
} break;
case 2117:
case 1412: /* struct_loop_statement : PIdent ':' loop_statement .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 552; {
/* line 3584 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
        yySynAttribute.Line = yyAttrStackPtr [3-1].Line;
        yySynAttribute.Tree->ACF_NODE.Label = - (yyAttrStackPtr [1-1].Scan.Ident);
        /* negative label stands for tIdent */
      
} break;
case 2118:
case 1440: /* loop_statement : DO ForLabel opt_comma WHILE '(' expression ')' CR1 execution_block ENDDO opt_ident .*/
  yyStateStackPtr -=11; yyAttrStackPtr -=11; yyNonterminal = 554; {
/* line 3594 "fortran.lalr" */
 yySynAttribute.Tree = mACF_WHILE (yyAttrStackPtr [6-1].Tree, yyAttrStackPtr [9-1].Tree); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);    
} break;
case 2119:
case 1442: /* loop_statement : DO ForLabel opt_comma Laufvariable '=' DoRange CR1 execution_block ENDDO opt_ident .*/
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 554; {
/* line 3601 "fortran.lalr" */
 yySynAttribute.Tree = mACF_DO (yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree, yyAttrStackPtr [8-1].Tree, 
                  mSERIAL_INFO(), mNO_HOME_INFO ()); 

        yySynAttribute.Line = NLine(yyAttrStackPtr [4-1]);    
      
} break;
case 2120:
case 1408: /* independent_clause : INDEPENDENT ind_clauses CR1 .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 553; {
/* line 3618 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
        yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);
      
} break;
case 2121: /* ind_clauses : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 556; {
/* line 3625 "fortran.lalr" */
 yySynAttribute.Tree = mPARALLEL_INFO (NoTree, NoTree, NoTree, NoTree); 
} break;
case 2122:
case 1402: /* ind_clauses : opt_comma ON home_expr ind_clauses .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 556; {
/* line 3630 "fortran.lalr" */
 yySynAttribute.Tree = SetParInfoHome (yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2123:
case 1405: /* ind_clauses : opt_comma resident_clause ind_clauses .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 556; {
/* line 3635 "fortran.lalr" */
 yySynAttribute.Tree = SetParInfoResident (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2124:
case 1406: /* ind_clauses : opt_comma new_clause ind_clauses .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 556; {
/* line 3640 "fortran.lalr" */
 yySynAttribute.Tree = SetParInfoNew (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2125:
case 1407: /* ind_clauses : opt_comma reduction_clause ind_clauses .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 556; {
/* line 3645 "fortran.lalr" */
 yySynAttribute.Tree = SetParInfoReduction (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2126:
case 1040: /* new_clause : NEW '(' new_var_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 559; {
/* line 3655 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 2127: /* new_var_list : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 561; {
/* line 3659 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY ()); 
} break;
case 2128:
case 1403: /* new_var_list : variable ',' new_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 561; {
/* line 3663 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2129:
case 1041: /* reduction_clause : REDUCTION '(' reduction_var_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 560; {
/* line 3673 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 2130: /* reduction_var_list : reduction_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 562; {
/* line 3677 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY ()); 
} break;
case 2131:
case 1404: /* reduction_var_list : reduction_var ',' reduction_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 562; {
/* line 3681 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2132: /* reduction_var : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 563; {
/* line 3685 "fortran.lalr" */
 yySynAttribute.Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
} break;
case 2133: /* reduction_var : structure_component .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 563; {
/* line 3689 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2134:
case 1439: /* loop_statement : DO ForLabel CR1 execution_block ENDDO opt_ident .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 554; {
/* line 3694 "fortran.lalr" */
 yySynAttribute.Tree = mACF_LOOP (yyAttrStackPtr [4-1].Tree); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);    
} break;
case 2135: /* ForLabel : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 555; {

} break;
case 2136:
case 1016: /* ForLabel : IntConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 555; {
/* line 3701 "fortran.lalr" */
 LabelDo (yyAttrStackPtr [1-1].Scan.IntConst); 
} break;
case 2137:
case 1441: /* Laufvariable : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 402; {
/* line 3705 "fortran.lalr" */
 yySynAttribute.Tree = mLOOP_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
} break;
case 2138: /* DoRange : expression ',' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 403; {
/* line 3709 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, mDUMMY_EXP()); 
} break;
case 2139: /* DoRange : expression ',' expression ',' expression .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 403; {
/* line 3713 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 2140:
case 1385: /* loop_statement : FORALL '(' forall_cont .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 554; {
/* line 3728 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);
      
} break;
case 2141:
case 1383: /* forall_cont : Laufvariable '=' Slice ',' forall_cont .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 565; {
/* line 3737 "fortran.lalr" */
 yySynAttribute.Tree = mACF_FORALL (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree,  
                               mACF_LIST (yyAttrStackPtr [5-1].Tree, mACF_EMPTY()), 
                               NoTree, mNO_HOME_INFO ());

        yySynAttribute.Tree->ACF_NODE.Line = NLine(yyAttrStackPtr [2-1]);
      
} break;
case 2142:
case 1384: /* forall_cont : Laufvariable '=' Slice forall_end .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 565; {
/* line 3746 "fortran.lalr" */
 yySynAttribute.Tree = mACF_FORALL (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [4-1].Tree, 
                               NoTree, mNO_HOME_INFO()); 
        yySynAttribute.Tree->ACF_NODE.Line = NLine(yyAttrStackPtr [2-1]);
      
} break;
case 2143:
case 1382: /* forall_cont : expression forall_end .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 565; {
/* line 3754 "fortran.lalr" */
 yySynAttribute.Tree = mACF_IF (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree, mACF_EMPTY ());
        yySynAttribute.Tree->ACF_NODE.Line = yyAttrStackPtr [2-1].Line; /* from ')' */ 
      
} break;
case 2144:
case 1381: /* forall_end : ')' assignment_statement .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 567; {
/* line 3760 "fortran.lalr" */
 yyAttrStackPtr [2-1].Tree = mACF_BASIC (yyAttrStackPtr [2-1].Tree);
        yyAttrStackPtr [2-1].Tree->ACF_NODE.Line = NLine(yyAttrStackPtr [1-1]);
        yySynAttribute.Tree = mACF_LIST ( yyAttrStackPtr [2-1].Tree, mACF_EMPTY() );  
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);
      
} break;
case 2145:
case 1034: /* forall_end : ')' CR1 execution_block ENDFORALL .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 567; {
/* line 3768 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);        
      
} break;
case 2146:
case 1365: /* if_statement : IF '(' expression ')' used_label ',' used_label ',' used_label .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 520; {
/* line 3781 "fortran.lalr" */
 yySynAttribute.Tree = mACF_BASIC( mCOMP_IF_STMT (yyAttrStackPtr [3-1].Tree, 
                           yyAttrStackPtr [5-1].Label, yyAttrStackPtr [7-1].Label, yyAttrStackPtr [9-1].Label));
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);  
} break;
case 2147:
case 1364: /* if_statement : IF '(' expression ')' action_stmt .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 520; {
/* line 3787 "fortran.lalr" */
 /* at first set label and line correctly */
        SetACFNode (yyAttrStackPtr [5-1].Tree, 0, yyAttrStackPtr [5-1].Line);
        yySynAttribute.Tree = mACF_IF (yyAttrStackPtr [3-1].Tree, 
                           mACF_LIST (yyAttrStackPtr [5-1].Tree, mACF_EMPTY()),
                           mACF_EMPTY()); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);  
} break;
case 2148:
case 1413: /* structured_statement : PIdent ':' if_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 509; {
/* line 3796 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
        yySynAttribute.Line = yyAttrStackPtr [3-1].Line;
        yySynAttribute.Tree->ACF_NODE.Label = - (yyAttrStackPtr [1-1].Scan.Ident);
        /* negative label stands for tIdent */
      
} break;
case 2149:
case 1430: /* structured_statement : if_construct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 509; {
/* line 3804 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2150:
case 1371: /* if_construct : IF '(' expression ')' THEN opt_ident CR1 execution_block else_part ENDIF opt_ident .*/
  yyStateStackPtr -=11; yyAttrStackPtr -=11; yyNonterminal = 568; {
/* line 3812 "fortran.lalr" */
 yySynAttribute.Tree = mACF_IF (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [8-1].Tree, yyAttrStackPtr [9-1].Tree); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);  
} break;
case 2151: /* else_part : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 569; {
/* line 3816 "fortran.lalr" */
 yySynAttribute.Tree = mACF_EMPTY (); 
} break;
case 2152:
case 1370: /* else_part : ELSEIF '(' expression ')' THEN opt_ident CR1 execution_block else_part .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 569; {
/* line 3821 "fortran.lalr" */
 yyAttrStackPtr [8-1].Tree = mACF_IF (yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [8-1].Tree,yyAttrStackPtr [9-1].Tree);
        yyAttrStackPtr [8-1].Tree->ACF_NODE.Line = NLine(yyAttrStackPtr [1-1]);
        yySynAttribute.Tree = mACF_LIST (yyAttrStackPtr [8-1].Tree, mACF_EMPTY());
      
} break;
case 2153:
case 1368: /* else_part : ELSE opt_ident CR1 execution_block .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 569; {
/* line 3828 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [4-1].Tree; 
} break;
case 2154:
case 1340: /* where_statement : WHERE '(' expression ')' action_stmt .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 525; {
/* line 3833 "fortran.lalr" */
 /* at first set label and line correctly */
        SetACFNode (yyAttrStackPtr [5-1].Tree, 0, yyAttrStackPtr [5-1].Line);
        yySynAttribute.Tree = mACF_WHERE (yyAttrStackPtr [3-1].Tree,
                           mACF_LIST (yyAttrStackPtr [5-1].Tree, mACF_EMPTY()),
                           mACF_EMPTY()); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);
      
} break;
case 2155:
case 1032: /* where_construct : WHERE '(' expression ')' CR1 execution_part elsewhere_part ENDWHERE .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 510; {
/* line 3847 "fortran.lalr" */
 yySynAttribute.Tree = mACF_WHERE (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [6-1].Tree, yyAttrStackPtr [7-1].Tree); 
        yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]); 
      
} break;
case 2156: /* elsewhere_part : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 570; {
/* line 3852 "fortran.lalr" */
 yySynAttribute.Tree = mACF_EMPTY (); 
} break;
case 2157:
case 1373: /* elsewhere_part : ELSEWHERE '(' expression ')' CR1 execution_part elsewhere_part .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 570; {
/* line 3858 "fortran.lalr" */
 yyAttrStackPtr [7-1].Tree = mACF_WHERE (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [6-1].Tree, yyAttrStackPtr [7-1].Tree); 
        yyAttrStackPtr [7-1].Tree->ACF_NODE.Line = NLine(yyAttrStackPtr [1-1]);
        yySynAttribute.Tree = mACF_LIST (yyAttrStackPtr [7-1].Tree, mACF_EMPTY());
      
} break;
case 2158:
case 1375: /* elsewhere_part : ELSEWHERE CR1 execution_part .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 570; {
/* line 3865 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 2159:
case 1379: /* case_construct : SELECTCASE '(' expression ')' CR1 case_list ENDSELECT opt_ident .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 511; {
/* line 3881 "fortran.lalr" */
 yySynAttribute.Tree = mACF_CASE (yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [6-1].Tree);
      yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]); 
    
} break;
case 2160: /* case_list : case_item .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 571; {
/* line 3888 "fortran.lalr" */
 yySynAttribute.Tree = mSELECTED_ACF_LIST (yyAttrStackPtr [1-1].Tree, mSELECTED_ACF_EMPTY ()); 
} break;
case 2161:
case 1380: /* case_list : case_item case_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 571; {
/* line 3893 "fortran.lalr" */
 yySynAttribute.Tree = mSELECTED_ACF_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2162:
case 1378: /* case_item : CASE case_selector opt_ident CR1 execution_block .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 572; {
/* line 3898 "fortran.lalr" */
 yySynAttribute.Tree = mSELECTED_ACF_NODE (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 2163:
case 1377: /* case_item : CASE DEFAULT opt_ident CR1 execution_block .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 572; {
/* line 3903 "fortran.lalr" */
 yySynAttribute.Tree = mSELECTED_ACF_NODE (mBTE_EMPTY (), yyAttrStackPtr [5-1].Tree); 
} break;
case 2164:
case 1033: /* case_selector : '(' case_value_range_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 573; {
/* line 3907 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 2165: /* case_value_range_list : case_value_range .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 574; {
/* line 3911 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, mBTE_EMPTY()); 
} break;
case 2166:
case 1376: /* case_value_range_list : case_value_range ',' case_value_range_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 574; {
/* line 3915 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2167: /* case_value_range : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 575; {
/* line 3919 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2168: /* case_value_range : expression ':' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 575; {
/* line 3923 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, mDUMMY_EXP (), mDUMMY_EXP ()); 
} break;
case 2169: /* case_value_range : ':' expression .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 575; {
/* line 3927 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (mDUMMY_EXP (), yyAttrStackPtr [2-1].Tree, mDUMMY_EXP ()); 
} break;
case 2170: /* case_value_range : expression ':' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 575; {
/* line 3931 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, mDUMMY_EXP ()); 
} break;
case 2171:
case 1391: /* hpf_statement : REALIGN realignee realign_attribute_stuff .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 508; {
/* line 3945 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree;
      yySynAttribute.Tree->REALIGN_STMT.ALIGNEE = mBTV_LIST (yyAttrStackPtr [2-1].Tree, mBTV_EMPTY());
      yySynAttribute.Tree = mACF_BASIC (yyAttrStackPtr [3-1].Tree);
      yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                  
    
} break;
case 2172:
case 1393: /* hpf_statement : REALIGN realign_attribute_stuff '::' realignee_list .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 508; {
/* line 3953 "fortran.lalr" */
 yySynAttribute.Tree =  yyAttrStackPtr [2-1].Tree;
      yySynAttribute.Tree->REALIGN_STMT.ALIGNEE = yyAttrStackPtr [4-1].Tree; 
      yySynAttribute.Tree = mACF_BASIC (yySynAttribute.Tree);
      yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);                  
    
} break;
case 2173:
case 1389: /* realign_attribute_stuff : WITH align_spec .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 577; {
/* line 3961 "fortran.lalr" */
 yySynAttribute.Tree = mREALIGN_STMT (NoTree, mBTE_EMPTY(), yyAttrStackPtr [2-1].Tree); 
} break;
case 2174:
case 1388: /* realign_attribute_stuff : '(' align_source_list ')' WITH align_spec .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 577; {
/* line 3965 "fortran.lalr" */
 yySynAttribute.Tree = mREALIGN_STMT (NoTree, yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 2175: /* realignee_list : realignee .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 578; {
/* line 3969 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY()); 
} break;
case 2176:
case 1392: /* realignee_list : realignee ',' realignee_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 578; {
/* line 3973 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2177:
case 1390: /* realignee : HPFIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 576; {
/* line 3977 "fortran.lalr" */
 yySynAttribute.Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
} break;
case 2178:
case 1397: /* hpf_statement : REDISTRIBUTE redistributee dist_format_clause opt_onto .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 508; {
/* line 3990 "fortran.lalr" */
 yyAttrStackPtr [2-1].Tree = mBTV_LIST (yyAttrStackPtr [2-1].Tree, mBTV_EMPTY ());
      yyAttrStackPtr [2-1].Tree = mREDISTRIBUTE_STMT (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [4-1].Tree);
      yySynAttribute.Tree = mACF_BASIC(yyAttrStackPtr [2-1].Tree);
      yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);                         
    
} break;
case 2179:
case 1399: /* hpf_statement : REDISTRIBUTE redist_attribute_stuff '::' redistributee_list .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 508; {
/* line 3998 "fortran.lalr" */
  yySynAttribute.Tree =  yyAttrStackPtr [2-1].Tree;
       yySynAttribute.Tree->REDISTRIBUTE_STMT.DISTRIBUTEE = yyAttrStackPtr [4-1].Tree; 
       yySynAttribute.Tree = mACF_BASIC (yySynAttribute.Tree);
    
} break;
case 2180:
case 1395: /* redist_attribute_stuff : dist_format_clause opt_onto .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 580; {
/* line 4005 "fortran.lalr" */
 yySynAttribute.Tree = mREDISTRIBUTE_STMT (NoTree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2181:
case 1396: /* redist_attribute_stuff : dist_onto_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 580; {
/* line 4009 "fortran.lalr" */
 yySynAttribute.Tree = mDEFAULT_DISTRIBUTION (0);
      yySynAttribute.Tree = mREDISTRIBUTE_STMT (NoTree, yySynAttribute.Tree, yyAttrStackPtr [1-1].Tree);
    
} break;
case 2182: /* redistributee_list : redistributee .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 581; {
/* line 4015 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY()); 
} break;
case 2183:
case 1398: /* redistributee_list : redistributee ',' redistributee_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 581; {
/* line 4019 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2184:
case 1394: /* redistributee : HPFIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 579; {
/* line 4023 "fortran.lalr" */
 yySynAttribute.Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
} break;
case 2185:
case 1432: /* hpf_statement : simple_on_directive CR1 executable_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 508; {
/* line 4033 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree = mACF_LIST (yyAttrStackPtr [3-1].Tree, mACF_EMPTY()); 
         SetBody (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree);
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2186:
case 1431: /* hpf_statement : simple_on_directive HPF_BEGIN CR1 execution_block HPF_END opt_hpf_on .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 508; {
/* line 4043 "fortran.lalr" */
 SetBody (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [4-1].Tree);
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2187: /* simple_on_directive : ON home_expr .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 582; {
/* line 4050 "fortran.lalr" */
 yySynAttribute.Tree = mACF_HOME (yyAttrStackPtr [2-1].Tree, true, NoTree);
         yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);
       
} break;
case 2188: /* simple_on_directive : ON home_expr ',' resident_clause .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 582; {
/* line 4056 "fortran.lalr" */
 yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);
         yySynAttribute.Tree = mACF_HOME (yyAttrStackPtr [2-1].Tree, true, NoTree);
         ApplyResidentClause (yySynAttribute.Tree, yyAttrStackPtr [4-1].Tree, yySynAttribute.Line);
       
} break;
case 2189:
case 1410: /* simple_on_directive : ON home_expr ',' new_clause .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 582; {
/* line 4063 "fortran.lalr" */
 yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);
         yySynAttribute.Tree = mACF_HOME (yyAttrStackPtr [2-1].Tree, true, NoTree);
         ApplyNewClause (yySynAttribute.Tree, yyAttrStackPtr [4-1].Tree, yySynAttribute.Line);
       
} break;
case 2190:
case 1409: /* simple_on_directive : ON home_expr ',' resident_clause ',' new_clause .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 582; {
/* line 4070 "fortran.lalr" */
 yySynAttribute.Line = NLine (yyAttrStackPtr [1-1]);
         yySynAttribute.Tree = mACF_HOME (yyAttrStackPtr [2-1].Tree, true, NoTree);
         ApplyResidentClause (yySynAttribute.Tree, yyAttrStackPtr [4-1].Tree, yySynAttribute.Line);
         ApplyNewClause      (yySynAttribute.Tree, yyAttrStackPtr [6-1].Tree, yySynAttribute.Line);
       
} break;
case 2191:
case 1039: /* home_expr : HOME '(' variable ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 557; {
/* line 4078 "fortran.lalr" */
 yySynAttribute.Tree = mON_VAR_CLAUSE (yyAttrStackPtr [3-1].Tree); 
} break;
case 2192:
case 1038: /* home_expr : '(' PIdent ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 557; {
/* line 4083 "fortran.lalr" */
 yyAttrStackPtr [2-1].Tree = mPROCESSOR_ARRAY (mTOP_OBJ (yyAttrStackPtr [2-1].Scan.Ident));
         yySynAttribute.Tree = mON_PROC_CLAUSE (yyAttrStackPtr [2-1].Tree); 
       
} break;
case 2193:
case 1037: /* home_expr : '(' PIdent '(' section_subscript_list ')' ')' .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 557; {
/* line 4089 "fortran.lalr" */
 yyAttrStackPtr [2-1].Tree = mTOP_OBJ (yyAttrStackPtr [2-1].Scan.Ident);
         yyAttrStackPtr [2-1].Tree = mPROCESSOR_SUBSET (CopyTree (yyAttrStackPtr [2-1].Tree), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree);
         yySynAttribute.Tree = mON_PROC_CLAUSE (yyAttrStackPtr [2-1].Tree); 
       
} break;
case 2194: /* opt_hpf_on : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 583; {

} break;
case 2195:
case 1042: /* opt_hpf_on : ON .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 583; {

} break;
case 2196:
case 1434: /* hpf_statement : simple_resident_directive CR1 executable_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 508; {
/* line 4105 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree = mACF_LIST (yyAttrStackPtr [3-1].Tree, mACF_EMPTY()); 
         yyAttrStackPtr [1-1].Tree->ACF_RESIDENT.RESIDENT_BODY = yyAttrStackPtr [3-1].Tree; 
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2197:
case 1433: /* hpf_statement : simple_resident_directive HPF_BEGIN CR1 execution_block HPF_END opt_hpf_resident .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 508; {
/* line 4115 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->ACF_RESIDENT.RESIDENT_BODY = yyAttrStackPtr [4-1].Tree; 
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2198:
case 1427: /* simple_resident_directive : resident_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 584; {
/* line 4122 "fortran.lalr" */
 yySynAttribute.Tree = mACF_RESIDENT (yyAttrStackPtr [1-1].Tree, NoTree); 
        yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
      
} break;
case 2199: /* opt_hpf_resident : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 585; {

} break;
case 2200:
case 1043: /* opt_hpf_resident : RESIDENT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 585; {

} break;
case 2201:
case 1401: /* resident_clause : RESIDENT opt_local_var_list .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 558; {
/* line 4137 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree;
         yySynAttribute.Line = NLine(yyAttrStackPtr [1-1]);
       
} break;
case 2202: /* opt_local_var_list : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 586; {
/* line 4145 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (mDUMMY_VAR(), mBTV_EMPTY ()); 
} break;
case 2203:
case 1036: /* opt_local_var_list : '(' local_var_list ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 586; {
/* line 4150 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 2204: /* local_var_list : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 587; {
/* line 4155 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, mBTV_EMPTY ()); 
} break;
case 2205:
case 1400: /* local_var_list : variable ',' local_var_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 587; {
/* line 4160 "fortran.lalr" */
 yySynAttribute.Tree = mBTV_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2206:
case 1436: /* hpf_statement : simple_new_directive CR1 executable_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 508; {
/* line 4171 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree = mACF_LIST (yyAttrStackPtr [3-1].Tree, mACF_EMPTY()); 
         yyAttrStackPtr [1-1].Tree->ACF_NEW.NEW_BODY = yyAttrStackPtr [3-1].Tree; 
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree;
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2207:
case 1435: /* hpf_statement : simple_new_directive HPF_BEGIN CR1 execution_block HPF_END opt_hpf_new .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 508; {
/* line 4181 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->ACF_NEW.NEW_BODY = yyAttrStackPtr [4-1].Tree; 
         yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2208:
case 1428: /* simple_new_directive : new_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 588; {
/* line 4188 "fortran.lalr" */
 yySynAttribute.Tree = mACF_NEW (yyAttrStackPtr [1-1].Tree, NoTree); 
        yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
      
} break;
case 2209: /* opt_hpf_new : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 589; {

} break;
case 2210:
case 1044: /* opt_hpf_new : NEW .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 589; {

} break;
case 2211:
case 1438: /* hpf_statement : simple_reduction_directive CR1 executable_construct .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 508; {
/* line 4203 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree = mACF_LIST (yyAttrStackPtr [3-1].Tree, mACF_EMPTY()); 
         yyAttrStackPtr [1-1].Tree->ACF_REDUCTION.REDUCTION_BODY = yyAttrStackPtr [3-1].Tree; 
         yySynAttribute.Tree = BuildSingleReductions (yyAttrStackPtr [1-1].Tree);
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2212:
case 1437: /* hpf_statement : simple_reduction_directive HPF_BEGIN CR1 execution_block HPF_END opt_hpf_reduction .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 508; {
/* line 4213 "fortran.lalr" */
 yyAttrStackPtr [1-1].Tree->ACF_REDUCTION.REDUCTION_BODY = yyAttrStackPtr [4-1].Tree; 
         yySynAttribute.Tree = BuildSingleReductions (yyAttrStackPtr [1-1].Tree);
         yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
       
} break;
case 2213:
case 1429: /* simple_reduction_directive : reduction_clause .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 590; {
/* line 4220 "fortran.lalr" */
 yySynAttribute.Tree = mACF_REDUCTION (false, yyAttrStackPtr [1-1].Tree, mBTV_EMPTY (), 
                                  mPROC_OBJ (DefaultId()), NoTree); 
        yySynAttribute.Line = yyAttrStackPtr [1-1].Line;
      
} break;
case 2214: /* opt_hpf_reduction : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 591; {

} break;
case 2215:
case 1045: /* opt_hpf_reduction : REDUCTION .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 591; {

} break;
case 2216:
case 1046: /* hpf_statement : task_flag TASK_REGION CR1 execution_block HPF_END TASK_REGION .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 508; {
/* line 4238 "fortran.lalr" */
 yySynAttribute.Tree = mACF_TASK_REGION (yyAttrStackPtr [1-1].Line, yyAttrStackPtr [4-1].Tree);
         yySynAttribute.Line = NLine (yyAttrStackPtr [2-1]);
       
} break;
case 2217: /* task_flag : INDEPENDENT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 592; {
/* line 4244 "fortran.lalr" */
 yySynAttribute.Line = 1; 
} break;
case 2218: /* task_flag : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 592; {
/* line 4248 "fortran.lalr" */
 yySynAttribute.Line = 0; 
} break;
case 2219:
case 1053: /* variable : PIdent .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 356; {
/* line 4258 "fortran.lalr" */
 yySynAttribute.Tree = mUSED_VAR (mVAR_OBJ (yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)); 
} break;
case 2220:
case 1055: /* variable : index_var .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 356; {
/* line 4262 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree ; 
} break;
case 2221:
case 1054: /* variable : structure_component .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 356; {
/* line 4266 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2222:
case 1072: /* structure_component : variable '%' PIdent .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 564; {
/* line 4270 "fortran.lalr" */
 yySynAttribute.Tree = mSELECTED_VAR (yyAttrStackPtr [1-1].Tree, mREC_COMP (yyAttrStackPtr [3-1].Scan.Ident)); 
} break;
case 2223:
case 885: /* index_var : variable '(' ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 593; {
/* line 4274 "fortran.lalr" */
 yySynAttribute.Tree = mINDEXED_VAR ( yyAttrStackPtr [1-1].Tree, mBTE_EMPTY() ); 
} break;
case 2224:
case 906: /* index_var : variable '(' section_subscript_list ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 593; {
/* line 4278 "fortran.lalr" */
 yySynAttribute.Tree = mINDEXED_VAR ( yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree ); 
} break;
case 2225: /* section_subscript_list : Index_Elem .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 493; {
/* line 4282 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, mBTE_EMPTY ()); 
} break;
case 2226:
case 1068: /* section_subscript_list : Index_Elem ',' section_subscript_list .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 493; {
/* line 4286 "fortran.lalr" */
 yySynAttribute.Tree = mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2227: /* Index_Elem : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 485; {
/* line 4290 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2228: /* Index_Elem : PIdent '=' expression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 485; {
/* line 4296 "fortran.lalr" */
 yySynAttribute.Tree = mNAMED_EXP (yyAttrStackPtr [1-1].Scan.Ident, yyAttrStackPtr [3-1].Tree); 
} break;
case 2229:
case 1069: /* Index_Elem : Slice .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 485; {
/* line 4300 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2230: /* Slice : dumexpression ':' dumexpression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 566; {
/* line 4304 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, mDUMMY_EXP ()); 
} break;
case 2231:
case 1070: /* Slice : dumexpression ':' dumexpression ':' dumexpression .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 566; {
/* line 4308 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 2232:
case 1071: /* Slice : dumexpression '::' dumexpression .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 566; {
/* line 4312 "fortran.lalr" */
 yySynAttribute.Tree = mSLICE_EXP (yyAttrStackPtr [1-1].Tree, mDUMMY_EXP(), yyAttrStackPtr [3-1].Tree); 
} break;
case 2233: /* dumexpression : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 594; {
/* line 4316 "fortran.lalr" */
 yySynAttribute.Tree = mDUMMY_EXP (); 
} break;
case 2234: /* dumexpression : expression .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 594; {
/* line 4320 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2235:
case 908: /* primary : '(' expression ')' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 595; {
/* line 4330 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 2236:
case 910: /* primary : '(' expression ',' impl_do_exp ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 595; {
/* line 4334 "fortran.lalr" */
 yyAttrStackPtr [4-1].Tree->DO_EXP.BODY = 
         mBTE_LIST (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree->DO_EXP.BODY); 
       yySynAttribute.Tree = yyAttrStackPtr [4-1].Tree; 
} break;
case 2237:
case 1074: /* impl_do_exp : expression ',' impl_do_exp .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 596; {
/* line 4340 "fortran.lalr" */
 yyAttrStackPtr [3-1].Tree->DO_EXP.BODY = 
         mBTE_LIST (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree->DO_EXP.BODY); 
       yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; 
} break;
case 2238:
case 1073: /* impl_do_exp : Laufvariable '=' DoRange .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 596; {
/* line 4346 "fortran.lalr" */
 yySynAttribute.Tree = mDO_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, mBTE_EMPTY()); 
} break;
case 2239: /* expression : expression defined_binary_op level5_expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 297; {
/* line 4354 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2240:
case 887: /* defined_binary_op : UserOp .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 597; {
/* line 4358 "fortran.lalr" */
 yySynAttribute.Tree = mOP_DEFINED (yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 2241: /* expression : level5_expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 297; {
/* line 4361 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2242: /* level5_expr : equiv_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 598; {
/* line 4365 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2243: /* level5_expr : level5_expr equiv_op equiv_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 598; {
/* line 4369 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2244:
case 901: /* equiv_op : EQV .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 431; {
/* line 4372 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EQV(); 
} break;
case 2245:
case 902: /* equiv_op : NEQV .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 431; {
/* line 4373 "fortran.lalr" */
 yySynAttribute.Tree = mOP_NEQV(); 
} break;
case 2246: /* equiv_operand : or_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 599; {
/* line 4376 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2247: /* equiv_operand : equiv_operand or_op or_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 599; {
/* line 4380 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2248:
case 903: /* or_op : OR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 430; {
/* line 4383 "fortran.lalr" */
 yySynAttribute.Tree = mOP_OR(); 
} break;
case 2249:
case 904: /* or_op : XOR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 430; {
/* line 4384 "fortran.lalr" */
 yySynAttribute.Tree = mOP_XOR(); 
} break;
case 2250:
case 1066: /* or_operand : and_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 600; {
/* line 4387 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2251:
case 1062: /* or_operand : or_operand and_op and_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 600; {
/* line 4391 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2252:
case 905: /* and_op : AND .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 429; {
/* line 4394 "fortran.lalr" */
 yySynAttribute.Tree = mOP_AND(); 
} break;
case 2253:
case 1063: /* and_operand : level4_expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 601; {
/* line 4397 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2254:
case 1057: /* and_operand : not_op level4_expr .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 601; {
/* line 4401 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2255:
case 886: /* not_op : NOT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 428; {
/* line 4404 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_NOT(); 
} break;
case 2256: /* level4_expr : level3_expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 602; {
/* line 4407 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2257: /* level4_expr : level3_expr rel_op level3_expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 602; {
/* line 4411 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2258:
case 890: /* rel_op : '==' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4413 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EQ(); 
} break;
case 2259:
case 894: /* rel_op : '<=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4414 "fortran.lalr" */
 yySynAttribute.Tree = mOP_LE(); 
} break;
case 2260:
case 892: /* rel_op : '>=' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4415 "fortran.lalr" */
 yySynAttribute.Tree = mOP_GE(); 
} break;
case 2261:
case 889: /* rel_op : '<>' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4416 "fortran.lalr" */
 yySynAttribute.Tree = mOP_NE(); 
} break;
case 2262:
case 893: /* rel_op : '<' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4417 "fortran.lalr" */
 yySynAttribute.Tree = mOP_LT(); 
} break;
case 2263:
case 891: /* rel_op : '>' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 427; {
/* line 4418 "fortran.lalr" */
 yySynAttribute.Tree = mOP_GT(); 
} break;
case 2264: /* level3_expr : level2_expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 603; {
/* line 4421 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2265: /* level3_expr : level3_expr concat_op level2_expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 603; {
/* line 4425 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2266:
case 888: /* concat_op : '//' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 426; {
/* line 4428 "fortran.lalr" */
 yySynAttribute.Tree = mOP_CONCAT (); 
} break;
case 2267: /* level2_expr : add_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 604; {
/* line 4431 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2268:
case 1067: /* level2_expr : level2_expr add_op signed_add_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 604; {
/* line 4435 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2269: /* level2_expr : '+' add_operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 604; {
/* line 4437 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP (mOP1_PSIGN(), yyAttrStackPtr [2-1].Tree); 
} break;
case 2270: /* level2_expr : '-' add_operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 604; {
/* line 4439 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP (mOP1_SIGN(), yyAttrStackPtr [2-1].Tree); 
} break;
case 2271:
case 895: /* add_op : '+' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 425; {
/* line 4441 "fortran.lalr" */
 yySynAttribute.Tree = mOP_PLUS();  
} break;
case 2272:
case 896: /* add_op : '-' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 425; {
/* line 4442 "fortran.lalr" */
 yySynAttribute.Tree = mOP_MINUS();  
} break;
case 2273: /* signed_add_operand : add_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 606; {
/* line 4445 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2274: /* signed_add_operand : '-' add_operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 606; {
/* line 4448 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP(mOP1_SIGN(), yyAttrStackPtr [2-1].Tree); 
} break;
case 2275:
case 1064: /* add_operand : mult_operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 605; {
/* line 4451 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2276:
case 1058: /* add_operand : add_operand mult_op mult_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 605; {
/* line 4453 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2277:
case 897: /* mult_op : '*' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 424; {
/* line 4455 "fortran.lalr" */
 yySynAttribute.Tree = mOP_TIMES();  
} break;
case 2278:
case 898: /* mult_op : '/' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 424; {
/* line 4456 "fortran.lalr" */
 yySynAttribute.Tree = mOP_DIVIDE(); 
} break;
case 2279: /* mult_operand : level1_expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 607; {
/* line 4459 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2280:
case 1059: /* mult_operand : level1_expr power_op mult_operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 607; {
/* line 4461 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXP (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 2281:
case 899: /* power_op : '**' .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 423; {
/* line 4463 "fortran.lalr" */
 yySynAttribute.Tree = mOP_EXPO(); 
} break;
case 2282:
case 1060: /* level1_expr : defined_unary_op primary .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 608; {
/* line 4466 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP (yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 2283:
case 881: /* defined_unary_op : UserOp .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 609; {
/* line 4469 "fortran.lalr" */
 yySynAttribute.Tree = mOP_DEFINED (yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 2284:
case 1056: /* level1_expr : primary .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 608; {
/* line 4472 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2285: /* primary : variable .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 595; {
/* line 4475 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_EXP (yyAttrStackPtr [1-1].Tree); 
} break;
case 2286:
case 1061: /* primary : Konstante .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 595; {
/* line 4478 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2287:
case 907: /* primary : '[' section_subscript_list ']' .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 595; {
/* line 4481 "fortran.lalr" */
 yySynAttribute.Tree = mARRAY_EXP (yyAttrStackPtr [2-1].Tree); 
} break;
case 2288:
case 900: /* primary : PReal '(' expression ')' .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 595; {
/* line 4484 "fortran.lalr" */
 yySynAttribute.Tree = mVAR_EXP ( mINDEXED_VAR (
                        mUSED_VAR (mVAR_OBJ(yyAttrStackPtr [1-1].Label, yyAttrStackPtr [1-1].Scan.Ident)),
                        mBTE_LIST (yyAttrStackPtr [3-1].Tree, mBTE_EMPTY ()))); 
} break;
case 2289:
case 884: /* PReal : REAL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 611; {
/* line 4489 "fortran.lalr" */
 yySynAttribute.Scan.Ident = IsIdent ("REAL");
       yySynAttribute.Label = NLine (yyAttrStackPtr [1-1]); 
} break;
case 2290: /* Konstante : IntConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 610; {
/* line 4500 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mINT_CONSTANT (yyAttrStackPtr [1-1].Scan.IntConst)); 
} break;
case 2291:
case 1065: /* Konstante : RealKonstante .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 610; {
/* line 4503 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (yyAttrStackPtr [1-1].Tree); 
} break;
case 2292:
case 909: /* Konstante : '(' expression ',' expression ')' .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 610; {
/* line 4507 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (MakeComplexConstant (yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree)); 
} break;
case 2293:
case 877: /* RealKonstante : IntConst '.' .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 612; {
/* line 4511 "fortran.lalr" */
 yySynAttribute.Tree = mREAL_CONSTANT (MakeIntToReal (yyAttrStackPtr [1-1].Scan.IntConst),
                                 default_real_size); 
} break;
case 2294:
case 878: /* RealKonstante : RealConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 612; {
/* line 4515 "fortran.lalr" */
 yySynAttribute.Tree = mREAL_CONSTANT (yyAttrStackPtr [1-1].Scan.StringConst, - yyAttrStackPtr [1-1].Scan.Ident); 
} break;
case 2295:
case 879: /* RealKonstante : DRealConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 612; {
/* line 4518 "fortran.lalr" */
 yySynAttribute.Tree = mREAL_CONSTANT (yyAttrStackPtr [1-1].Scan.StringConst, 2*default_real_size); 
} break;
case 2296:
case 880: /* Konstante : StringConst .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 610; {
/* line 4521 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mSTRING_CONSTANT (yyAttrStackPtr [1-1].Scan.StringConst)); 
} break;
case 2297:
case 882: /* Konstante : TRUE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 610; {
/* line 4524 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mBOOL_CONSTANT (1)); 
} break;
case 2298:
case 883: /* Konstante : FALSE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 610; {
/* line 4527 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mBOOL_CONSTANT (0)); 
} break;
case 2299:
case 1197: /* SignedKonstante : Konstante .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 405; {
/* line 4532 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 2300:
case 1192: /* SignedKonstante : '+' Konstante .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 405; {
/* line 4535 "fortran.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; 
} break;
case 2301: /* SignedKonstante : '-' IntConst .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 405; {
/* line 4538 "fortran.lalr" */
 yySynAttribute.Tree = mCONST_EXP (mINT_CONSTANT (- yyAttrStackPtr [2-1].Scan.IntConst)); 
} break;
case 2302:
case 1193: /* SignedKonstante : '-' RealKonstante .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 405; {
/* line 4541 "fortran.lalr" */
 yySynAttribute.Tree = mOP1_EXP (mOP1_SIGN(), mCONST_EXP (yyAttrStackPtr [2-1].Tree)); 
} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop; /* read nonterminal reduce ? */
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, Attribute);
	    yyTerminal = GetToken ();
	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = Parser_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadTermState) {		/* read or read terminal reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadTermState];	/* read nonterminal reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadTermState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadTermState]; /* read nonterminal reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginParser ()
   {
/* line 75 "fortran.lalr" */

  BeginScanner ();

   }

void CloseParser ()
   {

   }
