/* $Id: Scanner.c,v 2.16 1992/08/18 09:05:32 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "Scanner.h"
# include "Source.h"
# include "System.h"
# include "General.h"
# include "DynArray.h"
# include "Positions.h"
# include <stdio.h>
 
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = TokenPtr + TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= TokenLength - n; TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	1346
# define yyTableSize	8160
# define yyEobState	374
# define yyDefaultState	375
# define STD	1
# define BEG	3
# define NAMED	5
# define DIST	7
# define ASS	9
# define String1	11
# define String2	13
# define FORMAT	15
# define FORMAT1	17
# define ENDS	19
# define Incl1	21
# define Incl2	23
# define HPF	25
# define ADP	27
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		TokenPtr	;
	short		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 385},
{0, 0},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 90},
{1, 191},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 191},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 91},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 191},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 191},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{1, 158},
{3, 1346},
{3, 377},
{31, 374},
{32, 218},
{3, 72},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{35, 35},
{42, 374},
{58, 60},
{70, 338},
{71, 145},
{96, 66},
{91, 91},
{99, 368},
{99, 96},
{3, 391},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{104, 252},
{116, 374},
{32, 218},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{91, 91},
{158, 374},
{178, 93},
{183, 37},
{70, 338},
{71, 145},
{96, 66},
{114, 174},
{99, 368},
{99, 96},
{129, 79},
{3, 1055},
{3, 372},
{3, 1089},
{3, 371},
{3, 294},
{3, 1063},
{3, 347},
{3, 370},
{3, 369},
{3, 370},
{3, 370},
{3, 1178},
{3, 1166},
{3, 1039},
{3, 1094},
{3, 1098},
{3, 370},
{3, 1033},
{3, 344},
{3, 358},
{3, 1152},
{3, 370},
{3, 1103},
{3, 370},
{3, 370},
{3, 370},
{100, 362},
{247, 39},
{114, 174},
{108, 108},
{111, 111},
{129, 79},
{3, 1055},
{3, 372},
{3, 1089},
{3, 371},
{3, 294},
{3, 1063},
{3, 347},
{3, 370},
{3, 369},
{3, 370},
{3, 370},
{3, 1178},
{3, 1166},
{3, 1039},
{3, 1094},
{3, 1098},
{3, 370},
{3, 1033},
{3, 344},
{3, 358},
{3, 1152},
{3, 370},
{3, 1103},
{3, 370},
{3, 370},
{3, 370},
{5, 386},
{5, 376},
{94, 64},
{97, 43},
{98, 65},
{101, 268},
{108, 364},
{111, 312},
{115, 47},
{98, 368},
{101, 275},
{115, 47},
{131, 80},
{132, 78},
{123, 81},
{133, 76},
{134, 127},
{250, 48},
{97, 368},
{108, 220},
{100, 368},
{94, 368},
{123, 354},
{5, 391},
{178, 374},
{197, 177},
{267, 41},
{197, 177},
{272, 38},
{274, 40},
{115, 199},
{275, 272},
{275, 272},
{373, 374},
{94, 64},
{97, 43},
{98, 65},
{468, 469},
{108, 364},
{111, 312},
{585, 586},
{98, 368},
{249, 92},
{645, 646},
{131, 80},
{132, 78},
{123, 81},
{133, 76},
{134, 127},
{5, 1028},
{97, 368},
{108, 220},
{100, 368},
{94, 368},
{123, 354},
{101, 368},
{5, 338},
{5, 338},
{5, 338},
{5, 1026},
{5, 338},
{5, 1018},
{5, 338},
{5, 338},
{5, 1024},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 365},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{650, 651},
{655, 656},
{135, 73},
{658, 659},
{661, 662},
{101, 368},
{5, 338},
{5, 338},
{5, 338},
{5, 1026},
{5, 338},
{5, 1018},
{5, 338},
{5, 338},
{5, 1024},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 365},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{5, 338},
{7, 1030},
{7, 378},
{135, 73},
{102, 176},
{7, 61},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{102, 102},
{665, 666},
{110, 110},
{110, 193},
{668, 669},
{249, 374},
{145, 108},
{672, 673},
{676, 677},
{137, 132},
{7, 62},
{7, 717},
{110, 193},
{680, 681},
{680, 700},
{7, 198},
{7, 718},
{683, 684},
{685, 686},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{112, 112},
{687, 688},
{140, 83},
{142, 135},
{690, 691},
{125, 74},
{692, 693},
{169, 150},
{7, 1029},
{110, 193},
{102, 106},
{112, 197},
{112, 179},
{137, 132},
{7, 811},
{7, 361},
{7, 761},
{7, 352},
{7, 741},
{7, 954},
{7, 321},
{7, 368},
{7, 280},
{171, 118},
{125, 370},
{7, 924},
{7, 913},
{7, 368},
{7, 766},
{7, 770},
{145, 370},
{7, 735},
{7, 792},
{7, 719},
{140, 83},
{142, 135},
{7, 721},
{125, 74},
{112, 105},
{169, 150},
{698, 699},
{110, 193},
{703, 704},
{112, 197},
{112, 179},
{706, 707},
{7, 811},
{7, 361},
{7, 761},
{7, 352},
{7, 741},
{7, 954},
{7, 321},
{7, 368},
{7, 280},
{171, 118},
{125, 370},
{7, 924},
{7, 913},
{7, 368},
{7, 766},
{7, 770},
{145, 370},
{7, 735},
{7, 792},
{7, 719},
{694, 695},
{694, 702},
{7, 721},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 387},
{9, 379},
{9, 116},
{9, 116},
{9, 57},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 186},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 56},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 58},
{9, 116},
{9, 116},
{9, 59},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{9, 116},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{713, 714},
{11, 380},
{11, 54},
{11, 54},
{11, 55},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 392},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 715},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{11, 54},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{715, 716},
{13, 381},
{13, 52},
{13, 52},
{13, 53},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 393},
{13, 52},
{13, 713},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{13, 52},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 388},
{15, 51},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 394},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{15, 50},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 389},
{915, 916},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 395},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{17, 49},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 390},
{19, 382},
{19, 46},
{19, 46},
{19, 47},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 115},
{19, 114},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 114},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 114},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 114},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{19, 46},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{920, 921},
{1168, 1169},
{21, 45},
{21, 45},
{1174, 1175},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 396},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 1032},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{21, 45},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{0, 0},
{0, 0},
{23, 44},
{23, 44},
{0, 0},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 397},
{23, 44},
{23, 1031},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{23, 44},
{25, 383},
{199, 47},
{0, 0},
{25, 42},
{199, 47},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{163, 163},
{0, 0},
{0, 0},
{172, 147},
{143, 363},
{0, 0},
{273, 273},
{0, 0},
{173, 285},
{199, 199},
{0, 0},
{0, 0},
{0, 0},
{25, 712},
{273, 85},
{0, 0},
{25, 706},
{25, 711},
{25, 676},
{25, 679},
{25, 710},
{25, 678},
{25, 182},
{25, 674},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 102},
{25, 703},
{172, 147},
{25, 680},
{25, 694},
{25, 687},
{143, 292},
{173, 285},
{25, 490},
{25, 485},
{25, 592},
{25, 546},
{25, 482},
{25, 368},
{25, 583},
{25, 524},
{25, 501},
{25, 368},
{25, 368},
{25, 368},
{25, 368},
{25, 322},
{25, 528},
{25, 624},
{25, 368},
{25, 496},
{25, 476},
{25, 465},
{25, 368},
{25, 368},
{25, 612},
{25, 368},
{25, 368},
{25, 162},
{25, 709},
{25, 698},
{25, 708},
{163, 374},
{143, 292},
{165, 261},
{25, 490},
{25, 485},
{25, 592},
{25, 546},
{25, 482},
{25, 368},
{25, 583},
{25, 524},
{25, 501},
{25, 368},
{25, 368},
{25, 368},
{25, 368},
{25, 322},
{25, 528},
{25, 624},
{25, 368},
{25, 496},
{25, 476},
{25, 465},
{25, 368},
{25, 368},
{25, 612},
{25, 368},
{25, 368},
{25, 162},
{27, 384},
{198, 63},
{273, 374},
{27, 31},
{198, 63},
{165, 261},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{177, 35},
{0, 0},
{144, 315},
{175, 175},
{248, 248},
{0, 0},
{248, 86},
{0, 0},
{198, 198},
{0, 0},
{0, 0},
{248, 87},
{27, 712},
{165, 374},
{0, 0},
{27, 706},
{27, 711},
{27, 676},
{27, 679},
{27, 710},
{27, 678},
{27, 182},
{27, 674},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 102},
{27, 703},
{0, 0},
{27, 680},
{27, 694},
{27, 687},
{144, 291},
{175, 313},
{27, 409},
{27, 101},
{27, 421},
{27, 368},
{27, 433},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 462},
{27, 442},
{27, 302},
{27, 368},
{27, 368},
{27, 400},
{27, 403},
{27, 398},
{27, 368},
{27, 427},
{27, 368},
{27, 368},
{27, 368},
{27, 162},
{27, 709},
{27, 698},
{27, 708},
{167, 249},
{144, 291},
{175, 313},
{27, 409},
{27, 101},
{27, 421},
{27, 368},
{27, 433},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 368},
{27, 462},
{27, 442},
{27, 302},
{27, 368},
{27, 368},
{27, 400},
{27, 403},
{27, 398},
{27, 368},
{27, 427},
{27, 368},
{27, 368},
{27, 368},
{27, 162},
{29, 368},
{248, 374},
{674, 705},
{167, 249},
{0, 0},
{198, 374},
{0, 0},
{0, 0},
{674, 675},
{0, 0},
{0, 0},
{0, 0},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{674, 697},
{191, 314},
{193, 194},
{194, 167},
{195, 173},
{0, 0},
{167, 374},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 100},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{191, 314},
{193, 194},
{194, 167},
{195, 173},
{29, 368},
{0, 0},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 100},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{29, 368},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{0, 0},
{203, 67},
{204, 32},
{206, 262},
{207, 120},
{208, 172},
{209, 152},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{203, 67},
{204, 32},
{206, 262},
{207, 120},
{208, 172},
{209, 152},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{30, 30},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{0, 0},
{211, 283},
{212, 155},
{213, 153},
{170, 227},
{214, 151},
{215, 149},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{211, 283},
{212, 155},
{213, 153},
{170, 227},
{214, 151},
{215, 149},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{33, 33},
{43, 368},
{170, 374},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{185, 185},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{0, 0},
{216, 146},
{217, 122},
{218, 113},
{219, 204},
{0, 0},
{221, 215},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{216, 146},
{217, 122},
{218, 113},
{219, 204},
{43, 368},
{221, 215},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{43, 368},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{0, 0},
{0, 0},
{44, 44},
{44, 44},
{0, 0},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{0, 0},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{44, 44},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{0, 0},
{0, 0},
{45, 45},
{45, 45},
{0, 0},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{0, 0},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{45, 45},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{0, 0},
{0, 0},
{52, 52},
{52, 52},
{0, 0},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{0, 0},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{52, 52},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{0, 0},
{0, 0},
{54, 54},
{54, 54},
{0, 0},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{0, 0},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{54, 54},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{0, 0},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 164},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{56, 103},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{0, 0},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{62, 62},
{69, 338},
{271, 267},
{271, 267},
{271, 267},
{271, 267},
{271, 267},
{271, 267},
{271, 267},
{271, 267},
{0, 0},
{0, 0},
{0, 0},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{0, 0},
{222, 214},
{0, 0},
{0, 0},
{223, 195},
{0, 0},
{0, 0},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 70},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{222, 214},
{174, 166},
{200, 235},
{223, 195},
{69, 338},
{202, 88},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 70},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{69, 338},
{73, 370},
{174, 166},
{200, 235},
{0, 0},
{190, 248},
{202, 88},
{190, 86},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{190, 87},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{202, 374},
{224, 170},
{200, 374},
{0, 0},
{0, 0},
{0, 0},
{174, 374},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{224, 170},
{190, 370},
{210, 246},
{225, 258},
{73, 370},
{226, 157},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{73, 370},
{81, 370},
{190, 370},
{210, 246},
{225, 258},
{0, 0},
{226, 157},
{0, 0},
{0, 0},
{0, 0},
{268, 247},
{268, 247},
{0, 0},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{225, 374},
{227, 226},
{228, 316},
{230, 236},
{231, 203},
{0, 0},
{210, 374},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{227, 226},
{228, 316},
{230, 236},
{231, 203},
{81, 370},
{232, 148},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{81, 370},
{95, 368},
{268, 374},
{0, 0},
{0, 0},
{0, 0},
{232, 148},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{0, 0},
{233, 224},
{234, 156},
{235, 202},
{238, 89},
{0, 0},
{240, 219},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 94},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{233, 224},
{234, 156},
{235, 202},
{238, 89},
{95, 368},
{240, 219},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 94},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{95, 368},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{0, 0},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 164},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{103, 103},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{105, 185},
{0, 0},
{243, 217},
{244, 216},
{255, 231},
{259, 221},
{260, 228},
{261, 222},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{243, 217},
{244, 216},
{255, 231},
{259, 221},
{260, 228},
{261, 222},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{105, 33},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{106, 163},
{0, 0},
{262, 223},
{0, 0},
{263, 238},
{266, 255},
{0, 0},
{0, 0},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{262, 223},
{160, 265},
{263, 238},
{266, 255},
{166, 250},
{237, 68},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{106, 30},
{107, 104},
{0, 0},
{107, 104},
{107, 34},
{166, 250},
{237, 68},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 374},
{0, 0},
{0, 0},
{0, 0},
{160, 99},
{0, 0},
{160, 756},
{166, 374},
{0, 0},
{160, 844},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 657},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{160, 99},
{245, 307},
{160, 756},
{229, 119},
{236, 306},
{160, 844},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 657},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{107, 180},
{109, 36},
{245, 307},
{0, 0},
{229, 119},
{236, 306},
{0, 0},
{0, 0},
{245, 374},
{0, 0},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{229, 374},
{0, 0},
{0, 0},
{236, 374},
{0, 0},
{0, 0},
{270, 242},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{179, 104},
{0, 0},
{179, 104},
{121, 338},
{0, 0},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{179, 252},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{270, 242},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{109, 109},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 188},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{126, 196},
{127, 201},
{239, 207},
{241, 241},
{121, 338},
{0, 0},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 188},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{121, 338},
{124, 77},
{205, 171},
{239, 207},
{138, 84},
{126, 140},
{186, 269},
{126, 346},
{168, 154},
{220, 317},
{126, 123},
{127, 124},
{138, 370},
{239, 374},
{186, 103},
{124, 370},
{168, 206},
{254, 266},
{257, 257},
{280, 160},
{126, 343},
{126, 357},
{0, 0},
{241, 210},
{126, 326},
{127, 327},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{186, 58},
{124, 77},
{205, 171},
{186, 59},
{138, 84},
{126, 140},
{0, 0},
{126, 346},
{168, 154},
{220, 317},
{126, 123},
{127, 124},
{138, 370},
{205, 374},
{128, 370},
{124, 370},
{168, 206},
{254, 266},
{0, 0},
{280, 160},
{126, 343},
{126, 357},
{220, 374},
{241, 210},
{126, 326},
{127, 327},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{0, 0},
{0, 0},
{257, 229},
{254, 374},
{0, 0},
{0, 0},
{283, 254},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 125},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{186, 374},
{257, 229},
{258, 237},
{264, 263},
{128, 370},
{283, 254},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 125},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{128, 370},
{130, 370},
{283, 374},
{258, 237},
{264, 263},
{276, 274},
{276, 274},
{276, 274},
{276, 274},
{276, 274},
{276, 274},
{276, 274},
{276, 274},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{264, 374},
{282, 368},
{284, 209},
{285, 212},
{282, 279},
{0, 0},
{258, 374},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 82},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{282, 368},
{284, 209},
{285, 212},
{282, 279},
{130, 370},
{286, 270},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 82},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{130, 370},
{136, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{286, 270},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{0, 0},
{288, 129},
{291, 128},
{292, 142},
{298, 253},
{0, 0},
{299, 288},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 133},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{288, 129},
{291, 128},
{292, 142},
{298, 253},
{136, 370},
{299, 288},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 133},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{136, 370},
{139, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{0, 0},
{300, 137},
{301, 136},
{0, 0},
{307, 213},
{0, 0},
{308, 264},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 75},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{300, 137},
{301, 136},
{305, 259},
{307, 213},
{139, 370},
{308, 264},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 75},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{139, 370},
{141, 370},
{0, 0},
{305, 259},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{0, 0},
{309, 178},
{304, 338},
{305, 374},
{311, 244},
{0, 0},
{304, 337},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 134},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{309, 178},
{304, 338},
{310, 208},
{311, 244},
{141, 370},
{304, 337},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 134},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{141, 370},
{159, 257},
{181, 177},
{310, 208},
{181, 177},
{159, 368},
{0, 0},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{181, 35},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{0, 0},
{312, 243},
{315, 315},
{313, 205},
{0, 0},
{0, 0},
{310, 374},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 98},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{312, 243},
{242, 200},
{313, 205},
{314, 309},
{159, 368},
{315, 310},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 98},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{159, 368},
{161, 241},
{242, 200},
{269, 269},
{314, 309},
{161, 368},
{315, 310},
{0, 0},
{0, 0},
{256, 256},
{0, 0},
{269, 103},
{0, 0},
{0, 0},
{242, 374},
{0, 0},
{0, 0},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{0, 0},
{317, 286},
{269, 58},
{327, 301},
{314, 374},
{269, 59},
{335, 299},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 353},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{317, 286},
{256, 232},
{327, 301},
{316, 284},
{161, 368},
{335, 299},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 353},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{161, 368},
{162, 184},
{256, 232},
{162, 368},
{316, 284},
{0, 0},
{162, 251},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{256, 374},
{0, 0},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{0, 0},
{329, 290},
{324, 192},
{329, 370},
{337, 121},
{316, 374},
{324, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{329, 290},
{324, 192},
{329, 370},
{337, 121},
{162, 368},
{324, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{162, 368},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{0, 0},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 164},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{0, 0},
{164, 164},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 117},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{164, 103},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{176, 112},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{325, 295},
{339, 281},
{340, 351},
{302, 271},
{342, 332},
{325, 370},
{176, 197},
{176, 179},
{302, 276},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{180, 34},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{252, 252},
{325, 295},
{339, 281},
{340, 351},
{302, 368},
{342, 332},
{325, 370},
{176, 197},
{176, 179},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{0, 0},
{302, 368},
{0, 0},
{252, 105},
{0, 0},
{0, 0},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{180, 180},
{182, 670},
{182, 180},
{182, 180},
{182, 181},
{182, 107},
{182, 641},
{182, 689},
{182, 180},
{182, 180},
{182, 180},
{182, 180},
{182, 682},
{182, 180},
{182, 652},
{182, 667},
{182, 180},
{182, 180},
{182, 180},
{182, 180},
{182, 647},
{182, 180},
{182, 180},
{182, 180},
{182, 663},
{182, 180},
{182, 180},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{182, 670},
{182, 180},
{182, 180},
{182, 181},
{182, 107},
{182, 641},
{182, 689},
{182, 180},
{182, 180},
{182, 180},
{182, 180},
{182, 682},
{182, 180},
{182, 652},
{182, 667},
{182, 180},
{182, 180},
{182, 180},
{182, 180},
{182, 647},
{182, 180},
{182, 180},
{182, 180},
{182, 663},
{182, 180},
{182, 180},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{343, 335},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{0, 0},
{0, 0},
{0, 0},
{187, 338},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{265, 265},
{0, 0},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{343, 335},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{184, 183},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 69},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{188, 111},
{246, 240},
{265, 239},
{0, 0},
{187, 338},
{319, 308},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 69},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{187, 338},
{293, 126},
{246, 240},
{265, 239},
{188, 303},
{0, 0},
{319, 308},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{345, 341},
{246, 374},
{293, 1139},
{350, 304},
{265, 374},
{188, 338},
{189, 256},
{0, 0},
{0, 0},
{319, 374},
{189, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{293, 126},
{0, 0},
{0, 0},
{188, 303},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{345, 341},
{0, 0},
{293, 1139},
{350, 304},
{0, 0},
{188, 338},
{355, 348},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 139},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{192, 175},
{196, 196},
{201, 201},
{306, 225},
{189, 370},
{355, 348},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 139},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{189, 370},
{278, 95},
{277, 97},
{289, 370},
{306, 225},
{192, 278},
{196, 234},
{295, 370},
{196, 233},
{296, 370},
{318, 211},
{196, 168},
{201, 169},
{277, 368},
{278, 368},
{356, 333},
{289, 131},
{320, 368},
{296, 71},
{306, 374},
{192, 368},
{196, 260},
{196, 245},
{0, 0},
{295, 143},
{196, 165},
{201, 305},
{320, 29},
{330, 297},
{364, 319},
{0, 0},
{0, 0},
{330, 370},
{278, 95},
{277, 97},
{289, 370},
{0, 0},
{192, 278},
{196, 234},
{295, 370},
{196, 233},
{296, 370},
{318, 211},
{196, 168},
{201, 169},
{277, 368},
{278, 368},
{356, 333},
{289, 131},
{320, 368},
{296, 71},
{351, 324},
{192, 368},
{196, 260},
{196, 245},
{318, 374},
{295, 143},
{196, 165},
{201, 305},
{320, 29},
{330, 297},
{364, 319},
{359, 370},
{351, 368},
{330, 370},
{359, 144},
{201, 374},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{351, 324},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{0, 0},
{0, 0},
{0, 0},
{253, 370},
{359, 370},
{351, 368},
{0, 0},
{359, 144},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{363, 363},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{251, 109},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{0, 0},
{360, 368},
{363, 311},
{360, 323},
{253, 370},
{366, 359},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{253, 370},
{279, 368},
{360, 368},
{363, 311},
{360, 323},
{0, 0},
{366, 359},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{0, 0},
{336, 331},
{367, 366},
{400, 401},
{401, 402},
{0, 0},
{336, 1222},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 277},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{336, 331},
{367, 366},
{400, 401},
{401, 402},
{279, 368},
{336, 1222},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 277},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{279, 368},
{281, 368},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{0, 0},
{398, 399},
{405, 406},
{403, 404},
{398, 456},
{0, 0},
{403, 418},
{281, 368},
{281, 320},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{398, 399},
{405, 406},
{403, 404},
{398, 456},
{281, 368},
{403, 418},
{281, 368},
{281, 320},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{281, 368},
{287, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{0, 0},
{406, 407},
{407, 408},
{409, 410},
{410, 411},
{0, 0},
{411, 412},
{287, 370},
{287, 370},
{287, 130},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{406, 407},
{407, 408},
{409, 410},
{410, 411},
{287, 370},
{411, 412},
{287, 370},
{287, 370},
{287, 130},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{287, 370},
{290, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{0, 0},
{412, 413},
{413, 414},
{414, 415},
{415, 416},
{0, 0},
{416, 417},
{290, 287},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{412, 413},
{413, 414},
{414, 415},
{415, 416},
{290, 370},
{416, 417},
{290, 287},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{290, 370},
{294, 141},
{0, 0},
{294, 293},
{328, 370},
{333, 296},
{294, 1191},
{418, 419},
{357, 370},
{419, 420},
{421, 422},
{333, 370},
{328, 298},
{294, 1110},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{346, 1073},
{357, 289},
{422, 423},
{423, 424},
{424, 425},
{425, 426},
{346, 345},
{0, 0},
{0, 0},
{294, 141},
{297, 370},
{294, 293},
{328, 370},
{333, 296},
{294, 1191},
{418, 419},
{357, 370},
{419, 420},
{421, 422},
{333, 370},
{328, 298},
{294, 1110},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{346, 1073},
{357, 289},
{422, 423},
{423, 424},
{424, 425},
{425, 426},
{346, 345},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 190},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{0, 0},
{427, 428},
{428, 429},
{429, 430},
{297, 370},
{430, 431},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 190},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{297, 370},
{303, 338},
{427, 428},
{428, 429},
{429, 430},
{0, 0},
{430, 431},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{0, 0},
{431, 432},
{433, 434},
{434, 435},
{435, 436},
{0, 0},
{436, 437},
{303, 187},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{431, 432},
{433, 434},
{434, 435},
{435, 436},
{303, 338},
{436, 437},
{303, 187},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{303, 338},
{321, 368},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{0, 0},
{437, 438},
{439, 440},
{440, 441},
{442, 443},
{0, 0},
{444, 445},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 159},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{437, 438},
{439, 440},
{440, 441},
{442, 443},
{321, 368},
{444, 445},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 159},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{321, 368},
{322, 516},
{341, 334},
{344, 1252},
{358, 1237},
{321, 374},
{443, 444},
{344, 336},
{445, 446},
{341, 370},
{349, 355},
{322, 161},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{344, 1121},
{344, 1295},
{349, 1084},
{443, 450},
{446, 447},
{349, 1159},
{358, 328},
{0, 0},
{0, 0},
{0, 0},
{323, 368},
{322, 516},
{341, 334},
{344, 1252},
{358, 1237},
{0, 0},
{443, 444},
{344, 336},
{445, 446},
{341, 370},
{349, 355},
{322, 161},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{344, 1121},
{344, 1295},
{349, 1084},
{443, 450},
{446, 447},
{349, 1159},
{358, 328},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 282},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{0, 0},
{447, 448},
{448, 449},
{450, 451},
{323, 368},
{451, 452},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 282},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{323, 368},
{326, 370},
{447, 448},
{448, 449},
{450, 451},
{323, 374},
{451, 452},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{0, 0},
{452, 453},
{453, 454},
{454, 455},
{457, 458},
{0, 0},
{459, 460},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 300},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{452, 453},
{453, 454},
{454, 455},
{457, 458},
{326, 370},
{459, 460},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 300},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{326, 370},
{331, 370},
{0, 0},
{0, 0},
{0, 0},
{326, 374},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{0, 0},
{460, 461},
{456, 459},
{462, 463},
{463, 464},
{0, 0},
{456, 457},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 325},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{460, 461},
{456, 459},
{462, 463},
{463, 464},
{331, 370},
{456, 457},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 325},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{331, 370},
{332, 370},
{0, 0},
{0, 0},
{0, 0},
{331, 374},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{0, 0},
{466, 467},
{465, 466},
{467, 468},
{469, 470},
{0, 0},
{465, 634},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 329},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{466, 467},
{465, 466},
{467, 468},
{469, 470},
{332, 370},
{465, 634},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 329},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{332, 370},
{334, 370},
{0, 0},
{0, 0},
{0, 0},
{332, 374},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{0, 0},
{470, 471},
{471, 472},
{472, 473},
{473, 474},
{0, 0},
{474, 475},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 138},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{470, 471},
{471, 472},
{472, 473},
{473, 474},
{334, 370},
{474, 475},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 138},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{334, 370},
{338, 338},
{0, 0},
{0, 0},
{0, 0},
{334, 374},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{0, 0},
{476, 539},
{477, 478},
{479, 480},
{476, 477},
{0, 0},
{480, 481},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{476, 539},
{477, 478},
{479, 480},
{476, 477},
{338, 338},
{480, 481},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{338, 338},
{347, 370},
{482, 483},
{483, 484},
{486, 487},
{338, 374},
{404, 405},
{354, 370},
{347, 189},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{354, 342},
{404, 439},
{487, 488},
{488, 489},
{493, 494},
{494, 495},
{497, 498},
{0, 0},
{0, 0},
{0, 0},
{348, 370},
{0, 0},
{0, 0},
{0, 0},
{347, 370},
{482, 483},
{483, 484},
{486, 487},
{0, 0},
{404, 405},
{354, 370},
{347, 189},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{354, 342},
{404, 439},
{487, 488},
{488, 489},
{493, 494},
{494, 495},
{497, 498},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 330},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{0, 0},
{0, 0},
{498, 499},
{362, 362},
{348, 370},
{0, 0},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 330},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{348, 370},
{353, 360},
{352, 848},
{498, 499},
{361, 268},
{348, 374},
{352, 726},
{362, 230},
{372, 1076},
{361, 275},
{352, 871},
{353, 368},
{478, 479},
{371, 1280},
{0, 0},
{369, 1148},
{352, 339},
{371, 1046},
{485, 486},
{372, 367},
{362, 318},
{371, 1244},
{369, 1184},
{369, 349},
{0, 0},
{485, 598},
{478, 493},
{371, 356},
{491, 621},
{499, 500},
{501, 502},
{491, 492},
{503, 504},
{353, 360},
{352, 848},
{361, 748},
{0, 0},
{0, 0},
{352, 726},
{362, 230},
{372, 1076},
{0, 0},
{352, 871},
{353, 368},
{478, 479},
{371, 1280},
{361, 340},
{369, 1148},
{352, 339},
{371, 1046},
{485, 486},
{372, 367},
{362, 318},
{371, 1244},
{369, 1184},
{369, 349},
{365, 338},
{485, 598},
{478, 493},
{371, 356},
{491, 621},
{499, 500},
{501, 502},
{491, 492},
{503, 504},
{0, 0},
{0, 0},
{361, 748},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{361, 340},
{504, 505},
{496, 497},
{505, 506},
{506, 507},
{0, 0},
{496, 508},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 350},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{504, 505},
{496, 497},
{505, 506},
{506, 507},
{365, 338},
{496, 508},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 350},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{365, 338},
{368, 368},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{0, 0},
{510, 511},
{502, 530},
{511, 512},
{512, 513},
{0, 0},
{502, 503},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{510, 511},
{502, 530},
{511, 512},
{512, 513},
{368, 368},
{502, 503},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{368, 368},
{370, 370},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{0, 0},
{513, 514},
{514, 515},
{516, 517},
{518, 519},
{0, 0},
{519, 520},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{513, 514},
{514, 515},
{516, 517},
{518, 519},
{370, 370},
{519, 520},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{370, 370},
{490, 491},
{508, 616},
{509, 561},
{520, 521},
{508, 509},
{521, 522},
{490, 570},
{522, 523},
{524, 525},
{525, 526},
{526, 527},
{528, 529},
{529, 602},
{530, 531},
{509, 510},
{531, 532},
{532, 533},
{530, 578},
{533, 534},
{508, 518},
{534, 535},
{535, 536},
{536, 537},
{537, 538},
{539, 540},
{540, 541},
{541, 542},
{542, 543},
{543, 544},
{544, 545},
{0, 0},
{0, 0},
{490, 491},
{508, 616},
{509, 561},
{520, 521},
{508, 509},
{521, 522},
{490, 570},
{522, 523},
{524, 525},
{525, 526},
{526, 527},
{528, 529},
{529, 602},
{530, 531},
{509, 510},
{531, 532},
{532, 533},
{530, 578},
{533, 534},
{508, 518},
{534, 535},
{535, 536},
{536, 537},
{537, 538},
{539, 540},
{540, 541},
{541, 542},
{542, 543},
{543, 544},
{544, 545},
{546, 547},
{547, 548},
{548, 549},
{549, 550},
{550, 551},
{551, 552},
{552, 553},
{547, 604},
{553, 554},
{555, 556},
{556, 557},
{557, 558},
{558, 559},
{559, 560},
{561, 562},
{562, 563},
{546, 555},
{563, 564},
{564, 565},
{565, 566},
{566, 567},
{567, 568},
{568, 569},
{570, 571},
{571, 572},
{572, 573},
{573, 574},
{574, 575},
{575, 576},
{576, 577},
{578, 579},
{579, 580},
{546, 547},
{547, 548},
{548, 549},
{549, 550},
{550, 551},
{551, 552},
{552, 553},
{547, 604},
{553, 554},
{555, 556},
{556, 557},
{557, 558},
{558, 559},
{559, 560},
{561, 562},
{562, 563},
{546, 555},
{563, 564},
{564, 565},
{565, 566},
{566, 567},
{567, 568},
{568, 569},
{570, 571},
{571, 572},
{572, 573},
{573, 574},
{574, 575},
{575, 576},
{576, 577},
{578, 579},
{579, 580},
{580, 581},
{581, 582},
{583, 584},
{584, 585},
{586, 587},
{587, 588},
{588, 589},
{589, 590},
{590, 591},
{592, 593},
{593, 594},
{594, 595},
{595, 596},
{596, 597},
{598, 599},
{599, 600},
{600, 601},
{602, 603},
{604, 605},
{605, 606},
{606, 607},
{607, 608},
{608, 609},
{609, 610},
{610, 611},
{612, 613},
{613, 614},
{614, 615},
{616, 617},
{617, 618},
{618, 619},
{619, 620},
{580, 581},
{581, 582},
{583, 584},
{584, 585},
{586, 587},
{587, 588},
{588, 589},
{589, 590},
{590, 591},
{592, 593},
{593, 594},
{594, 595},
{595, 596},
{596, 597},
{598, 599},
{599, 600},
{600, 601},
{602, 603},
{604, 605},
{605, 606},
{606, 607},
{607, 608},
{608, 609},
{609, 610},
{610, 611},
{612, 613},
{613, 614},
{614, 615},
{616, 617},
{617, 618},
{618, 619},
{619, 620},
{621, 622},
{622, 623},
{624, 625},
{625, 626},
{626, 627},
{627, 628},
{628, 629},
{629, 630},
{630, 631},
{631, 632},
{632, 633},
{634, 635},
{635, 636},
{636, 637},
{637, 638},
{638, 639},
{639, 640},
{641, 642},
{642, 643},
{643, 644},
{644, 645},
{647, 648},
{648, 649},
{649, 650},
{653, 701},
{654, 655},
{660, 661},
{657, 696},
{663, 664},
{664, 665},
{667, 668},
{670, 671},
{621, 622},
{622, 623},
{624, 625},
{625, 626},
{626, 627},
{627, 628},
{628, 629},
{629, 630},
{630, 631},
{631, 632},
{632, 633},
{634, 635},
{635, 636},
{636, 637},
{637, 638},
{638, 639},
{639, 640},
{641, 642},
{642, 643},
{643, 644},
{644, 645},
{647, 648},
{648, 649},
{649, 650},
{652, 653},
{654, 655},
{660, 661},
{653, 654},
{663, 664},
{664, 665},
{667, 668},
{670, 671},
{671, 672},
{682, 683},
{652, 660},
{657, 658},
{689, 690},
{721, 722},
{719, 902},
{722, 732},
{723, 724},
{724, 725},
{727, 728},
{722, 723},
{726, 803},
{719, 822},
{728, 729},
{721, 775},
{682, 685},
{726, 727},
{729, 730},
{689, 692},
{719, 720},
{730, 731},
{732, 733},
{733, 734},
{652, 653},
{735, 736},
{0, 0},
{653, 654},
{737, 738},
{738, 739},
{719, 990},
{739, 740},
{671, 672},
{682, 683},
{652, 660},
{657, 658},
{689, 690},
{721, 722},
{719, 902},
{722, 732},
{723, 724},
{724, 725},
{727, 728},
{722, 723},
{726, 803},
{719, 822},
{728, 729},
{721, 775},
{682, 685},
{726, 727},
{729, 730},
{689, 692},
{719, 720},
{730, 731},
{732, 733},
{733, 734},
{736, 779},
{735, 736},
{736, 977},
{741, 742},
{737, 738},
{738, 739},
{719, 990},
{739, 740},
{742, 743},
{743, 744},
{744, 745},
{745, 746},
{746, 747},
{741, 781},
{748, 749},
{749, 750},
{750, 751},
{751, 752},
{736, 940},
{736, 788},
{752, 753},
{753, 754},
{736, 737},
{754, 755},
{756, 757},
{757, 758},
{758, 759},
{759, 760},
{0, 0},
{762, 763},
{763, 764},
{764, 765},
{736, 779},
{768, 769},
{736, 977},
{741, 742},
{0, 0},
{768, 834},
{0, 0},
{0, 0},
{742, 743},
{743, 744},
{744, 745},
{745, 746},
{746, 747},
{741, 781},
{748, 749},
{749, 750},
{750, 751},
{751, 752},
{736, 940},
{736, 788},
{752, 753},
{753, 754},
{736, 737},
{754, 755},
{756, 757},
{757, 758},
{758, 759},
{759, 760},
{761, 819},
{762, 763},
{763, 764},
{764, 765},
{767, 768},
{768, 769},
{766, 839},
{761, 1006},
{766, 767},
{768, 834},
{771, 772},
{761, 762},
{772, 773},
{766, 842},
{761, 796},
{773, 774},
{771, 949},
{770, 863},
{775, 776},
{767, 930},
{772, 893},
{776, 777},
{777, 778},
{782, 783},
{761, 784},
{779, 780},
{784, 785},
{785, 786},
{786, 787},
{788, 789},
{781, 782},
{770, 907},
{761, 819},
{779, 1017},
{770, 771},
{789, 790},
{767, 768},
{770, 897},
{766, 839},
{761, 1006},
{766, 767},
{781, 851},
{771, 772},
{761, 762},
{772, 773},
{766, 842},
{761, 796},
{773, 774},
{771, 949},
{770, 863},
{775, 776},
{767, 930},
{772, 893},
{776, 777},
{777, 778},
{782, 783},
{761, 784},
{779, 780},
{784, 785},
{785, 786},
{786, 787},
{788, 789},
{781, 782},
{770, 907},
{790, 791},
{779, 1017},
{770, 771},
{789, 790},
{792, 883},
{770, 897},
{793, 794},
{794, 795},
{792, 886},
{781, 851},
{796, 995},
{796, 797},
{797, 798},
{798, 799},
{799, 800},
{800, 801},
{801, 802},
{803, 804},
{804, 805},
{805, 806},
{806, 807},
{807, 808},
{808, 809},
{792, 793},
{792, 962},
{809, 810},
{812, 813},
{811, 812},
{813, 814},
{814, 815},
{815, 816},
{816, 817},
{790, 791},
{811, 879},
{811, 825},
{819, 820},
{792, 883},
{817, 936},
{793, 794},
{794, 795},
{792, 886},
{817, 818},
{796, 995},
{796, 797},
{797, 798},
{798, 799},
{799, 800},
{800, 801},
{801, 802},
{803, 804},
{804, 805},
{805, 806},
{806, 807},
{807, 808},
{808, 809},
{792, 793},
{792, 962},
{809, 810},
{812, 813},
{811, 812},
{813, 814},
{814, 815},
{815, 816},
{816, 817},
{820, 821},
{811, 879},
{811, 825},
{819, 820},
{822, 823},
{817, 936},
{823, 824},
{825, 826},
{826, 827},
{817, 818},
{827, 828},
{828, 829},
{829, 830},
{830, 831},
{831, 832},
{832, 833},
{834, 835},
{835, 836},
{836, 837},
{837, 838},
{839, 840},
{840, 841},
{842, 843},
{845, 1014},
{844, 845},
{846, 847},
{848, 849},
{849, 850},
{851, 852},
{852, 853},
{845, 846},
{853, 854},
{820, 821},
{854, 855},
{855, 856},
{857, 858},
{822, 823},
{844, 857},
{823, 824},
{825, 826},
{826, 827},
{851, 984},
{827, 828},
{828, 829},
{829, 830},
{830, 831},
{831, 832},
{832, 833},
{834, 835},
{835, 836},
{836, 837},
{837, 838},
{839, 840},
{840, 841},
{842, 843},
{845, 1014},
{844, 845},
{846, 847},
{848, 849},
{849, 850},
{851, 852},
{852, 853},
{845, 846},
{853, 854},
{858, 859},
{854, 855},
{855, 856},
{857, 858},
{859, 860},
{844, 857},
{860, 861},
{861, 862},
{864, 865},
{851, 984},
{863, 864},
{863, 919},
{865, 866},
{866, 867},
{867, 868},
{868, 869},
{869, 870},
{871, 872},
{872, 873},
{873, 874},
{874, 875},
{875, 876},
{876, 877},
{877, 878},
{879, 880},
{880, 881},
{881, 882},
{883, 884},
{884, 885},
{886, 887},
{887, 888},
{888, 889},
{858, 859},
{889, 890},
{890, 891},
{891, 892},
{859, 860},
{893, 894},
{860, 861},
{861, 862},
{864, 865},
{894, 895},
{863, 864},
{863, 919},
{865, 866},
{866, 867},
{867, 868},
{868, 869},
{869, 870},
{871, 872},
{872, 873},
{873, 874},
{874, 875},
{875, 876},
{876, 877},
{877, 878},
{879, 880},
{880, 881},
{881, 882},
{883, 884},
{884, 885},
{886, 887},
{887, 888},
{888, 889},
{895, 896},
{889, 890},
{890, 891},
{891, 892},
{897, 898},
{893, 894},
{898, 899},
{899, 900},
{900, 901},
{894, 895},
{902, 903},
{903, 904},
{904, 905},
{905, 906},
{907, 908},
{908, 909},
{909, 910},
{910, 911},
{911, 912},
{913, 914},
{897, 993},
{914, 915},
{916, 917},
{917, 918},
{919, 920},
{921, 922},
{922, 923},
{924, 925},
{925, 926},
{926, 927},
{927, 928},
{928, 929},
{895, 896},
{913, 944},
{930, 931},
{931, 932},
{897, 898},
{932, 933},
{898, 899},
{899, 900},
{900, 901},
{924, 1000},
{902, 903},
{903, 904},
{904, 905},
{905, 906},
{907, 908},
{908, 909},
{909, 910},
{910, 911},
{911, 912},
{913, 914},
{897, 993},
{914, 915},
{916, 917},
{917, 918},
{919, 920},
{921, 922},
{922, 923},
{924, 925},
{925, 926},
{926, 927},
{927, 928},
{928, 929},
{933, 934},
{913, 944},
{930, 931},
{931, 932},
{934, 935},
{932, 933},
{936, 937},
{937, 938},
{938, 939},
{924, 1000},
{940, 941},
{941, 942},
{942, 943},
{944, 945},
{945, 946},
{946, 947},
{947, 948},
{949, 971},
{950, 951},
{951, 952},
{952, 953},
{949, 950},
{954, 955},
{955, 956},
{956, 957},
{957, 958},
{958, 959},
{959, 960},
{960, 961},
{962, 963},
{963, 964},
{964, 965},
{933, 934},
{965, 966},
{966, 967},
{967, 968},
{934, 935},
{968, 969},
{936, 937},
{937, 938},
{938, 939},
{969, 970},
{940, 941},
{941, 942},
{942, 943},
{944, 945},
{945, 946},
{946, 947},
{947, 948},
{949, 971},
{950, 951},
{951, 952},
{952, 953},
{949, 950},
{954, 955},
{955, 956},
{956, 957},
{957, 958},
{958, 959},
{959, 960},
{960, 961},
{962, 963},
{963, 964},
{964, 965},
{971, 972},
{965, 966},
{966, 967},
{967, 968},
{972, 973},
{968, 969},
{973, 974},
{974, 975},
{975, 976},
{969, 970},
{977, 978},
{978, 979},
{979, 980},
{980, 981},
{981, 982},
{982, 983},
{984, 985},
{985, 986},
{986, 987},
{987, 988},
{988, 989},
{990, 991},
{991, 992},
{993, 994},
{995, 996},
{996, 997},
{997, 998},
{998, 999},
{1000, 1001},
{1001, 1002},
{1002, 1003},
{1003, 1004},
{971, 972},
{1004, 1005},
{1006, 1007},
{1007, 1008},
{972, 973},
{1008, 1009},
{973, 974},
{974, 975},
{975, 976},
{1009, 1010},
{977, 978},
{978, 979},
{979, 980},
{980, 981},
{981, 982},
{982, 983},
{984, 985},
{985, 986},
{986, 987},
{987, 988},
{988, 989},
{990, 991},
{991, 992},
{993, 994},
{995, 996},
{996, 997},
{997, 998},
{998, 999},
{1000, 1001},
{1001, 1002},
{1002, 1003},
{1003, 1004},
{1010, 1011},
{1004, 1005},
{1006, 1007},
{1007, 1008},
{1011, 1012},
{1008, 1009},
{1012, 1013},
{1014, 1015},
{1015, 1016},
{1009, 1010},
{1018, 1019},
{1019, 1020},
{1020, 1021},
{1021, 1022},
{1022, 1023},
{1024, 1025},
{1026, 1027},
{1033, 1034},
{0, 0},
{1035, 1036},
{1036, 1037},
{0, 0},
{1037, 1038},
{0, 0},
{1040, 1041},
{1041, 1042},
{1042, 1043},
{1043, 1044},
{1044, 1045},
{1046, 1047},
{1047, 1048},
{1034, 1108},
{1010, 1011},
{1034, 1304},
{1034, 1035},
{1039, 1201},
{1011, 1012},
{1048, 1049},
{1012, 1013},
{1014, 1015},
{1015, 1016},
{1049, 1050},
{1018, 1019},
{1019, 1020},
{1020, 1021},
{1021, 1022},
{1022, 1023},
{1024, 1025},
{1026, 1027},
{1033, 1034},
{1034, 1117},
{1035, 1036},
{1036, 1037},
{1034, 1069},
{1037, 1038},
{1039, 1040},
{1040, 1041},
{1041, 1042},
{1042, 1043},
{1043, 1044},
{1044, 1045},
{1046, 1047},
{1047, 1048},
{1034, 1108},
{1050, 1051},
{1034, 1304},
{1034, 1035},
{1039, 1201},
{1051, 1052},
{1048, 1049},
{1052, 1053},
{1053, 1054},
{1055, 1056},
{1049, 1050},
{1056, 1057},
{1057, 1058},
{1058, 1059},
{1059, 1060},
{1060, 1061},
{1055, 1134},
{1061, 1212},
{1064, 1065},
{1034, 1117},
{1063, 1064},
{1061, 1062},
{1034, 1069},
{1065, 1149},
{1039, 1040},
{1066, 1067},
{1063, 1288},
{1067, 1068},
{1069, 1070},
{1070, 1071},
{1071, 1072},
{1073, 1074},
{1074, 1075},
{1050, 1051},
{1076, 1077},
{1065, 1066},
{1077, 1078},
{1051, 1052},
{1078, 1079},
{1052, 1053},
{1053, 1054},
{1055, 1056},
{1079, 1080},
{1056, 1057},
{1057, 1058},
{1058, 1059},
{1059, 1060},
{1060, 1061},
{1055, 1134},
{1061, 1212},
{1064, 1065},
{1080, 1081},
{1063, 1064},
{1061, 1062},
{1081, 1082},
{1065, 1149},
{1082, 1083},
{1066, 1067},
{1063, 1288},
{1067, 1068},
{1069, 1070},
{1070, 1071},
{1071, 1072},
{1073, 1074},
{1074, 1075},
{1084, 1085},
{1076, 1077},
{1065, 1066},
{1077, 1078},
{1085, 1086},
{1078, 1079},
{1086, 1087},
{1087, 1088},
{1090, 1091},
{1079, 1080},
{1091, 1092},
{1092, 1093},
{1094, 1095},
{1089, 1131},
{1095, 1096},
{1096, 1097},
{0, 0},
{1101, 1102},
{1080, 1081},
{0, 0},
{1089, 1324},
{1081, 1082},
{0, 0},
{1082, 1083},
{1089, 1090},
{1099, 1100},
{1104, 1105},
{1089, 1124},
{0, 0},
{1095, 1267},
{1105, 1106},
{1099, 1319},
{1084, 1085},
{1100, 1101},
{1098, 1172},
{1106, 1107},
{1085, 1086},
{1089, 1113},
{1086, 1087},
{1087, 1088},
{1090, 1091},
{1100, 1228},
{1091, 1092},
{1092, 1093},
{1094, 1095},
{1089, 1131},
{1095, 1096},
{1096, 1097},
{1098, 1216},
{1101, 1102},
{1103, 1144},
{1098, 1099},
{1089, 1324},
{1111, 1112},
{1098, 1232},
{1113, 1114},
{1089, 1090},
{1099, 1100},
{1104, 1105},
{1089, 1124},
{1103, 1104},
{1095, 1267},
{1105, 1106},
{1099, 1319},
{1108, 1109},
{1100, 1101},
{1098, 1172},
{1106, 1107},
{1110, 1111},
{1089, 1113},
{1114, 1115},
{1115, 1116},
{1108, 1342},
{1100, 1228},
{1117, 1118},
{1118, 1119},
{1119, 1120},
{1121, 1122},
{1122, 1123},
{1110, 1261},
{1098, 1216},
{1125, 1126},
{1103, 1144},
{1098, 1099},
{1127, 1128},
{1111, 1112},
{1098, 1232},
{1113, 1114},
{1124, 1208},
{1124, 1125},
{1126, 1155},
{1128, 1129},
{1103, 1104},
{1129, 1130},
{1131, 1132},
{1132, 1133},
{1108, 1109},
{1134, 1135},
{1126, 1127},
{1135, 1136},
{1110, 1111},
{1131, 1142},
{1114, 1115},
{1115, 1116},
{1108, 1342},
{1136, 1137},
{1117, 1118},
{1118, 1119},
{1119, 1120},
{1121, 1122},
{1122, 1123},
{1110, 1261},
{1137, 1138},
{1125, 1126},
{1139, 1140},
{1140, 1141},
{1127, 1128},
{1142, 1143},
{1144, 1145},
{1145, 1146},
{1124, 1208},
{1124, 1125},
{1126, 1155},
{1128, 1129},
{1146, 1147},
{1129, 1130},
{1131, 1132},
{1132, 1133},
{1149, 1150},
{1134, 1135},
{1126, 1127},
{1135, 1136},
{1150, 1151},
{1131, 1142},
{1152, 1153},
{1153, 1154},
{1155, 1156},
{1136, 1137},
{1156, 1157},
{1157, 1158},
{1159, 1160},
{1160, 1343},
{1161, 1162},
{1162, 1163},
{1137, 1138},
{1163, 1164},
{1139, 1140},
{1140, 1141},
{1160, 1242},
{1142, 1143},
{1144, 1145},
{1145, 1146},
{1160, 1161},
{1159, 1255},
{1164, 1165},
{1166, 1167},
{1146, 1147},
{1167, 1168},
{1169, 1170},
{1170, 1171},
{1149, 1150},
{1172, 1273},
{1172, 1173},
{1173, 1174},
{1150, 1151},
{1175, 1176},
{1152, 1153},
{1153, 1154},
{1155, 1156},
{1166, 1283},
{1156, 1157},
{1157, 1158},
{1159, 1160},
{1160, 1343},
{1161, 1162},
{1162, 1163},
{1176, 1177},
{1163, 1164},
{1178, 1179},
{1179, 1180},
{1160, 1242},
{1180, 1181},
{1181, 1182},
{1182, 1183},
{1160, 1161},
{1159, 1255},
{1164, 1165},
{1166, 1167},
{1184, 1185},
{1167, 1168},
{1169, 1170},
{1170, 1171},
{1178, 1332},
{1172, 1273},
{1172, 1173},
{1173, 1174},
{1185, 1186},
{1175, 1176},
{1186, 1187},
{1187, 1188},
{1188, 1189},
{1166, 1283},
{1189, 1190},
{1191, 1192},
{1192, 1193},
{1193, 1194},
{1194, 1195},
{1195, 1196},
{1176, 1177},
{1196, 1197},
{1178, 1179},
{1179, 1180},
{1197, 1198},
{1180, 1181},
{1181, 1182},
{1182, 1183},
{1198, 1199},
{1199, 1200},
{1201, 1202},
{1202, 1203},
{1184, 1185},
{1203, 1204},
{1204, 1205},
{1205, 1206},
{1178, 1332},
{1206, 1207},
{1208, 1209},
{1209, 1210},
{1185, 1186},
{1208, 1338},
{1186, 1187},
{1187, 1188},
{1188, 1189},
{1210, 1211},
{1189, 1190},
{1191, 1192},
{1192, 1193},
{1193, 1194},
{1194, 1195},
{1195, 1196},
{1212, 1213},
{1196, 1197},
{1213, 1214},
{1214, 1215},
{1197, 1198},
{1216, 1217},
{1217, 1218},
{1218, 1219},
{1198, 1199},
{1199, 1200},
{1201, 1202},
{1202, 1203},
{1219, 1220},
{1203, 1204},
{1204, 1205},
{1205, 1206},
{1220, 1221},
{1206, 1207},
{1208, 1209},
{1209, 1210},
{1222, 1223},
{1208, 1338},
{1223, 1224},
{1224, 1225},
{1225, 1226},
{1210, 1211},
{1226, 1227},
{1228, 1229},
{1229, 1230},
{1230, 1231},
{1232, 1233},
{1233, 1234},
{1212, 1213},
{1234, 1235},
{1213, 1214},
{1214, 1215},
{1235, 1236},
{1216, 1217},
{1217, 1218},
{1218, 1219},
{1237, 1238},
{1238, 1239},
{1239, 1240},
{1240, 1241},
{1219, 1220},
{1242, 1243},
{1232, 1317},
{1244, 1245},
{1220, 1221},
{1245, 1246},
{1246, 1247},
{1247, 1248},
{1222, 1223},
{1248, 1249},
{1223, 1224},
{1224, 1225},
{1225, 1226},
{1249, 1250},
{1226, 1227},
{1228, 1229},
{1229, 1230},
{1230, 1231},
{1232, 1233},
{1233, 1234},
{1250, 1251},
{1234, 1235},
{1252, 1253},
{1253, 1254},
{1235, 1236},
{1255, 1256},
{1256, 1257},
{1257, 1258},
{1237, 1238},
{1238, 1239},
{1239, 1240},
{1240, 1241},
{1258, 1259},
{1242, 1243},
{1232, 1317},
{1244, 1245},
{1259, 1260},
{1245, 1246},
{1246, 1247},
{1247, 1248},
{1261, 1262},
{1248, 1249},
{1262, 1263},
{1263, 1264},
{1264, 1265},
{1249, 1250},
{1265, 1266},
{1267, 1268},
{1268, 1269},
{1269, 1270},
{1270, 1271},
{1271, 1272},
{1250, 1251},
{1261, 1311},
{1252, 1253},
{1253, 1254},
{1273, 1274},
{1255, 1256},
{1256, 1257},
{1257, 1258},
{1274, 1275},
{1275, 1276},
{1276, 1277},
{1277, 1278},
{1258, 1259},
{1278, 1279},
{1280, 1281},
{1281, 1282},
{1259, 1260},
{1283, 1284},
{1284, 1285},
{1285, 1286},
{1261, 1262},
{1286, 1287},
{1262, 1263},
{1263, 1264},
{1264, 1265},
{1288, 1289},
{1265, 1266},
{1267, 1268},
{1268, 1269},
{1269, 1270},
{1270, 1271},
{1271, 1272},
{1289, 1290},
{1261, 1311},
{1290, 1291},
{1291, 1292},
{1273, 1274},
{1292, 1293},
{1293, 1294},
{1295, 1296},
{1274, 1275},
{1275, 1276},
{1276, 1277},
{1277, 1278},
{1296, 1297},
{1278, 1279},
{1280, 1281},
{1281, 1282},
{1297, 1298},
{1283, 1284},
{1284, 1285},
{1285, 1286},
{1298, 1299},
{1286, 1287},
{1299, 1300},
{1300, 1301},
{1301, 1302},
{1288, 1289},
{1302, 1303},
{1304, 1305},
{1305, 1306},
{1306, 1307},
{1307, 1308},
{1308, 1309},
{1289, 1290},
{1309, 1310},
{1290, 1291},
{1291, 1292},
{1311, 1312},
{1292, 1293},
{1293, 1294},
{1295, 1296},
{1312, 1313},
{1313, 1314},
{1314, 1315},
{1315, 1316},
{1296, 1297},
{1317, 1318},
{1319, 1320},
{1320, 1321},
{1297, 1298},
{1321, 1322},
{1322, 1323},
{1324, 1325},
{1298, 1299},
{1325, 1326},
{1299, 1300},
{1300, 1301},
{1301, 1302},
{1326, 1327},
{1302, 1303},
{1304, 1305},
{1305, 1306},
{1306, 1307},
{1307, 1308},
{1308, 1309},
{1327, 1328},
{1309, 1310},
{1328, 1329},
{1329, 1330},
{1311, 1312},
{1330, 1331},
{1332, 1333},
{1333, 1334},
{1312, 1313},
{1313, 1314},
{1314, 1315},
{1315, 1316},
{1334, 1335},
{1317, 1318},
{1319, 1320},
{1320, 1321},
{1335, 1336},
{1321, 1322},
{1322, 1323},
{1324, 1325},
{1336, 1337},
{1325, 1326},
{1338, 1339},
{1339, 1340},
{1340, 1341},
{1326, 1327},
{1343, 1344},
{1344, 1345},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1327, 1328},
{0, 0},
{1328, 1329},
{1329, 1330},
{0, 0},
{1330, 1331},
{1332, 1333},
{1333, 1334},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1334, 1335},
{0, 0},
{0, 0},
{0, 0},
{1335, 1336},
{0, 0},
{0, 0},
{0, 0},
{1336, 1337},
{0, 0},
{1338, 1339},
{1339, 1340},
{1340, 1341},
{0, 0},
{1343, 1344},
{1344, 1345},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [118],
& yyComb [0],
& yyComb [232],
& yyComb [0],
& yyComb [346],
& yyComb [0],
& yyComb [466],
& yyComb [0],
& yyComb [593],
& yyComb [0],
& yyComb [720],
& yyComb [0],
& yyComb [847],
& yyComb [0],
& yyComb [974],
& yyComb [0],
& yyComb [1101],
& yyComb [0],
& yyComb [1228],
& yyComb [0],
& yyComb [1355],
& yyComb [0],
& yyComb [1472],
& yyComb [0],
& yyComb [1585],
& yyComb [0],
& yyComb [1672],
& yyComb [1747],
& yyComb [2],
& yyComb [63],
& yyComb [1822],
& yyComb [0],
& yyComb [84],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [15],
& yyComb [1909],
& yyComb [2032],
& yyComb [2159],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2286],
& yyComb [0],
& yyComb [2413],
& yyComb [0],
& yyComb [2540],
& yyComb [0],
& yyComb [85],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2667],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2758],
& yyComb [75],
& yyComb [76],
& yyComb [0],
& yyComb [2845],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [2932],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [115],
& yyComb [0],
& yyComb [0],
& yyComb [178],
& yyComb [3019],
& yyComb [62],
& yyComb [175],
& yyComb [166],
& yyComb [64],
& yyComb [177],
& yyComb [212],
& yyComb [312],
& yyComb [3142],
& yyComb [103],
& yyComb [3221],
& yyComb [3296],
& yyComb [3376],
& yyComb [180],
& yyComb [3460],
& yyComb [339],
& yyComb [181],
& yyComb [340],
& yyComb [0],
& yyComb [114],
& yyComb [239],
& yyComb [34],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [3498],
& yyComb [0],
& yyComb [185],
& yyComb [3551],
& yyComb [337],
& yyComb [3557],
& yyComb [3558],
& yyComb [3630],
& yyComb [98],
& yyComb [3717],
& yyComb [184],
& yyComb [185],
& yyComb [187],
& yyComb [188],
& yyComb [256],
& yyComb [3804],
& yyComb [296],
& yyComb [3548],
& yyComb [3891],
& yyComb [320],
& yyComb [3978],
& yyComb [317],
& yyComb [1468],
& yyComb [1580],
& yyComb [343],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [46],
& yyComb [4069],
& yyComb [3356],
& yyComb [4160],
& yyComb [4249],
& yyComb [1439],
& yyComb [4372],
& yyComb [1496],
& yyComb [3311],
& yyComb [1609],
& yyComb [3558],
& yyComb [334],
& yyComb [1819],
& yyComb [355],
& yyComb [1434],
& yyComb [1439],
& yyComb [2782],
& yyComb [1581],
& yyComb [4451],
& yyComb [1553],
& yyComb [138],
& yyComb [3488],
& yyComb [4488],
& yyComb [4059],
& yyComb [4546],
& yyComb [141],
& yyComb [4621],
& yyComb [1899],
& yyComb [3594],
& yyComb [4659],
& yyComb [4718],
& yyComb [4770],
& yyComb [2853],
& yyComb [1666],
& yyComb [4829],
& yyComb [1660],
& yyComb [1653],
& yyComb [1664],
& yyComb [4830],
& yyComb [223],
& yyComb [1586],
& yyComb [1473],
& yyComb [2778],
& yyComb [4831],
& yyComb [2776],
& yyComb [1728],
& yyComb [1729],
& yyComb [3538],
& yyComb [1724],
& yyComb [1725],
& yyComb [1726],
& yyComb [1727],
& yyComb [2869],
& yyComb [1812],
& yyComb [1813],
& yyComb [1814],
& yyComb [1816],
& yyComb [1817],
& yyComb [1899],
& yyComb [1900],
& yyComb [1901],
& yyComb [1902],
& yyComb [3547],
& yyComb [1891],
& yyComb [2735],
& yyComb [2738],
& yyComb [2822],
& yyComb [2863],
& yyComb [2865],
& yyComb [2915],
& yyComb [2916],
& yyComb [3391],
& yyComb [2914],
& yyComb [2915],
& yyComb [2949],
& yyComb [2999],
& yyComb [3000],
& yyComb [3001],
& yyComb [3394],
& yyComb [3304],
& yyComb [2993],
& yyComb [3506],
& yyComb [2998],
& yyComb [3560],
& yyComb [4078],
& yyComb [3197],
& yyComb [3198],
& yyComb [3379],
& yyComb [4670],
& yyComb [176],
& yyComb [1582],
& yyComb [247],
& yyComb [222],
& yyComb [4911],
& yyComb [4487],
& yyComb [4949],
& yyComb [3564],
& yyComb [3209],
& yyComb [4168],
& yyComb [3606],
& yyComb [3654],
& yyComb [3214],
& yyComb [3215],
& yyComb [3216],
& yyComb [3286],
& yyComb [3288],
& yyComb [3648],
& yyComb [4673],
& yyComb [3275],
& yyComb [233],
& yyComb [2929],
& yyComb [4162],
& yyComb [3451],
& yyComb [2747],
& yyComb [230],
& yyComb [1470],
& yyComb [231],
& yyComb [224],
& yyComb [3709],
& yyComb [4827],
& yyComb [4828],
& yyComb [5036],
& yyComb [3561],
& yyComb [5123],
& yyComb [3710],
& yyComb [3627],
& yyComb [3710],
& yyComb [3711],
& yyComb [3746],
& yyComb [5210],
& yyComb [3796],
& yyComb [4828],
& yyComb [5297],
& yyComb [3799],
& yyComb [3800],
& yyComb [4714],
& yyComb [5344],
& yyComb [4832],
& yyComb [4834],
& yyComb [5417],
& yyComb [3797],
& yyComb [3799],
& yyComb [3881],
& yyComb [3882],
& yyComb [4482],
& yyComb [5504],
& yyComb [3973],
& yyComb [3912],
& yyComb [4784],
& yyComb [3873],
& yyComb [3875],
& yyComb [3957],
& yyComb [4006],
& yyComb [3975],
& yyComb [4063],
& yyComb [4065],
& yyComb [4095],
& yyComb [4097],
& yyComb [4185],
& yyComb [4150],
& yyComb [4820],
& yyComb [4678],
& yyComb [4843],
& yyComb [5591],
& yyComb [5645],
& yyComb [5709],
& yyComb [4234],
& yyComb [4446],
& yyComb [5796],
& yyComb [4149],
& yyComb [5351],
& yyComb [4238],
& yyComb [4852],
& yyComb [5883],
& yyComb [5970],
& yyComb [5358],
& yyComb [6057],
& yyComb [4148],
& yyComb [5019],
& yyComb [4244],
& yyComb [6144],
& yyComb [4429],
& yyComb [4436],
& yyComb [5650],
& yyComb [4448],
& yyComb [4616],
& yyComb [5651],
& yyComb [4714],
& yyComb [5370],
& yyComb [6195],
& yyComb [6259],
& yyComb [5656],
& yyComb [4723],
& yyComb [4876],
& yyComb [6318],
& yyComb [6313],
& yyComb [6201],
& yyComb [4758],
& yyComb [4822],
& yyComb [5355],
& yyComb [5652],
& yyComb [4882],
& yyComb [4962],
& yyComb [6351],
& yyComb [6321],
& yyComb [4975],
& yyComb [4842],
& yyComb [6401],
& yyComb [4978],
& yyComb [5017],
& yyComb [6488],
& yyComb [6326],
& yyComb [6575],
& yyComb [6329],
& yyComb [6324],
& yyComb [147],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [5103],
& yyComb [0],
& yyComb [5020],
& yyComb [5033],
& yyComb [0],
& yyComb [5112],
& yyComb [6207],
& yyComb [5101],
& yyComb [5200],
& yyComb [5202],
& yyComb [0],
& yyComb [5195],
& yyComb [5196],
& yyComb [5195],
& yyComb [5289],
& yyComb [5292],
& yyComb [5274],
& yyComb [5290],
& yyComb [5293],
& yyComb [0],
& yyComb [5353],
& yyComb [5348],
& yyComb [0],
& yyComb [5350],
& yyComb [5367],
& yyComb [5379],
& yyComb [5362],
& yyComb [5366],
& yyComb [0],
& yyComb [5440],
& yyComb [5443],
& yyComb [5427],
& yyComb [5434],
& yyComb [5481],
& yyComb [0],
& yyComb [5476],
& yyComb [5485],
& yyComb [5501],
& yyComb [5490],
& yyComb [5582],
& yyComb [0],
& yyComb [5569],
& yyComb [5568],
& yyComb [0],
& yyComb [5574],
& yyComb [5652],
& yyComb [5576],
& yyComb [5643],
& yyComb [5672],
& yyComb [5716],
& yyComb [5720],
& yyComb [0],
& yyComb [5734],
& yyComb [5738],
& yyComb [5771],
& yyComb [5777],
& yyComb [5775],
& yyComb [0],
& yyComb [5878],
& yyComb [5789],
& yyComb [0],
& yyComb [5793],
& yyComb [5873],
& yyComb [0],
& yyComb [5879],
& yyComb [5865],
& yyComb [0],
& yyComb [5965],
& yyComb [5946],
& yyComb [5956],
& yyComb [183],
& yyComb [5950],
& yyComb [6047],
& yyComb [6046],
& yyComb [6045],
& yyComb [6040],
& yyComb [6043],
& yyComb [0],
& yyComb [6134],
& yyComb [6139],
& yyComb [6325],
& yyComb [6126],
& yyComb [6121],
& yyComb [0],
& yyComb [6190],
& yyComb [6201],
& yyComb [0],
& yyComb [6330],
& yyComb [6199],
& yyComb [6214],
& yyComb [6210],
& yyComb [0],
& yyComb [6622],
& yyComb [6336],
& yyComb [0],
& yyComb [6220],
& yyComb [6222],
& yyComb [0],
& yyComb [6396],
& yyComb [6213],
& yyComb [6281],
& yyComb [6341],
& yyComb [0],
& yyComb [6333],
& yyComb [6480],
& yyComb [6344],
& yyComb [6378],
& yyComb [6389],
& yyComb [6379],
& yyComb [0],
& yyComb [6634],
& yyComb [6627],
& yyComb [6480],
& yyComb [6465],
& yyComb [6477],
& yyComb [6555],
& yyComb [6557],
& yyComb [0],
& yyComb [6549],
& yyComb [0],
& yyComb [6564],
& yyComb [6571],
& yyComb [6632],
& yyComb [6625],
& yyComb [6621],
& yyComb [0],
& yyComb [6627],
& yyComb [6630],
& yyComb [6639],
& yyComb [0],
& yyComb [6631],
& yyComb [6626],
& yyComb [6642],
& yyComb [6633],
& yyComb [6645],
& yyComb [6638],
& yyComb [6650],
& yyComb [6650],
& yyComb [6642],
& yyComb [6637],
& yyComb [0],
& yyComb [6641],
& yyComb [6638],
& yyComb [6655],
& yyComb [6647],
& yyComb [6659],
& yyComb [6658],
& yyComb [0],
& yyComb [6687],
& yyComb [6684],
& yyComb [6693],
& yyComb [6685],
& yyComb [6681],
& yyComb [6692],
& yyComb [6687],
& yyComb [6690],
& yyComb [0],
& yyComb [6691],
& yyComb [6705],
& yyComb [6694],
& yyComb [6699],
& yyComb [6706],
& yyComb [0],
& yyComb [6691],
& yyComb [6691],
& yyComb [6695],
& yyComb [6705],
& yyComb [6713],
& yyComb [6695],
& yyComb [6697],
& yyComb [6713],
& yyComb [0],
& yyComb [6717],
& yyComb [6711],
& yyComb [6701],
& yyComb [6704],
& yyComb [6722],
& yyComb [6706],
& yyComb [6700],
& yyComb [0],
& yyComb [6708],
& yyComb [6722],
& yyComb [6757],
& yyComb [6741],
& yyComb [0],
& yyComb [6757],
& yyComb [6749],
& yyComb [186],
& yyComb [6762],
& yyComb [6753],
& yyComb [6751],
& yyComb [6764],
& yyComb [6757],
& yyComb [0],
& yyComb [6744],
& yyComb [6767],
& yyComb [6759],
& yyComb [6763],
& yyComb [6770],
& yyComb [0],
& yyComb [6759],
& yyComb [6772],
& yyComb [6765],
& yyComb [0],
& yyComb [6762],
& yyComb [0],
& yyComb [6758],
& yyComb [6761],
& yyComb [6771],
& yyComb [6779],
& yyComb [6761],
& yyComb [6763],
& yyComb [6779],
& yyComb [0],
& yyComb [6776],
& yyComb [6766],
& yyComb [6779],
& yyComb [0],
& yyComb [6776],
& yyComb [6780],
& yyComb [6783],
& yyComb [6777],
& yyComb [0],
& yyComb [6817],
& yyComb [6811],
& yyComb [0],
& yyComb [6808],
& yyComb [6812],
& yyComb [6825],
& yyComb [6824],
& yyComb [6811],
& yyComb [6812],
& yyComb [6817],
& yyComb [6815],
& yyComb [6815],
& yyComb [0],
& yyComb [6822],
& yyComb [6820],
& yyComb [6825],
& yyComb [6837],
& yyComb [6819],
& yyComb [6835],
& yyComb [0],
& yyComb [6840],
& yyComb [6830],
& yyComb [6824],
& yyComb [6839],
& yyComb [238],
& yyComb [0],
& yyComb [6827],
& yyComb [6825],
& yyComb [6842],
& yyComb [277],
& yyComb [0],
& yyComb [6875],
& yyComb [6866],
& yyComb [6827],
& yyComb [278],
& yyComb [0],
& yyComb [6869],
& yyComb [280],
& yyComb [0],
& yyComb [6830],
& yyComb [281],
& yyComb [0],
& yyComb [6837],
& yyComb [6835],
& yyComb [324],
& yyComb [0],
& yyComb [6836],
& yyComb [327],
& yyComb [0],
& yyComb [6841],
& yyComb [6884],
& yyComb [330],
& yyComb [0],
& yyComb [1669],
& yyComb [0],
& yyComb [335],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [321],
& yyComb [0],
& yyComb [6884],
& yyComb [340],
& yyComb [0],
& yyComb [341],
& yyComb [0],
& yyComb [337],
& yyComb [0],
& yyComb [6887],
& yyComb [355],
& yyComb [0],
& yyComb [357],
& yyComb [0],
& yyComb [402],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [376],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [381],
& yyComb [0],
& yyComb [0],
& yyComb [395],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [568],
& yyComb [0],
& yyComb [690],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [6893],
& yyComb [0],
& yyComb [6885],
& yyComb [6890],
& yyComb [6884],
& yyComb [6892],
& yyComb [0],
& yyComb [6899],
& yyComb [6897],
& yyComb [6881],
& yyComb [6894],
& yyComb [6889],
& yyComb [0],
& yyComb [6892],
& yyComb [6906],
& yyComb [0],
& yyComb [6908],
& yyComb [6943],
& yyComb [6907],
& yyComb [6903],
& yyComb [6915],
& yyComb [0],
& yyComb [6933],
& yyComb [6948],
& yyComb [6947],
& yyComb [6945],
& yyComb [6943],
& yyComb [6951],
& yyComb [0],
& yyComb [6955],
& yyComb [6948],
& yyComb [6941],
& yyComb [6945],
& yyComb [6963],
& yyComb [6962],
& yyComb [6962],
& yyComb [0],
& yyComb [6947],
& yyComb [6960],
& yyComb [6952],
& yyComb [6966],
& yyComb [0],
& yyComb [7003],
& yyComb [6958],
& yyComb [6955],
& yyComb [6970],
& yyComb [0],
& yyComb [6996],
& yyComb [7003],
& yyComb [6963],
& yyComb [0],
& yyComb [7020],
& yyComb [7005],
& yyComb [7002],
& yyComb [6999],
& yyComb [0],
& yyComb [7013],
& yyComb [7005],
& yyComb [7021],
& yyComb [0],
& yyComb [7025],
& yyComb [0],
& yyComb [7025],
& yyComb [7007],
& yyComb [0],
& yyComb [7027],
& yyComb [7019],
& yyComb [7027],
& yyComb [0],
& yyComb [7012],
& yyComb [7021],
& yyComb [7054],
& yyComb [0],
& yyComb [7071],
& yyComb [7059],
& yyComb [7059],
& yyComb [0],
& yyComb [7065],
& yyComb [7060],
& yyComb [7072],
& yyComb [7068],
& yyComb [7062],
& yyComb [7079],
& yyComb [0],
& yyComb [7073],
& yyComb [7074],
& yyComb [7072],
& yyComb [7085],
& yyComb [7088],
& yyComb [7070],
& yyComb [7088],
& yyComb [0],
& yyComb [7083],
& yyComb [7082],
& yyComb [7081],
& yyComb [7094],
& yyComb [7097],
& yyComb [7079],
& yyComb [7104],
& yyComb [0],
& yyComb [7091],
& yyComb [7120],
& yyComb [0],
& yyComb [7131],
& yyComb [7124],
& yyComb [0],
& yyComb [7120],
& yyComb [7131],
& yyComb [7135],
& yyComb [7129],
& yyComb [7131],
& yyComb [7140],
& yyComb [7132],
& yyComb [7127],
& yyComb [0],
& yyComb [7147],
& yyComb [7129],
& yyComb [7135],
& yyComb [7133],
& yyComb [0],
& yyComb [7140],
& yyComb [7128],
& yyComb [0],
& yyComb [7134],
& yyComb [0],
& yyComb [7151],
& yyComb [7148],
& yyComb [7137],
& yyComb [0],
& yyComb [7138],
& yyComb [7158],
& yyComb [0],
& yyComb [7155],
& yyComb [7143],
& yyComb [7149],
& yyComb [7164],
& yyComb [7154],
& yyComb [0],
& yyComb [7158],
& yyComb [7182],
& yyComb [7181],
& yyComb [7193],
& yyComb [7200],
& yyComb [0],
& yyComb [7188],
& yyComb [7203],
& yyComb [7195],
& yyComb [7204],
& yyComb [7190],
& yyComb [7206],
& yyComb [7194],
& yyComb [0],
& yyComb [7200],
& yyComb [7209],
& yyComb [7201],
& yyComb [7197],
& yyComb [7208],
& yyComb [7203],
& yyComb [7205],
& yyComb [0],
& yyComb [7202],
& yyComb [7220],
& yyComb [7197],
& yyComb [0],
& yyComb [7201],
& yyComb [7219],
& yyComb [0],
& yyComb [7208],
& yyComb [7205],
& yyComb [7222],
& yyComb [7215],
& yyComb [7227],
& yyComb [7226],
& yyComb [0],
& yyComb [7232],
& yyComb [7217],
& yyComb [7255],
& yyComb [0],
& yyComb [7262],
& yyComb [7254],
& yyComb [7258],
& yyComb [7265],
& yyComb [0],
& yyComb [7252],
& yyComb [7264],
& yyComb [7267],
& yyComb [7253],
& yyComb [0],
& yyComb [7265],
& yyComb [7261],
& yyComb [7256],
& yyComb [7272],
& yyComb [7260],
& yyComb [0],
& yyComb [7278],
& yyComb [7265],
& yyComb [889],
& yyComb [7262],
& yyComb [7268],
& yyComb [0],
& yyComb [7265],
& yyComb [1142],
& yyComb [7283],
& yyComb [7261],
& yyComb [0],
& yyComb [7286],
& yyComb [7263],
& yyComb [7274],
& yyComb [7269],
& yyComb [7271],
& yyComb [0],
& yyComb [7285],
& yyComb [7280],
& yyComb [7283],
& yyComb [7323],
& yyComb [7316],
& yyComb [0],
& yyComb [7328],
& yyComb [7319],
& yyComb [7327],
& yyComb [0],
& yyComb [7313],
& yyComb [7323],
& yyComb [7316],
& yyComb [0],
& yyComb [7333],
& yyComb [7317],
& yyComb [7327],
& yyComb [7335],
& yyComb [0],
& yyComb [7338],
& yyComb [7324],
& yyComb [7342],
& yyComb [7331],
& yyComb [0],
& yyComb [7325],
& yyComb [7333],
& yyComb [7345],
& yyComb [7329],
& yyComb [7341],
& yyComb [7336],
& yyComb [7338],
& yyComb [0],
& yyComb [7351],
& yyComb [7336],
& yyComb [7340],
& yyComb [7336],
& yyComb [7338],
& yyComb [7350],
& yyComb [7347],
& yyComb [7360],
& yyComb [0],
& yyComb [7383],
& yyComb [7388],
& yyComb [7373],
& yyComb [7377],
& yyComb [7391],
& yyComb [0],
& yyComb [7377],
& yyComb [7381],
& yyComb [7381],
& yyComb [7392],
& yyComb [7380],
& yyComb [7398],
& yyComb [0],
& yyComb [7395],
& yyComb [7391],
& yyComb [7387],
& yyComb [7398],
& yyComb [7405],
& yyComb [0],
& yyComb [7393],
& yyComb [7405],
& yyComb [0],
& yyComb [7406],
& yyComb [0],
& yyComb [7396],
& yyComb [7401],
& yyComb [7409],
& yyComb [7391],
& yyComb [0],
& yyComb [7409],
& yyComb [7408],
& yyComb [7415],
& yyComb [7418],
& yyComb [7409],
& yyComb [0],
& yyComb [7421],
& yyComb [7405],
& yyComb [7424],
& yyComb [7426],
& yyComb [7432],
& yyComb [7451],
& yyComb [7440],
& yyComb [0],
& yyComb [7454],
& yyComb [7442],
& yyComb [0],
& yyComb [0],
& yyComb [7447],
& yyComb [7445],
& yyComb [7463],
& yyComb [7453],
& yyComb [7454],
& yyComb [0],
& yyComb [7461],
& yyComb [0],
& yyComb [7453],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [7464],
& yyComb [7482],
& yyComb [7450],
& yyComb [7469],
& yyComb [7469],
& yyComb [0],
& yyComb [7486],
& yyComb [7464],
& yyComb [7465],
& yyComb [7469],
& yyComb [7473],
& yyComb [7455],
& yyComb [0],
& yyComb [7480],
& yyComb [7470],
& yyComb [7477],
& yyComb [7478],
& yyComb [7513],
& yyComb [7519],
& yyComb [7502],
& yyComb [7518],
& yyComb [0],
& yyComb [7512],
& yyComb [7514],
& yyComb [7512],
& yyComb [7525],
& yyComb [7528],
& yyComb [7510],
& yyComb [7531],
& yyComb [0],
& yyComb [7520],
& yyComb [7515],
& yyComb [7537],
& yyComb [7539],
& yyComb [7522],
& yyComb [0],
& yyComb [7534],
& yyComb [7530],
& yyComb [7541],
& yyComb [0],
& yyComb [7534],
& yyComb [7542],
& yyComb [0],
& yyComb [7546],
& yyComb [7540],
& yyComb [7534],
& yyComb [7541],
& yyComb [7565],
& yyComb [7566],
& yyComb [7566],
& yyComb [0],
& yyComb [7559],
& yyComb [7575],
& yyComb [7568],
& yyComb [7582],
& yyComb [0],
& yyComb [7592],
& yyComb [7573],
& yyComb [7571],
& yyComb [7586],
& yyComb [0],
& yyComb [7576],
& yyComb [7589],
& yyComb [7581],
& yyComb [0],
& yyComb [7613],
& yyComb [7596],
& yyComb [7599],
& yyComb [7577],
& yyComb [0],
& yyComb [7622],
& yyComb [7597],
& yyComb [7590],
& yyComb [7610],
& yyComb [0],
& yyComb [7640],
& yyComb [0],
& yyComb [7639],
& yyComb [7613],
& yyComb [0],
& yyComb [7632],
& yyComb [7638],
& yyComb [7646],
& yyComb [0],
& yyComb [7633],
& yyComb [7637],
& yyComb [7642],
& yyComb [0],
& yyComb [7642],
& yyComb [7642],
& yyComb [0],
& yyComb [7655],
& yyComb [7641],
& yyComb [7669],
& yyComb [7650],
& yyComb [7650],
& yyComb [7668],
& yyComb [0],
& yyComb [7662],
& yyComb [7663],
& yyComb [0],
& yyComb [7658],
& yyComb [7670],
& yyComb [7678],
& yyComb [7678],
& yyComb [0],
& yyComb [7676],
& yyComb [7670],
& yyComb [0],
& yyComb [7692],
& yyComb [0],
& yyComb [7693],
& yyComb [7681],
& yyComb [7699],
& yyComb [0],
& yyComb [0],
& yyComb [7696],
& yyComb [7700],
& yyComb [0],
& yyComb [7695],
& yyComb [7710],
& yyComb [0],
& yyComb [7707],
& yyComb [7704],
& yyComb [7700],
& yyComb [0],
& yyComb [7715],
& yyComb [7714],
& yyComb [7716],
& yyComb [7722],
& yyComb [7722],
& yyComb [7729],
& yyComb [0],
& yyComb [7734],
& yyComb [7721],
& yyComb [1143],
& yyComb [7718],
& yyComb [7724],
& yyComb [0],
& yyComb [7723],
& yyComb [7724],
& yyComb [1146],
& yyComb [7743],
& yyComb [7731],
& yyComb [0],
& yyComb [7757],
& yyComb [7734],
& yyComb [7746],
& yyComb [7741],
& yyComb [7743],
& yyComb [0],
& yyComb [7752],
& yyComb [7764],
& yyComb [7769],
& yyComb [7776],
& yyComb [7771],
& yyComb [7762],
& yyComb [0],
& yyComb [7762],
& yyComb [7775],
& yyComb [7763],
& yyComb [7785],
& yyComb [7775],
& yyComb [7784],
& yyComb [7778],
& yyComb [7793],
& yyComb [7792],
& yyComb [0],
& yyComb [7785],
& yyComb [7794],
& yyComb [7789],
& yyComb [7793],
& yyComb [7784],
& yyComb [7785],
& yyComb [0],
& yyComb [7793],
& yyComb [7792],
& yyComb [7799],
& yyComb [0],
& yyComb [7818],
& yyComb [7810],
& yyComb [7818],
& yyComb [0],
& yyComb [7816],
& yyComb [7812],
& yyComb [7807],
& yyComb [7827],
& yyComb [7818],
& yyComb [0],
& yyComb [7819],
& yyComb [7837],
& yyComb [7829],
& yyComb [7841],
& yyComb [7841],
& yyComb [0],
& yyComb [7846],
& yyComb [7828],
& yyComb [7844],
& yyComb [0],
& yyComb [7848],
& yyComb [7839],
& yyComb [7844],
& yyComb [7853],
& yyComb [0],
& yyComb [7842],
& yyComb [7854],
& yyComb [7857],
& yyComb [7843],
& yyComb [0],
& yyComb [7845],
& yyComb [0],
& yyComb [7854],
& yyComb [7864],
& yyComb [7856],
& yyComb [7852],
& yyComb [7864],
& yyComb [7862],
& yyComb [7870],
& yyComb [0],
& yyComb [7864],
& yyComb [7882],
& yyComb [0],
& yyComb [7880],
& yyComb [7876],
& yyComb [7872],
& yyComb [7887],
& yyComb [7897],
& yyComb [0],
& yyComb [7899],
& yyComb [7888],
& yyComb [7893],
& yyComb [7907],
& yyComb [7898],
& yyComb [0],
& yyComb [7902],
& yyComb [7897],
& yyComb [7899],
& yyComb [7913],
& yyComb [7903],
& yyComb [0],
& yyComb [7919],
& yyComb [7911],
& yyComb [7920],
& yyComb [7906],
& yyComb [7922],
& yyComb [7911],
& yyComb [0],
& yyComb [7910],
& yyComb [7930],
& yyComb [0],
& yyComb [7929],
& yyComb [7913],
& yyComb [7923],
& yyComb [7932],
& yyComb [0],
& yyComb [7927],
& yyComb [7945],
& yyComb [7930],
& yyComb [7942],
& yyComb [7938],
& yyComb [7940],
& yyComb [0],
& yyComb [7953],
& yyComb [7942],
& yyComb [7949],
& yyComb [7947],
& yyComb [7950],
& yyComb [7962],
& yyComb [7958],
& yyComb [7969],
& yyComb [0],
& yyComb [7954],
& yyComb [7958],
& yyComb [7958],
& yyComb [7969],
& yyComb [7957],
& yyComb [7976],
& yyComb [0],
& yyComb [7975],
& yyComb [7974],
& yyComb [7970],
& yyComb [7981],
& yyComb [7988],
& yyComb [0],
& yyComb [7988],
& yyComb [0],
& yyComb [7987],
& yyComb [7977],
& yyComb [7996],
& yyComb [7985],
& yyComb [0],
& yyComb [7998],
& yyComb [7983],
& yyComb [8004],
& yyComb [8009],
& yyComb [7994],
& yyComb [8010],
& yyComb [7999],
& yyComb [0],
& yyComb [8011],
& yyComb [8010],
& yyComb [8021],
& yyComb [8027],
& yyComb [8020],
& yyComb [0],
& yyComb [8022],
& yyComb [8030],
& yyComb [8012],
& yyComb [0],
& yyComb [0],
& yyComb [8033],
& yyComb [8021],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
5,
1,
31,
3,
31,
5,
25,
7,
30,
9,
5,
11,
5,
13,
30,
15,
5,
17,
30,
19,
5,
21,
5,
23,
5,
25,
5,
27,
31,
31,
0,
31,
31,
31,
31,
0,
0,
0,
0,
0,
0,
0,
42,
42,
42,
42,
42,
0,
42,
42,
0,
42,
42,
42,
42,
42,
42,
42,
0,
0,
42,
42,
0,
43,
43,
43,
0,
0,
42,
69,
73,
42,
42,
73,
73,
73,
73,
73,
73,
73,
112,
81,
81,
81,
0,
0,
0,
0,
0,
110,
116,
0,
0,
95,
112,
95,
95,
95,
95,
95,
95,
112,
91,
116,
116,
116,
104,
116,
116,
91,
116,
116,
0,
116,
116,
0,
103,
0,
0,
0,
128,
0,
124,
128,
128,
128,
145,
158,
128,
158,
130,
130,
130,
130,
130,
158,
136,
128,
158,
139,
158,
141,
145,
145,
128,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
121,
159,
163,
163,
0,
186,
0,
0,
0,
167,
167,
0,
170,
170,
170,
0,
174,
163,
163,
0,
163,
165,
180,
176,
184,
163,
163,
0,
163,
187,
161,
189,
193,
161,
165,
166,
167,
167,
177,
0,
198,
0,
0,
0,
202,
202,
0,
205,
205,
205,
205,
0,
210,
210,
210,
210,
210,
210,
210,
210,
210,
0,
220,
220,
220,
220,
0,
225,
225,
225,
0,
229,
229,
229,
229,
229,
229,
0,
0,
237,
0,
239,
242,
0,
242,
242,
0,
0,
268,
0,
0,
249,
268,
268,
273,
0,
254,
0,
256,
0,
258,
258,
258,
258,
258,
0,
0,
242,
271,
0,
273,
254,
268,
275,
0,
276,
268,
268,
279,
279,
252,
279,
283,
281,
0,
283,
283,
283,
283,
287,
287,
283,
290,
290,
295,
296,
287,
287,
283,
297,
297,
297,
297,
281,
283,
303,
0,
0,
306,
306,
306,
0,
310,
310,
310,
0,
314,
0,
316,
0,
0,
281,
0,
321,
0,
321,
326,
0,
326,
326,
326,
326,
0,
0,
326,
0,
334,
334,
338,
0,
323,
321,
326,
331,
331,
341,
332,
347,
326,
0,
325,
338,
321,
321,
321,
326,
334,
348,
326,
341,
326,
321,
368,
373,
373,
373,
373,
370,
370,
373,
370,
373,
370,
370,
0,
0,
0,
0,
72,
61,
57,
55,
53,
47,
42,
31,
158,
373,
116,
50,
49,
46,
0,
54,
52,
50,
49,
45,
44,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
101,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
302,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
180,
180,
180,
180,
180,
34,
180,
180,
180,
180,
34,
180,
180,
180,
180,
34,
180,
180,
34,
180,
180,
34,
180,
180,
180,
34,
180,
180,
34,
180,
180,
180,
34,
373,
0,
373,
0,
0,
0,
373,
0,
180,
180,
34,
180,
34,
373,
0,
180,
180,
34,
180,
34,
373,
0,
34,
0,
373,
0,
0,
34,
0,
373,
0,
0,
373,
0,
0,
0,
0,
0,
0,
373,
0,
373,
0,
0,
0,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
302,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
368,
338,
338,
338,
338,
338,
338,
338,
338,
338,
338,
0,
0,
386,
0,
0,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
370,
386,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
158,
158,
0,
0,
0,
0,
0,
0,
116,
116,
54,
54,
52,
52,
50,
50,
49,
49,
46,
46,
45,
45,
44,
44,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
44,
45,
0,
0,
0,
0,
0,
0,
52,
0,
54,
0,
103,
0,
0,
0,
0,
0,
62,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
103,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
103,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
103,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
54,
52,
0,
0,
45,
44,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
# line 58 "fortran.rex"


#include <math.h>
#include "global.h"             /* verbose_flag */

# ifdef WIN32
# include <io.h>             /* for testing file access */
# else
# include <unistd.h>             /* for testing file access */
# endif

#include "Memory.h"
#include "StringMem.h"
#include "Idents.h"
#include "labels.h"              /* InitLabels, LabelDefine */

#define WORD_LENGTH 2048
#define STRING_LENGTH 2048

int MakeEndDos, EndDoSwitch;

extern double   atof(/* const char *nptr */);  /* import from stdlib.h */

extern int is_assignment;   /* is 1 if there was a = in the line */

/**************************************************************************
*                                                                         *
*  ReservedWordState:  helps to find out if some identifiers are          *
*                      reserved words or not (in state DIST)              *
*                                                                         *
*  0      :  usual state                                                  *
*  1      :  TO can be reserved word after ASSIGN (ASSIGN label TO var)   *
*  2      :  REAL, DOUBLE, INTEGER, CHARACTER, COMPLEX, TYPE              *
*            after IMPLICIT, RECURSIVE                                    *
*  3      :  DATA, INTRINSIC, .... after type specification               *
*  5      :  RESULT after FUNCTION                                        *
*  6      :  THEN, READ, GOTO, ... after IF                               *
*  7      :  OPERATOR, ASSIGNMENT after INTERFACE                         *
*  8      :  ONLY after USE                                               *
*  9      :  WHILE, !PARALLEL, TIMES after DO                             *
*                                                                         *
*  ReservedWordState will be set to 0 at the begin of a new line          *
*                                                                         *
**************************************************************************/

int ReservedWordState;  /* needed for context of parsing/scanner */

#define StateAssign 1
#define StateTypes  2 
#define StateFunc   5   /* RESULT (...) is valid  */
#define StateIf     6   /* after if_expression, then, basic statements */
#define StateInterf 7   /* after INTERFACE   */
#define StateUse    8   /* after USE */
#define StateDo     9   /* after DO */
#define StateElseIf 10  /* after ELSEIF is THEN valid */
#define StateModule 11  /* after MODULE */

void ErrorAttribute (Token, Attribute)
int Token;
tScanAttribute *Attribute;
{
  /* called if a token is inserted ? */

  fprintf (stderr, "ERROR in file %s\n", CurrentSourceName ());

  /* printf("ERROR line = %d, col = %d (HANDLING)\n",
          Attribute->Position.Line, Attribute->Position.Column); */
}

void SetIdentifier ()  /* set identifier representation in scan attribute */

{ int MyLength;
  char MyWord[WORD_LENGTH];
 
  MyLength = GetUpper(MyWord);
  Attribute.Ident=MakeIdent(MyWord,MyLength);
}

#define TokNL             255  /* Zeilenvorschub = Semikolon           */

#define TokIdentifier       1  /* Identifier                           */
#define TokInteger          2  /* Integer-Konstante                    */
#define TokRealLiteral      3  /* Real-Konstante                       */
#define TokDRealLiteral     4  /* Double Real-Konstante                */
#define TokCharLiteral      5  /* Char-Konstante                       */

#define TokLabel            6  /* Integer Label                        */
#define TokUserOp           7  /* User defined Operator                */

#define TokBecomes         10  /*  "="  Zuweisung                      */
#define TokConcatenation   11  /*  "//" Konkatenation                  */
#define TokPAssign         12  /*  "=>" Pointer-Assignment             */
#define TokLParanthesis    13  /*  "(" Klammer auf                     */
#define TokRParanthesis    14  /*  ")" Klammer zu                      */

#define TokAdd             15  /*  "+" numerische Addition             */
#define TokMinus           16  /*  "-" Subtraktion                     */
#define TokStar            17  /*  "*" Multiplikation                  */
#define TokDivide          18  /*  "/" Division                        */
#define TokPow             19  /*  "**" Potenzierung                   */

#define TokColon           20  /*  ":" Doppelpunkt                     */
#define TokComma           21  /*  "," Komma                           */
#define TokQuote           22  /*  Anfuehrungszeichen                  */

#define TokLBracket        23  /*  "["                                 */
#define TokRBracket        24  /*  "]"                                 */
#define TokLStrike         25  /*  "(/"                                */
#define TokRStrike         26  /*  "/)"                                */
#define TokDoubleColon     27  /*  "::"                                */
#define TokPoint           28  /*  "."                                 */
#define TokPercent         29  /*  "%"                                 */

#define TokNotEqual        30  /*  ".NE." ungleich                     */
#define TokEqual           31  /*  ".EQ." , == gleich                  */
#define TokGreater         32  /*  ".GT." groesser als                 */
#define TokGreaterEqual    33  /*  ".GE." groesser gleich              */
#define TokLess            34  /*  ".LT." kleiner                      */
#define TokLessEqual       35  /*  ".LE." kleiner gleich               */

#define TokAnd             36  /*  ".AND." logisches und               */
#define TokOr              37  /*  ".OR."  logisches oder              */
#define TokXor             44  /*  ".XOR." logisch excl.es oder        */
#define TokEquiv           39  /*  ".EQV." logische Aequivalenz        */
#define TokNotEquiv        40  /*  ".NEQV." logische Nicht-Aequivalenz */

#define TokTrue            41  /*  ".TRUE." logisch wahr               */
#define TokFalse           42  /*  ".FALSE." logisch falsch            */
#define TokNot             43  /*  ".NOT."  Negation                   */

#define TokBlockData       45  /*  " BLOCK DATA "                      */
#define TokData            46  /*  " DATA       "                      */
#define TokInclude         47  /*  " INCLUDE    "                      */
#define TokIntrinsic       48  /*  " INTRINSIC  "                      */

#define TokDeclInt         50  /*  "integer <>"                        */
#define TokDeclReal        51  /*  "real <>"                           */
#define TokDeclComplex     52  /*  "complex <>"                        */
#define TokDeclLogical     53  /*  "logical <>"                        */
#define TokDeclCharacter   54  /*  "character <>"                      */
#define TokDeclDouble      55  /*  "double precision"                  */
#define TokDeclCDouble     56  /*  "double complex"                    */

#define TokSave            57  /*  "SAVE"                              */
#define TokImplicit        58  /*  "IMPLICIT"                          */
#define TokExternal        59  /*  "EXTERNAL"                          */
#define TokParameter       60  /*  "PARAMETER"                         */
#define TokDimension       61  /*  "DIMENSION"                         */
#define TokCommon          62  /*  "COMMON"                            */
#define TokEquivalence     63  /*  "EQUIVALENCE"                       */
#define TokProgram         64  /*  "PROGRAM"                           */
#define TokRecursive       65  /*  "RECURSIVE"                         */
#define TokSubroutine      66  /*  "SUBROUTINE"                        */
#define TokFunction        67  /*  "FUNCTION"                          */
#define TokEnd             68  /*  "END"                               */
#define TokDo              69  /*  "DO"                                */
#define TokWhile           70  /*  "WHILE"                             */
#define TokIf              71  /*  "IF"                                */
#define TokThen            72  /*  "THEN"                              */
#define TokElse            73  /*  "ELSE"                              */
#define TokElseIf          74  /*  "ELSEIF"                            */
#define TokEndDo           75  /*  "ENDDO"                             */
#define TokEndIf           76  /*  "ENDIF"                             */
#define TokResult          77  /*  "RESULT"                            */

#define TokAssign          78  /*  "ASSIGN"                            */
#define TokTo              79  /*  "TO"                                */

#define TokCall            80  /*  "CALL"                              */
#define TokContinue        81  /*  "CONTINUE"                          */
#define TokStop            82  /*  "STOP"                              */
#define TokReturn          83  /*  "RETURN"                            */
#define TokFormat          85  /*  "FORMAT"                            */
#define TokFormatString    86  /*   Parameter for Format               */
#define TokGoto            87  /*  "GOTO" or "GO TO"                   */
  
#define TokEntry           88  /*  "ENTRY"                             */

#define TokRead            90  /*  "READ"                              */
#define TokWrite           91  /*  "WRITE"                             */
#define TokPrint           92  /*  "PRINT"                             */
#define TokOpen            93  /*  "OPEN"                              */
#define TokClose           94  /*  "CLOSE"                             */
#define TokInquire         95  /*  "INQUIRE"                           */
#define TokBackspace       96  /*  "BACKSPACE"                         */
#define TokEndfile         97  /*  "ENDFILE"                           */
#define TokRewind          98  /*  "REWIND"                            */

#define TokAllocate       100  /*  "ALLOCATE"                          */
#define TokDeallocate     101  /*  "DEALLOCATE"                        */
#define TokWhere          102  /*  "WHERE"                             */
#define TokEndWhere       103  /*  "ENDWHERE"                          */
#define TokElseWhere      104  /*  "ELSEWHERE"                         */
#define TokSelectCase     105  /*  "SELECT CASE"                       */
#define TokEndSelect      205  /*  "END SELECT"                        */
#define TokCase           106  /*  "CASE"                              */
#define TokDefault        107  /*  "DEFAULT"                           */
#define TokForall         109  /*  "FORALL"                            */
#define TokEndForall      114  /*  "END FORALL"                        */
#define TokIntent         110  /*  "INTENT"                            */
#define TokIn             111  /*  "IN"                                */
#define TokOut            112  /*  "OUT"                               */
#define TokInOut          113  /*  "INOUT"                             */
#define TokCycle          115  /*  "CYCLE"                             */
#define TokExit           116  /*  "EXIT"                              */

#define TokReduce         121  /*  "REDUCE"                            */

#define TokType           130  /*  "TYPE"                              */
#define TokEndType        131  /*  "END TYPE"                          */
#define TokInterface      132  /*  "INTERFACE"                         */
#define TokEndInterface   133  /*  "END INTERFACE"                     */
#define TokModule         134  /*  "MODULE"                            */
#define TokContains       136  /*  "CONTAINS"                          */
#define TokUse            137  /*  "USE"                               */
#define TokOnly           138  /*  "ONLY"                              */

#define TokProcedure      125  /*  "PROCEDURE"                         */
#define TokOperator       126  /*  "OPERATOR"                          */
#define TokAssignment     127  /*  "ASSIGNMENT"                        */

#define TokAllocatable    140  /*  "ALLOCATABLE"                       */
#define TokOptional       141  /*  "OPTIONAL"                          */
#define TokPointer        142  /*  "POINTER"                           */
#define TokTarget         143  /*  "TARGET"                            */
#define TokPublic         144  /*  "PUBLIC"                            */
#define TokPrivate        145  /*  "PRIVATE"                           */
#define TokNameList       147  /*  "NAMELIST"                          */
#define TokSequence       148  /*  "SEQUENCE"                          */

#define TokNullify        146  /*  "NULLIFY"                           */

#define TokPure           180  /*  "PURE"                              */
#define TokExtrinsic      181  /*  "EXTRINSIC (...)"                   */

#define TokDimension1     191  /*  "DIMENSION"                         */
#define TokParameter1     192  /*  "PARAMETER"                         */
#define TokIntent1        193  /*  "INTENT"                            */
#define TokExternal1      194  /*  "EXTERNAL"                          */
#define TokIntrinsic1     195  /*  "INTRINSIC"                         */
#define TokOptional1      196  /*  "OPTIONAL"                          */
#define TokPointer1       197  /*  "POINTER"                           */
#define TokSave1          198  /*  "SAVE"                              */
#define TokTarget1        199  /*  "TARGET"                            */
#define TokData1          200  /*  "DATA"                              */
#define TokPublic1        201  /*  "PUBLIC"                            */
#define TokPrivate1       202  /*  "PRIVATE"                           */
#define TokAllocatable1   203  /*  "ALLOCATABLE"                       */
#define TokArray1         204  /*  "ARRAY"                             */
#define TokSequence1      206  /*  "SEQUENCE"                          */
#define TokLayout1        240  /*  "LAYOUT"                            */
#define TokPassBy1        241  /*  "PASS_BY"                           */
#define TokMapTo1         242  /*  "MAP_TO"                            */

/***********************************************************************
*                                                                      *
*  New Tokens for HPF                                                  *
*                                                                      *
***********************************************************************/

#define TokAlign          151  /*  "ALIGN"                             */
#define TokWith           152  /*  "WITH"                              */
#define TokRealign        153  /*  "REALIGN"                           */
#define TokDistribute     154  /*  "DISTRIBUTE"                        */
#define TokRedistribute   155  /*  "REDISTRIBUTE"                      */
#define TokProcessors     156  /*  "PROCESSORS"                        */
#define TokTemplate       157  /*  "TEMPLATE"                          */
#define TokDynamic        158  /*  "DYNAMIC"                           */
#define TokOnto           159  /*  "ONTO"                              */
#define TokBlock          160  /*  "BLOCK"                             */
#define TokCyclic         161  /*  "CYCLIC"                            */
#define TokNoSequence     162  /*  "NO SEQUENCE"                       */
#define TokHPFSequence    163  /*  "SEQUENCE"                          */
#define TokIndependent    164  /*  "INDEPENDENT"                       */
#define TokResident       165  /*  "RESIDENT"                          */
#define TokOn             166  /*  "ON"                                */
#define TokNew            167  /*  "NEW"                               */
#define TokReduction      168  /*  "REDUCTION"                         */
#define TokInherit        169  /*  "INHERIT"                           */
#define TokHome           170  /*  "HOME"                              */

/***********************************************************************
*                                                                      *
*  New Tokens for HPF2.0                                               *
*                                                                      *
***********************************************************************/

#define TokGenBlock       208  /*  "GEN_BLOCK"                         */
#define TokIndirect       209  /*  "INDIRECT"                          */
#define TokArbitrary      219  /*  "ARBIRTRARY"                        */
#define TokHPFBegin       210  /*  "BEGIN"                             */
#define TokHPFEnd         211  /*  "END"                               */
#define TokTaskRegion     212  /*  "TASK REGION"                       */
#define TokRange          214  /*  "RANGE"                             */
#define TokAll            215  /*  "ALL"                               */
#define TokLayout         216  /*  "LAYOUT"                            */
#define TokPassBy         217  /*  "PASS_BY"                           */
#define TokMapTo          218  /*  "MAP_TO"                            */

/***********************************************************************
*                                                                      *
*  Tokens only needed for new ADP directives                           *
*                                                                      *
***********************************************************************/

#define TokMap            220  /*  "MAP"                               */
#define TokShadow         221  /*  "SHADOW"                            */
#define TokShared         222  /*  "SHARED"                            */
#define TokRMA            223  /*  "RMA"                               */
#define TokTrace          224  /*  "TRACE"                             */
#define TokTree           225  /*  "TREE"                              */
#define TokSelect         226  /*  "SELECT"                            */
#define TokNoVector       227  /*  "NOVECTOR"                          */
#define TokNoConcur       228  /*  "NOCONCUR"                          */
#define TokShort          229  /*  "SHORT"                             */
#define TokExpand         230  /*  "EXPAND"                            */
#define TokVector         231  /*  "VECTOR"                            */
#define TokConcur         232  /*  "CONCUR"                            */
#define TokSkip           233  /*  "SKIP"                              */

/**************************************************************************
*                                                                         *
*  checking whether an identifier is a reserved word or not               *
*                                                                         *
**************************************************************************/

int NoAssign (Token)
int Token;

{ if (is_assignment == 1)

     { SetIdentifier ();
       return (TokIdentifier);
     }
   else
     return (Token);

} /* NoAssign */

int CheckReswd (State, Token)
int State, Token;
{ if (ReservedWordState == State)
     return (Token);
   else
     { SetIdentifier ();
       return (TokIdentifier);
     }
}

int CheckReswd2 (State1, State2, Token)
int State1, State2, Token;
{ if ((ReservedWordState == State1) || (ReservedWordState == State2))
     return (Token);
   else
     { SetIdentifier ();
       return (TokIdentifier);
     }
}

/**************************************************************************
*                                                                         *
*  C o n v e r t i n g  binary/octal/hexadezimal  C o n s t a n t s       *
*                                                                         *
*   Z'FF' -> 255   B"0101"  ->   5  O'777'  -> 511                        *
*   Z"00" ->   0   B"0111"  ->   7  O'333'  -> 219                        *
*                                                                         *
**************************************************************************/

int rep_convert (MyWord, MyLength, base)

char MyWord[];
int  MyLength, base;
{ int number, digit;
  char a;
  int i;

  number = 0;
  for (i=0; i<MyLength;i++)
   { digit = MyWord[i];
     if ((digit >= '0') && (digit <= '9'))
        digit = digit - '0';
      else if ((digit >= 'a') && (digit <= 'f'))
        digit = 10 + digit - 'a';
      else if ((digit >= 'A') && (digit <= 'F'))
        digit = 10 + digit - 'A';
     number = number*base + digit;
   }
  return (number);
}

/**************************************************************************
*                                                                         *
*  S A V I N G    Info on token from BEG                                  *
*                                                                         *
*  SaveBEGToken (token)                                                   *
*                                                                         *
*    - token has been first token of line                                 *
*    - in any case goto state ASS                                         *
*                                                                         *
**************************************************************************/

int BEGToken;
int BEGTokenLength;

void SaveBEGToken (t)
int t;

{ char MyWord[WORD_LENGTH];
  /* printf ("SaveBEGToken (%d)\n", t); */
  BEGToken = t;
  BEGTokenLength  = GetUpper (MyWord);
  Attribute.Ident = MakeIdent(MyWord, BEGTokenLength);
  yyStart (ASS);
}

int GetBEGToken ()
{ /* there was really a token from state BEG */
  if (BEGToken == TokImplicit)      ReservedWordState = StateTypes;
  if (BEGToken == TokRecursive)     ReservedWordState = StateTypes;
  if (BEGToken == TokPure)          ReservedWordState = StateTypes;
  if (BEGToken == TokExtrinsic)     ReservedWordState = StateTypes;
  if (BEGToken == TokAssign)        ReservedWordState = StateAssign;
  if (BEGToken == TokFunction)      ReservedWordState = StateFunc;
  if (BEGToken == TokIf)            ReservedWordState = StateIf;
  if (BEGToken == TokUse)           ReservedWordState = StateUse;
  if (BEGToken == TokDo)            ReservedWordState = StateDo;
  if (BEGToken == TokModule)        ReservedWordState = StateModule;
  return (BEGToken);
}

/**************************************************************************
*                                                                         *
*  IsParNesting                                                           *
*                                                                         *
*   IF (MINFA.LE.0) LFALL(1)=1                                            *
*       xxxxxxxxxxxxxxxxxxx          returns .false.                      *
*                                                                         *
*   IF (IFALL(1) == 0) THEN                                               *
*       xxxxxxxxxx                   returns .false.                      *
*                                                                         *
**************************************************************************/

static int IsParNesting ()

{ char MyWord [WORD_LENGTH];
  char c;
  int  i, MyLength;
  int  ParNest;

  ParNest = 0;

  MyLength = GetWord (MyWord) - 1;

  /* MyWord :  sparce* "=" |  space* "(" ANY* ")" space* "="   */

  for (i=0; i<MyLength; i++)

    { c = MyWord[i];
      if (c == ' ') ParNest = ParNest;  /* mothing to do */
      else if (c == ')') ParNest--;
      else if (c == '(') ParNest++;
      else if (ParNest == 0) return (0);
    }

   /* Myword can also be :  '( a(5) ='  from 'if (a(5) == 0) then ') */

   if (ParNest == 0) return (1);
   return (0);

} /* IsParNesting */

/**************************************************************************
*                                                                         *
*  GetKindIdent :  "123.54_dp"  -> MakeIdent ("dp")                       *
*                                                                         *
**************************************************************************/

static tIdent GetKindIdent (my_word, len)

char *my_word;
int  len;

{ int i, pos;

  pos = 0;
 
  for (i=0; i<len;i++)
     if (my_word[i] == '_') pos = i+1;

  if (pos == 0) return DefaultId();

  /* my_word+pos, ..., my_word+len is the kind string */

  return MakeIdent (my_word+pos, len-pos);

} /* GetKindIdent */

/**************************************************************************
*                                                                         *
*  END Handling                                                           *
*                                                                         *
**************************************************************************/

int EndToken()

{ if (EndDoSwitch == 1)
    { EndDoSwitch = 0;
      return (TokEndDo);
    }
  if (MakeEndDos > 0)
    { MakeEndDos   -= 1;
      EndDoSwitch  = 1;
      return (TokNL);
    }
  return (TokNL);
} /* EndToken */

/**************************************************************************
*                                                                         *
*  Label Handling                                                         *
*                                                                         *
**************************************************************************/

static int TheLabel = 0;

static void SetTheLabel (label)  

int label;

{ if (TheLabel != 0)
     printf ("label %d has been ignored\n", TheLabel);

  LabelDefine (label);  /* sets also MakeEndDos */

  TheLabel = label;

} /* SetTheLabel */

int GetTheLabel ()

{ int label;

  label    = TheLabel;
  TheLabel = 0;

  return (label);

} /* GetTheLabel */


 
int GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
# line 609 "fortran.rex"


  static char MyWord[WORD_LENGTH], 
              StringWord[STRING_LENGTH];
  static int  i, StringLength, MyLength;

   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      TokenLength = yyChBufferIndexReg - (unsigned char *) TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 92:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 716 "fortran.rex"
{ yyStart (HPF);              
} yy1: goto yyBegin;
case 93:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 718 "fortran.rex"
{ yyStart (ADP);              
} yy2: goto yyBegin;
case 91:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 720 "fortran.rex"
{ yyStart(BEG);
                              ReservedWordState = 0;
                              MyLength = GetWord(MyWord);
                              SetTheLabel (atoi((char *) MyWord));
                            
} yy3: goto yyBegin;
case 90:;
case 158:;
case 191:;
case 385:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 726 "fortran.rex"
{ yyStart(BEG);
                              ReservedWordState = 0;
                              yyLess (0);
                            
} yy4: goto yyBegin;
case 1346:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 737 "fortran.rex"
{
} yy5: goto yyBegin;
case 72:;
case 377:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 739 "fortran.rex"
{ yyStart(STD); yyEol(0); return(TokNL);    
} yy6: goto yyBegin;
case 1345:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 747 "fortran.rex"
{ SaveBEGToken (TokDeclInt);       
} yy7: goto yyBegin;
case 1342:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 748 "fortran.rex"
{ SaveBEGToken (TokDeclReal);      
} yy8: goto yyBegin;
case 1341:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 749 "fortran.rex"
{ SaveBEGToken (TokDeclComplex);   
} yy9: goto yyBegin;
case 1337:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 750 "fortran.rex"
{ SaveBEGToken (TokDeclLogical);   
} yy10: goto yyBegin;
case 1331:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 751 "fortran.rex"
{ SaveBEGToken (TokDeclCharacter); 
} yy11: goto yyBegin;
case 88:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 753 "fortran.rex"
{ yyStart (DIST);
                                      return(TokDeclDouble);           
} yy12: goto yyBegin;
case 89:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 756 "fortran.rex"
{ yyStart (DIST);
                                      return(TokDeclCDouble);          
} yy13: goto yyBegin;
case 85:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 758 "fortran.rex"
{ yyStart (DIST);
                                      yyLess (4); 
                                      return(TokType);                 
} yy14: goto yyBegin;
case 1323:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 768 "fortran.rex"
{ SaveBEGToken(TokProgram);        
} yy15: goto yyBegin;
case 1318:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 769 "fortran.rex"
{ SaveBEGToken(TokPure);           
} yy16: goto yyBegin;
case 1316:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 770 "fortran.rex"
{ SaveBEGToken(TokExtrinsic);      
} yy17: goto yyBegin;
case 1310:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 771 "fortran.rex"
{ SaveBEGToken(TokRecursive);      
} yy18: goto yyBegin;
case 1303:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 772 "fortran.rex"
{ SaveBEGToken(TokSubroutine);     
} yy19: goto yyBegin;
case 1294:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 773 "fortran.rex"
{ SaveBEGToken(TokFunction);       
} yy20: goto yyBegin;
case 74:;
case 147:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 774 "fortran.rex"
{ yyStart(DIST);
                                      return(TokBlockData);            
} yy21: goto yyBegin;
case 1287:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 776 "fortran.rex"
{ SaveBEGToken(TokModule);         
} yy22: goto yyBegin;
case 1282:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 784 "fortran.rex"
{ SaveBEGToken(TokData);           
} yy23: goto yyBegin;
case 1279:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 785 "fortran.rex"
{ SaveBEGToken(TokParameter);      
} yy24: goto yyBegin;
case 1272:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 786 "fortran.rex"
{ SaveBEGToken(TokOptional);       
} yy25: goto yyBegin;
case 1266:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 787 "fortran.rex"
{ SaveBEGToken (TokExternal);      
} yy26: goto yyBegin;
case 1260:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 788 "fortran.rex"
{ SaveBEGToken(TokIntrinsic);      
} yy27: goto yyBegin;
case 1254:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 789 "fortran.rex"
{ SaveBEGToken(TokSave);           
} yy28: goto yyBegin;
case 1251:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 790 "fortran.rex"
{ SaveBEGToken(TokDimension);      
} yy29: goto yyBegin;
case 1243:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 791 "fortran.rex"
{ SaveBEGToken(TokIntent);         
} yy30: goto yyBegin;
case 1241:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 792 "fortran.rex"
{ SaveBEGToken(TokTarget);         
} yy31: goto yyBegin;
case 1236:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 793 "fortran.rex"
{ SaveBEGToken(TokPublic);         
} yy32: goto yyBegin;
case 1231:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 794 "fortran.rex"
{ SaveBEGToken(TokPrivate);        
} yy33: goto yyBegin;
case 1227:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 795 "fortran.rex"
{ SaveBEGToken(TokSequence);       
} yy34: goto yyBegin;
case 1221:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 796 "fortran.rex"
{ SaveBEGToken(TokPointer);        
} yy35: goto yyBegin;
case 1215:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 797 "fortran.rex"
{ SaveBEGToken(TokAllocatable);    
} yy36: goto yyBegin;
case 1211:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 799 "fortran.rex"
{ SaveBEGToken(TokCommon);         
} yy37: goto yyBegin;
case 1207:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 800 "fortran.rex"
{ SaveBEGToken(TokNameList);       
} yy38: goto yyBegin;
case 1200:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 801 "fortran.rex"
{ SaveBEGToken(TokEquivalence);    
} yy39: goto yyBegin;
case 1190:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 802 "fortran.rex"
{ SaveBEGToken(TokImplicit);       
} yy40: goto yyBegin;
case 87:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 803 "fortran.rex"
{ yyStart (Incl1);                 
} yy41: goto yyBegin;
case 86:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 804 "fortran.rex"
{ yyStart (Incl2);                 
} yy42: goto yyBegin;
case 1183:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 806 "fortran.rex"
{ SaveBEGToken(TokLayout);         
} yy43: goto yyBegin;
case 1177:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 807 "fortran.rex"
{ SaveBEGToken(TokPassBy);         
} yy44: goto yyBegin;
case 1171:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 808 "fortran.rex"
{ SaveBEGToken(TokMapTo);          
} yy45: goto yyBegin;
case 253:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 816 "fortran.rex"
{ SaveBEGToken(TokType);           
} yy46: goto yyBegin;
case 80:;
case 153:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 817 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndType);              
} yy47: goto yyBegin;
case 1165:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 819 "fortran.rex"
{ SaveBEGToken(TokInterface);      
} yy48: goto yyBegin;
case 82:;
case 155:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 820 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndInterface);         
} yy49: goto yyBegin;
case 1158:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 822 "fortran.rex"
{ SaveBEGToken(TokContains);       
} yy50: goto yyBegin;
case 1154:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 823 "fortran.rex"
{ SaveBEGToken(TokUse);            
} yy51: goto yyBegin;
case 356:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 825 "fortran.rex"
{ SaveBEGToken(TokDo);              
} yy52: goto yyBegin;
case 83:;
case 156:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 827 "fortran.rex"
{ yyStart (DIST);
                                      if (MakeEndDos > 0)
                                         return (TokContinue);
                                       else
                                         return(TokEndDo);             
} yy53: goto yyBegin;
case 1151:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 833 "fortran.rex"
{ SaveBEGToken(TokForall);         
} yy54: goto yyBegin;
case 84:;
case 157:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 834 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndForall);            
} yy55: goto yyBegin;
case 1148:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 837 "fortran.rex"
{ SaveBEGToken(TokIf);             
} yy56: goto yyBegin;
case 127:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 838 "fortran.rex"
{ SaveBEGToken(TokElse);           
} yy57: goto yyBegin;
case 77:;
case 150:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 839 "fortran.rex"
{ yyStart (DIST);
                                      ReservedWordState = StateElseIf;
                                      return(TokElseIf);               
} yy58: goto yyBegin;
case 81:;
case 154:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 842 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndIf);                
} yy59: goto yyBegin;
case 1147:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 845 "fortran.rex"
{ SaveBEGToken(TokWhere);          
} yy60: goto yyBegin;
case 76:;
case 149:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 846 "fortran.rex"
{ yyStart (DIST);
                                      return(TokElseWhere);            
} yy61: goto yyBegin;
case 78:;
case 151:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 848 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndWhere);             
} yy62: goto yyBegin;
case 73:;
case 146:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 851 "fortran.rex"
{ SaveBEGToken(TokSelectCase);     
} yy63: goto yyBegin;
case 79:;
case 152:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 853 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndSelect);            
} yy64: goto yyBegin;
case 1143:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 856 "fortran.rex"
{ SaveBEGToken(TokCase);           
} yy65: goto yyBegin;
case 1141:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 858 "fortran.rex"
{ SaveBEGToken(TokEntry);          
} yy66: goto yyBegin;
case 126:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 860 "fortran.rex"
{ yyStart (DIST);
                                      return (NoAssign(TokEnd));       
} yy67: goto yyBegin;
case 1138:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 869 "fortran.rex"
{ SaveBEGToken(TokAssign);         
} yy68: goto yyBegin;
case 1133:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 870 "fortran.rex"
{ SaveBEGToken(TokCall);           
} yy69: goto yyBegin;
case 1130:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 871 "fortran.rex"
{ SaveBEGToken(TokContinue);       
} yy70: goto yyBegin;
case 1123:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 872 "fortran.rex"
{ SaveBEGToken(TokStop);           
} yy71: goto yyBegin;
case 1120:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 873 "fortran.rex"
{ SaveBEGToken(TokReturn);         
} yy72: goto yyBegin;
case 75:;
case 148:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 874 "fortran.rex"
{ yyStart (DIST);
                                      return(TokGoto);                 
} yy73: goto yyBegin;
case 1116:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 876 "fortran.rex"
{ SaveBEGToken(TokCycle);          
} yy74: goto yyBegin;
case 1112:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 877 "fortran.rex"
{ SaveBEGToken(TokExit);           
} yy75: goto yyBegin;
case 1109:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 879 "fortran.rex"
{ SaveBEGToken(TokRead);           
} yy76: goto yyBegin;
case 1107:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 880 "fortran.rex"
{ SaveBEGToken(TokWrite);          
} yy77: goto yyBegin;
case 1102:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 881 "fortran.rex"
{ SaveBEGToken(TokPrint);          
} yy78: goto yyBegin;
case 1097:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 882 "fortran.rex"
{ SaveBEGToken(TokOpen);           
} yy79: goto yyBegin;
case 1093:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 883 "fortran.rex"
{ SaveBEGToken(TokClose);          
} yy80: goto yyBegin;
case 1088:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 884 "fortran.rex"
{ SaveBEGToken(TokInquire);        
} yy81: goto yyBegin;
case 1083:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 885 "fortran.rex"
{ SaveBEGToken(TokBackspace);      
} yy82: goto yyBegin;
case 1075:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 886 "fortran.rex"
{ SaveBEGToken(TokEndfile);        
} yy83: goto yyBegin;
case 1072:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 887 "fortran.rex"
{ SaveBEGToken(TokRewind);         
} yy84: goto yyBegin;
case 1068:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 889 "fortran.rex"
{ yyStart (FORMAT);
                                      StringLength = 0;
                                      return (TokFormat);              
} yy85: goto yyBegin;
case 1062:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 892 "fortran.rex"
{ SaveBEGToken(TokAllocate);       
} yy86: goto yyBegin;
case 1054:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 893 "fortran.rex"
{ SaveBEGToken(TokDeallocate);     
} yy87: goto yyBegin;
case 1045:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 894 "fortran.rex"
{ SaveBEGToken(TokNullify);        
} yy88: goto yyBegin;
case 1038:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 895 "fortran.rex"
{ SaveBEGToken(TokReduce);         
} yy89: goto yyBegin;
case 71:;
case 123:;
case 124:;
case 125:;
case 128:;
case 129:;
case 130:;
case 131:;
case 132:;
case 133:;
case 134:;
case 135:;
case 136:;
case 137:;
case 138:;
case 139:;
case 140:;
case 141:;
case 142:;
case 143:;
case 144:;
case 145:;
case 189:;
case 190:;
case 287:;
case 288:;
case 289:;
case 290:;
case 291:;
case 292:;
case 293:;
case 294:;
case 295:;
case 296:;
case 297:;
case 298:;
case 299:;
case 300:;
case 301:;
case 325:;
case 326:;
case 327:;
case 328:;
case 329:;
case 330:;
case 331:;
case 332:;
case 333:;
case 334:;
case 335:;
case 336:;
case 341:;
case 342:;
case 343:;
case 344:;
case 345:;
case 346:;
case 347:;
case 348:;
case 349:;
case 354:;
case 355:;
case 357:;
case 358:;
case 359:;
case 366:;
case 367:;
case 369:;
case 370:;
case 371:;
case 372:;
case 1033:;
case 1034:;
case 1035:;
case 1036:;
case 1037:;
case 1039:;
case 1040:;
case 1041:;
case 1042:;
case 1043:;
case 1044:;
case 1046:;
case 1047:;
case 1048:;
case 1049:;
case 1050:;
case 1051:;
case 1052:;
case 1053:;
case 1055:;
case 1056:;
case 1057:;
case 1058:;
case 1059:;
case 1060:;
case 1061:;
case 1063:;
case 1064:;
case 1065:;
case 1066:;
case 1067:;
case 1069:;
case 1070:;
case 1071:;
case 1073:;
case 1074:;
case 1076:;
case 1077:;
case 1078:;
case 1079:;
case 1080:;
case 1081:;
case 1082:;
case 1084:;
case 1085:;
case 1086:;
case 1087:;
case 1089:;
case 1090:;
case 1091:;
case 1092:;
case 1094:;
case 1095:;
case 1096:;
case 1098:;
case 1099:;
case 1100:;
case 1101:;
case 1103:;
case 1104:;
case 1105:;
case 1106:;
case 1108:;
case 1110:;
case 1111:;
case 1113:;
case 1114:;
case 1115:;
case 1117:;
case 1118:;
case 1119:;
case 1121:;
case 1122:;
case 1124:;
case 1125:;
case 1126:;
case 1127:;
case 1128:;
case 1129:;
case 1131:;
case 1132:;
case 1134:;
case 1135:;
case 1136:;
case 1137:;
case 1139:;
case 1140:;
case 1142:;
case 1144:;
case 1145:;
case 1146:;
case 1149:;
case 1150:;
case 1152:;
case 1153:;
case 1155:;
case 1156:;
case 1157:;
case 1159:;
case 1160:;
case 1161:;
case 1162:;
case 1163:;
case 1164:;
case 1166:;
case 1167:;
case 1168:;
case 1169:;
case 1170:;
case 1172:;
case 1173:;
case 1174:;
case 1175:;
case 1176:;
case 1178:;
case 1179:;
case 1180:;
case 1181:;
case 1182:;
case 1184:;
case 1185:;
case 1186:;
case 1187:;
case 1188:;
case 1189:;
case 1191:;
case 1192:;
case 1193:;
case 1194:;
case 1195:;
case 1196:;
case 1197:;
case 1198:;
case 1199:;
case 1201:;
case 1202:;
case 1203:;
case 1204:;
case 1205:;
case 1206:;
case 1208:;
case 1209:;
case 1210:;
case 1212:;
case 1213:;
case 1214:;
case 1216:;
case 1217:;
case 1218:;
case 1219:;
case 1220:;
case 1222:;
case 1223:;
case 1224:;
case 1225:;
case 1226:;
case 1228:;
case 1229:;
case 1230:;
case 1232:;
case 1233:;
case 1234:;
case 1235:;
case 1237:;
case 1238:;
case 1239:;
case 1240:;
case 1242:;
case 1244:;
case 1245:;
case 1246:;
case 1247:;
case 1248:;
case 1249:;
case 1250:;
case 1252:;
case 1253:;
case 1255:;
case 1256:;
case 1257:;
case 1258:;
case 1259:;
case 1261:;
case 1262:;
case 1263:;
case 1264:;
case 1265:;
case 1267:;
case 1268:;
case 1269:;
case 1270:;
case 1271:;
case 1273:;
case 1274:;
case 1275:;
case 1276:;
case 1277:;
case 1278:;
case 1280:;
case 1281:;
case 1283:;
case 1284:;
case 1285:;
case 1286:;
case 1288:;
case 1289:;
case 1290:;
case 1291:;
case 1292:;
case 1293:;
case 1295:;
case 1296:;
case 1297:;
case 1298:;
case 1299:;
case 1300:;
case 1301:;
case 1302:;
case 1304:;
case 1305:;
case 1306:;
case 1307:;
case 1308:;
case 1309:;
case 1311:;
case 1312:;
case 1313:;
case 1314:;
case 1315:;
case 1317:;
case 1319:;
case 1320:;
case 1321:;
case 1322:;
case 1324:;
case 1325:;
case 1326:;
case 1327:;
case 1328:;
case 1329:;
case 1330:;
case 1332:;
case 1333:;
case 1334:;
case 1335:;
case 1336:;
case 1338:;
case 1339:;
case 1340:;
case 1343:;
case 1344:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 897 "fortran.rex"
{ SaveBEGToken(TokIdentifier);     
} yy90: goto yyBegin;
case 45:;
case 396:;
# line 905 "fortran.rex"
{ MyLength = GetWord (MyWord);
                         Attribute.StringConst =
                             PutString (MyWord, MyLength); 
} yy91: goto yyBegin;
case 1032:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 909 "fortran.rex"
{  BeginFile (MyWord);
                   yyStart (STD); 
                
} yy92: goto yyBegin;
case 44:;
case 397:;
# line 913 "fortran.rex"
{ MyLength = GetWord (MyWord);
                         Attribute.StringConst =
                             PutString (MyWord, MyLength); 
} yy93: goto yyBegin;
case 1031:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 917 "fortran.rex"
{  BeginFile (MyWord);
                   yyStart (STD); 
                
} yy94: goto yyBegin;
case 1030:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 927 "fortran.rex"
{
} yy95: goto yyBegin;
case 63:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 929 "fortran.rex"
{ yyEol (0);                         
} yy96: goto yyBegin;
case 1029:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 931 "fortran.rex"
{ yyStart (BEG);
                                       return (TokNL);
                                     
} yy97: goto yyBegin;
case 61:;
case 378:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 947 "fortran.rex"
{ if (yyEof)
                                      return (TokNL);
                                    else
                                      { yyEol (0); 
                                        yyStart (ENDS); 
                                      }
                                 
} yy98: goto yyBegin;
case 47:;
case 382:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 963 "fortran.rex"
{ if (yyEof)
                                      return (TokNL);
                                    else
                                      yyEol (0); 
                                 
} yy99: goto yyBegin;
case 48:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 969 "fortran.rex"
{ if ((MakeEndDos == 0) && (EndDoSwitch == 0))
                       { yyStart (ADP);  /* directive can be accepted now */ }
                     else
                       { yyLess (0); }      /* do not use characters         */
                    return (EndToken());
                  
} yy100: goto yyBegin;
case 46:;
case 114:;
case 115:;
case 390:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 978 "fortran.rex"
{  yyLess (0);
                                   if ((MakeEndDos == 0) && (EndDoSwitch == 0))
                                      yyStart (STD);
                                   return (EndToken());
                                
} yy101: goto yyBegin;
case 19:;
case 20:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 984 "fortran.rex"
{  printf ("empty at ends\n");
                                   if ((MakeEndDos == 0) && (EndDoSwitch == 0))
                                      yyStart (STD);
                                   return (EndToken());
                                
} yy102: goto yyBegin;
case 60:;
# line 1003 "fortran.rex"
{ /* was a reserved word, PUBLIC, PRIVATE, ... */

                        yyLess  (0);
                        yyStart (DIST);
                        return  (GetBEGToken());                    
} yy103: goto yyBegin;
case 58:;
# line 1009 "fortran.rex"
{ /* not a reserved word, will be a construct id  */

                       yyLess  (0);      /* = to be scanned againg */
                       yyStart (NAMED);
                       return  (TokIdentifier);                     
} yy104: goto yyBegin;
case 59:;
case 117:;
# line 1020 "fortran.rex"
{ /* not a reserved word, will be an assign */

                     if (IsParNesting ())
                       { yyLess (0);
                         yyStart (DIST);
                         return  (TokIdentifier);                    
                       }
                      else
                       { yyLess (0);
                         yyStart (DIST);
                         return  (GetBEGToken());                    
                       }
                   
} yy105: goto yyBegin;
case 57:;
case 379:;
# line 1034 "fortran.rex"
{ /* it was a reserved word */

                     yyEol   (0);
                     yyStart (ENDS);
                     return  (GetBEGToken());                     
} yy106: goto yyBegin;
case 56:;
case 116:;
case 186:;
case 387:;
# line 1040 "fortran.rex"
{ /* token form BEG was a reserved word */
                     yyLess  (0);
                     yyStart (DIST);
                     return  (GetBEGToken());                     
} yy107: goto yyBegin;
case 1028:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1056 "fortran.rex"
{ return (TokColon);         
} yy108: goto yyBegin;
case 1027:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1058 "fortran.rex"
{ yyStart (DIST);
                             return (TokDo);            
} yy109: goto yyBegin;
case 1025:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1061 "fortran.rex"
{ yyStart (DIST);
                             return (TokIf);            
} yy110: goto yyBegin;
case 1023:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1064 "fortran.rex"
{ yyStart (DIST);
                             return (TokForall);        
} yy111: goto yyBegin;
case 70:;
case 122:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1067 "fortran.rex"
{ yyStart (DIST);
                                        return(TokSelectCase);     
} yy112: goto yyBegin;
case 69:;
case 121:;
case 187:;
case 188:;
case 303:;
case 304:;
case 337:;
case 338:;
case 350:;
case 365:;
case 1018:;
case 1019:;
case 1020:;
case 1021:;
case 1022:;
case 1024:;
case 1026:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1070 "fortran.rex"
{ SetIdentifier ();
                                        return (TokIdentifier); 
} yy113: goto yyBegin;
case 1017:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1081 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclReal));      
} yy114: goto yyBegin;
case 1016:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1082 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclInt));       
} yy115: goto yyBegin;
case 1013:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1083 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclCharacter)); 
} yy116: goto yyBegin;
case 1005:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1084 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclLogical));   
} yy117: goto yyBegin;
case 999:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1085 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclComplex));   
} yy118: goto yyBegin;
case 67:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1087 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclDouble)); 
} yy119: goto yyBegin;
case 68:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1089 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclCDouble)); 
} yy120: goto yyBegin;
case 994:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1090 "fortran.rex"
{ return(CheckReswd(StateTypes,TokPure)); 
} yy121: goto yyBegin;
case 992:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1091 "fortran.rex"
{ return(CheckReswd(StateTypes,TokType));   
} yy122: goto yyBegin;
case 989:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1092 "fortran.rex"
{ return(CheckReswd(StateTypes,TokExtrinsic)); 
} yy123: goto yyBegin;
case 983:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1093 "fortran.rex"
{ return(CheckReswd(StateTypes,TokRecursive)); 
} yy124: goto yyBegin;
case 976:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1097 "fortran.rex"
{ return(CheckReswd(StateModule,TokProcedure)); 
} yy125: goto yyBegin;
case 970:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1102 "fortran.rex"
{ return(TokSubroutine);           
} yy126: goto yyBegin;
case 961:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1103 "fortran.rex"
{ ReservedWordState = StateFunc;
                                       return(TokFunction);             
} yy127: goto yyBegin;
case 953:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1105 "fortran.rex"
{ return(TokProgram);              
} yy128: goto yyBegin;
case 948:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1106 "fortran.rex"
{ return(TokModule);               
} yy129: goto yyBegin;
case 64:;
case 118:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1107 "fortran.rex"
{ return(TokBlockData);            
} yy130: goto yyBegin;
case 943:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1109 "fortran.rex"
{ return(CheckReswd(StateFunc,TokResult));      
} yy131: goto yyBegin;
case 939:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1117 "fortran.rex"
{ return(TokAllocatable1);
} yy132: goto yyBegin;
case 935:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1118 "fortran.rex"
{ return(TokOptional1);   
} yy133: goto yyBegin;
case 929:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1119 "fortran.rex"
{ return(TokLayout1);     
} yy134: goto yyBegin;
case 923:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1120 "fortran.rex"
{ return(TokPassBy1);     
} yy135: goto yyBegin;
case 918:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1121 "fortran.rex"
{ return(TokMapTo1);      
} yy136: goto yyBegin;
case 912:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1122 "fortran.rex"
{ return(TokPointer1);    
} yy137: goto yyBegin;
case 906:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1123 "fortran.rex"
{ return(TokTarget1);     
} yy138: goto yyBegin;
case 901:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1124 "fortran.rex"
{ return(TokPublic1);     
} yy139: goto yyBegin;
case 896:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1125 "fortran.rex"
{ return(TokPrivate1);    
} yy140: goto yyBegin;
case 892:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1126 "fortran.rex"
{ return(TokSequence1);   
} yy141: goto yyBegin;
case 885:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1127 "fortran.rex"
{ return(TokSave1);       
} yy142: goto yyBegin;
case 882:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1128 "fortran.rex"
{ return(TokArray1);      
} yy143: goto yyBegin;
case 878:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1129 "fortran.rex"
{ return(TokDimension1);  
} yy144: goto yyBegin;
case 870:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1130 "fortran.rex"
{ return(TokParameter1);  
} yy145: goto yyBegin;
case 862:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1131 "fortran.rex"
{ return(TokIntrinsic1);  
} yy146: goto yyBegin;
case 856:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1132 "fortran.rex"
{ return(TokExternal1);   
} yy147: goto yyBegin;
case 850:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1133 "fortran.rex"
{ return(TokData1);       
} yy148: goto yyBegin;
case 847:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1134 "fortran.rex"
{ return(TokIntent1);     
} yy149: goto yyBegin;
case 160:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1138 "fortran.rex"
{ return(TokIn);                 
} yy150: goto yyBegin;
case 66:;
case 120:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1139 "fortran.rex"
{ return(TokInOut);              
} yy151: goto yyBegin;
case 843:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1140 "fortran.rex"
{ return(TokOut);                
} yy152: goto yyBegin;
case 841:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1150 "fortran.rex"
{ return(CheckReswd(StateUse,TokOnly));       
} yy153: goto yyBegin;
case 838:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1159 "fortran.rex"
{ return(TokOperator);   
} yy154: goto yyBegin;
case 833:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1160 "fortran.rex"
{ return(TokAssignment); 
} yy155: goto yyBegin;
case 824:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1172 "fortran.rex"
{ return(CheckReswd2 (StateIf,
                                            StateElseIf, TokThen));       
} yy156: goto yyBegin;
case 821:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1175 "fortran.rex"
{ return(CheckReswd(StateIf,TokCall));       
} yy157: goto yyBegin;
case 818:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1176 "fortran.rex"
{ return(CheckReswd(StateIf,TokAllocate));   
} yy158: goto yyBegin;
case 810:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1177 "fortran.rex"
{ return(CheckReswd(StateIf,TokDeallocate)); 
} yy159: goto yyBegin;
case 802:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1178 "fortran.rex"
{ return(CheckReswd(StateIf,TokContinue));   
} yy160: goto yyBegin;
case 795:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1179 "fortran.rex"
{ return(CheckReswd(StateIf,TokStop));       
} yy161: goto yyBegin;
case 791:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1180 "fortran.rex"
{ return(CheckReswd(StateIf,TokReturn));     
} yy162: goto yyBegin;
case 65:;
case 119:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1181 "fortran.rex"
{ return(CheckReswd(StateIf,TokGoto));       
} yy163: goto yyBegin;
case 787:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1183 "fortran.rex"
{ return(CheckReswd(StateIf,TokCycle));      
} yy164: goto yyBegin;
case 783:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1184 "fortran.rex"
{ return(CheckReswd(StateIf,TokExit));       
} yy165: goto yyBegin;
case 780:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1186 "fortran.rex"
{ return(CheckReswd(StateIf,TokRead));       
} yy166: goto yyBegin;
case 778:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1187 "fortran.rex"
{ return(CheckReswd(StateIf,TokWrite));      
} yy167: goto yyBegin;
case 774:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1188 "fortran.rex"
{ return(CheckReswd(StateIf,TokPrint));      
} yy168: goto yyBegin;
case 769:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1189 "fortran.rex"
{ return(CheckReswd(StateIf,TokOpen));       
} yy169: goto yyBegin;
case 765:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1190 "fortran.rex"
{ return(CheckReswd(StateIf,TokClose));      
} yy170: goto yyBegin;
case 760:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1191 "fortran.rex"
{ return(CheckReswd(StateIf,TokInquire));    
} yy171: goto yyBegin;
case 755:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1192 "fortran.rex"
{ return(CheckReswd(StateIf,TokBackspace));  
} yy172: goto yyBegin;
case 747:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1193 "fortran.rex"
{ return(CheckReswd(StateIf,TokEndfile));    
} yy173: goto yyBegin;
case 740:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1194 "fortran.rex"
{ return(CheckReswd(StateIf,TokRewind));     
} yy174: goto yyBegin;
case 734:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1197 "fortran.rex"
{ return(CheckReswd(StateIf,TokWhere));      
} yy175: goto yyBegin;
case 731:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1203 "fortran.rex"
{ return(TokDefault);        
} yy176: goto yyBegin;
case 725:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1211 "fortran.rex"
{ return(CheckReswd(StateDo,TokWhile));        
} yy177: goto yyBegin;
case 720:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1215 "fortran.rex"
{ return (CheckReswd (StateAssign, TokTo));    
} yy178: goto yyBegin;
case 62:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1217 "fortran.rex"
{
} yy179: goto yyBegin;
case 718:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1219 "fortran.rex"
{ StringLength = 0;
               yyStart (String1); 
} yy180: goto yyBegin;
case 717:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1222 "fortran.rex"
{ StringLength = 0;
                  yyStart (String2); 
} yy181: goto yyBegin;
case 54:;
case 392:;
# line 1232 "fortran.rex"
{ MyLength = GetWord (MyWord); 
                       if (MyLength >= WORD_LENGTH) 
                         { printf ("Scanner fatal error: too long word %d  = %s \n",
                                   MyLength, MyWord);
                           exit (-1);
                         }
                       if (StringLength + MyLength >= STRING_LENGTH) 
                         { printf ("Scanner fatal error: too long string");
                           printf ("length %d + %d >= %d\n", StringLength,
                                    MyLength, STRING_LENGTH);
                           exit (-1);
                         }
                       for (i=0; i<MyLength; i++) 
                          StringWord[StringLength+i] = MyWord[i];
                       StringLength += MyLength; 
} yy182: goto yyBegin;
case 55:;
case 380:;
# line 1248 "fortran.rex"
{ printf ("error: string exceeds line\n");
                  SourceFileErrors += 1;
                  yyPrevious;
                  Attribute.StringConst = PutString (StringWord, StringLength);
                  return (TokCharLiteral); 
                
} yy183: goto yyBegin;
case 716:;
# line 1255 "fortran.rex"
{ StringWord[StringLength] = 39;
                       StringLength += 1;             
} yy184: goto yyBegin;
case 715:;
# line 1258 "fortran.rex"
{ yyPrevious;
                 Attribute.StringConst = PutString (StringWord, StringLength);
                 return (TokCharLiteral); 
} yy185: goto yyBegin;
case 52:;
case 393:;
# line 1262 "fortran.rex"
{ MyLength = GetWord (MyWord); 
                       for (i=0; i<MyLength; i++) 
                          StringWord[StringLength+i] = MyWord[i];
                       StringLength += MyLength; 
} yy186: goto yyBegin;
case 53:;
case 381:;
# line 1267 "fortran.rex"
{ printf ("error: string exceeds line\n");
                  SourceFileErrors += 1;
                  yyPrevious;
                  Attribute.StringConst = PutString (StringWord, StringLength);
                  return (TokCharLiteral); 
                
} yy187: goto yyBegin;
case 714:;
# line 1274 "fortran.rex"
{ StringWord[StringLength] = 34;
                                StringLength += 1;             
} yy188: goto yyBegin;
case 713:;
# line 1277 "fortran.rex"
{ yyPrevious;
                 Attribute.StringConst = PutString (StringWord, StringLength);
                 return (TokCharLiteral); 
} yy189: goto yyBegin;
case 712:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1289 "fortran.rex"
{ return(TokPercent);              
} yy190: goto yyBegin;
case 706:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1291 "fortran.rex"
{ return(TokLParanthesis);         
} yy191: goto yyBegin;
case 711:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1292 "fortran.rex"
{ return(TokRParanthesis);         
} yy192: goto yyBegin;
case 703:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1293 "fortran.rex"
{ return(TokColon);                
} yy193: goto yyBegin;
case 710:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1294 "fortran.rex"
{ return(TokComma);                
} yy194: goto yyBegin;
case 709:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1296 "fortran.rex"
{ return(TokLBracket);             
} yy195: goto yyBegin;
case 708:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1297 "fortran.rex"
{ return(TokRBracket);             
} yy196: goto yyBegin;
case 707:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1298 "fortran.rex"
{ return(TokLBracket);             
} yy197: goto yyBegin;
case 705:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1299 "fortran.rex"
{ return(TokRBracket);             
} yy198: goto yyBegin;
case 704:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1301 "fortran.rex"
{ ReservedWordState = 0; /* no reserved words */
                                  return(TokDoubleColon);          
} yy199: goto yyBegin;
case 694:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1310 "fortran.rex"
{ return(TokBecomes);              
} yy200: goto yyBegin;
case 702:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1311 "fortran.rex"
{ return(TokPAssign);              
} yy201: goto yyBegin;
case 182:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1319 "fortran.rex"
{ return(TokPoint);                
} yy202: goto yyBegin;
case 701:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1327 "fortran.rex"
{ return(TokNotEqual);             
} yy203: goto yyBegin;
case 700:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1328 "fortran.rex"
{ return(TokNotEqual);             
} yy204: goto yyBegin;
case 699:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1330 "fortran.rex"
{ return(TokNotEqual);             
} yy205: goto yyBegin;
case 697:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1332 "fortran.rex"
{ return(TokNotEqual);             
} yy206: goto yyBegin;
case 696:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1333 "fortran.rex"
{ return(TokEqual);                
} yy207: goto yyBegin;
case 695:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1334 "fortran.rex"
{ return(TokEqual);                
} yy208: goto yyBegin;
case 693:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1335 "fortran.rex"
{ return(TokGreater);              
} yy209: goto yyBegin;
case 687:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1336 "fortran.rex"
{ return(TokGreater);              
} yy210: goto yyBegin;
case 691:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1337 "fortran.rex"
{ return(TokGreaterEqual);         
} yy211: goto yyBegin;
case 688:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1338 "fortran.rex"
{ return(TokGreaterEqual);         
} yy212: goto yyBegin;
case 686:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1339 "fortran.rex"
{ return(TokLess);                 
} yy213: goto yyBegin;
case 680:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1340 "fortran.rex"
{ return(TokLess);                 
} yy214: goto yyBegin;
case 684:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1341 "fortran.rex"
{ return(TokLessEqual);            
} yy215: goto yyBegin;
case 681:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1342 "fortran.rex"
{ return(TokLessEqual);            
} yy216: goto yyBegin;
case 679:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1344 "fortran.rex"
{ return(TokAdd);                  
} yy217: goto yyBegin;
case 678:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1345 "fortran.rex"
{ return(TokMinus);                
} yy218: goto yyBegin;
case 676:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1346 "fortran.rex"
{ return(TokStar);                 
} yy219: goto yyBegin;
case 674:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1347 "fortran.rex"
{ return(TokDivide);               
} yy220: goto yyBegin;
case 677:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1348 "fortran.rex"
{ return(TokPow);                  
} yy221: goto yyBegin;
case 675:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1349 "fortran.rex"
{ return(TokConcatenation);        
} yy222: goto yyBegin;
case 673:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1352 "fortran.rex"
{ return(TokAnd);                  
} yy223: goto yyBegin;
case 669:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1353 "fortran.rex"
{ return(TokOr);                   
} yy224: goto yyBegin;
case 666:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1354 "fortran.rex"
{ return(TokXor);                  
} yy225: goto yyBegin;
case 662:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1355 "fortran.rex"
{ return(TokNot);                  
} yy226: goto yyBegin;
case 659:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1356 "fortran.rex"
{ return(TokEquiv);                
} yy227: goto yyBegin;
case 656:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1357 "fortran.rex"
{ return(TokNotEquiv);             
} yy228: goto yyBegin;
case 651:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1359 "fortran.rex"
{ return(TokTrue);                 
} yy229: goto yyBegin;
case 646:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1360 "fortran.rex"
{ return(TokFalse);                
} yy230: goto yyBegin;
case 34:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1363 "fortran.rex"
{ MyLength = GetUpper (MyWord);
                               Attribute.Ident = MakeIdent (MyWord,MyLength);
                               return (TokUserOp);              
} yy231: goto yyBegin;
case 50:;
case 388:;
case 394:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1373 "fortran.rex"
{ MyLength = GetWord (MyWord);
                    for (i=0; i<MyLength; i++) 
                       StringWord[StringLength+i] = MyWord[i];
                    StringLength += MyLength; 
                  
} yy232: goto yyBegin;
case 51:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1378 "fortran.rex"
{ yyStart(FORMAT1);
                    yyEol(0);
                    Attribute.StringConst =
                       PutString(StringWord, StringLength);
                    return (TokFormatString);
                  
} yy233: goto yyBegin;
case 49:;
case 389:;
case 395:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1385 "fortran.rex"
{ yyLess (0);
                    yyStart (STD);
                    return (TokNL);
                  
} yy234: goto yyBegin;
case 640:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1396 "fortran.rex"
{ return(TokTemplate);             
} yy235: goto yyBegin;
case 633:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1397 "fortran.rex"
{ return(TokProcessors);           
} yy236: goto yyBegin;
case 623:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1398 "fortran.rex"
{ return(TokAlign);                
} yy237: goto yyBegin;
case 620:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1399 "fortran.rex"
{ return(TokRealign);              
} yy238: goto yyBegin;
case 615:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1400 "fortran.rex"
{ return(TokWith);                 
} yy239: goto yyBegin;
case 611:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1401 "fortran.rex"
{ return(TokDistribute);           
} yy240: goto yyBegin;
case 603:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1402 "fortran.rex"
{ return(TokOnto);                 
} yy241: goto yyBegin;
case 601:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1403 "fortran.rex"
{ return(TokBlock);                
} yy242: goto yyBegin;
case 597:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1404 "fortran.rex"
{ return(TokCyclic);               
} yy243: goto yyBegin;
case 591:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1405 "fortran.rex"
{ return(TokGenBlock);             
} yy244: goto yyBegin;
case 582:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1406 "fortran.rex"
{ return(TokIndirect);             
} yy245: goto yyBegin;
case 577:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1407 "fortran.rex"
{ return(TokArbitrary);            
} yy246: goto yyBegin;
case 569:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1408 "fortran.rex"
{ return(TokRedistribute);         
} yy247: goto yyBegin;
case 560:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1409 "fortran.rex"
{ return(TokDynamic);              
} yy248: goto yyBegin;
case 554:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1410 "fortran.rex"
{ return(TokDimension);            
} yy249: goto yyBegin;
case 545:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1411 "fortran.rex"
{ return(TokHPFSequence);          
} yy250: goto yyBegin;
case 43:;
case 113:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1413 "fortran.rex"
{ return(TokNoSequence);           
} yy251: goto yyBegin;
case 538:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1414 "fortran.rex"
{ return(TokIndependent);          
} yy252: goto yyBegin;
case 529:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1415 "fortran.rex"
{ return(TokOn);                   
} yy253: goto yyBegin;
case 527:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1416 "fortran.rex"
{ return(TokHome);                 
} yy254: goto yyBegin;
case 523:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1417 "fortran.rex"
{ return(TokResident);             
} yy255: goto yyBegin;
case 517:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1418 "fortran.rex"
{ return(TokNew);                  
} yy256: goto yyBegin;
case 515:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1419 "fortran.rex"
{ return(TokReduction);            
} yy257: goto yyBegin;
case 507:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1420 "fortran.rex"
{ return(TokInherit);              
} yy258: goto yyBegin;
case 500:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1421 "fortran.rex"
{ return(TokRange);                
} yy259: goto yyBegin;
case 495:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1422 "fortran.rex"
{ return(TokShared);               
} yy260: goto yyBegin;
case 492:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1423 "fortran.rex"
{ return(TokAll);                  
} yy261: goto yyBegin;
case 489:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1424 "fortran.rex"
{ return(TokHPFBegin);             
} yy262: goto yyBegin;
case 484:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1425 "fortran.rex"
{ return(TokHPFEnd);               
} yy263: goto yyBegin;
case 481:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1426 "fortran.rex"
{ return(TokShadow);               
} yy264: goto yyBegin;
case 475:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1427 "fortran.rex"
{ return(TokTaskRegion);           
} yy265: goto yyBegin;
case 42:;
case 383:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1429 "fortran.rex"
{ yyStart(STD);
                                  yyEol(0);
                                  return (TokNL); 
} yy266: goto yyBegin;
case 464:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1439 "fortran.rex"
{ return(TokMap);            
} yy267: goto yyBegin;
case 461:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1440 "fortran.rex"
{ return(TokTrace);          
} yy268: goto yyBegin;
case 458:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1441 "fortran.rex"
{ return(TokTree);           
} yy269: goto yyBegin;
case 455:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1442 "fortran.rex"
{ return(TokNoVector);       
} yy270: goto yyBegin;
case 449:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1443 "fortran.rex"
{ return(TokNoConcur);       
} yy271: goto yyBegin;
case 441:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1444 "fortran.rex"
{ return(TokShort);          
} yy272: goto yyBegin;
case 438:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1445 "fortran.rex"
{ return(TokExpand);         
} yy273: goto yyBegin;
case 432:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1446 "fortran.rex"
{ return(TokVector);         
} yy274: goto yyBegin;
case 426:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1447 "fortran.rex"
{ return(TokConcur);         
} yy275: goto yyBegin;
case 420:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1448 "fortran.rex"
{ return(TokSkip);           
} yy276: goto yyBegin;
case 417:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1449 "fortran.rex"
{ return(TokAllocate);       
} yy277: goto yyBegin;
case 408:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1450 "fortran.rex"
{ return(TokShared);         
} yy278: goto yyBegin;
case 402:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1451 "fortran.rex"
{ return(TokRMA);            
} yy279: goto yyBegin;
case 399:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1452 "fortran.rex"
{ return(TokTo);             
} yy280: goto yyBegin;
case 31:;
case 384:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1454 "fortran.rex"
{ yyStart(STD);
                                  yyEol(0);
                                  return (TokNL); 
} yy281: goto yyBegin;
case 38:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1466 "fortran.rex"
{ 
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 2);
                 return (TokInteger); 
} yy282: goto yyBegin;
case 39:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1471 "fortran.rex"
{ 
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 2);
                 return (TokInteger); 
} yy283: goto yyBegin;
case 40:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1476 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 8);
                 return (TokInteger); 
} yy284: goto yyBegin;
case 41:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1481 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 8);
                 return (TokInteger); 
} yy285: goto yyBegin;
case 36:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1486 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 16);
                 return (TokInteger); 
} yy286: goto yyBegin;
case 37:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1491 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 16);
                 return (TokInteger); 
} yy287: goto yyBegin;
case 29:;
case 94:;
case 95:;
case 96:;
case 97:;
case 98:;
case 99:;
case 100:;
case 101:;
case 159:;
case 161:;
case 162:;
case 192:;
case 277:;
case 278:;
case 279:;
case 280:;
case 281:;
case 282:;
case 302:;
case 320:;
case 321:;
case 322:;
case 323:;
case 324:;
case 339:;
case 340:;
case 351:;
case 352:;
case 353:;
case 360:;
case 361:;
case 368:;
case 398:;
case 400:;
case 401:;
case 403:;
case 404:;
case 405:;
case 406:;
case 407:;
case 409:;
case 410:;
case 411:;
case 412:;
case 413:;
case 414:;
case 415:;
case 416:;
case 418:;
case 419:;
case 421:;
case 422:;
case 423:;
case 424:;
case 425:;
case 427:;
case 428:;
case 429:;
case 430:;
case 431:;
case 433:;
case 434:;
case 435:;
case 436:;
case 437:;
case 439:;
case 440:;
case 442:;
case 443:;
case 444:;
case 445:;
case 446:;
case 447:;
case 448:;
case 450:;
case 451:;
case 452:;
case 453:;
case 454:;
case 456:;
case 457:;
case 459:;
case 460:;
case 462:;
case 463:;
case 465:;
case 466:;
case 467:;
case 468:;
case 469:;
case 470:;
case 471:;
case 472:;
case 473:;
case 474:;
case 476:;
case 477:;
case 478:;
case 479:;
case 480:;
case 482:;
case 483:;
case 485:;
case 486:;
case 487:;
case 488:;
case 490:;
case 491:;
case 493:;
case 494:;
case 496:;
case 497:;
case 498:;
case 499:;
case 501:;
case 502:;
case 503:;
case 504:;
case 505:;
case 506:;
case 508:;
case 509:;
case 510:;
case 511:;
case 512:;
case 513:;
case 514:;
case 516:;
case 518:;
case 519:;
case 520:;
case 521:;
case 522:;
case 524:;
case 525:;
case 526:;
case 528:;
case 530:;
case 531:;
case 532:;
case 533:;
case 534:;
case 535:;
case 536:;
case 537:;
case 539:;
case 540:;
case 541:;
case 542:;
case 543:;
case 544:;
case 546:;
case 547:;
case 548:;
case 549:;
case 550:;
case 551:;
case 552:;
case 553:;
case 555:;
case 556:;
case 557:;
case 558:;
case 559:;
case 561:;
case 562:;
case 563:;
case 564:;
case 565:;
case 566:;
case 567:;
case 568:;
case 570:;
case 571:;
case 572:;
case 573:;
case 574:;
case 575:;
case 576:;
case 578:;
case 579:;
case 580:;
case 581:;
case 583:;
case 584:;
case 585:;
case 586:;
case 587:;
case 588:;
case 589:;
case 590:;
case 592:;
case 593:;
case 594:;
case 595:;
case 596:;
case 598:;
case 599:;
case 600:;
case 602:;
case 604:;
case 605:;
case 606:;
case 607:;
case 608:;
case 609:;
case 610:;
case 612:;
case 613:;
case 614:;
case 616:;
case 617:;
case 618:;
case 619:;
case 621:;
case 622:;
case 624:;
case 625:;
case 626:;
case 627:;
case 628:;
case 629:;
case 630:;
case 631:;
case 632:;
case 634:;
case 635:;
case 636:;
case 637:;
case 638:;
case 639:;
case 719:;
case 721:;
case 722:;
case 723:;
case 724:;
case 726:;
case 727:;
case 728:;
case 729:;
case 730:;
case 732:;
case 733:;
case 735:;
case 736:;
case 737:;
case 738:;
case 739:;
case 741:;
case 742:;
case 743:;
case 744:;
case 745:;
case 746:;
case 748:;
case 749:;
case 750:;
case 751:;
case 752:;
case 753:;
case 754:;
case 756:;
case 757:;
case 758:;
case 759:;
case 761:;
case 762:;
case 763:;
case 764:;
case 766:;
case 767:;
case 768:;
case 770:;
case 771:;
case 772:;
case 773:;
case 775:;
case 776:;
case 777:;
case 779:;
case 781:;
case 782:;
case 784:;
case 785:;
case 786:;
case 788:;
case 789:;
case 790:;
case 792:;
case 793:;
case 794:;
case 796:;
case 797:;
case 798:;
case 799:;
case 800:;
case 801:;
case 803:;
case 804:;
case 805:;
case 806:;
case 807:;
case 808:;
case 809:;
case 811:;
case 812:;
case 813:;
case 814:;
case 815:;
case 816:;
case 817:;
case 819:;
case 820:;
case 822:;
case 823:;
case 825:;
case 826:;
case 827:;
case 828:;
case 829:;
case 830:;
case 831:;
case 832:;
case 834:;
case 835:;
case 836:;
case 837:;
case 839:;
case 840:;
case 842:;
case 844:;
case 845:;
case 846:;
case 848:;
case 849:;
case 851:;
case 852:;
case 853:;
case 854:;
case 855:;
case 857:;
case 858:;
case 859:;
case 860:;
case 861:;
case 863:;
case 864:;
case 865:;
case 866:;
case 867:;
case 868:;
case 869:;
case 871:;
case 872:;
case 873:;
case 874:;
case 875:;
case 876:;
case 877:;
case 879:;
case 880:;
case 881:;
case 883:;
case 884:;
case 886:;
case 887:;
case 888:;
case 889:;
case 890:;
case 891:;
case 893:;
case 894:;
case 895:;
case 897:;
case 898:;
case 899:;
case 900:;
case 902:;
case 903:;
case 904:;
case 905:;
case 907:;
case 908:;
case 909:;
case 910:;
case 911:;
case 913:;
case 914:;
case 915:;
case 916:;
case 917:;
case 919:;
case 920:;
case 921:;
case 922:;
case 924:;
case 925:;
case 926:;
case 927:;
case 928:;
case 930:;
case 931:;
case 932:;
case 933:;
case 934:;
case 936:;
case 937:;
case 938:;
case 940:;
case 941:;
case 942:;
case 944:;
case 945:;
case 946:;
case 947:;
case 949:;
case 950:;
case 951:;
case 952:;
case 954:;
case 955:;
case 956:;
case 957:;
case 958:;
case 959:;
case 960:;
case 962:;
case 963:;
case 964:;
case 965:;
case 966:;
case 967:;
case 968:;
case 969:;
case 971:;
case 972:;
case 973:;
case 974:;
case 975:;
case 977:;
case 978:;
case 979:;
case 980:;
case 981:;
case 982:;
case 984:;
case 985:;
case 986:;
case 987:;
case 988:;
case 990:;
case 991:;
case 993:;
case 995:;
case 996:;
case 997:;
case 998:;
case 1000:;
case 1001:;
case 1002:;
case 1003:;
case 1004:;
case 1006:;
case 1007:;
case 1008:;
case 1009:;
case 1010:;
case 1011:;
case 1012:;
case 1014:;
case 1015:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1496 "fortran.rex"
{
                  MyLength = GetUpper(MyWord);
                  Attribute.Ident=MakeIdent(MyWord,MyLength);
                  return(TokIdentifier);                      
} yy288: goto yyBegin;
case 30:;
case 102:;
case 163:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1503 "fortran.rex"
{ 
                  MyLength = GetUpper(MyWord);
                  Attribute.IntConst=atoi((char *)MyWord);
                  Attribute.Ident = GetKindIdent (MyWord, MyLength);
                  return(TokInteger);       
} yy289: goto yyBegin;
case 33:;
case 112:;
case 185:;
case 252:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1513 "fortran.rex"
{ 
                  MyLength = GetUpper (MyWord);
                  Attribute.StringConst = PutString (MyWord, MyLength);
                  Attribute.Ident = GetKindIdent (MyWord, MyLength);
                  return(TokRealLiteral);           
                
} yy290: goto yyBegin;
case 35:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
# line 1523 "fortran.rex"
{  
                  MyLength = GetWord (MyWord);
                  Attribute.StringConst = PutString (MyWord, MyLength);
                  return(TokDRealLiteral);           
} yy291: goto yyBegin;
case 391:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yy292: goto yyBegin;
case 386:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yy293: goto yyBegin;
case 376:;
{/* EolAction */
yyLineCount ++;
yyLineStart = yyChBufferIndexReg - 1;
} yy294: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 7:;
case 8:;
case 9:;
case 10:;
case 11:;
case 12:;
case 13:;
case 14:;
case 15:;
case 16:;
case 17:;
case 18:;
case 21:;
case 22:;
case 23:;
case 24:;
case 25:;
case 26:;
case 27:;
case 28:;
case 32:;
case 103:;
case 104:;
case 105:;
case 106:;
case 107:;
case 108:;
case 109:;
case 110:;
case 111:;
case 164:;
case 165:;
case 166:;
case 167:;
case 168:;
case 169:;
case 170:;
case 171:;
case 172:;
case 173:;
case 174:;
case 175:;
case 176:;
case 177:;
case 178:;
case 179:;
case 180:;
case 181:;
case 183:;
case 184:;
case 193:;
case 194:;
case 195:;
case 196:;
case 197:;
case 198:;
case 199:;
case 200:;
case 201:;
case 202:;
case 203:;
case 204:;
case 205:;
case 206:;
case 207:;
case 208:;
case 209:;
case 210:;
case 211:;
case 212:;
case 213:;
case 214:;
case 215:;
case 216:;
case 217:;
case 218:;
case 219:;
case 220:;
case 221:;
case 222:;
case 223:;
case 224:;
case 225:;
case 226:;
case 227:;
case 228:;
case 229:;
case 230:;
case 231:;
case 232:;
case 233:;
case 234:;
case 235:;
case 236:;
case 237:;
case 238:;
case 239:;
case 240:;
case 241:;
case 242:;
case 243:;
case 244:;
case 245:;
case 246:;
case 247:;
case 248:;
case 249:;
case 250:;
case 251:;
case 254:;
case 255:;
case 256:;
case 257:;
case 258:;
case 259:;
case 260:;
case 261:;
case 262:;
case 263:;
case 264:;
case 265:;
case 266:;
case 267:;
case 268:;
case 269:;
case 270:;
case 271:;
case 272:;
case 273:;
case 274:;
case 275:;
case 276:;
case 283:;
case 284:;
case 285:;
case 286:;
case 305:;
case 306:;
case 307:;
case 308:;
case 309:;
case 310:;
case 311:;
case 312:;
case 313:;
case 314:;
case 315:;
case 316:;
case 317:;
case 318:;
case 319:;
case 362:;
case 363:;
case 364:;
case 373:;
case 641:;
case 642:;
case 643:;
case 644:;
case 645:;
case 647:;
case 648:;
case 649:;
case 650:;
case 652:;
case 653:;
case 654:;
case 655:;
case 657:;
case 658:;
case 660:;
case 661:;
case 663:;
case 664:;
case 665:;
case 667:;
case 668:;
case 670:;
case 671:;
case 672:;
case 682:;
case 683:;
case 685:;
case 689:;
case 690:;
case 692:;
case 698:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 375:
	 Attribute.Position.Line   = yyLineCount;
	 Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
# line 616 "fortran.rex"

  printf ("illegal character: ");
  yyEcho;
  printf (" in Line %d", yyLineCount);
  printf (" in file %s", CurrentSourceName ());
  printf ("\n");

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 374:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = TokenPtr;
	    register char * yyTarget = TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    Attribute.Position.Line   = yyLineCount;
	    Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
# line 634 "fortran.rex"


  /* Attention: EOF is only executed after the last file */

  /* Hint: the following statement
 
     close_include_file ();

     should be executed when an included file will be closed */


	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = BeginSource (yyFileName);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void BeginScanner ()
   {
# line 624 "fortran.rex"

  InitMemory ();
  InitStringMemory ();
  InitIdents ();
  InitLabels ();
  MakeEndDos = 0;
  EndDoSwitch  = 0;
  ReservedWordState = 0;

   }
 
void CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": Scanner: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": Scanner: file stack underflow (too many calls of CloseFile)\n"); break;
      }
      Scanner_Exit ();
   }
